indexing

	description:

		"Eiffel call agents"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 2002, Eric Bezault and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: 2002/10/21 21:32:31 $"
	revision: "$Revision: 1.3 $"

class ET_CALL_AGENT

inherit

	ET_EXPRESSION

creation

	make

feature {NONE} -- Initialization

	make (an_agent: like agent_keyword) is
			-- Create a new call agent.
		require
			an_agent_not_void: an_agent /= Void
		do
			agent_keyword := an_agent
		ensure
			agent_keyword_set: agent_keyword = an_agent
		end

feature -- Access

	agent_keyword: ET_KEYWORD
			-- 'agent' keyword

	position: ET_POSITION is
			-- Position of first character of
			-- current node in source code
		do
			Result := agent_keyword.position
		end

	break: ET_BREAK is
			-- Break which appears just after current node
		do
			Result := agent_keyword.break
		end

feature -- Processing

	process (a_processor: ET_AST_PROCESSOR) is
			-- Process current node.
		do
			a_processor.process_call_agent (Current)
		end

invariant

	agent_keyword_not_void: agent_keyword /= Void

end
