indexing

	description:

		"Scanners for Eiffel parsers"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2002, Eric Bezault and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: 2002/11/29 09:57:41 $"
	revision: "$Revision: 1.13 $"

class ET_EIFFEL_SCANNER

inherit

	ET_EIFFEL_SCANNER_SKELETON

creation

	make, make_with_factory

feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= VS3)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
			yy_acclist ?= yy_acclist_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 45 then
if yy_act <= 23 then
if yy_act <= 12 then
if yy_act <= 6 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + 1
--|#line 32 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 32")
end

				last_break_end := 0
				last_comment_end := 0
				process_one_char_symbol (text_item (1))
			
else
yy_set_line_column
--|#line 37 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 37")
end

				last_text_count := 1
				last_break_end := text_count
				last_comment_end := 0
				process_one_char_symbol (text_item (1))
			
end
else
yy_set_line_column
--|#line 43 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 43")
end

				last_text_count := 1
				last_break_end := 0
				last_comment_end := text_count
				process_one_char_symbol (text_item (1))
			
end
else
if yy_act <= 5 then
if yy_act = 4 then
	yy_column := yy_column + 2
--|#line 49 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 49")
end

				last_break_end := 0
				last_comment_end := 0
				process_two_char_symbol (text_item (1), text_item (2))
			
else
yy_set_line_column
--|#line 54 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 54")
end

				last_text_count := 2
				last_break_end := text_count
				last_comment_end := 0
				process_two_char_symbol (text_item (1), text_item (2))
			
end
else
yy_set_line_column
--|#line 60 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 60")
end

				last_text_count := 2
				last_break_end := 0
				last_comment_end := text_count
				process_two_char_symbol (text_item (1), text_item (2))
			
end
end
else
if yy_act <= 9 then
if yy_act <= 8 then
if yy_act = 7 then
	yy_end := yy_end - 1
	yy_column := yy_column + 4
--|#line 82 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 82")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_once_keyword (Current)
			
else
	yy_end := yy_end - 1
yy_set_line_column
--|#line 90 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 90")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_text_count := 4
				last_break_end := text_count
				last_comment_end := 0
				last_value := ast_factory.new_once_keyword (Current)
			
end
else
	yy_end := yy_end - 1
yy_set_line_column
--|#line 99 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 99")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_text_count := 4
				last_break_end := 0
				last_comment_end := text_count
				last_value := ast_factory.new_once_keyword (Current)
			
end
else
if yy_act <= 11 then
if yy_act = 10 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 112 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 112")
end

				last_break_end := 0
				last_comment_end := 0
				process_identifier (text_count)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 117 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 117")
end

				last_text_count := text_count
				break_kind := identifier_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 130 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 130")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_free_operator (Current)
			
end
end
end
else
if yy_act <= 18 then
if yy_act <= 15 then
if yy_act <= 14 then
if yy_act = 13 then
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 138 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 138")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + 3
--|#line 150 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 150")
end

				last_break_end := 0
				last_comment_end := 0
				process_c1_character_constant (text_item (2))
			
end
else
yy_set_line_column
--|#line 155 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 155")
end

				last_text_count := 3
				last_break_end := text_count
				last_comment_end := 0
				process_c1_character_constant (text_item (2))
			
end
else
if yy_act <= 17 then
if yy_act = 16 then
yy_set_line_column
--|#line 161 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 161")
end

				last_text_count := 3
				last_break_end := 0
				last_comment_end := text_count
				process_c1_character_constant (text_item (2))
			
else
	yy_column := yy_column + 4
--|#line 167 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 167")
end

				last_break_end := 0
				last_comment_end := 0
				process_c2_character_constant (text_item (3))
			
end
else
yy_set_line_column
--|#line 172 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 172")
end

				last_text_count := 4
				last_break_end := text_count
				last_comment_end := 0
				process_c2_character_constant (text_item (3))
			
end
end
else
if yy_act <= 21 then
if yy_act <= 20 then
if yy_act = 19 then
yy_set_line_column
--|#line 178 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 178")
end

				last_text_count := 4
				last_break_end := 0
				last_comment_end := text_count
				process_c2_character_constant (text_item (3))
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 185 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 185")
end

				last_token := E_CHARACTER
				last_literal_start := 4
				last_literal_end := text_count - 2
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_c3_character_constant (Current)
			
end
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 193 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 193")
end

				last_text_count := text_count
				last_literal_start := 4
				last_literal_end := last_text_count - 2
				break_kind := character_break
				more
				set_start_condition (BREAK)
			
end
else
if yy_act = 22 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 202 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 202")
end

					-- Syntax error: missing character / at end
					-- of special character specification %/code/.
				column := column + text_count
				error_handler.report_SCAS_error (current_position)
				last_value := current_position
				column := column - text_count
				last_token := E_CHARERR
			
else
	yy_column := yy_column + 3
--|#line 211 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 211")
end

					-- Syntax error: missing ASCII code in
					-- special character specification %/code/.
				column := column + 3
				error_handler.report_SCAC_error (current_position)
				last_value := current_position
				column := column - 3
				last_token := E_CHARERR
			
end
end
end
end
else
if yy_act <= 34 then
if yy_act <= 29 then
if yy_act <= 26 then
if yy_act <= 25 then
if yy_act = 24 then
	yy_column := yy_column + 2
--|#line 220 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 220")
end

					-- Syntax error: missing character between quotes.
				column := column + 1
				error_handler.report_SCQQ_error (current_position)
				last_value := current_position
				column := column - 1
				last_token := E_CHARERR
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 228 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 228")
end

					-- Syntax error: missing quote at
					-- end of character constant.
				column := column + text_count
				error_handler.report_SCEQ_error (current_position)
				last_value := current_position
				column := column - text_count
				last_token := E_CHARERR
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 241 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 241")
end

				last_token := E_STRFREEOP
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_regular_manifest_string (Current)
			
end
else
if yy_act <= 28 then
if yy_act = 27 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 249 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 249")
end

				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_freeop_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 258 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 258")
end

					-- Regular manifest string.
				last_break_end := 0
				last_comment_end := 0
				process_regular_manifest_string (text_count)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 264 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 264")
end

					-- Regular manifest string.
				last_text_count := text_count
				break_kind := string_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 32 then
if yy_act <= 31 then
if yy_act = 30 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 272 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 272")
end

					-- Verbatim string.
				verbatim_marker := text_substring (2, text_count - 1)
				set_start_condition (VS1)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 280 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 280")
end

				verbatim_open_white_characters := text
				last_literal_start := 1
				last_literal_end := 0
				set_start_condition (VS2)
			
end
else
	yy_column := yy_column + 1
--|#line 286 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 286")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
end
else
if yy_act = 33 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 302 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 302")
end

				if is_verbatim_string_closer (last_literal_end + 1, text_count - 1) then
					last_token := E_STRING
					last_break_end := 0
					last_comment_end := 0
					last_value := ast_factory.new_verbatim_string (verbatim_marker, verbatim_open_white_characters,
						text_substring (last_literal_end + 1, text_count - verbatim_marker.count - 2), Current)
					verbatim_marker := Void
					verbatim_open_white_characters := Void
					set_start_condition (INITIAL)
				else
					more
					set_start_condition (VS3)
				end
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 317 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 317")
end

				if is_verbatim_string_closer (last_literal_end + 1, text_count - 1) then
					verbatim_close_white_characters := text_substring (last_literal_end + 1, text_count - verbatim_marker.count - 2)
					last_text_count := text_count
					break_kind := str_verbatim_break
					more
					set_start_condition (BREAK)
				else
					more
					set_start_condition (VS3)
				end
			
end
end
end
else
if yy_act <= 40 then
if yy_act <= 37 then
if yy_act <= 36 then
if yy_act = 35 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 329 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 329")
end

				more
				set_start_condition (VS3)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 333 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 333")
end

				more
				last_literal_end := text_count - 2
			
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 337 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 337")
end

				more
				last_literal_end := text_count - 1
			
end
else
if yy_act <= 39 then
if yy_act = 38 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 341 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 341")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 357 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 357")
end

				more
				last_literal_end := text_count - 2
				set_start_condition (VS2)
			
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 362 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 362")
end

				more
				last_literal_end := text_count - 1
				set_start_condition (VS2)
			
end
end
else
if yy_act <= 43 then
if yy_act <= 42 then
if yy_act = 41 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 367 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 367")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 381 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 381")
end

					-- Manifest string with special characters.
				last_token := E_STRING
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_special_manifest_string (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 390 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 390")
end

					-- Manifest string with special characters.
				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_special_break
				more
				set_start_condition (BREAK)
			
end
else
if yy_act = 44 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 399 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 399")
end

					-- Manifest string with special characters which may be made
					-- up of several lines or may include invalid characters.
					-- Keep track of current line and column.
				ms_line := line
				ms_column := column
				more
				set_start_condition (MS)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 410 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 410")
end

					-- Multi-line manifest string.
				more
				set_start_condition (MSN)
			
end
end
end
end
end
else
if yy_act <= 68 then
if yy_act <= 57 then
if yy_act <= 51 then
if yy_act <= 48 then
if yy_act <= 47 then
if yy_act = 46 then
	yy_end := yy_start + yy_more_len + 2
	yy_column := yy_column + 2
--|#line 415 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 415")
end

					-- Multi-line manifest string.

					-- Syntax error: no space allowed after character
					-- % at end of line in multi-line manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSNS_error (current_position)
				column := ms_column
				line := ms_line
				more
				set_start_condition (MSN1)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 428 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 428")
end

				more
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 431 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 431")
end

					-- Syntax error: missing character / at end of special
					-- character specification %/code/ in manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSAS_error (current_position)
				column := ms_column
				line := ms_line
				more
			
end
else
if yy_act <= 50 then
if yy_act = 49 then
	yy_column := yy_column + 2
--|#line 441 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 441")
end

					-- Syntax error: missing ASCII code in special character
					-- specification %/code/ in manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSAC_error (current_position)
				column := ms_column
				line := ms_line
				more
			
else
	yy_column := yy_column + 2
--|#line 451 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 451")
end

					-- Syntax error: special character specification
					-- %l where l is a letter code should be in
					-- upper-case in manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSCU_error (current_position)
				column := ms_column
				line := ms_line
				more
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 462 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 462")
end

				more
			
end
end
else
if yy_act <= 54 then
if yy_act <= 53 then
if yy_act = 52 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 465 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 465")
end

				last_token := E_STRING
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_special_manifest_string (Current)
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 474 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 474")
end

				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_special_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + 2
--|#line 482 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 482")
end

					-- Syntax error: Invalid special character
					-- in manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSSC_error (current_position)
				column := ms_column
				line := ms_line
				more
			
end
else
if yy_act <= 56 then
if yy_act = 55 then
	yy_column := yy_column + 1
--|#line 492 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 492")
end

					-- Syntax error: invalid special character
					-- %l in manifest strings.
				column := yy_column
				line := yy_line
				error_handler.report_SSSC_error (current_position)
				last_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 504 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 504")
end

					-- Syntax error: Invalid new-line in manifest string.
				column := 1
				line := yy_line
				error_handler.report_SSNL_error (current_position)
				last_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 530 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 530")
end

				more
				set_start_condition (MSN)
			
end
end
end
else
if yy_act <= 63 then
if yy_act <= 60 then
if yy_act <= 59 then
if yy_act = 58 then
	yy_column := yy_column + 1
--|#line 534 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 534")
end

					-- Should never happen.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 549 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 549")
end

				more
				set_start_condition (MS)
			
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 553 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 553")
end

					-- Syntax error: empty line in middle of
					-- multi-line manifest string.
				column := 1
				line := yy_line - 1
				error_handler.report_SSEL_error (current_position)
				column := ms_column
				line := ms_line
				more
			
end
else
if yy_act <= 62 then
if yy_act = 61 then
	yy_column := yy_column + 1
--|#line 563 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 563")
end

					-- Syntax error: missing character % at beginning
					-- of line in multi-line manifest string.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSNP_error (current_position)
				last_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 592 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 592")
end

				last_token := E_BIT
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_bit_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 600 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 600")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := bit_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 66 then
if yy_act <= 65 then
if yy_act = 64 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 612 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 612")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_regular_integer_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 620 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 620")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := integer_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 628 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 628")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_integer_constant (Current)
			
end
else
if yy_act = 67 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 636 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 636")
end

					-- Syntax error: an underscore may not be
					-- the first character of an integer.
				error_handler.report_SIFU_error (current_position)
				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_integer_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 647 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 647")
end

					-- Syntax error: an underscore must be followed
					-- by three digits and there must not be any
					-- consecutive group of four digits.
				error_handler.report_SITD_error (current_position)
				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_integer_constant (Current)
			
end
end
end
end
else
if yy_act <= 79 then
if yy_act <= 74 then
if yy_act <= 71 then
if yy_act <= 70 then
if yy_act = 69 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 659 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 659")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := uinteger_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 667 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 667")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_hexadecimal_integer_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 675 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 675")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := hinteger_break
				more
				set_start_condition (BREAK)
			
end
else
if yy_act <= 73 then
if yy_act = 72 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 687 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 687")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 688 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 688")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 689 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 689")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 77 then
if yy_act <= 76 then
if yy_act = 75 then
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 697 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 697")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_regular_real_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 698 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 698")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_regular_real_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 699 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 699")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_regular_real_constant (Current)
			
end
else
if yy_act = 78 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 710 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 710")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 711 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 711")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
end
end
end
else
if yy_act <= 85 then
if yy_act <= 82 then
if yy_act <= 81 then
if yy_act = 80 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 712 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 712")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 720 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 720")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_real_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 721 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 721")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_real_constant (Current)
			
end
else
if yy_act <= 84 then
if yy_act = 83 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 722 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 722")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_value := ast_factory.new_underscored_real_constant (Current)
			
else
yy_set_line_column
--|#line 737 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 737")
end

				last_literal_start := 1
				last_literal_end := 0
				last_text_count := 0
				last_break_end := text_count
				last_comment_end := 0
				last_value := ast_factory.new_break (Current)
				last_token := E_BREAK
			
end
else
yy_set_line_column
--|#line 747 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 747")
end

				last_literal_start := 1
				last_literal_end := 0
				last_text_count := 0
				last_break_end := 0
				last_comment_end := text_count
				last_value := ast_factory.new_comment (Current)
				last_token := E_BREAK
			
end
end
else
if yy_act <= 88 then
if yy_act <= 87 then
if yy_act = 86 then
yy_set_line_column
--|#line 758 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 758")
end

				last_break_end := text_count
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
else
yy_set_line_column
--|#line 764 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 764")
end

				last_break_end := 0
				last_comment_end := text_count
				process_break
				set_start_condition (INITIAL)
			
end
else
	yy_column := yy_column + 1
--|#line 770 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 770")
end

					-- Should never happen.
				less (0)
				last_break_end := 0
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
end
else
if yy_act = 89 then
	yy_column := yy_column + 1
--|#line 791 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 791")
end

				last_token := E_UNKNOWN
				last_value := current_position
			
else
yy_set_line_column
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end
terminate
when 1 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Should never happen.
				last_break_end := 0
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
when 2 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Syntax error: missing double quote at
					-- end of manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSEQ_error (current_position)
				last_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
when 3 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Syntax error: missing character % at beginning
					-- of line in multi-line manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSNP_error (current_position)
				last_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
when 4 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Should never happen.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
when 5 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
when 6 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
when 7 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_value := current_position
				set_start_condition (INITIAL)
			
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   18,   19,   20,   19,   21,   22,   23,   18,   24,
			   21,   21,   25,   26,   27,   28,   29,   30,   31,   32,
			   21,   33,   34,   35,   35,   35,   35,   35,   35,   35,
			   36,   21,   37,   21,   38,   35,   35,   35,   35,   35,
			   35,   40,   41,   40,   40,   41,   40,   44,   64,   65,
			   45,   42,   46,   44,   42,  312,   45,   81,   46,   48,
			   49,   48,   48,   49,   48,   50,   64,   65,   50,   52,
			   53,   52,   52,   53,   52,   55,   56,   55,   55,   56,
			   55,   58,   59,   60,  312,   61,   58,   59,   60,   81,
			   61,   66,   66,   66,   66,   66,   66,   68,   68,   68,

			  309,   67,   78,   79,   67,  130,  131,   69,   71,   72,
			   73,  306,   62,   76,   76,   76,  301,   62,   68,   68,
			   68,   91,   91,   91,   68,   68,   68,  101,   80,  102,
			  101,   92,  102,   74,   69,  292,   81,   81,   68,   68,
			   68,   71,   81,   73,   95,   95,   95,  284,   69,   81,
			  295,   82,   82,   82,   83,   83,   83,  115,  116,  115,
			   68,   68,   68,   96,   84,   85,   74,   86,   86,   87,
			   69,   68,   68,   68,  120,  121,   88,  122,   81,  132,
			  131,   69,  117,  118,  117,  101,   89,  102,   88,   81,
			  130,  131,   90,   83,   83,   83,  112,  113,  112,   91,

			   91,   91,  114,   84,   85,  268,   87,   87,   87,   92,
			   97,   97,   97,   97,   97,   97,  291,  103,  103,  103,
			   98,  146,   93,   98,  201,   89,   94,  104,  120,  127,
			  147,  128,   93,  119,  132,  131,   94,  105,  106,  107,
			  108,  105,  109,  105,  109,  109,  109,  105,  105,  105,
			  110,  105,  105,  105,  105,  109,  105,  109,  105,  109,
			  109,  109,  105,  105,  109,  109,  105,  105,  105,  105,
			  105,  111,  111,  111,  111,  111,  105,  123,  120,  124,
			  284,  122,  123,  126,  124,  233,  122,   66,   66,   66,
			   68,   68,   68,  135,  135,  135,  233,   67,  169,  184,

			   69,   73,   93,  136,  283,   70,  167,   70,  125,  137,
			  169,   73,   93,  125,  141,  142,  141,  167,   71,  257,
			   73,   76,   76,   76,  249,  148,  148,  148,  160,  160,
			  161,  161,  161,  161,  138,  149,  242,  162,  162,  162,
			   89,  261,  170,   74,  150,  150,  150,  163,   95,   95,
			   95,  171,  229,  312,  151,  190,  241,  152,  152,  152,
			  146,   95,   95,   95,   97,   97,   97,   95,  153,  179,
			  240,  103,  103,  103,   98,  212,  154,  156,  156,  156,
			   96,  104,  173,  174,  173,  120,  121,  157,  122,  207,
			  158,  158,  158,  173,  175,  173,  176,  176,  176,  214,

			  182,  159,  164,  164,  164,  112,  113,  112,  115,  116,
			  115,  114,  165,  177,  180,  166,  166,  166,  117,  118,
			  117,  126,  121,  181,  122,  123,  120,  124,  101,  122,
			  102,  123,  126,  124,  167,  122,  120,  127,  164,  128,
			  162,  119,  126,  127,  198,  128,  191,  119,  177,  177,
			  177,  182,  182,  182,  150,  192,  125,  170,  178,  146,
			  193,  183,  125,  141,  142,  141,  171,  137,  179,   73,
			  185,  185,  185,  141,  142,  141,  188,   71,  188,   73,
			  186,  186,  186,  135,  189,  189,  189,  146,  146,  146,
			  187,  103,  138,  148,  148,  148,  172,   67,  194,  194,

			  194,   99,   74,  149,  195,  195,   91,   83,  196,  196,
			  196,  197,  197,  197,  150,  150,  150,  202,  202,  143,
			  145,  203,  203,  203,  151,  143,  140,  199,  199,  199,
			  204,  204,  205,  205,  205,  205,  180,  134,  200,  206,
			  206,  206,  167,  167,  167,  181,  201,  207,  207,  207,
			  209,  133,  191,   93,  170,  170,  170,  208,  210,  210,
			  210,  192,   99,   93,   98,  173,  174,  173,  211,  176,
			  176,  176,  180,  180,  180,  212,  212,  212,  139,  185,
			  185,  185,   69,   81,  312,  213,  186,  186,  186,  215,
			  215,  215,  217,  189,  189,  189,  187,  191,  219,  216,

			  191,  191,  191,  221,  221,  221,  192,  220,  312,  312,
			  218,  196,  196,  196,  150,  150,  150,  224,  224,  224,
			  225,  225,  225,  238,  151,  312,  312,  222,  222,  222,
			  226,  226,  239,  312,  227,  227,  227,  228,  228,  228,
			  203,  203,  203,  234,  234,  234,  223,  229,  229,  229,
			  100,  210,  210,  210,  235,  235,  235,  230,  236,  312,
			  231,  231,  231,  219,  237,  215,  215,  215,  219,  219,
			  219,  312,  220,  312,  312,  216,  312,  312,  149,  232,
			  242,  242,  242,  245,  245,  245,  246,  246,  246,  312,
			  243,  312,  312,  221,  221,  221,  247,  247,  247,  248,

			  248,  248,  312,  312,  244,  227,  227,  227,  249,  249,
			  249,  253,  253,  253,  254,  254,  254,  312,  250,  312,
			  312,  251,  251,  251,  255,  255,  255,  258,  258,  258,
			  238,  259,  312,  312,  238,  238,  238,  260,  262,  239,
			  252,  156,  156,  156,  187,  312,  312,  263,  264,  264,
			  264,  157,  312,  312,  248,  248,  248,  265,  265,  312,
			  312,  266,  266,  266,  312,  256,  266,  266,  266,  267,
			  267,  267,  268,  268,  268,  248,  248,  248,  272,  272,
			  272,  312,  269,  273,  273,  273,  271,  274,  274,  274,
			  275,  275,  275,  276,  276,  276,  270,  277,  277,  262,

			  312,  275,  275,  275,  154,  279,  279,  279,  263,  266,
			  266,  266,  258,  258,  258,  280,  259,  312,  281,  281,
			  281,  312,  260,  262,  262,  262,  285,  285,  285,  282,
			  289,  289,  289,  216,  242,  242,  242,  286,  286,  312,
			  312,  287,  287,  287,  243,  312,  312,  266,  266,  266,
			  288,  288,  312,  312,  289,  289,  289,  290,  290,  290,
			  292,  292,  292,  294,  294,  294,  275,  275,  275,  312,
			  293,  312,  312,  275,  275,  275,  296,  296,  296,  297,
			  297,  312,  312,  298,  298,  298,  284,  284,  284,  312,
			  299,  268,  268,  268,  312,  312,  260,  287,  287,  287,

			  312,  269,  289,  289,  289,  303,  303,  303,  304,  304,
			  312,  312,  305,  305,  305,  312,  312,  306,  306,  306,
			  274,  274,  274,  223,  268,  268,  268,  307,  298,  298,
			  298,  285,  285,  285,  269,  312,  312,  300,  300,  300,
			  305,  305,  305,  312,  309,  309,  309,  312,  312,  232,
			  294,  294,  294,  312,  310,  312,  223,  301,  301,  301,
			  303,  303,  303,  312,  312,  312,  312,  302,  312,  312,
			  289,  289,  289,  306,  306,  306,  252,  312,  312,  312,
			  312,  312,  312,  307,  312,  312,  308,  308,  308,  168,
			  168,  312,  312,  168,  168,  168,  312,  312,  168,  312,

			  312,  312,  312,  312,  312,  232,  309,  309,  309,  312,
			  312,  312,  312,  312,  312,  312,  310,  312,  312,  311,
			  311,  311,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  252,   39,
			   39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
			   39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   47,   47,   47,   47,   47,   47,   47,   47,   47,
			   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,

			   47,   47,   51,   51,   51,   51,   51,   51,   51,   51,
			   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
			   51,   51,   51,   54,   54,   54,   54,   54,   54,   54,
			   54,   54,   54,   54,   54,   54,   54,   54,   54,   54,
			   54,   54,   54,   54,   57,   57,   57,   57,   57,   57,
			   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
			   57,   57,   57,   57,   57,   63,   63,   63,   63,   63,
			   63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
			   63,   63,   63,   63,   63,   63,   70,   70,  312,   70,
			   70,   70,   70,   70,   70,   70,   70,   70,   70,   70,

			   70,   70,   70,   70,   70,   70,   70,   75,   75,   75,
			   75,  312,  312,   75,   75,   75,   75,   75,   75,   75,
			   75,   75,   75,   75,   75,   75,   75,   75,   77,   77,
			  312,   77,   77,   77,   77,   77,   77,   77,   77,   77,
			   77,   77,   77,   77,   77,   77,   77,   77,   77,   93,
			   93,   93,  312,  312,  312,  312,   93,  312,  312,   93,
			   93,  312,  312,   93,   93,   93,   93,   93,   93,  100,
			  100,  312,  100,  100,  100,  100,  100,  100,  100,  100,
			  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
			  119,  119,  119,  119,  119,  119,  119,  119,  119,  119,

			  119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
			  119,  125,  125,  125,  125,  125,  125,  125,  125,  125,
			  125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
			  125,  125,  129,  129,  129,  129,  129,  129,  129,  129,
			  129,  129,  129,  129,  129,  129,  129,  129,  129,  129,
			  129,  129,  129,   72,   72,  312,   72,   72,   72,   72,
			   72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
			   72,   72,   72,   72,  139,  139,  139,  139,  312,  312,
			  139,  312,  312,  139,  139,  139,  139,  312,  139,  144,
			  144,  312,  144,  144,  144,  144,  144,  144,  144,  144,

			  144,  144,  144,  144,  144,  144,  144,  144,  144,  144,
			  133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
			  133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
			  133,  155,  155,  155,  155,  155,  155,  155,  155,  155,
			  312,  155,  155,  155,  155,  155,  155,  155,  155,  155,
			  155,  155,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,  100,  100,  100,  100,  312,  312,  100,
			  312,  312,  100,  100,  100,  100,  312,  100,  134,  134,
			  134,  134,  134,  134,  134,  134,  134,  134,  134,  134,

			  134,  134,  134,  134,  134,  134,  134,  134,  134,  139,
			  139,  312,  139,  139,  139,  139,  139,  139,  139,  139,
			  139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
			  190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
			  190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
			  190,  193,  193,  193,  193,  193,  193,  193,  193,  193,
			  193,  193,  193,  193,  193,  193,  193,  193,  193,  193,
			  193,  193,  214,  214,  214,  214,  214,  214,  214,  214,
			  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
			  214,  214,  214,  240,  240,  240,  240,  240,  240,  240,

			  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
			  240,  240,  240,  240,  278,  278,  278,  278,  278,  278,
			  278,  278,  278,  312,  278,  278,  278,  278,  278,  278,
			  278,  278,  278,  278,  278,  283,  283,  283,  283,  283,
			  283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
			  283,  283,  283,  283,  283,  283,   17,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    3,    3,    3,    4,    4,    4,    5,   15,   15,
			    5,    3,    5,    6,    4,   33,    6,   33,    6,    7,
			    7,    7,    8,    8,    8,    7,   16,   16,    8,    9,
			    9,    9,   10,   10,   10,   11,   11,   11,   12,   12,
			   12,   13,   13,   13,   32,   13,   14,   14,   14,   32,
			   14,   19,   19,   19,   20,   20,   20,   21,   21,   21,

			  310,   19,   24,   24,   20,   63,   63,   21,   22,   22,
			   22,  307,   13,   23,   23,   23,  302,   14,   25,   25,
			   25,   35,   35,   35,   27,   27,   27,   43,   25,   43,
			  100,   35,  100,   22,   27,  293,   27,   25,   26,   26,
			   26,   70,   27,   70,   38,   38,   38,  283,   26,   26,
			  280,   26,   26,   26,   28,   28,   28,   52,   52,   52,
			   31,   31,   31,   38,   28,   28,   70,   28,   28,   28,
			   31,   34,   34,   34,   57,   57,   28,   57,   31,   65,
			   65,   34,   55,   55,   55,  109,   28,  109,   28,   34,
			  129,  129,   28,   30,   30,   30,   48,   48,   48,   36,

			   36,   36,   48,   30,   30,  269,   30,   30,   30,   36,
			   40,   40,   40,   41,   41,   41,  274,   45,   45,   45,
			   40,   80,   93,   41,  274,   30,   36,   45,   62,   62,
			   80,   62,   93,   62,  131,  131,   36,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   58,   58,   58,
			  261,   58,   60,   60,   60,  204,   60,   66,   66,   66,
			   68,   68,   68,   71,   71,   71,  205,   66,   94,  139,

			   68,  139,   94,   71,  260,   72,  204,   72,   58,   72,
			   94,   72,   94,   60,   74,   74,   74,  205,   74,  234,
			   74,   75,   75,   75,  250,   81,   81,   81,   86,   86,
			   86,   87,   87,   87,   72,   81,  243,   88,   88,   88,
			  234,  237,   99,   74,   82,   82,   82,   88,   95,   95,
			   95,   99,  230,   86,   82,  218,  217,   82,   82,   82,
			  133,   96,   96,   96,   97,   97,   97,   95,   82,  133,
			  216,  101,  101,  101,   97,  213,   82,   85,   85,   85,
			   96,  101,  106,  106,  106,  119,  119,   85,  119,  208,
			   85,   85,   85,  108,  108,  108,  110,  110,  110,  187,

			  183,   85,   89,   89,   89,  112,  112,  112,  115,  115,
			  115,  112,   89,  178,  134,   89,   89,   89,  117,  117,
			  117,  121,  121,  134,  121,  123,  123,  123,  211,  123,
			  211,  124,  124,  124,   89,  124,  125,  125,  165,  125,
			  163,  125,  127,  127,  157,  127,  147,  127,  128,  128,
			  128,  137,  137,  137,  151,  147,  123,  171,  128,  179,
			  149,  137,  124,  138,  138,  138,  171,  138,  179,  138,
			  140,  140,  140,  141,  141,  141,  144,  141,  145,  141,
			  143,  143,  143,  136,  145,  145,  145,  146,  146,  146,
			  143,  104,  138,  148,  148,  148,  102,  146,  152,  152,

			  152,   98,  141,  148,  153,  153,   92,   84,  153,  153,
			  153,  154,  154,  154,  158,  158,  158,  159,  159,   79,
			   78,  159,  159,  159,  158,   77,   73,  158,  158,  158,
			  160,  160,  160,  161,  161,  161,  181,   69,  158,  166,
			  166,  166,  167,  167,  167,  181,  158,  168,  168,  168,
			  169,   67,  190,  169,  170,  170,  170,  168,  172,  172,
			  172,  190,   42,  169,  170,  173,  173,  173,  176,  176,
			  176,  176,  180,  180,  180,  184,  184,  184,  185,  185,
			  185,  185,  180,   37,   29,  184,  186,  186,  186,  188,
			  188,  188,  189,  189,  189,  189,  186,  192,  193,  188,

			  191,  191,  191,  194,  194,  194,  192,  193,   17,    0,
			  191,  195,  195,  195,  196,  196,  196,  197,  197,  197,
			  199,  199,  199,  214,  196,    0,    0,  196,  196,  196,
			  200,  200,  214,    0,  200,  200,  200,  201,  201,  201,
			  202,  202,  202,  206,  206,  206,  196,  203,  203,  203,
			  210,  210,  210,  210,  209,  209,  209,  203,  209,    0,
			  203,  203,  203,  220,  209,  215,  215,  215,  219,  219,
			  219,    0,  220,    0,    0,  215,    0,    0,  219,  203,
			  221,  221,  221,  222,  222,  222,  223,  223,  223,    0,
			  221,    0,    0,  221,  221,  221,  224,  224,  224,  225,

			  225,  225,    0,    0,  221,  226,  226,  226,  227,  227,
			  227,  228,  228,  228,  231,  231,  231,    0,  227,    0,
			    0,  227,  227,  227,  232,  232,  232,  235,  235,  235,
			  239,  235,    0,    0,  238,  238,  238,  235,  240,  239,
			  227,  233,  233,  233,  238,    0,    0,  240,  241,  241,
			  241,  233,    0,    0,  233,  233,  233,  244,  244,    0,
			    0,  244,  244,  244,    0,  233,  245,  245,  245,  246,
			  246,  246,  247,  247,  247,  248,  248,  248,  251,  251,
			  251,    0,  247,  252,  252,  252,  248,  253,  253,  253,
			  254,  254,  254,  255,  255,  255,  247,  256,  256,  263,

			    0,  256,  256,  256,  247,  257,  257,  257,  263,  265,
			  265,  265,  258,  258,  258,  257,  258,    0,  257,  257,
			  257,    0,  258,  262,  262,  262,  267,  267,  267,  257,
			  272,  272,  272,  262,  266,  266,  266,  270,  270,    0,
			    0,  270,  270,  270,  266,    0,    0,  266,  266,  266,
			  271,  271,    0,    0,  271,  271,  271,  273,  273,  273,
			  275,  275,  275,  276,  276,  276,  277,  277,  277,    0,
			  275,    0,    0,  275,  275,  275,  281,  281,  281,  282,
			  282,    0,    0,  282,  282,  282,  284,  284,  284,    0,
			  284,  285,  285,  285,    0,    0,  284,  286,  286,  286,

			    0,  285,  288,  288,  288,  290,  290,  290,  291,  291,
			    0,    0,  291,  291,  291,    0,    0,  294,  294,  294,
			  296,  296,  296,  285,  287,  287,  287,  294,  297,  297,
			  297,  300,  300,  300,  287,    0,    0,  287,  287,  287,
			  304,  304,  304,    0,  303,  303,  303,    0,    0,  294,
			  308,  308,  308,    0,  303,    0,  287,  289,  289,  289,
			  311,  311,  311,    0,    0,    0,    0,  289,    0,    0,
			  289,  289,  289,  298,  298,  298,  303,    0,    0,    0,
			    0,    0,    0,  298,    0,    0,  298,  298,  298,  333,
			  333,    0,    0,  333,  333,  333,    0,    0,  333,    0,

			    0,    0,    0,    0,    0,  298,  305,  305,  305,    0,
			    0,    0,    0,    0,    0,    0,  305,    0,    0,  305,
			  305,  305,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  305,  313,
			  313,  313,  313,  313,  313,  313,  313,  313,  313,  313,
			  313,  313,  313,  313,  313,  313,  313,  313,  313,  313,
			  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
			  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
			  314,  315,  315,  315,  315,  315,  315,  315,  315,  315,
			  315,  315,  315,  315,  315,  315,  315,  315,  315,  315,

			  315,  315,  316,  316,  316,  316,  316,  316,  316,  316,
			  316,  316,  316,  316,  316,  316,  316,  316,  316,  316,
			  316,  316,  316,  317,  317,  317,  317,  317,  317,  317,
			  317,  317,  317,  317,  317,  317,  317,  317,  317,  317,
			  317,  317,  317,  317,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  318,  319,  319,  319,  319,  319,
			  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
			  319,  319,  319,  319,  319,  319,  320,  320,    0,  320,
			  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,

			  320,  320,  320,  320,  320,  320,  320,  321,  321,  321,
			  321,    0,    0,  321,  321,  321,  321,  321,  321,  321,
			  321,  321,  321,  321,  321,  321,  321,  321,  322,  322,
			    0,  322,  322,  322,  322,  322,  322,  322,  322,  322,
			  322,  322,  322,  322,  322,  322,  322,  322,  322,  323,
			  323,  323,    0,    0,    0,    0,  323,    0,    0,  323,
			  323,    0,    0,  323,  323,  323,  323,  323,  323,  324,
			  324,    0,  324,  324,  324,  324,  324,  324,  324,  324,
			  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
			  325,  325,  325,  325,  325,  325,  325,  325,  325,  325,

			  325,  325,  325,  325,  325,  325,  325,  325,  325,  325,
			  325,  326,  326,  326,  326,  326,  326,  326,  326,  326,
			  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
			  326,  326,  327,  327,  327,  327,  327,  327,  327,  327,
			  327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
			  327,  327,  327,  328,  328,    0,  328,  328,  328,  328,
			  328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
			  328,  328,  328,  328,  329,  329,  329,  329,    0,    0,
			  329,    0,    0,  329,  329,  329,  329,    0,  329,  330,
			  330,    0,  330,  330,  330,  330,  330,  330,  330,  330,

			  330,  330,  330,  330,  330,  330,  330,  330,  330,  330,
			  331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
			  331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
			  331,  332,  332,  332,  332,  332,  332,  332,  332,  332,
			    0,  332,  332,  332,  332,  332,  332,  332,  332,  332,
			  332,  332,  334,  334,  334,  334,  334,  334,  334,  334,
			  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
			  334,  334,  334,  335,  335,  335,  335,    0,    0,  335,
			    0,    0,  335,  335,  335,  335,    0,  335,  336,  336,
			  336,  336,  336,  336,  336,  336,  336,  336,  336,  336,

			  336,  336,  336,  336,  336,  336,  336,  336,  336,  337,
			  337,    0,  337,  337,  337,  337,  337,  337,  337,  337,
			  337,  337,  337,  337,  337,  337,  337,  337,  337,  337,
			  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
			  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
			  338,  339,  339,  339,  339,  339,  339,  339,  339,  339,
			  339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
			  339,  339,  340,  340,  340,  340,  340,  340,  340,  340,
			  340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
			  340,  340,  340,  341,  341,  341,  341,  341,  341,  341,

			  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
			  341,  341,  341,  341,  342,  342,  342,  342,  342,  342,
			  342,  342,  342,    0,  342,  342,  342,  342,  342,  342,
			  342,  342,  342,  342,  342,  343,  343,  343,  343,  343,
			  343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
			  343,  343,  343,  343,  343,  343,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   39,   42,   44,   50,   57,   60,   67,
			   70,   73,   76,   79,   84,   45,   63,  608, 1656,   89,
			   92,   95,  102,  111,   94,  116,  136,  122,  152,  544,
			  191,  158,   70,   36,  169,  119,  197,  551,  129, 1656,
			  208,  211,  550,  121, 1656,  215,  236, 1656,  194, 1656,
			 1656, 1656,  155, 1656, 1656,  180, 1656,  171,  275, 1656,
			  280, 1656,  225,  102, 1656,  176,  285,  539,  288,  525,
			  135,  291,  303,  512,  312,  319, 1656,  516,  506,  510,
			  218,  323,  342, 1656,  495,  375,  313,  316,  335,  400,
			    0, 1656,  494,  193,  273,  333,  346,  362,  489,  339,

			  124,  369,  482, 1656,  479, 1656,  380, 1656,  391,  179,
			  381, 1656,  403, 1656, 1656,  406, 1656,  416, 1656,  382,
			 1656,  418, 1656,  423,  429,  433, 1656,  439,  446,  187,
			 1656,  231, 1656,  357,  411, 1656,  471,  449,  461,  293,
			  455,  471, 1656,  478,  467,  469,  485,  443,  491,  448,
			 1656,  442,  483,  493,  496, 1656, 1656,  432,  512,  506,
			  515,  518, 1656,  428, 1656,  426,  524,  527,  545,  524,
			  552,  454,  543,  563, 1656, 1656,  554, 1656,  401,  456,
			  570,  533, 1656,  388,  573,  564,  584,  387,  587,  578,
			  549,  598,  594,  595,  588,  596,  612,  602, 1656,  605,

			  619,  622,  625,  645,  272,  283,  628, 1656,  377,  652,
			  636,  422, 1656,  363,  620,  663,  358,  347,  343,  666,
			  660,  678,  668,  671,  681,  684,  690,  706,  696, 1656,
			  340,  699,  709,  739,  306,  725, 1656,  329,  732,  727,
			  735,  746, 1656,  324,  746,  751,  754,  770,  760, 1656,
			  312,  763,  768,  772,  775,  778,  786,  803,  810, 1656,
			  292,  277,  821,  796, 1656,  794,  832,  811, 1656,  193,
			  826,  839,  815,  842,  190,  858,  848,  851, 1656, 1656,
			  138,  861,  868,  144,  884,  889,  882,  922,  887,  955,
			  890,  897, 1656,  123,  915, 1656,  905,  913,  971, 1656,

			  916, 1656,  104,  942,  925, 1004, 1656,   99,  935, 1656,
			   88,  945, 1656, 1038, 1059, 1080, 1101, 1122, 1143, 1164,
			 1185, 1206, 1227, 1247, 1268, 1289, 1310, 1331, 1352, 1369,
			 1388, 1409, 1430,  977, 1451, 1468, 1487, 1508, 1529, 1550,
			 1571, 1592, 1613, 1634>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  312,    1,  313,  313,  314,  314,  315,  315,  316,
			  316,  317,  317,  318,  318,  319,  319,  312,  312,  312,
			  312,  312,  320,  321,  322,  312,  312,  312,  312,   28,
			  312,  312,   27,   32,  312,  323,  323,  312,  312,  312,
			  312,  312,  312,  324,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  325,  325,  312,
			  325,  312,  326,  327,  312,  327,  312,  312,  312,  312,
			  320,  312,  328,  329,  320,  321,  312,  312,  330,  312,
			  331,  312,  312,  312,  312,  332,   28,   30,  312,  312,
			  333,  312,  312,   36,   36,   89,  312,  312,  312,  334,

			  324,  312,  335,  312,  312,  312,  312,  312,  312,  324,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  325,
			  312,  325,  312,  325,  325,  326,  312,  326,  312,  327,
			  312,  327,  312,  331,  336,  312,  312,  312,  328,  337,
			  312,  320,  312,  312,  312,  312,  312,  338,  312,  312,
			  312,  312,   82,  312,  312,  312,  312,  312,  312,  312,
			   86,   87,  312,  312,  312,  312,   89,  166,  333,   36,
			  312,  334,  312,  312,  312,  312,  312,  312,  312,  331,
			  312,  336,  312,  312,  312,  312,  312,  312,  312,  312,
			  338,  312,  338,  339,  152,  312,  312,  312,  312,  158,

			  312,  312,  312,  312,  160,  161,  167,  312,  312,  323,
			  312,  324,  312,  312,  340,  312,  312,  312,  312,  312,
			  339,  312,  196,  312,  312,  199,  312,  312,  312,  312,
			  312,  203,  312,  332,  167,  312,  312,  312,  312,  340,
			  341,  312,  312,  312,  312,  222,  312,  312,  221,  312,
			  312,  227,  312,  312,  231,  312,  312,  342,  312,  312,
			  312,  343,  312,  341,  312,  312,  312,  312,  312,  312,
			  312,  312,  251,  312,  247,  312,  312,  312,  312,  312,
			  312,  274,  312,  343,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  281,  312,  312,  312,

			  287,  312,  312,  312,  312,  312,  312,  312,  298,  312,
			  312,  305,    0,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  312,  312,  312>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    5,    6,    7,    5,    8,    7,    9,
			   10,   10,    5,   11,    5,   12,   13,   14,   15,   16,
			   17,   17,   17,   17,   17,   17,   17,   17,   18,    5,
			   19,   20,   21,   22,    7,   23,   24,   25,   23,   26,
			   23,   27,   28,   27,   27,   27,   28,   27,   29,   30,
			   27,   28,   28,   28,   28,   28,   28,   27,   27,   27,
			   27,   31,   32,   33,    5,   34,    1,   35,   36,   37,

			   35,   26,   35,   27,   38,   27,   27,   27,   38,   27,
			   39,   30,   27,   38,   38,   38,   38,   38,   38,   27,
			   40,   27,   27,    5,    7,    5,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    4,    1,    5,    1,    6,    7,
			    8,    1,    9,   10,   11,   12,   12,   13,    1,   14,
			    1,   15,    1,   16,   16,   17,   18,    2,   19,   19,
			   20,    1,    1,    1,    2,   12,   12,   21,    2,    2,
			    2>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    2,    3,    4,    5,    6,    8,
			   12,   15,   18,   21,   24,   27,   30,   33,   36,   42,
			   48,   54,   57,   60,   63,   66,   70,   74,   76,   78,
			   80,   84,   87,   89,   91,   93,   96,   98,  100,  102,
			  104,  107,  109,  111,  113,  115,  117,  119,  121,  123,
			  125,  127,  129,  131,  133,  135,  137,  139,  139,  141,
			  141,  142,  146,  147,  147,  149,  150,  151,  152,  153,
			  155,  156,  157,  161,  163,  163,  164,  168,  172,  174,
			  176,  176,  177,  177,  179,  181,  184,  185,  187,  187,

			  188,  189,  191,  191,  192,  192,  193,  194,  195,  196,
			  198,  200,  202,  202,  203,  204,  204,  205,  205,  206,
			  207,  208,  209,  210,  211,  212,  213,  215,  216,  219,
			  220,  221,  222,  224,  225,  226,  228,  228,  234,  236,
			  237,  237,  238,  239,  240,  241,  243,  244,  246,  248,
			  248,  250,  250,  254,  254,  254,  255,  257,  258,  262,
			  263,  267,  271,  272,  272,  273,  273,  275,  277,  279,
			  281,  282,  283,  283,  283,  284,  286,  287,  288,  288,
			  289,  290,  291,  294,  294,  296,  296,  298,  298,  299,
			  300,  302,  304,  306,  307,  311,  311,  315,  315,  316,

			  320,  320,  320,  320,  324,  328,  332,  334,  335,  335,
			  337,  337,  339,  340,  340,  341,  343,  343,  344,  344,
			  345,  346,  348,  352,  352,  352,  356,  356,  364,  364,
			  366,  366,  370,  370,  371,  374,  375,  376,  376,  377,
			  378,  379,  380,  381,  381,  381,  385,  385,  387,  389,
			  393,  393,  401,  401,  401,  405,  405,  406,  407,  407,
			  409,  409,  410,  411,  412,  413,  413,  415,  415,  416,
			  416,  416,  416,  424,  424,  426,  428,  428,  428,  429,
			  431,  432,  434,  435,  435,  435,  437,  437,  439,  439,
			  443,  443,  443,  444,  444,  446,  447,  449,  449,  451,

			  452,  454,  456,  456,  460,  460,  464,  465,  465,  467,
			  469,  469,  473,  473>>)
		end

	yy_acclist_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   38,   38,   41,   41,   91,   89,   90,   84,   85,
			   89,   90,   84,   85,   90,    1,   89,   90,   44,   89,
			   90,   12,   89,   90,   25,   89,   90,    1,   89,   90,
			    1,   89,   90,    1,   89,   90,   64,   68,   89,   90,
			 -155, -159,   64,   68,   89,   90, -155, -159,   64,   68,
			   89,   90, -155, -159,    1,   89,   90,    1,   89,   90,
			    1,   89,   90,    1,   89,   90,   10,   89,   90, -101,
			   10,   89,   90, -101,   89,   90,   89,   90,   88,   90,
			   86,   87,   88,   90,   86,   87,   90,   88,   90,   51,
			   90,   56,   90,   52,   90, -143,   55,   90,   61,   90,

			   61,   90,   60,   90,   59,   61,   90,   58,   90,   58,
			   90,   57,   90,   32,   90,   32,   90,   31,   90,   38,
			   90,   38,   90,   37,   90,   38,   90,   35,   90,   38,
			   90,   41,   90,   40,   90,   41,   90,   84,   85,    2,
			    3,   44,   28,   42, -119, -133,   44,   44, -120,   12,
			   13,   25,   25,   24,   25,   85,    4,   77,   83, -164,
			 -170,  -65,  -69, -162,   64,   68, -155, -159,   64,   68,
			 -155, -159,   62, -153,   68, -159,  -11,   10, -101,   10,
			 -101,   67,   68, -159,   67,   86,   87,   87,   51,   52,
			 -143,  -53,   54,   54,   45,   54,   51,   54,   49,   54,

			   50,   54,   60,   59,   57,   31,   38,   37,   38,   35,
			   38,   38,   38,   36,   37,   38,   33,   35, -124,   41,
			   40,   41,   39,   40,   85,    3,  -29,  -43,   26,   28,
			   42, -117, -119, -133,   44, -120,   44,   44,  -30,   14,
			   25,   23,   25,   85,    3,   85,    5,    6,  -74,  -80,
			   77,   83, -164, -170,   75,  -72,   75,   75,   77,   83,
			 -164, -170,   75,   64,   68, -155, -159,   64,   68, -155,
			 -159,  -63,  -69,   68, -159,   68, -159,   70, -161,   10,
			 -101,   87,   87,   46,   45,   46,   48,  -34,   85,    3,
			    3,  -27,  -29,  -43,   42, -133,   15,   16,   17,   22,

			    3,   85,    3,   85,    3,   85,    6,   77,   83, -164,
			 -170,   77,   83, -164, -170,  -72,   77,   83, -164, -170,
			   76,   82, -163, -169,   64,   68, -155, -159,   64,   68,
			 -155, -159,   68, -159,  -71,   10, -101,   47,   51,  -43,
			   16,   18,   19,   25,    6,    6,   77, -164,   77,   83,
			 -164, -170,   77,   83, -164, -170,   76,   77,   82,   83,
			 -163, -164, -169, -170,  -73,  -79,   76,   82, -163, -169,
			 -162,   66,   68, -159,  -11,    7,   16,   16,   19,   20,
			  -74,   77,   83, -164, -170,   83, -170,   77, -164,  -73,
			  -74,  -79,  -80,   76,   77,   82,   83, -163, -164, -169,

			 -170,   76,   82, -163, -169,   75, -168,    8,    9,  -11,
			   19,   19,   21,   77, -164,  -80,   76,   77,   82,   83,
			 -163, -164, -169, -170,   83, -170,   76, -163,   81,  -78,
			   81,   81,   83, -170,   81,   83, -170,   83, -170,   76,
			   77, -163, -164,  -73,   82, -169,  -78,   83, -170,   82,
			 -169,    9,   83, -170,  -73,  -74,   82,   83, -169, -170,
			   82,   83, -169, -170,  -79,   82, -169,  -79,  -80,   82,
			   83, -169, -170>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 1656
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 312
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 313
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is true
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is true
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 90
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 91
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	BREAK: INTEGER is 1
	MS: INTEGER is 2
	MSN: INTEGER is 3
	MSN1: INTEGER is 4
	VS1: INTEGER is 5
	VS2: INTEGER is 6
	VS3: INTEGER is 7
			-- Start condition codes

feature -- User-defined features



end
