indexing

	description: 

		"Scanners for an XML parser"

	implements: "XML 1.0 Second Edition - W3C Recommendation 6 October 2000 (referred as 'XML1.0')"
	noncompliance_unicode: "UTF8 is assumed and all chars >255 are assumed to be LETTERS"

	library: "Gobo XML library"
	copyright: "Copyright (c) 2002, Eric Bezault and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: 2002/12/13 16:50:06 $"
	revision: "$Revision: 1.6 $"

	-- TODO:
	-- system literal accepts non-CHAR
	-- use NOAPOSCHAR/NOQUOTCHAR for attribute value?

class XM_EIFFEL_SCANNER

inherit

	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_scanner_stdin
		redefine
			set_input_buffer,
			reset, fatal_error
		end

	XM_EIFFEL_TOKENS
		export {NONE} all end

	XM_EIFFEL_PARSER_ERRORS
		export {NONE} all end

creation

	make_scanner


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= dtd_ignore)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 69 then
if yy_act <= 35 then
if yy_act <= 18 then
if yy_act <= 9 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + 4
	yy_position := yy_position + 4
--|#line 139 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 139")
end
 
			set_last_token (COMMENT_START)
			push_start_condition (comment_state)
		
else
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 147 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 147")
end

			set_last_token (COMMENT_END)
			pop_start_condition
		
end
else
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 152 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 152")
end
 
			set_last_token (COMMENT_DASHDASH) -- conformance error XML1.0:2.5
			last_value := text
		
end
else
if yy_act = 4 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 157 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 157")
end

			set_last_token (CHARDATA)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 162 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 162")
end

			set_last_token (CHARDATA_UTF8)
			last_value := text
		
end
end
else
if yy_act <= 7 then
if yy_act = 6 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 167 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 167")
end

			set_last_token (CHARDATA)
			last_value := text
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 178 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 178")
end

			set_last_token (XMLDECLARATION_START)
			push_start_condition (xmldeclaration)
		
end
else
if yy_act = 8 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 183 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 183")
end

				-- "<?xml" matched by previous rule when allowed.
			set_last_token (PI_RESERVED)
		
else
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 187 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 187")
end

				-- <?xml caught by previous rules.
			set_last_token (PI_START)
			push_start_condition (processinginstruction)
		
end
end
end
else
if yy_act <= 14 then
if yy_act <= 12 then
if yy_act <= 11 then
if yy_act = 10 then
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 196 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 196")
end

			set_last_token (XMLDECLARATION_END)
			pop_start_condition
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 202 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 202")
end

			set_last_token (XMLDECLARATION_VERSION) 
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 207 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 207")
end

			set_last_token (XMLDECLARATION_STANDALONE_YES) 
		
end
else
if yy_act = 13 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 211 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 211")
end

			set_last_token (XMLDECLARATION_STANDALONE_NO) 
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 215 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 215")
end

			set_last_token (XMLDECLARATION_ENCODING)
		
end
end
else
if yy_act <= 16 then
if yy_act = 15 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 219 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 219")
end
 
			set_last_token (SPACE) 
		
else
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 226 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 226")
end

			set_last_token (PI_END)
			pop_start_condition
		
end
else
if yy_act = 17 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 230 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 230")
end

			set_last_token (PI_TARGET)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 235 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 235")
end

			set_last_token (PI_TARGET_UTF8)
			last_value := text
		
end
end
end
end
else
if yy_act <= 27 then
if yy_act <= 23 then
if yy_act <= 21 then
if yy_act <= 20 then
if yy_act = 19 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 240 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 240")
end

			set_last_token (SPACE)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 244 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 244")
end

			set_last_token (CHARDATA)
			last_value := text
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 248 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 248")
end

			set_last_token (CHARDATA_UTF8)
			last_value := text
		
end
else
if yy_act = 22 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 253 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 253")
end
 
			set_last_token (CHARDATA) 
			last_value := text
		
else
	yy_column := yy_column + 9
	yy_position := yy_position + 9
--|#line 261 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 261")
end

	set_last_token (CDATA_START)
	push_start_condition (cdata)

end
end
else
if yy_act <= 25 then
if yy_act = 24 then
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 268 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 268")
end
 
			set_last_token (CDATA_END) 
			pop_start_condition
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 272 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 272")
end

				-- End of line handling XML1.0:2.11.
			set_last_token (CHARDATA)
			last_value := normalized_newline
		
end
else
if yy_act = 26 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 278 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 278")
end

			set_last_token (CHARDATA)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 282 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 282")
end

				-- Big chunks in `last_value'.
			set_last_token (CHARDATA_UTF8)
			last_value := text
		
end
end
end
else
if yy_act <= 31 then
if yy_act <= 29 then
if yy_act = 28 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 288 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 288")
end
 
			set_last_token (CHARDATA) 
			last_value := text
		
else
	yy_column := yy_column + 9
	yy_position := yy_position + 9
--|#line 294 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 294")
end

		set_last_token (DOCTYPE_START)
		push_start_condition (dtd_in)
	
end
else
if yy_act = 30 then
	yy_column := yy_column + 9
	yy_position := yy_position + 9
--|#line 301 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 301")
end
 set_last_token (DOCTYPE_REQUIRED) 
else
	yy_column := yy_column + 8
	yy_position := yy_position + 8
--|#line 302 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 302")
end
 set_last_token (DOCTYPE_IMPLIED) 
end
end
else
if yy_act <= 33 then
if yy_act = 32 then
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 303 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 303")
end
 set_last_token (DOCTYPE_FIXED) 
else
	yy_column := yy_column + 5
	yy_position := yy_position + 5
--|#line 304 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 304")
end

			set_last_token (DOCTYPE_ATT_CDATA) 
			last_value := text
		
end
else
if yy_act = 34 then
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 308 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 308")
end

			set_last_token (DOCTYPE_ATT_ID) 
			last_value := text
		
else
	yy_column := yy_column + 5
	yy_position := yy_position + 5
--|#line 312 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 312")
end

			set_last_token (DOCTYPE_ATT_IDREF)
			last_value := text
		
end
end
end
end
end
else
if yy_act <= 52 then
if yy_act <= 44 then
if yy_act <= 40 then
if yy_act <= 38 then
if yy_act <= 37 then
if yy_act = 36 then
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 316 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 316")
end

			set_last_token (DOCTYPE_ATT_IDREFS)
			last_value := text
		
else
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 320 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 320")
end

			set_last_token (DOCTYPE_ATT_ENTITY)
			last_value := text
		
end
else
	yy_column := yy_column + 8
	yy_position := yy_position + 8
--|#line 324 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 324")
end

			set_last_token (DOCTYPE_ATT_ENTITIES) 
			last_value := text
		
end
else
if yy_act = 39 then
	yy_column := yy_column + 7
	yy_position := yy_position + 7
--|#line 328 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 328")
end

			set_last_token (DOCTYPE_ATT_NMTOKEN) 
			last_value := text
		
else
	yy_column := yy_column + 8
	yy_position := yy_position + 8
--|#line 332 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 332")
end

			set_last_token (DOCTYPE_ATT_NMTOKENS)
			last_value := text
		
end
end
else
if yy_act <= 42 then
if yy_act = 41 then
	yy_column := yy_column + 8
	yy_position := yy_position + 8
--|#line 336 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 336")
end

			set_last_token (DOCTYPE_ATT_NOTATION)
			last_value := text
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 340 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 340")
end

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_single)
		
end
else
if yy_act = 43 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 344 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 344")
end

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_double)
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 352 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 352")
end

			set_last_token (DOCTYPE_DECLARATION_START)
			push_start_condition (doctype)
		
end
end
end
else
if yy_act <= 48 then
if yy_act <= 46 then
if yy_act = 45 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 362 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 362")
end

			set_last_token (DOCTYPE_DECLARATION_START)
			push_start_condition (doctype) -- Same, but balances end.
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 367 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 367")
end

			set_last_token (DOCTYPE_DECLARATION_END)
			pop_start_condition
		
end
else
if yy_act = 47 then
	yy_column := yy_column + 9
	yy_position := yy_position + 9
--|#line 372 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 372")
end

			set_last_token (DOCTYPE_ELEMENT)
			push_start_condition (dtd_element)
		
else
	yy_column := yy_column + 9
	yy_position := yy_position + 9
--|#line 376 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 376")
end

			set_last_token (DOCTYPE_ATTLIST)
			push_start_condition (dtd_attlist)
		
end
end
else
if yy_act <= 50 then
if yy_act = 49 then
	yy_column := yy_column + 8
	yy_position := yy_position + 8
--|#line 380 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 380")
end

			set_last_token (DOCTYPE_ENTITY)
			push_start_condition (dtd_entity)
		
else
	yy_column := yy_column + 10
	yy_position := yy_position + 10
--|#line 384 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 384")
end

			set_last_token (DOCTYPE_NOTATION)
			push_start_condition (dtd_notation)
		
end
else
if yy_act = 51 then
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 389 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 389")
end

			set_last_token (DOCTYPE_IGNORE)
			last_value := text
		
else
	yy_column := yy_column + 7
	yy_position := yy_position + 7
--|#line 394 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 394")
end

			set_last_token (DOCTYPE_INCLUDE)
			last_value := text
		
end
end
end
end
else
if yy_act <= 61 then
if yy_act <= 57 then
if yy_act <= 55 then
if yy_act <= 54 then
if yy_act = 53 then
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 399 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 399")
end

			set_last_token (DOCTYPE_CONDITIONAL_START)
		
else
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 403 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 403")
end

			set_last_token (DOCTYPE_CONDITIONAL_END)
		
end
else
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 410 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 410")
end

			set_last_token (DOCTYPE_CONDITIONAL_START)
			push_start_condition (dtd_ignore) -- Self, for exit.
		
end
else
if yy_act = 56 then
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 415 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 415")
end

			set_last_token (DOCTYPE_CONDITIONAL_END)
			pop_start_condition
		
else
	yy_column := yy_column + 4
	yy_position := yy_position + 4
--|#line 420 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 420")
end

			set_last_token (CHARDATA)
		
end
end
else
if yy_act <= 59 then
if yy_act = 58 then
	yy_column := yy_column + 7
	yy_position := yy_position + 7
--|#line 427 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 427")
end
 set_last_token (DOCTYPE_PCDATA) 
else
	yy_column := yy_column + 5
	yy_position := yy_position + 5
--|#line 429 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 429")
end

			set_last_token (DOCTYPE_ELEMENT_EMPTY)
			last_value := text
		
end
else
if yy_act = 60 then
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 434 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 434")
end

			set_last_token (DOCTYPE_ELEMENT_ANY)
			last_value := text
		
else
	yy_column := yy_column + 5
	yy_position := yy_position + 5
--|#line 442 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 442")
end

			set_last_token (DOCTYPE_NDATA)
			last_value := text
		
end
end
end
else
if yy_act <= 65 then
if yy_act <= 63 then
if yy_act = 62 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 450 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 450")
end
 
			set_last_token (DOCTYPE_END)
			pop_start_condition
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 455 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 455")
end
 
			set_last_token (NAME) 
			last_value := text
		
end
else
if yy_act = 64 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 459 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 459")
end
 
			set_last_token (NAME_UTF8) 
			last_value := text
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 463 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 463")
end

			set_last_token (SPACE)
		
end
end
else
if yy_act <= 67 then
if yy_act = 66 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 480 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 480")
end

			set_last_token (DOCTYPE_SYSTEM)
			last_value := system_literal_text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 485 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 485")
end

			set_last_token (DOCTYPE_SYSTEM_UTF8)
			last_value := system_literal_text
		
end
else
if yy_act = 68 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 490 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 490")
end

			set_last_token (DOCTYPE_SYSTEM_UTF8)
			last_value := system_literal_text
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 495 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 495")
end

			set_last_token (DOCTYPE_PUBLIC)
			last_value := system_literal_text
		
end
end
end
end
end
end
else
if yy_act <= 104 then
if yy_act <= 87 then
if yy_act <= 78 then
if yy_act <= 74 then
if yy_act <= 72 then
if yy_act <= 71 then
if yy_act = 70 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 504 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 504")
end
 set_last_token (DOCTYPE_GROUP_OR) 
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 505 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 505")
end
 set_last_token (DOCTYPE_GROUP_SEQ) 
end
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 506 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 506")
end
 set_last_token (DOCTYPE_GROUP_START) 
end
else
if yy_act = 73 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 507 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 507")
end
 set_last_token (DOCTYPE_GROUP_END) 
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 508 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 508")
end
 set_last_token (DOCTYPE_GROUP_ZEROONE) 
end
end
else
if yy_act <= 76 then
if yy_act = 75 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 509 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 509")
end
 set_last_token (DOCTYPE_GROUP_ANY) 
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 510 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 510")
end
 set_last_token (DOCTYPE_GROUP_ONEMORE) 
end
else
if yy_act = 77 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 512 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 512")
end

			set_last_token (NMTOKEN) 
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 516 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 516")
end

			set_last_token (NMTOKEN_UTF8) 
			last_value := text
		
end
end
end
else
if yy_act <= 83 then
if yy_act <= 81 then
if yy_act <= 80 then
if yy_act = 79 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 524 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 524")
end
 
			set_last_token (DOCTYPE_PERCENT) 
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 527 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 527")
end

			set_last_token (VALUE_START)
			push_start_condition (entity_value_single)
		
end
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 531 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 531")
end

			set_last_token (VALUE_START)
			push_start_condition (entity_value_double)
		
end
else
if yy_act = 82 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 539 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 539")
end

			set_last_token (DOCTYPE_PEREFERENCE)
			last_value := text_substring (2, text_count - 1)
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 544 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 544")
end

			set_last_token (DOCTYPE_PEREFERENCE_UTF8)
			last_value := text_substring (2, text_count - 1)
		
end
end
else
if yy_act <= 85 then
if yy_act = 84 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 548 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 548")
end

			set_last_token (ENTITY_INVALID)
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 555 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 555")
end

			set_last_token (ENTITYVALUE_PEREFERENCE)
			last_value := text_substring (2, text_count - 1)
		
end
else
if yy_act = 86 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 559 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 559")
end

			set_last_token (ENTITYVALUE_PEREFERENCE_UTF8)
			last_value := text_substring (2, text_count - 1)
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 567 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 567")
end

			set_last_token (ENTITY_INVALID)
		
end
end
end
end
else
if yy_act <= 96 then
if yy_act <= 92 then
if yy_act <= 90 then
if yy_act <= 89 then
if yy_act = 88 then
	yy_column := yy_column + 2
	yy_position := yy_position + 2
--|#line 574 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 574")
end

	set_last_token (TAG_START_END)
	push_start_condition (tag)

else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 579 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 579")
end

	set_last_token (TAG_START)
	push_start_condition (tag)

end
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 586 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 586")
end

			set_last_token (TAG_END_EMPTY)
			pop_start_condition
		
end
else
if yy_act = 91 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 591 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 591")
end
 
			set_last_token (TAG_END) 
			pop_start_condition
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 597 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 597")
end

			 set_last_token (TAG_NAME_COLON) 
		
end
end
else
if yy_act <= 94 then
if yy_act = 93 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 600 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 600")
end
 
			set_last_token (TAG_NAME_FIRST)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 604 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 604")
end
 
			set_last_token (TAG_NAME_FIRST_UTF8)
			last_value := text
		
end
else
if yy_act = 95 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 608 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 608")
end
 
			set_last_token (TAG_NAME_ATOM) 
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 612 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 612")
end
 
			set_last_token (TAG_NAME_ATOM_UTF8) 
			last_value := text
		
end
end
end
else
if yy_act <= 100 then
if yy_act <= 98 then
if yy_act = 97 then
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 616 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 616")
end

			set_last_token (SPACE) 
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 619 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 619")
end

			set_last_token (EQ) 
		
end
else
if yy_act = 99 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 623 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 623")
end
 
			set_last_token (VALUE_START) 
			push_start_condition (attribute_value_single)
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 627 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 627")
end

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_double)
		
end
end
else
if yy_act <= 102 then
if yy_act = 101 then
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 640 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 640")
end

				set_last_token (CHARDATA)
				last_value := "%'"
			
else
	yy_column := yy_column + 6
	yy_position := yy_position + 6
--|#line 644 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 644")
end

				set_last_token (CHARDATA)
				last_value := "%""
			
end
else
if yy_act = 103 then
	yy_column := yy_column + 4
	yy_position := yy_position + 4
--|#line 648 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 648")
end

				set_last_token (CHARDATA)
				last_value := "<"
			
else
	yy_column := yy_column + 4
	yy_position := yy_position + 4
--|#line 652 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 652")
end

				set_last_token (CHARDATA)
				last_value := ">"
			
end
end
end
end
end
else
if yy_act <= 121 then
if yy_act <= 113 then
if yy_act <= 109 then
if yy_act <= 107 then
if yy_act <= 106 then
if yy_act = 105 then
	yy_column := yy_column + 5
	yy_position := yy_position + 5
--|#line 656 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 656")
end

				set_last_token (CHARDATA)
				last_value := "&"
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 664 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 664")
end
 
				set_last_token (CONTENT_ENTITY) 
				last_value := text_substring (2, text_count - 1)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 668 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 668")
end
 
				set_last_token (CONTENT_ENTITY_UTF8) 
				last_value := text_substring (2, text_count - 1)
			
end
else
if yy_act = 108 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 676 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 676")
end
 
				set_last_token (CHARDATA) -- Bypassed
				last_value := text
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 680 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 680")
end
 
				set_last_token (CHARDATA_UTF8) -- Bypassed
				last_value := text
			
end
end
else
if yy_act <= 111 then
if yy_act = 110 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 687 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 687")
end

			set_last_token (CHARDATA)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 695 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 695")
end
 
				set_last_token (ATTRIBUTE_ENTITY)
				last_value := text_substring (2, text_count - 1)
			
end
else
if yy_act = 112 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 699 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 699")
end
 
				set_last_token (ATTRIBUTE_ENTITY_UTF8)
				last_value := text_substring (2, text_count - 1)
			
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 704 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 704")
end

			set_last_token (ATTRIBUTE_LT) -- Conformance error.
			last_value := text
		
end
end
end
else
if yy_act <= 117 then
if yy_act <= 115 then
if yy_act = 114 then
	yy_line := yy_line + 1
	yy_column := 1
	yy_position := yy_position + 2
--|#line 708 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 708")
end

				-- XML1.0:3.3.3 Attribute value normalization.
			set_last_token (CHARDATA)
			if has_normalized_newline then
				last_value := two_normalized_spaces
			else
				last_value := normalized_space
			end
		
else
yy_set_line_column
	yy_position := yy_position + 1
--|#line 717 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 717")
end

				-- XML1.0:3.3.3 Attribute value normalization.
			set_last_token (CHARDATA)
			last_value := normalized_space
		
end
else
if yy_act = 116 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 722 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 722")
end

			set_last_token (CHARDATA)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 726 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 726")
end

			set_last_token (CHARDATA_UTF8)
			last_value := text
		
end
end
else
if yy_act <= 119 then
if yy_act = 118 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 734 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 734")
end
 
			character_entity.from_decimal (text_substring (3, text_count - 1))
			if character_entity.is_valid then
				if character_entity.is_ascii then
					set_last_token (CHARDATA)
				else
					set_last_token (CHARDATA_UTF8)
				end
				last_value := character_entity.to_utf8
			else
				set_last_token (ENTITY_INVALID)
			end
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 748 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 748")
end

			character_entity.from_hexadecimal (text_substring (4, text_count - 1))
			if character_entity.is_valid then
				if character_entity.is_ascii then
					set_last_token (CHARDATA)
				else
					set_last_token (CHARDATA_UTF8)
				end
				last_value := character_entity.to_utf8
			else
				set_last_token (ENTITY_INVALID)
			end
		
end
else
if yy_act = 120 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 763 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 763")
end

			set_last_token (ENTITY_INVALID)
			last_value := text
		
else
yy_set_line_column
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 771 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 771")
end

				-- End of line handling XML1.0:2.11.
			set_last_token (CHARDATA)
			last_value := normalized_newline
		
end
end
end
end
else
if yy_act <= 130 then
if yy_act <= 126 then
if yy_act <= 124 then
if yy_act <= 123 then
if yy_act = 122 then
yy_set_line_column
	yy_position := yy_position + 1
--|#line 776 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 776")
end

			set_last_token (CHARDATA)
			last_value := text			
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 780 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 780")
end

			set_last_token (CHARDATA)
			last_value := text
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 784 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 784")
end

			set_last_token (CHARDATA_UTF8)
			last_value := text
		
end
else
if yy_act = 125 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 792 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 792")
end
 
			set_last_token (VALUE_END) 
			pop_start_condition
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 796 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 796")
end

			set_last_token (CHARDATA) 
			last_value := text
		
end
end
else
if yy_act <= 128 then
if yy_act = 127 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 804 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 804")
end

			set_last_token (VALUE_END)
			pop_start_condition
		
else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 808 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 808")
end

			set_last_token (CHARDATA) 
			last_value := text
		
end
else
if yy_act = 129 then
	yy_column := yy_column + 3
	yy_position := yy_position + 3
--|#line 816 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 816")
end

		-- XML1.0:14 ]]> not allowed in markup.
	last_token := CONTENT_CONDITIONAL_END
	last_value := text

else
	yy_line := yy_line + 1
	yy_column := 1
	yy_position := yy_position + 2
--|#line 822 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 822")
end

		-- End of line handling XML1.0:2.11.
	set_last_token (SPACE)
	last_value := normalized_newline

end
end
end
else
if yy_act <= 134 then
if yy_act <= 132 then
if yy_act = 131 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 828 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 828")
end
 
	set_last_token (SPACE) 
	last_value := normalized_newline

else
	yy_line := yy_line + 1
	yy_column := 1
	yy_position := yy_position + 1
--|#line 833 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 833")
end

	set_last_token (SPACE) 
	last_value := normalized_newline

end
else
if yy_act = 133 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 838 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 838")
end

		-- Space not matched by newline normalization.
	set_last_token (SPACE)
	last_value := text

else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 844 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 844")
end
 
	set_last_token (CHARDATA)
	last_value := text

end
end
else
if yy_act <= 136 then
if yy_act = 135 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
	yy_position := yy_position + yy_end - yy_start - yy_more_len
--|#line 849 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 849")
end
 
	set_last_token (CHARDATA_UTF8)
	last_value := text

else
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 854 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 854")
end

	set_last_token (CHARDATA)
	last_value := text

end
else
if yy_act = 137 then
	yy_column := yy_column + 1
	yy_position := yy_position + 1
--|#line 859 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 859")
end

		-- Default rule.
	set_last_token (INPUT_INVALID)
	last_value := text

else
yy_set_line_column
	yy_position := yy_position + 1
--|#line 0 "xm_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xm_eiffel_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			terminate
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		local
			an_array: ARRAY [INTEGER]
		once
			!! an_array.make (0, 4781)
			yy_nxt_template_1 (an_array)
			yy_nxt_template_2 (an_array)
			Result := yy_fixed_array (an_array)
		end

	yy_nxt_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			    0,   36,   37,   38,   39,   37,  336,  177,  157,  158,
			  177,   41,  177,  159,  849,  177,  849,  196,  849,  401,
			   36,  849,   50,  217,  217,  217,  217,  849,   36,   36,
			   50,  197,  849,   42,  649,  849,  198,   51,  147,  650,
			  160,  402,  161,  628,  849,   51,  162,  198,  849,  606,
			  163,  607,   36,  217,  217,  217,  217,  236,  236,  236,
			  236,  403,   43,  849,  126,   67,   68,   67,   67,   67,
			   68,   67,   67,   36,  391,   74,   75,  392,  834,  139,
			  446,   36,   36,  447,   74,   75,   36,   36,   36,   44,
			   45,   46,   47,   48,   36,   37,   38,   39,   37,   69,

			  834,   36,   36,   69,   41,   36,   36,   36,   52,   53,
			   54,   55,   56,   36,   36,   36,   52,   53,   54,   55,
			   56,  200,  200,  200,   36,   36,   42,  202,  202,  202,
			  830,   70,  203,  203,   76,   70,  126,  126,  204,  204,
			  204,  554,   71,   76,  830,   72,   71,  215,  215,   72,
			  848,  139,   36,   36,   36,   43,  234,  234,   36,   36,
			   36,   77,   78,   79,   80,   81,  554,   36,   36,   36,
			   77,   78,   79,   80,   81,  212,  212,  212,  847,   36,
			   36,   36,   44,   45,   46,   47,   48,   36,   57,   58,
			   57,   57,   59,   59,   59,   59,   59,   59,   59,   59,

			   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
			   59,   59,   59,   59,   59,   59,   59,   60,   59,   59,
			   59,   59,   61,   60,   60,   60,   60,   60,   60,   60,
			   60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
			   60,   60,   60,   60,   60,   60,   59,   59,   59,   60,
			   60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
			   60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
			   60,   59,   36,   36,   36,   62,   63,   64,   65,   66,
			   36,   82,   83,   82,   82,   36,   84,   36,   36,   36,
			   36,   85,   36,   36,   36,   36,   36,   86,   86,   87,

			   86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
			   88,   36,   36,   89,   90,   36,   91,   91,   91,   91,
			   91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
			   91,   91,   91,   91,   91,   91,   91,   91,   91,   36,
			   36,   36,   91,   91,   91,   91,   91,   91,   91,   91,
			   91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
			   91,   91,   91,   91,   36,   36,   36,   36,   92,   93,
			   94,   95,   96,   36,   97,   98,   99,   97,  404,  101,
			  157,  158,  846,  102,  103,  159,   36,  164,  252,  252,
			  165,  845,  166,  164,  844,   36,  165,  169,  166,  180,

			  181,  182,  183,  184,  405,  104,  214,  214,  214,   36,
			  147,  844,  160,   36,  161,  216,  216,  216,  162,   36,
			  813,  126,  163,  274,  274,  126,  843,  170,  840,  167,
			  814,  126,  185,  296,  296,  167,   36,  815,   36,   36,
			   36,  169,   36,  231,  231,  231,   36,  816,   36,  206,
			  207,  208,  209,  210,  321,  321,  171,  834,   36,   36,
			   36,  105,  106,  107,  108,  109,   36,   97,   98,   99,
			   97,  170,  101,  233,  233,  233,  102,  103,  345,  345,
			   36,   36,   36,  172,  173,  174,  175,  176,  187,  206,
			  207,  208,  209,  210,  188,  842,  189,  841,  104,  840,

			  171,  190,  219,  220,  221,  222,  223,  235,  235,  235,
			  249,  249,  249,  191,  192,  193,  194,  195,  236,  236,
			  236,  236,  365,  365,   36,   36,   36,  172,  173,  174,
			  175,  176,  242,  243,  244,  245,  246,  251,  251,  251,
			  253,  253,  253,  271,  271,  271,  254,  254,  254,  254,
			  185,   36,   36,   36,  105,  106,  107,  108,  109,   36,
			   97,   98,   99,   97,  255,  110,  273,  273,  273,  102,
			  111,  254,  254,  254,  254,  275,  275,  275,  256,  257,
			  259,  260,  261,  262,  263,  256,  256,  256,  256,  255,
			  311,  104,  266,  267,  268,  269,  270,  278,  279,  280,

			  281,  282,  367,  256,  257,  368,  284,  293,  293,  293,
			  381,  381,  285,  369,  286,  295,  295,  295,  830,  287,
			  297,  297,  297,  300,  301,  302,  303,  304,  318,  318,
			  318,  288,  289,  290,  291,  292,  306,  307,  308,  309,
			  310,  320,  320,  320,   36,   36,   36,  105,  106,  107,
			  108,  109,   36,   97,   98,   99,   97,  839,  110,  322,
			  322,  322,  102,  111,  323,  323,  323,  323,  339,  203,
			  203,  313,  314,  315,  316,  317,  323,  323,  323,  323,
			  838,  340,  399,  399,  104,  325,  326,  327,  328,  329,
			  331,  332,  333,  334,  335,  342,  342,  342,  344,  344,

			  344,  331,  332,  333,  334,  335,  346,  346,  346,  215,
			  215,  337,  331,  332,  333,  334,  335,  338,  349,  350,
			  351,  352,  353,  355,  356,  357,  358,  359,  360,  362,
			  362,  362,  361,  364,  364,  364,  370,   36,   36,   36,
			  105,  106,  107,  108,  109,   36,  112,  113,  114,  112,
			  371,  101,  372,  836,  116,  117,  103,  331,  332,  333,
			  334,  335,  366,  366,  366,  373,  375,  374,  355,  356,
			  357,  358,  359,  355,  356,  357,  358,  359,  378,  378,
			  378,  380,  380,  380,  837,  355,  356,  357,  358,  359,
			  355,  356,  357,  358,  359,  382,  382,  382,  200,  200,

			  200,  355,  356,  357,  358,  359,  355,  356,  357,  358,
			  359,  202,  202,  202,  836,  331,  332,  333,  334,  335,
			  180,  181,  182,  183,  184,  204,  204,  204,  415,  415,
			   36,   36,   36,  118,  119,  120,  121,  122,   36,  112,
			  113,  114,  112,  835,  101,  419,  419,  116,  117,  103,
			  383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
			  396,  396,  396,  398,  398,  398,  400,  400,  400,  180,
			  181,  182,  183,  184,  200,  200,  200,  200,  200,  200,
			  407,  407,  407,  408,  408,  408,  206,  207,  208,  209,
			  210,  212,  212,  212,  214,  214,  214,  216,  216,  216,

			  206,  207,  208,  209,  210,  212,  212,  212,  212,  212,
			  212,  554,  384,  410,  410,  410,  411,  411,  411,  217,
			  217,  217,  217,   36,   36,   36,  118,  119,  120,  121,
			  122,   36,  112,  113,  114,  112,  555,  110,  252,  252,
			  116,  117,  111,  219,  220,  221,  222,  223,  412,  412,
			  412,  414,  414,  414,  416,  416,  416,  231,  231,  231,
			  418,  418,  418,  420,  420,  420,  231,  231,  231,  231,
			  231,  231,  421,  421,  421,  422,  422,  422,  236,  236,
			  236,  236,  242,  243,  244,  245,  246,  249,  249,  249,
			  251,  251,  251,  253,  253,  253,  242,  243,  244,  245,

			  246,  249,  249,  249,  249,  249,  249,  427,  427,  427,
			  428,  428,  428,  429,  429,  429,   36,   36,   36,  118,
			  119,  120,  121,  122,   36,  112,  113,  114,  112,  832,
			  110,  432,  432,  116,  117,  111,  254,  254,  254,  254,
			  256,  256,  256,  256,  259,  260,  261,  262,  263,  431,
			  431,  431,  436,  436,  255,  433,  433,  433,  266,  267,
			  268,  269,  270,  271,  271,  271,  296,  296,  256,  257,
			  435,  435,  435,  437,  437,  437,  266,  267,  268,  269,
			  270,  271,  271,  271,  271,  271,  271,  438,  438,  438,
			  439,  439,  439,  278,  279,  280,  281,  282,  293,  293,

			  293,  295,  295,  295,  297,  297,  297,  454,  454,   36,
			   36,   36,  118,  119,  120,  121,  122,   36,  123,  124,
			  123,  123,   36,   36,   36,   36,  125,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,  126,   36,  127,
			   36,  128,   36,  126,  126,  126,  126,  126,  126,  126,
			  126,  129,  126,  126,  126,  126,  126,  130,  126,  126,
			  131,  126,  126,  126,  126,  126,  132,   36,  133,  126,
			  126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
			  126,  126,  126,  126,  126,  126,  126,  126,  126,  126,

			  126,   36,   36,   36,   36,  134,  135,  136,  137,  138,
			   36,  123,  124,  123,  123,   36,   36,  140,   36,  125,
			   36,   36,  141,  142,  143,  144,  145,  146,  146,   36,
			  146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
			  147,   36,   36,   36,  128,  148,  149,  147,  147,  147,
			  150,  147,  147,  147,  147,  147,  147,  147,  147,  147,
			  147,  147,  147,  147,  147,  147,  147,  147,  147,   36,
			   36,   36,  147,  147,  147,  147,  147,  147,  147,  147,
			  147,  147,  147,  147,  147,  147,  147,  147,  147,  147,
			  147,  147,  147,  147,  151,   36,   36,   36,  152,  153,

			  154,  155,  156,  218,  218,  218,  218,  218,  218,  218,
			  218,  218,  218,  218,  218,  321,  321,  218,  451,  451,
			  451,  453,  453,  453,  455,  455,  455,  467,  467,  218,
			  218,  218,  218,  278,  279,  280,  281,  282,  293,  293,
			  293,  293,  293,  293,  456,  456,  456,  457,  457,  457,
			  300,  301,  302,  303,  304,  480,  480,  218,  218,  218,
			  318,  318,  318,  320,  320,  320,  322,  322,  322,  464,
			  464,  464,  466,  466,  466,  468,  468,  468,  477,  477,
			  477,  831,  218,  479,  479,  479,  225,  226,  227,  228,
			  229,  849,  481,  481,  481,  300,  301,  302,  303,  304,

			  828,  186,  186,  827,  186,  186,  186,  186,  186,  186,
			  186,  186,  186,  186,  826,  385,  318,  318,  318,  318,
			  318,  318,  482,  482,  482,  493,  493,  383,  383,  383,
			  469,  383,  383,  383,  383,  383,  383,  483,  483,  483,
			  323,  323,  323,  323,  490,  490,  490,  492,  492,  492,
			  494,  494,  494,  331,  332,  333,  334,  335,  342,  342,
			  342,  496,  496,  496,  497,  497,  498,  498,  498,  504,
			  825,  401,  386,  387,  388,  389,  390,  218,  218,  218,
			  218,  218,  218,  218,  218,  218,  218,  218,  218,  470,
			  499,  218,  505,  636,  500,  503,  331,  332,  333,  334,

			  335,  824,  501,  218,  218,  218,  218,  342,  342,  342,
			  342,  342,  342,  502,  506,  508,  508,  508,  636,  331,
			  332,  333,  334,  335,  509,  509,  509,  511,  511,  511,
			  822,  218,  218,  218,  823,  331,  332,  333,  334,  335,
			  513,  513,  513,  331,  332,  333,  334,  335,  822,  331,
			  332,  333,  334,  335,  514,  514,  218,  515,  515,  515,
			  225,  226,  227,  228,  229,  412,  412,  412,  412,  412,
			  412,  412,  412,  412,  412,  412,  412,  518,  518,  412,
			  349,  350,  351,  352,  353,  355,  356,  357,  358,  359,
			  521,  412,  412,  412,  412,  362,  362,  362,  517,  517,

			  517,  519,  519,  519,  520,  355,  356,  357,  358,  359,
			  362,  362,  362,  362,  362,  362,  522,  522,  522,  412,
			  412,  412,  523,  523,  523,  821,  527,  819,  355,  356,
			  357,  358,  359,  541,  541,  355,  356,  357,  358,  359,
			  378,  378,  378,  820,  412,  569,  569,  529,  225,  226,
			  227,  228,  229,  849,  528,  532,  378,  378,  378,  530,
			  535,  535,  535,  283,  283,  531,  283,  283,  283,  283,
			  283,  283,  283,  283,  283,  283,  819,  440,  355,  356,
			  357,  358,  359,  355,  356,  357,  358,  359,  355,  356,
			  357,  358,  359,  355,  356,  357,  358,  359,  548,  355,

			  356,  357,  358,  359,  536,  536,  536,  331,  332,  333,
			  334,  335,  383,  383,  383,  383,  383,  383,  383,  383,
			  383,  383,  818,  537,  396,  396,  396,  540,  540,  540,
			  542,  542,  542,  817,  441,  442,  443,  444,  445,  305,
			  305,  817,  305,  305,  305,  305,  305,  305,  305,  305,
			  305,  305,  812,  458,  811,  386,  387,  388,  389,  390,
			  396,  396,  396,  396,  396,  396,  549,  549,  549,  550,
			  550,  550,  200,  200,  200,  200,  200,  200,  212,  212,
			  212,  212,  212,  212,  219,  220,  221,  222,  223,  412,
			  412,  412,  412,  412,  412,  556,  556,  556,  557,  557,

			  557,  231,  231,  231,  231,  231,  231,  558,  558,  558,
			  459,  460,  461,  462,  463,  849,  559,  559,  559,  231,
			  231,  231,  231,  231,  231,  312,  312,  810,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  809,  471,
			  249,  249,  249,  249,  249,  249,  259,  260,  261,  262,
			  263,  429,  429,  429,  429,  429,  429,  563,  563,  563,
			  564,  564,  564,  271,  271,  271,  271,  271,  271,  565,
			  565,  565,  566,  566,  566,  271,  271,  271,  271,  271,
			  271,  451,  451,  451,  568,  568,  568,  570,  570,  570,
			  576,  451,  451,  451,  581,  581,  472,  473,  474,  475,

			  476,  324,  324,  583,  324,  324,  324,  324,  324,  324,
			  324,  324,  324,  324,  808,  484,  451,  451,  451,  577,
			  577,  577,  578,  578,  578,  293,  293,  293,  293,  293,
			  293,  464,  464,  464,  580,  580,  580,  582,  582,  582,
			  464,  464,  464,  464,  464,  464,  593,  441,  442,  443,
			  444,  445,  584,  584,  584,  585,  585,  585,  591,  591,
			  459,  460,  461,  462,  463,  477,  477,  477,  590,  590,
			  590,  600,  485,  486,  487,  488,  489,  383,  383,  383,
			  383,  586,  383,  383,  383,  383,  587,  807,  537,  592,
			  592,  592,  477,  477,  477,  477,  477,  477,  594,  594,

			  594,  598,  598,  472,  473,  474,  475,  476,  595,  595,
			  595,  318,  318,  318,  318,  318,  318,  490,  490,  490,
			  597,  597,  597,  599,  599,  599,  609,  806,  485,  486,
			  487,  488,  489,  490,  490,  490,  490,  490,  490,  601,
			  601,  601,  602,  602,  602,  342,  342,  342,  342,  342,
			  342,  603,  603,  603,  604,  604,  604,  610,  612,  342,
			  342,  342,  611,  773,  773,  331,  332,  333,  334,  335,
			  342,  342,  342,  349,  350,  351,  352,  353,  511,  511,
			  511,  511,  511,  511,  614,  614,  614,  615,  615,  615,
			  778,  778,  331,  332,  333,  334,  335,  618,  623,  331,

			  332,  333,  334,  335,  331,  332,  333,  334,  335,  362,
			  362,  362,  362,  362,  362,  616,  616,  616,  617,  617,
			  617,  355,  356,  357,  358,  359,  362,  362,  362,  622,
			  624,  355,  356,  357,  358,  359,  362,  362,  362,  626,
			  793,  794,  355,  356,  357,  358,  359,  625,  378,  378,
			  378,  378,  378,  378,  396,  396,  396,  396,  396,  396,
			  795,  796,  627,  355,  356,  357,  358,  359,  629,  629,
			  629,  630,  630,  630,  396,  396,  396,  636,  355,  356,
			  357,  358,  359,  396,  396,  396,  355,  356,  357,  358,
			  359,  355,  356,  357,  358,  359,  331,  332,  333,  334,

			  335,  805,  637,  412,  412,  412,  412,  412,  412,  231,
			  231,  231,  231,  231,  231,  429,  429,  429,  429,  429,
			  429,  271,  271,  271,  271,  271,  271,  451,  451,  451,
			  451,  451,  451,  641,  641,  641,  642,  642,  642,  451,
			  451,  451,  451,  451,  451,  464,  464,  464,  464,  464,
			  464,  646,  646,  646,  647,  647,  647,  464,  464,  464,
			  464,  464,  464,  383,  383,  383,  383,  383,  383,  383,
			  383,  383,  383,  804,  648,  383,  383,  383,  383,  383,
			  383,  383,  383,  383,  383,  803,  648,  477,  477,  477,
			  477,  477,  477,  651,  651,  651,  652,  652,  652,  477,

			  477,  477,  477,  477,  477,  490,  490,  490,  490,  490,
			  490,  653,  653,  653,  654,  654,  654,  490,  490,  490,
			  490,  490,  490,  342,  342,  342,  342,  342,  342,  659,
			  780,  661,  662,  511,  511,  511,  786,  660,  511,  511,
			  511,  362,  362,  362,  362,  362,  362,  668,  396,  396,
			  396,  396,  396,  396,  664,  781,  669,  670,  673,  451,
			  451,  451,  451,  451,  451,  331,  332,  333,  334,  335,
			  331,  332,  333,  334,  335,  331,  332,  333,  334,  335,
			  331,  332,  333,  334,  335,  355,  356,  357,  358,  359,
			  355,  356,  357,  358,  359,  671,  672,  797,  798,  355,

			  356,  357,  358,  359,  355,  356,  357,  358,  359,  691,
			  331,  332,  333,  334,  335,  678,  678,  678,  678,  680,
			  680,  680,  680,  464,  464,  464,  464,  464,  464,  692,
			  355,  356,  357,  358,  359,  477,  477,  477,  355,  356,
			  357,  358,  359,  477,  477,  477,  490,  490,  490,  679,
			  490,  490,  490,  679,  693,  694,  701,  331,  332,  333,
			  334,  335,  355,  356,  357,  358,  359,  355,  356,  357,
			  358,  359,  699,  702,  678,  678,  678,  678,  331,  332,
			  333,  334,  335,  703,  785,  700,  331,  332,  333,  334,
			  335,  355,  356,  357,  358,  359,  331,  332,  333,  334,

			  335,  714,  799,  800,  331,  332,  333,  334,  335,  680,
			  680,  680,  680,  720,  776,  771,  355,  356,  357,  358,
			  359,  355,  356,  357,  358,  359,  751,  355,  356,  357,
			  358,  359,  331,  332,  333,  334,  335,  715,  715,  715,
			  715,  721,  716,  716,  716,  716,  769,  722,  768,  331,
			  332,  333,  334,  335,  355,  356,  357,  358,  359,  767,
			  766,  355,  356,  357,  358,  359,  355,  356,  357,  358,
			  359,  709,  709,  709,  709,  331,  332,  333,  334,  335,
			  738,  355,  356,  357,  358,  359,  355,  356,  357,  358,
			  359,  715,  715,  715,  715,  757,  732,  716,  716,  716,

			  716,  733,  734,  727,  739,  740,  829,  735,  752,  753,
			  754,  755,  756,  830,  763,  355,  356,  357,  358,  359,
			  725,  725,  725,  725,  331,  332,  333,  334,  335,  331,
			  332,  333,  334,  335,  355,  356,  357,  358,  359,  355,
			  356,  357,  358,  359,  787,  355,  356,  357,  358,  359,
			  833,  750,  743,  727,  727,  727,  727,  834,  745,  716,
			  716,  716,  716,  746,  355,  356,  357,  358,  359,  770,
			  770,  770,  758,  759,  760,  761,  762,  355,  356,  357,
			  358,  359,  743,  743,  743,  743,  782,  764,  772,  772,
			  772,  790,  765,  774,  774,  774,  775,  775,  775,  777,

			  777,  777,  779,  779,  779,  766,  766,  766,  766,  750,
			  749,  783,  770,  770,  770,  770,  770,  770,  788,  788,
			  788,  789,  789,  789,  748,  747,  752,  753,  754,  755,
			  756,  775,  775,  775,  775,  775,  775,  784,  791,  791,
			  791,  792,  792,  792,  784,  784,  784,  784,  744,  801,
			  770,  770,  770,  742,  802,  770,  770,  770,  775,  775,
			  775,  775,  775,  775,  741,  737,  736,  731,  758,  759,
			  760,  761,  762,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,

			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
			   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
			   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
			   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
			   49,   49,   49,   49,   49,   49,   49,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,

			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,  100,  100,  100,  100,  100,  100,  100,  100,  100,
			  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
			  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
			  100,  100,  100,  100,  100,  100,  100,  100,  100,  100>>,
			1, 3000, 0)
		end

	yy_nxt_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			  100,  100,  100,  100,  100,  100,  100,  100,  115,  115,
			  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
			  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
			  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
			  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
			  115,  115,  115,  115,  115,  168,  168,  168,  168,  168,
			  168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
			  168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
			  168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
			  168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

			  168,  168,  179,  179,  179,  179,  730,  179,  179,  179,
			  179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
			  179,  729,  179,  179,  179,  179,  179,  179,  179,  179,
			  179,  179,  179,  179,  179,  728,  179,  179,  179,  179,
			  179,  179,  179,  179,  186,  726,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  725,  724,  723,  719,  186,
			  538,  718,  717,  713,  186,  186,  186,  186,  186,  186,
			  186,  186,  186,  186,  712,  711,  186,  186,  186,  186,
			  186,  186,  186,  186,  205,  205,  205,  205,  205,  205,
			  205,  205,  205,  205,  710,  205,  205,  205,  205,  205,

			  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
			  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
			  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
			  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
			  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
			  218,  709,  218,  218,  218,  218,  218,  218,  218,  218,
			  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
			  218,  218,  224,  224,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  708,  224,  224,  224,  224,  224,  224,

			  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  224,  241,  707,  706,  241,  241,  241,
			  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
			  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
			  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
			  241,  705,  241,  241,  241,  241,  241,  241,  241,  241,
			  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
			  258,  704,  698,  697,  696,  695,  258,  258,  258,  258,
			  258,  258,  258,  258,  258,  258,  690,  689,  258,  258,
			  258,  258,  258,  258,  258,  258,  265,  265,  265,  265,

			  265,  265,  265,  265,  265,  265,  265,  688,  687,  686,
			  686,  685,  265,  265,  265,  265,  265,  265,  265,  265,
			  265,  265,  684,  683,  265,  265,  265,  265,  265,  265,
			  265,  265,  277,  682,  277,  277,  681,  677,  277,  277,
			  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
			  277,  676,  277,  277,  277,  277,  277,  277,  277,  277,
			  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
			  277,  277,  277,  277,  283,  675,  674,  667,  666,  665,
			  663,  658,  657,  656,  655,  645,  644,  643,  640,  283,
			  639,  638,  635,  634,  283,  283,  283,  283,  283,  283,

			  283,  283,  283,  283,  633,  632,  283,  283,  283,  283,
			  283,  283,  283,  283,  299,  631,  299,  628,  621,  620,
			  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
			  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
			  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
			  299,  299,  299,  299,  299,  299,  305,  619,  613,  608,
			  605,  305,  305,  305,  305,  305,  305,  305,  305,  305,
			  305,  596,  589,  305,  305,  305,  305,  305,  305,  305,
			  305,  312,  588,  579,  575,  574,  573,  572,  571,  567,
			  562,  561,  560,  553,  552,  551,  312,  547,  546,  545,

			  544,  312,  312,  312,  312,  312,  312,  312,  312,  312,
			  312,  543,  539,  312,  312,  312,  312,  312,  312,  312,
			  312,  324,  534,  533,  526,  525,  324,  324,  324,  324,
			  324,  324,  324,  324,  324,  324,  524,  516,  324,  324,
			  324,  324,  324,  324,  324,  324,  330,  330,  330,  330,
			  330,  330,  330,  330,  330,  330,  330,  330,  512,  510,
			  507,  495,  330,  330,  330,  330,  330,  330,  330,  330,
			  330,  330,  491,  478,  330,  330,  330,  330,  330,  330,
			  330,  330,  348,  348,  348,  348,  348,  348,  348,  348,
			  348,  348,  348,  348,  465,  319,  452,  450,  348,  348,

			  348,  348,  348,  348,  348,  348,  348,  348,  449,  448,
			  348,  348,  348,  348,  348,  348,  348,  348,  354,  354,
			  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
			  294,  434,  430,  264,  354,  354,  354,  354,  354,  354,
			  354,  354,  354,  354,  426,  250,  354,  354,  354,  354,
			  354,  354,  354,  354,  200,  200,  200,  200,  425,  200,
			  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
			  200,  200,  200,  424,  200,  200,  200,  200,  200,  200,
			  200,  200,  200,  200,  200,  200,  200,  423,  200,  200,
			  200,  200,  200,  200,  200,  200,  212,  212,  212,  212,

			  212,  212,  212,  212,  212,  212,  417,  212,  212,  212,
			  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
			  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
			  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
			  212,  212,  231,  231,  231,  231,  231,  231,  231,  231,
			  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
			  231,  231,  231,  413,  231,  231,  231,  231,  231,  231,
			  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
			  231,  231,  231,  231,  249,  409,  213,  249,  249,  249,
			  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,

			  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
			  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
			  249,  406,  249,  249,  249,  249,  249,  249,  249,  249,
			  271,  271,  271,  271,  271,  271,  271,  271,  271,  271,
			  271,  397,  395,  394,  393,  201,  271,  271,  271,  271,
			  271,  271,  271,  271,  271,  271,  379,  377,  271,  271,
			  271,  271,  271,  271,  271,  271,  293,  376,  293,  293,
			  363,  347,  293,  293,  293,  293,  293,  293,  293,  293,
			  293,  293,  293,  293,  293,  343,  293,  293,  293,  293,
			  293,  293,  293,  293,  293,  293,  293,  293,  293,  293,

			  293,  293,  293,  293,  293,  293,  293,  293,  318,  341,
			  318,  319,  298,  294,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
			  342,  342,  276,  272,  264,  250,  342,  342,  342,  342,
			  342,  342,  342,  342,  342,  342,  248,  247,  342,  342,
			  342,  342,  342,  342,  342,  342,  362,  362,  362,  362,
			  362,  362,  362,  362,  362,  362,  362,  362,  240,  239,

			  238,  237,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  362,  232,  230,  362,  362,  362,  362,  362,  362,
			  362,  362,  396,  396,  396,  396,  396,  396,  396,  396,
			  396,  396,  396,  396,  396,  213,  211,  201,  396,  396,
			  396,  396,  396,  396,  396,  396,  396,  396,  199,  178,
			  396,  396,  396,  396,  396,  396,  396,  396,  412,  412,
			  412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
			  412,  412,  412,  412,  412,  412,  412,  412,  412,  849,
			  412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
			  412,  412,  412,  412,  412,  412,  412,  412,  412,  412,

			  429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
			  429,  849,  849,  849,  849,  849,  429,  429,  429,  429,
			  429,  429,  429,  429,  429,  429,  849,  849,  429,  429,
			  429,  429,  429,  429,  429,  429,  451,  451,  451,  451,
			  451,  451,  451,  451,  451,  451,  451,  451,  451,  849,
			  849,  849,  451,  451,  451,  451,  451,  451,  451,  451,
			  451,  451,  849,  849,  451,  451,  451,  451,  451,  451,
			  451,  451,  464,  464,  464,  464,  464,  464,  464,  464,
			  464,  464,  464,  464,  464,  849,  849,  849,  464,  464,
			  464,  464,  464,  464,  464,  464,  464,  464,  849,  849,

			  464,  464,  464,  464,  464,  464,  464,  464,  477,  477,
			  477,  477,  477,  477,  477,  477,  477,  477,  477,  477,
			  477,  849,  849,  849,  477,  477,  477,  477,  477,  477,
			  477,  477,  477,  477,  849,  849,  477,  477,  477,  477,
			  477,  477,  477,  477,  490,  490,  490,  490,  490,  490,
			  490,  490,  490,  490,  490,  490,  490,  849,  849,  849,
			  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
			  849,  849,  490,  490,  490,  490,  490,  490,  490,  490,
			  511,  511,  511,  511,  511,  511,  511,  511,  511,  511,
			  511,  511,  849,  849,  849,  849,  511,  511,  511,  511,

			  511,  511,  511,  511,  511,  511,  849,  849,  511,  511,
			  511,  511,  511,  511,  511,  511,  732,  732,  732,  732,
			  732,  732,  732,  849,  732,  732,  732,  732,  732,  732,
			  732,  732,  732,  732,  732,  732,  732,  732,  849,  849,
			  732,  732,  732,  732,  732,  732,  732,  732,  732,  732,
			  732,  849,  849,  732,  732,  732,  732,  732,  732,  732,
			  733,  733,  733,  733,  849,  733,  733,  849,  733,  733,
			  733,  733,  733,  733,  733,  733,  733,  733,  733,  733,
			  733,  733,  849,  849,  733,  733,  733,  733,  733,  733,
			  733,  733,  733,  733,  733,  849,  849,  733,  733,  733,

			  733,  733,  733,  733,  734,  734,  734,  734,  734,  734,
			  734,  734,  734,  734,  734,  734,  734,  734,  734,  734,
			  734,  734,  734,  734,  734,  734,  734,  734,  734,  734,
			  734,  734,  734,  734,  734,  734,  734,  734,  734,  734,
			  734,  734,  734,  734,  734,  734,  734,  734,  734,  734,
			  735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
			  735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
			  735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
			  735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
			  735,  735,  735,  735,  735,  735,  770,  770,  770,  770,

			  770,  770,  770,  770,  770,  770,  770,  770,  770,  770,
			  770,  770,  770,  770,  770,  770,  770,  770,  770,  770,
			  770,  770,  770,  770,  770,  770,  770,  770,  770,  770,
			  770,  770,  770,  770,  770,  770,  770,  770,  770,  770,
			  770,  770,  775,  775,  775,  775,  775,  775,  775,  775,
			  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
			  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
			  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
			  775,  775,  775,  775,  775,  775,  775,  775,   35,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849>>,
			1, 1782, 3000)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		local
			an_array: ARRAY [INTEGER]
		once
			!! an_array.make (0, 4781)
			yy_chk_template_1 (an_array)
			yy_chk_template_2 (an_array)
			Result := yy_fixed_array (an_array)
		end

	yy_chk_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			    0,    1,    1,    1,    1,    1,  127,   37,   27,   27,
			   37,    1,  177,   27,    0,  177,    0,   42,    0,  196,
			    3,    0,    3,   57,   57,   57,   57,    0,    4,   23,
			    4,   42,    0,    1,  588,    0,  127,    3,   27,  588,
			   27,  196,   27,  588,    0,    4,   27,   42,    0,  500,
			   27,  500,   23,   58,   58,   58,   58,   67,   67,   67,
			   67,  196,    1,    0,   23,    7,    7,    7,    7,    8,
			    8,    8,    8,    9,  187,    9,    9,  187,  848,   23,
			  284,   23,   10,  284,   10,   10,    1,    1,    1,    1,
			    1,    1,    1,    1,    2,    2,    2,    2,    2,    7,

			  847,   24,   31,    8,    2,    3,    3,    3,    3,    3,
			    3,    3,    3,    4,    4,    4,    4,    4,    4,    4,
			    4,   44,   44,   44,   24,   31,    2,   46,   46,   46,
			  846,    7,   47,   47,    9,    8,   24,   31,   48,   48,
			   48,  404,    7,   10,  845,    7,    8,   55,   55,    8,
			  843,   24,   31,   24,   31,    2,   65,   65,    9,    9,
			    9,    9,    9,    9,    9,    9,  404,   10,   10,   10,
			   10,   10,   10,   10,   10,   52,   52,   52,  842,    2,
			    2,    2,    2,    2,    2,    2,    2,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   13,   13,   13,   13,   13,  198,   13,
			   28,   28,  841,   13,   13,   28,   32,   29,   80,   80,
			   29,  839,   29,   30,  838,   33,   30,   33,   30,   40,

			   40,   40,   40,   40,  198,   13,   54,   54,   54,   32,
			   28,  837,   28,   29,   28,   56,   56,   56,   28,   30,
			  801,   32,   28,   95,   95,   29,  835,   33,  834,   29,
			  801,   30,   41,  108,  108,   30,   32,  802,   32,   34,
			   29,   34,   29,   62,   62,   62,   30,  802,   30,   49,
			   49,   49,   49,   49,  121,  121,   33,  833,   13,   13,
			   13,   13,   13,   13,   13,   13,   14,   14,   14,   14,
			   14,   34,   14,   64,   64,   64,   14,   14,  137,  137,
			   33,   33,   33,   33,   33,   33,   33,   33,   41,   50,
			   50,   50,   50,   50,   41,  832,   41,  831,   14,  830,

			   34,   41,   59,   59,   59,   59,   59,   66,   66,   66,
			   77,   77,   77,   41,   41,   41,   41,   41,   68,   68,
			   68,   68,  155,  155,   34,   34,   34,   34,   34,   34,
			   34,   34,   73,   73,   73,   73,   73,   79,   79,   79,
			   81,   81,   81,   92,   92,   92,   82,   82,   82,   82,
			  102,   14,   14,   14,   14,   14,   14,   14,   14,   15,
			   15,   15,   15,   15,   82,   15,   94,   94,   94,   15,
			   15,   83,   83,   83,   83,   96,   96,   96,   82,   82,
			   86,   86,   86,   86,   86,   89,   89,   89,   89,   83,
			  117,   15,   91,   91,   91,   91,   91,  100,  100,  100,

			  100,  100,  158,   83,   83,  158,  102,  105,  105,  105,
			  175,  175,  102,  158,  102,  107,  107,  107,  829,  102,
			  109,  109,  109,  115,  115,  115,  115,  115,  118,  118,
			  118,  102,  102,  102,  102,  102,  116,  116,  116,  116,
			  116,  120,  120,  120,   15,   15,   15,   15,   15,   15,
			   15,   15,   16,   16,   16,   16,   16,  828,   16,  122,
			  122,  122,   16,   16,  123,  123,  123,  123,  130,  183,
			  183,  117,  117,  117,  117,  117,  124,  124,  124,  124,
			  827,  131,  194,  194,   16,  125,  125,  125,  125,  125,
			  126,  126,  126,  126,  126,  134,  134,  134,  136,  136,

			  136,  130,  130,  130,  130,  130,  138,  138,  138,  209,
			  209,  129,  131,  131,  131,  131,  131,  129,  146,  146,
			  146,  146,  146,  147,  147,  147,  147,  147,  149,  152,
			  152,  152,  150,  154,  154,  154,  160,   16,   16,   16,
			   16,   16,   16,   16,   16,   17,   17,   17,   17,   17,
			  161,   17,  162,  826,   17,   17,   17,  129,  129,  129,
			  129,  129,  156,  156,  156,  163,  167,  163,  149,  149,
			  149,  149,  149,  150,  150,  150,  150,  150,  172,  172,
			  172,  174,  174,  174,  825,  160,  160,  160,  160,  160,
			  161,  161,  161,  161,  161,  176,  176,  176,  180,  180,

			  180,  162,  162,  162,  162,  162,  163,  163,  163,  163,
			  163,  182,  182,  182,  824,  167,  167,  167,  167,  167,
			  179,  179,  179,  179,  179,  184,  184,  184,  222,  222,
			   17,   17,   17,   17,   17,   17,   17,   17,   18,   18,
			   18,   18,   18,  823,   18,  228,  228,   18,   18,   18,
			  185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
			  191,  191,  191,  193,  193,  193,  195,  195,  195,  200,
			  200,  200,  200,  200,  201,  201,  201,  202,  202,  202,
			  203,  203,  203,  204,  204,  204,  205,  205,  205,  205,
			  205,  206,  206,  206,  208,  208,  208,  210,  210,  210,

			  212,  212,  212,  212,  212,  213,  213,  213,  214,  214,
			  214,  405,  185,  215,  215,  215,  216,  216,  216,  217,
			  217,  217,  217,   18,   18,   18,   18,   18,   18,   18,
			   18,   19,   19,   19,   19,   19,  405,   19,  245,  245,
			   19,   19,   19,  218,  218,  218,  218,  218,  219,  219,
			  219,  221,  221,  221,  223,  223,  223,  225,  225,  225,
			  227,  227,  227,  229,  229,  229,  232,  232,  232,  233,
			  233,  233,  234,  234,  234,  235,  235,  235,  236,  236,
			  236,  236,  241,  241,  241,  241,  241,  242,  242,  242,
			  244,  244,  244,  246,  246,  246,  249,  249,  249,  249,

			  249,  250,  250,  250,  251,  251,  251,  252,  252,  252,
			  253,  253,  253,  259,  259,  259,   19,   19,   19,   19,
			   19,   19,   19,   19,   20,   20,   20,   20,   20,  821,
			   20,  262,  262,   20,   20,   20,  254,  254,  254,  254,
			  256,  256,  256,  256,  258,  258,  258,  258,  258,  261,
			  261,  261,  269,  269,  254,  263,  263,  263,  265,  265,
			  265,  265,  265,  266,  266,  266,  281,  281,  254,  254,
			  268,  268,  268,  270,  270,  270,  271,  271,  271,  271,
			  271,  272,  272,  272,  273,  273,  273,  274,  274,  274,
			  275,  275,  275,  277,  277,  277,  277,  277,  278,  278,

			  278,  280,  280,  280,  282,  282,  282,  291,  291,   20,
			   20,   20,   20,   20,   20,   20,   20,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,

			   25,   25,   25,   60,   60,   60,   60,   60,   60,   60,
			   60,   60,   60,   60,   60,  303,  303,   60,  288,  288,
			  288,  290,  290,  290,  292,  292,  292,  309,  309,   60,
			   60,   60,   60,  293,  293,  293,  293,  293,  294,  294,
			  294,  295,  295,  295,  296,  296,  296,  297,  297,  297,
			  299,  299,  299,  299,  299,  316,  316,   60,   60,   60,
			  300,  300,  300,  302,  302,  302,  304,  304,  304,  306,
			  306,  306,  308,  308,  308,  310,  310,  310,  313,  313,
			  313,  820,   60,  315,  315,  315,   60,   60,   60,   60,
			   60,  186,  317,  317,  317,  318,  318,  318,  318,  318,

			  818,  186,  186,  816,  186,  186,  186,  186,  186,  186,
			  186,  186,  186,  186,  815,  186,  319,  319,  319,  320,
			  320,  320,  321,  321,  321,  328,  328,  311,  311,  311,
			  311,  311,  311,  311,  311,  311,  311,  322,  322,  322,
			  323,  323,  323,  323,  325,  325,  325,  327,  327,  327,
			  329,  329,  329,  330,  330,  330,  330,  330,  331,  331,
			  331,  333,  333,  333,  334,  334,  335,  335,  335,  338,
			  814,  336,  186,  186,  186,  186,  186,  224,  224,  224,
			  224,  224,  224,  224,  224,  224,  224,  224,  224,  311,
			  336,  224,  339,  554,  336,  337,  342,  342,  342,  342,

			  342,  813,  336,  224,  224,  224,  224,  343,  343,  343,
			  344,  344,  344,  336,  340,  345,  345,  345,  554,  338,
			  338,  338,  338,  338,  346,  346,  346,  349,  349,  349,
			  812,  224,  224,  224,  811,  337,  337,  337,  337,  337,
			  351,  351,  351,  339,  339,  339,  339,  339,  810,  340,
			  340,  340,  340,  340,  352,  352,  224,  353,  353,  353,
			  224,  224,  224,  224,  224,  231,  231,  231,  231,  231,
			  231,  231,  231,  231,  231,  231,  231,  358,  358,  231,
			  348,  348,  348,  348,  348,  354,  354,  354,  354,  354,
			  361,  231,  231,  231,  231,  355,  355,  355,  357,  357,

			  357,  359,  359,  359,  360,  362,  362,  362,  362,  362,
			  363,  363,  363,  364,  364,  364,  365,  365,  365,  231,
			  231,  231,  366,  366,  366,  809,  370,  808,  361,  361,
			  361,  361,  361,  389,  389,  360,  360,  360,  360,  360,
			  379,  379,  379,  807,  231,  444,  444,  372,  231,  231,
			  231,  231,  231,  283,  371,  375,  380,  380,  380,  373,
			  381,  381,  381,  283,  283,  374,  283,  283,  283,  283,
			  283,  283,  283,  283,  283,  283,  806,  283,  370,  370,
			  370,  370,  370,  372,  372,  372,  372,  372,  371,  371,
			  371,  371,  371,  373,  373,  373,  373,  373,  396,  374,

			  374,  374,  374,  374,  382,  382,  382,  375,  375,  375,
			  375,  375,  383,  383,  383,  383,  383,  383,  383,  383,
			  383,  383,  805,  383,  386,  386,  386,  388,  388,  388,
			  390,  390,  390,  804,  283,  283,  283,  283,  283,  305,
			  305,  803,  305,  305,  305,  305,  305,  305,  305,  305,
			  305,  305,  800,  305,  799,  396,  396,  396,  396,  396,
			  397,  397,  397,  398,  398,  398,  399,  399,  399,  400,
			  400,  400,  407,  407,  407,  408,  408,  408,  410,  410,
			  410,  411,  411,  411,  412,  412,  412,  412,  412,  413,
			  413,  413,  414,  414,  414,  415,  415,  415,  416,  416,

			  416,  417,  417,  417,  418,  418,  418,  419,  419,  419,
			  305,  305,  305,  305,  305,  312,  420,  420,  420,  421,
			  421,  421,  422,  422,  422,  312,  312,  798,  312,  312,
			  312,  312,  312,  312,  312,  312,  312,  312,  797,  312,
			  427,  427,  427,  428,  428,  428,  429,  429,  429,  429,
			  429,  430,  430,  430,  431,  431,  431,  432,  432,  432,
			  433,  433,  433,  434,  434,  434,  435,  435,  435,  436,
			  436,  436,  437,  437,  437,  438,  438,  438,  439,  439,
			  439,  441,  441,  441,  443,  443,  443,  445,  445,  445,
			  451,  452,  452,  452,  462,  462,  312,  312,  312,  312,

			  312,  324,  324,  464,  324,  324,  324,  324,  324,  324,
			  324,  324,  324,  324,  796,  324,  453,  453,  453,  454,
			  454,  454,  455,  455,  455,  456,  456,  456,  457,  457,
			  457,  459,  459,  459,  461,  461,  461,  463,  463,  463,
			  465,  465,  465,  466,  466,  466,  477,  451,  451,  451,
			  451,  451,  467,  467,  467,  468,  468,  468,  475,  475,
			  464,  464,  464,  464,  464,  472,  472,  472,  474,  474,
			  474,  490,  324,  324,  324,  324,  324,  469,  469,  469,
			  469,  469,  469,  469,  469,  469,  469,  795,  469,  476,
			  476,  476,  478,  478,  478,  479,  479,  479,  480,  480,

			  480,  488,  488,  477,  477,  477,  477,  477,  481,  481,
			  481,  482,  482,  482,  483,  483,  483,  485,  485,  485,
			  487,  487,  487,  489,  489,  489,  503,  794,  490,  490,
			  490,  490,  490,  491,  491,  491,  492,  492,  492,  493,
			  493,  493,  494,  494,  494,  495,  495,  495,  496,  496,
			  496,  497,  497,  497,  498,  498,  498,  504,  506,  508,
			  508,  508,  505,  755,  755,  503,  503,  503,  503,  503,
			  509,  509,  509,  511,  511,  511,  511,  511,  512,  512,
			  512,  513,  513,  513,  514,  514,  514,  515,  515,  515,
			  761,  761,  506,  506,  506,  506,  506,  521,  528,  504,

			  504,  504,  504,  504,  505,  505,  505,  505,  505,  516,
			  516,  516,  517,  517,  517,  518,  518,  518,  519,  519,
			  519,  520,  520,  520,  520,  520,  522,  522,  522,  527,
			  529,  521,  521,  521,  521,  521,  523,  523,  523,  531,
			  780,  780,  528,  528,  528,  528,  528,  530,  535,  535,
			  535,  536,  536,  536,  539,  539,  539,  540,  540,  540,
			  781,  781,  532,  527,  527,  527,  527,  527,  541,  541,
			  541,  542,  542,  542,  549,  549,  549,  555,  529,  529,
			  529,  529,  529,  550,  550,  550,  530,  530,  530,  530,
			  530,  531,  531,  531,  531,  531,  532,  532,  532,  532,

			  532,  793,  555,  556,  556,  556,  557,  557,  557,  558,
			  558,  558,  559,  559,  559,  563,  563,  563,  564,  564,
			  564,  565,  565,  565,  566,  566,  566,  567,  567,  567,
			  568,  568,  568,  569,  569,  569,  570,  570,  570,  577,
			  577,  577,  578,  578,  578,  579,  579,  579,  580,  580,
			  580,  581,  581,  581,  582,  582,  582,  584,  584,  584,
			  585,  585,  585,  586,  586,  586,  586,  586,  586,  586,
			  586,  586,  586,  786,  586,  587,  587,  587,  587,  587,
			  587,  587,  587,  587,  587,  785,  587,  589,  589,  589,
			  590,  590,  590,  591,  591,  591,  592,  592,  592,  594,

			  594,  594,  595,  595,  595,  596,  596,  596,  597,  597,
			  597,  598,  598,  598,  599,  599,  599,  601,  601,  601,
			  602,  602,  602,  603,  603,  603,  604,  604,  604,  609,
			  764,  611,  612,  614,  614,  614,  768,  610,  615,  615,
			  615,  616,  616,  616,  617,  617,  617,  622,  629,  629,
			  629,  630,  630,  630,  618,  764,  623,  624,  627,  641,
			  641,  641,  642,  642,  642,  609,  609,  609,  609,  609,
			  610,  610,  610,  610,  610,  611,  611,  611,  611,  611,
			  612,  612,  612,  612,  612,  618,  618,  618,  618,  618,
			  623,  623,  623,  623,  623,  625,  626,  782,  782,  622,

			  622,  622,  622,  622,  624,  624,  624,  624,  624,  659,
			  627,  627,  627,  627,  627,  636,  636,  636,  636,  637,
			  637,  637,  637,  646,  646,  646,  647,  647,  647,  660,
			  626,  626,  626,  626,  626,  651,  651,  651,  625,  625,
			  625,  625,  625,  652,  652,  652,  653,  653,  653,  636,
			  654,  654,  654,  637,  661,  662,  670,  659,  659,  659,
			  659,  659,  664,  664,  664,  664,  664,  668,  668,  668,
			  668,  668,  669,  671,  678,  678,  678,  678,  660,  660,
			  660,  660,  660,  672,  767,  669,  673,  673,  673,  673,
			  673,  670,  670,  670,  670,  670,  662,  662,  662,  662,

			  662,  692,  783,  783,  661,  661,  661,  661,  661,  680,
			  680,  680,  680,  699,  759,  753,  669,  669,  669,  669,
			  669,  671,  671,  671,  671,  671,  734,  672,  672,  672,
			  672,  672,  691,  691,  691,  691,  691,  693,  693,  693,
			  693,  702,  694,  694,  694,  694,  749,  703,  746,  692,
			  692,  692,  692,  692,  700,  700,  700,  700,  700,  745,
			  744,  699,  699,  699,  699,  699,  701,  701,  701,  701,
			  701,  709,  709,  709,  709,  714,  714,  714,  714,  714,
			  720,  702,  702,  702,  702,  702,  703,  703,  703,  703,
			  703,  715,  715,  715,  715,  735,  715,  716,  716,  716,

			  716,  715,  716,  709,  721,  722,  819,  716,  734,  734,
			  734,  734,  734,  819,  737,  720,  720,  720,  720,  720,
			  725,  725,  725,  725,  693,  693,  693,  693,  693,  694,
			  694,  694,  694,  694,  738,  738,  738,  738,  738,  721,
			  721,  721,  721,  721,  770,  722,  722,  722,  722,  722,
			  822,  733,  725,  727,  727,  727,  727,  822,  727,  750,
			  750,  750,  750,  727,  739,  739,  739,  739,  739,  752,
			  752,  752,  735,  735,  735,  735,  735,  740,  740,  740,
			  740,  740,  743,  743,  743,  743,  765,  743,  754,  754,
			  754,  775,  743,  756,  756,  756,  758,  758,  758,  760,

			  760,  760,  762,  762,  762,  766,  766,  766,  766,  732,
			  731,  765,  771,  771,  771,  772,  772,  772,  773,  773,
			  773,  774,  774,  774,  729,  728,  770,  770,  770,  770,
			  770,  776,  776,  776,  777,  777,  777,  766,  778,  778,
			  778,  779,  779,  779,  784,  784,  784,  784,  726,  784,
			  788,  788,  788,  724,  784,  789,  789,  789,  791,  791,
			  791,  792,  792,  792,  723,  719,  718,  713,  775,  775,
			  775,  775,  775,  850,  850,  850,  850,  850,  850,  850,
			  850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
			  850,  850,  850,  850,  850,  850,  850,  850,  850,  850,

			  850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
			  850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
			  851,  851,  851,  851,  851,  851,  851,  851,  851,  851,
			  851,  851,  851,  851,  851,  851,  851,  851,  851,  851,
			  851,  851,  851,  851,  851,  851,  851,  851,  851,  851,
			  851,  851,  851,  851,  851,  851,  851,  851,  851,  851,
			  851,  851,  851,  851,  851,  851,  851,  852,  852,  852,
			  852,  852,  852,  852,  852,  852,  852,  852,  852,  852,
			  852,  852,  852,  852,  852,  852,  852,  852,  852,  852,
			  852,  852,  852,  852,  852,  852,  852,  852,  852,  852,

			  852,  852,  852,  852,  852,  852,  852,  852,  852,  852,
			  852,  852,  852,  852,  853,  853,  853,  853,  853,  853,
			  853,  853,  853,  853,  853,  853,  853,  853,  853,  853,
			  853,  853,  853,  853,  853,  853,  853,  853,  853,  853,
			  853,  853,  853,  853,  853,  853,  853,  853,  853,  853,
			  853,  853,  853,  853,  853,  853,  853,  853,  853,  853,
			  853,  854,  854,  854,  854,  854,  854,  854,  854,  854,
			  854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
			  854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
			  854,  854,  854,  854,  854,  854,  854,  854,  854,  854>>,
			1, 3000, 0)
		end

	yy_chk_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			  854,  854,  854,  854,  854,  854,  854,  854,  855,  855,
			  855,  855,  855,  855,  855,  855,  855,  855,  855,  855,
			  855,  855,  855,  855,  855,  855,  855,  855,  855,  855,
			  855,  855,  855,  855,  855,  855,  855,  855,  855,  855,
			  855,  855,  855,  855,  855,  855,  855,  855,  855,  855,
			  855,  855,  855,  855,  855,  856,  856,  856,  856,  856,
			  856,  856,  856,  856,  856,  856,  856,  856,  856,  856,
			  856,  856,  856,  856,  856,  856,  856,  856,  856,  856,
			  856,  856,  856,  856,  856,  856,  856,  856,  856,  856,
			  856,  856,  856,  856,  856,  856,  856,  856,  856,  856,

			  856,  856,  857,  857,  857,  857,  712,  857,  857,  857,
			  857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
			  857,  711,  857,  857,  857,  857,  857,  857,  857,  857,
			  857,  857,  857,  857,  857,  710,  857,  857,  857,  857,
			  857,  857,  857,  857,  858,  708,  883,  883,  883,  883,
			  883,  883,  883,  883,  883,  707,  705,  704,  698,  858,
			  883,  697,  695,  690,  858,  858,  858,  858,  858,  858,
			  858,  858,  858,  858,  689,  688,  858,  858,  858,  858,
			  858,  858,  858,  858,  859,  859,  859,  859,  859,  859,
			  859,  859,  859,  859,  687,  859,  859,  859,  859,  859,

			  859,  859,  859,  859,  859,  859,  859,  859,  859,  859,
			  859,  859,  859,  859,  859,  859,  859,  859,  859,  859,
			  859,  859,  859,  859,  859,  859,  859,  859,  859,  859,
			  860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
			  860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
			  860,  683,  860,  860,  860,  860,  860,  860,  860,  860,
			  860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
			  860,  860,  861,  861,  861,  861,  861,  861,  861,  861,
			  861,  861,  861,  861,  861,  861,  861,  861,  861,  861,
			  861,  861,  861,  682,  861,  861,  861,  861,  861,  861,

			  861,  861,  861,  861,  861,  861,  861,  861,  861,  861,
			  861,  861,  861,  861,  862,  681,  679,  862,  862,  862,
			  862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
			  862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
			  862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
			  862,  677,  862,  862,  862,  862,  862,  862,  862,  862,
			  863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
			  863,  676,  667,  666,  665,  663,  863,  863,  863,  863,
			  863,  863,  863,  863,  863,  863,  658,  657,  863,  863,
			  863,  863,  863,  863,  863,  863,  864,  864,  864,  864,

			  864,  864,  864,  864,  864,  864,  864,  656,  655,  650,
			  649,  645,  864,  864,  864,  864,  864,  864,  864,  864,
			  864,  864,  644,  640,  864,  864,  864,  864,  864,  864,
			  864,  864,  865,  639,  865,  865,  638,  635,  865,  865,
			  865,  865,  865,  865,  865,  865,  865,  865,  865,  865,
			  865,  634,  865,  865,  865,  865,  865,  865,  865,  865,
			  865,  865,  865,  865,  865,  865,  865,  865,  865,  865,
			  865,  865,  865,  865,  866,  633,  632,  621,  620,  619,
			  613,  608,  607,  606,  605,  575,  572,  571,  562,  866,
			  561,  560,  553,  552,  866,  866,  866,  866,  866,  866,

			  866,  866,  866,  866,  547,  544,  866,  866,  866,  866,
			  866,  866,  866,  866,  867,  543,  867,  538,  526,  525,
			  867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
			  867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
			  867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
			  867,  867,  867,  867,  867,  867,  868,  524,  510,  501,
			  499,  868,  868,  868,  868,  868,  868,  868,  868,  868,
			  868,  486,  473,  868,  868,  868,  868,  868,  868,  868,
			  868,  869,  470,  460,  450,  449,  448,  447,  446,  442,
			  425,  424,  423,  403,  402,  401,  869,  395,  394,  393,

			  392,  869,  869,  869,  869,  869,  869,  869,  869,  869,
			  869,  391,  387,  869,  869,  869,  869,  869,  869,  869,
			  869,  870,  377,  376,  369,  368,  870,  870,  870,  870,
			  870,  870,  870,  870,  870,  870,  367,  356,  870,  870,
			  870,  870,  870,  870,  870,  870,  871,  871,  871,  871,
			  871,  871,  871,  871,  871,  871,  871,  871,  350,  347,
			  341,  332,  871,  871,  871,  871,  871,  871,  871,  871,
			  871,  871,  326,  314,  871,  871,  871,  871,  871,  871,
			  871,  871,  872,  872,  872,  872,  872,  872,  872,  872,
			  872,  872,  872,  872,  307,  301,  289,  287,  872,  872,

			  872,  872,  872,  872,  872,  872,  872,  872,  286,  285,
			  872,  872,  872,  872,  872,  872,  872,  872,  873,  873,
			  873,  873,  873,  873,  873,  873,  873,  873,  873,  873,
			  279,  267,  260,  255,  873,  873,  873,  873,  873,  873,
			  873,  873,  873,  873,  248,  243,  873,  873,  873,  873,
			  873,  873,  873,  873,  874,  874,  874,  874,  240,  874,
			  874,  874,  874,  874,  874,  874,  874,  874,  874,  874,
			  874,  874,  874,  239,  874,  874,  874,  874,  874,  874,
			  874,  874,  874,  874,  874,  874,  874,  238,  874,  874,
			  874,  874,  874,  874,  874,  874,  875,  875,  875,  875,

			  875,  875,  875,  875,  875,  875,  226,  875,  875,  875,
			  875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
			  875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
			  875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
			  875,  875,  876,  876,  876,  876,  876,  876,  876,  876,
			  876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
			  876,  876,  876,  220,  876,  876,  876,  876,  876,  876,
			  876,  876,  876,  876,  876,  876,  876,  876,  876,  876,
			  876,  876,  876,  876,  877,  211,  207,  877,  877,  877,
			  877,  877,  877,  877,  877,  877,  877,  877,  877,  877,

			  877,  877,  877,  877,  877,  877,  877,  877,  877,  877,
			  877,  877,  877,  877,  877,  877,  877,  877,  877,  877,
			  877,  199,  877,  877,  877,  877,  877,  877,  877,  877,
			  878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
			  878,  192,  190,  189,  188,  181,  878,  878,  878,  878,
			  878,  878,  878,  878,  878,  878,  173,  171,  878,  878,
			  878,  878,  878,  878,  878,  878,  879,  170,  879,  879,
			  153,  140,  879,  879,  879,  879,  879,  879,  879,  879,
			  879,  879,  879,  879,  879,  135,  879,  879,  879,  879,
			  879,  879,  879,  879,  879,  879,  879,  879,  879,  879,

			  879,  879,  879,  879,  879,  879,  879,  879,  880,  133,
			  880,  119,  114,  106,  880,  880,  880,  880,  880,  880,
			  880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
			  880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
			  880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
			  881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
			  881,  881,   99,   93,   87,   78,  881,  881,  881,  881,
			  881,  881,  881,  881,  881,  881,   76,   75,  881,  881,
			  881,  881,  881,  881,  881,  881,  882,  882,  882,  882,
			  882,  882,  882,  882,  882,  882,  882,  882,   72,   71,

			   70,   69,  882,  882,  882,  882,  882,  882,  882,  882,
			  882,  882,   63,   61,  882,  882,  882,  882,  882,  882,
			  882,  882,  884,  884,  884,  884,  884,  884,  884,  884,
			  884,  884,  884,  884,  884,   53,   51,   45,  884,  884,
			  884,  884,  884,  884,  884,  884,  884,  884,   43,   39,
			  884,  884,  884,  884,  884,  884,  884,  884,  885,  885,
			  885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
			  885,  885,  885,  885,  885,  885,  885,  885,  885,   35,
			  885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
			  885,  885,  885,  885,  885,  885,  885,  885,  885,  885,

			  886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
			  886,    0,    0,    0,    0,    0,  886,  886,  886,  886,
			  886,  886,  886,  886,  886,  886,    0,    0,  886,  886,
			  886,  886,  886,  886,  886,  886,  887,  887,  887,  887,
			  887,  887,  887,  887,  887,  887,  887,  887,  887,    0,
			    0,    0,  887,  887,  887,  887,  887,  887,  887,  887,
			  887,  887,    0,    0,  887,  887,  887,  887,  887,  887,
			  887,  887,  888,  888,  888,  888,  888,  888,  888,  888,
			  888,  888,  888,  888,  888,    0,    0,    0,  888,  888,
			  888,  888,  888,  888,  888,  888,  888,  888,    0,    0,

			  888,  888,  888,  888,  888,  888,  888,  888,  889,  889,
			  889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
			  889,    0,    0,    0,  889,  889,  889,  889,  889,  889,
			  889,  889,  889,  889,    0,    0,  889,  889,  889,  889,
			  889,  889,  889,  889,  890,  890,  890,  890,  890,  890,
			  890,  890,  890,  890,  890,  890,  890,    0,    0,    0,
			  890,  890,  890,  890,  890,  890,  890,  890,  890,  890,
			    0,    0,  890,  890,  890,  890,  890,  890,  890,  890,
			  891,  891,  891,  891,  891,  891,  891,  891,  891,  891,
			  891,  891,    0,    0,    0,    0,  891,  891,  891,  891,

			  891,  891,  891,  891,  891,  891,    0,    0,  891,  891,
			  891,  891,  891,  891,  891,  891,  892,  892,  892,  892,
			  892,  892,  892,    0,  892,  892,  892,  892,  892,  892,
			  892,  892,  892,  892,  892,  892,  892,  892,    0,    0,
			  892,  892,  892,  892,  892,  892,  892,  892,  892,  892,
			  892,    0,    0,  892,  892,  892,  892,  892,  892,  892,
			  893,  893,  893,  893,    0,  893,  893,    0,  893,  893,
			  893,  893,  893,  893,  893,  893,  893,  893,  893,  893,
			  893,  893,    0,    0,  893,  893,  893,  893,  893,  893,
			  893,  893,  893,  893,  893,    0,    0,  893,  893,  893,

			  893,  893,  893,  893,  894,  894,  894,  894,  894,  894,
			  894,  894,  894,  894,  894,  894,  894,  894,  894,  894,
			  894,  894,  894,  894,  894,  894,  894,  894,  894,  894,
			  894,  894,  894,  894,  894,  894,  894,  894,  894,  894,
			  894,  894,  894,  894,  894,  894,  894,  894,  894,  894,
			  895,  895,  895,  895,  895,  895,  895,  895,  895,  895,
			  895,  895,  895,  895,  895,  895,  895,  895,  895,  895,
			  895,  895,  895,  895,  895,  895,  895,  895,  895,  895,
			  895,  895,  895,  895,  895,  895,  895,  895,  895,  895,
			  895,  895,  895,  895,  895,  895,  896,  896,  896,  896,

			  896,  896,  896,  896,  896,  896,  896,  896,  896,  896,
			  896,  896,  896,  896,  896,  896,  896,  896,  896,  896,
			  896,  896,  896,  896,  896,  896,  896,  896,  896,  896,
			  896,  896,  896,  896,  896,  896,  896,  896,  896,  896,
			  896,  896,  897,  897,  897,  897,  897,  897,  897,  897,
			  897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
			  897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
			  897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
			  897,  897,  897,  897,  897,  897,  897,  897,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849>>,
			1, 1782, 3000)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,   93,   19,   27,  186,    0,   63,   67,   72,
			   81,  279,    0,  372,  465,  558,  651,  744,  837,  930,
			 1023, 1116,    0,   19,   91, 1209,    0,    1,  373,  380,
			  386,   92,  376,  394,  438, 4179, 4688,    5, 4688, 4146,
			  310,  424,   11, 4086,   35, 4049,   41,   45,   52,  360,
			  400, 4118,   89, 4047,  320,   60,  329,   21,   51,  413,
			 1297, 4078,  357, 4024,  387,   69,  421,   55,  516, 4066,
			 4026, 4019, 4030,  443, 4688, 4074, 4014,  424, 3977,  451,
			  301,  454,  544,  569, 4688, 4688,  491, 4029, 4688,  583,
			 4688,  503,  457, 3975,  480,  336,  489, 4688, 4688, 4059,

			  508, 4688,  542, 4688, 4688,  521, 3925,  529,  346,  534,
			 4688, 4688, 4688, 4688, 4009,  534,  547,  582,  542, 3923,
			  555,  367,  573,  662,  674,  596,  601,    0, 4688,  668,
			  612,  623, 4688, 3947,  609, 3897,  612,  391,  620, 4688,
			 3920, 4688, 4688, 4688, 4688, 4688,  629,  634, 4688,  679,
			  684, 4688,  643, 3882,  647,  435,  676, 4688,  560, 4688,
			  696,  701,  712,  717, 4688, 4688, 4688,  726, 4688, 4688,
			 3961, 3895,  692, 3868,  695,  523,  709,   10, 4688,  731,
			  712, 3857,  725,  582,  739,  829, 1383,    1, 3864, 3863,
			 3861,  774, 3853,  777,  595,  780,    1, 4688,  321, 3886,

			  780,  788,  791,  794,  797,  797,  805, 3798,  808,  622,
			  811, 3850,  811,  819,  822,  827,  830,  917,  854,  862,
			 3775,  865,  741,  868, 1471,  871, 3718,  874,  758,  877,
			 4688, 1559,  880,  883,  886,  889,  976, 4688, 3721, 3709,
			 3680,  893,  901, 3657,  904,  851,  907, 4688, 3709,  907,
			  915,  918,  921,  924, 1034, 3698, 1038, 4688,  955,  927,
			 3644,  963,  944,  969, 4688,  969,  977, 3643,  984,  965,
			  987,  987,  995,  998, 1001, 1004, 4688, 1004, 1012, 3642,
			 1015,  979, 1018, 1645,    7, 3629, 3628, 3616, 1232, 3608,
			 1235, 1020, 1238, 1244, 1252, 1255, 1258, 1261, 4688, 1261,

			 1274, 3607, 1277, 1228, 1280, 1721, 1283, 3606, 1286, 1240,
			 1289, 1406, 1807, 1292, 3585, 1297, 1268, 1306, 1306, 1330,
			 1333, 1336, 1351, 1438, 1883, 1358, 3584, 1361, 1338, 1364,
			 1364, 1372, 3573, 1375, 1377, 1380, 1453, 1446, 1430, 1454,
			 1460, 3625, 1407, 1421, 1424, 1429, 1438, 3620, 1491, 1441,
			 3570, 1454, 1467, 1471, 1496, 1509, 3549, 1512, 1490, 1515,
			 1546, 1539, 1516, 1524, 1527, 1530, 1536, 3591, 3577, 3583,
			 1589, 1599, 1594, 1604, 1610, 1618, 3563, 3587, 4688, 1554,
			 1570, 1574, 1618, 1691,    0, 4688, 1638, 3524, 1641, 1546,
			 1644, 3535, 3525, 3567, 3566, 3522, 1666, 1674, 1677, 1680,

			 1683, 3577, 3544, 3554,   93,  863, 4688, 1686, 1689, 4688,
			 1692, 1695, 1695, 1703, 1706, 1709, 1712, 1715, 1718, 1721,
			 1730, 1733, 1736, 3517, 3517, 3511, 4688, 1754, 1757, 1757,
			 1765, 1768, 1771, 1774, 1777, 1780, 1783, 1786, 1789, 1792,
			 4688, 1795, 3501, 1798, 1558, 1801, 3512, 3512, 3554, 3553,
			 3509, 1858, 1805, 1830, 1833, 1836, 1839, 1842, 4688, 1845,
			 3495, 1848, 1807, 1851, 1871, 1854, 1857, 1866, 1869, 1956,
			 3559, 4688, 1879, 3484, 1882, 1871, 1903, 1914, 1906, 1909,
			 1912, 1922, 1925, 1928, 4688, 1931, 3483, 1934, 1914, 1937,
			 1939, 1947, 1950, 1953, 1956, 1959, 1962, 1965, 1968, 3505,

			    2, 3509, 4688, 1976, 2010, 2015, 2003, 4688, 1973, 1984,
			 3518, 1984, 1992, 1995, 1998, 2001, 2023, 2026, 2029, 2032,
			 2032, 2042, 2040, 2050, 3500, 3468, 3466, 2074, 2053, 2089,
			 2097, 2102, 2107, 4688, 4688, 2062, 2065, 4688, 3485, 2068,
			 2071, 2082, 2085, 3483, 3426, 4688, 4688, 3424, 4688, 2088,
			 2097, 4688, 3454, 3452, 1446, 2130, 2117, 2120, 2123, 2126,
			 3424, 3423, 3417, 2129, 2132, 2135, 2138, 2141, 2144, 2147,
			 2150, 3455, 3407, 4688, 4688, 3405, 4688, 2153, 2156, 2159,
			 2162, 2165, 2168, 4688, 2171, 2174, 2242, 2254,   11, 2201,
			 2204, 2207, 2210, 4688, 2213, 2216, 2219, 2222, 2225, 2228,

			 4688, 2231, 2234, 2237, 2240, 3429, 3442, 3427, 3426, 2276,
			 2281, 2286, 2291, 3443, 2247, 2252, 2255, 2258, 2296, 3438,
			 3431, 3421, 2310, 2301, 2315, 2349, 2341, 2321, 4688, 2262,
			 2265, 4688, 3444, 3443, 3396, 3400, 2413, 2417, 3365, 3369,
			 3348, 2273, 2276, 4688, 3390, 3379, 2337, 2340, 4688, 3378,
			 3377, 2349, 2357, 2360, 2364, 3361, 3359, 3342, 3349, 2368,
			 2389, 2415, 2407, 3320, 2373, 3334, 3328, 3327, 2378, 2427,
			 2402, 2432, 2438, 2397, 4688, 4688, 3313, 3296, 2472, 3281,
			 2507, 3241, 3221, 3177, 4688, 4688, 4688, 3149, 3134, 3119,
			 3108, 2443, 2460, 2535, 2540, 3125, 4688, 3120, 3105, 2472,

			 2465, 2477, 2492, 2497, 3106, 3119, 4688, 3085, 3070, 2569,
			 3081, 3072, 3048, 2722, 2486, 2589, 2595, 4688, 2726, 2724,
			 2526, 2550, 2556, 2723, 2693, 2618, 2674, 2651, 2670, 2669,
			 4688, 2660, 2702, 2639, 2519, 2583, 4688, 2574, 2545, 2575,
			 2588, 4688, 4688, 2680, 2492, 2537, 2526, 4688, 4688, 2497,
			 2657, 4688, 2583, 2427, 2602, 1976, 2607, 4688, 2610, 2426,
			 2613, 2003, 2616, 4688, 2274, 2630, 2703, 2465, 2317, 4688,
			 2637, 2626, 2629, 2632, 2635, 2679, 2645, 2648, 2652, 2655,
			 2086, 2081, 2343, 2423, 2742, 2264, 2252, 4688, 2664, 2669,
			 4688, 2672, 2675, 2183, 1985, 1969, 1845, 1820, 1785, 1736,

			 1683,  346,  363, 1734, 1721, 1685, 1658, 1579, 1609, 1588,
			 1530, 1470, 1512, 1426, 1402, 1339, 1335, 4688, 1346, 2584,
			 1302,  975, 2628,  764,  807,  705,  741,  601,  618,  591,
			  492,  431,  456,  430,  416,  360, 4688,  404,  382,  346,
			 4688,  311,  133,   79, 4688,   99,   59,   55,    7, 4688,
			 2772, 2819, 2866, 2913, 2960, 3007, 3054, 3096, 3136, 3182,
			 3224, 3266, 3312, 3348, 3384, 3426, 3466, 3508, 3533, 3573,
			 3598, 3634, 3670, 3706, 3748, 3794, 3836, 3882, 3918, 3960,
			 4002, 4038, 4074, 3132, 4110, 4152, 4188, 4224, 4260, 4296,
			 4332, 4368, 4413, 4457, 4502, 4548, 4594, 4640>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  850,  850,  851,  851,  849,    5,  852,  852,  853,
			  853,  849,   11,  854,  854,  854,  854,  855,  855,  855,
			  855,  849,   21,   21,   21,  849,   25,   25,   25,   21,
			   21,   21,   21,  856,  856,  849,  849,  849,  849,  849,
			  857,  858,  849,  849,  849,  849,  849,  849,  849,  859,
			  859,  849,  849,  849,  849,  849,  849,  849,  849,  860,
			  861,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  862,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  863,  849,  849,  849,
			  849,  864,  849,  849,  849,  849,  849,  849,  849,  849,

			  865,  849,  866,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  867,  868,  869,  849,  849,
			  849,  849,  849,  849,  849,  870,  871,  849,  849,  871,
			  871,  871,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  872,  873,  849,  873,
			  873,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  873,  873,  873,  873,  849,  849,  849,  871,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  857,
			  849,  849,  849,  849,  849,  849,  858,  186,  186,  186,
			  186,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  874,  849,  849,  849,  849,  859,  849,  849,  849,  849,
			  849,  849,  875,  849,  849,  849,  849,  849,  860,  849,
			  849,  849,  849,  849,  861,  849,  849,  849,  849,  849,
			  849,  876,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  862,  849,  849,  849,  849,  849,  849,  849,  877,
			  849,  849,  849,  849,  849,  849,  849,  849,  863,  849,
			  849,  849,  849,  849,  849,  864,  849,  849,  849,  849,
			  849,  878,  849,  849,  849,  849,  849,  865,  849,  849,
			  849,  849,  849,  866,  283,  283,  283,  283,  849,  849,
			  849,  849,  849,  879,  849,  849,  849,  849,  849,  867,

			  849,  849,  849,  849,  849,  868,  849,  849,  849,  849,
			  849,  849,  869,  849,  849,  849,  849,  849,  880,  849,
			  849,  849,  849,  849,  870,  849,  849,  849,  849,  849,
			  871,  849,  849,  849,  849,  849,  849,  871,  871,  871,
			  871,  849,  881,  849,  849,  849,  849,  849,  872,  849,
			  849,  849,  849,  849,  873,  849,  849,  849,  849,  849,
			  873,  873,  882,  849,  849,  849,  849,  849,  849,  849,
			  873,  873,  873,  873,  873,  871,  849,  849,  849,  849,
			  849,  849,  849,  849,  883,  849,  849,  849,  849,  849,
			  849,  186,  186,  186,  186,  186,  884,  849,  849,  849,

			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  885,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  886,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  283,  283,  283,  283,
			  283,  887,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  888,  849,  849,  849,  849,  849,
			  883,  849,  849,  849,  849,  849,  849,  889,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  890,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  849,  849,  849,  871,  871,  871,  871,  849,  849,  849,
			  849,  891,  849,  849,  849,  849,  849,  849,  849,  849,
			  873,  873,  849,  849,  849,  849,  849,  873,  873,  873,
			  873,  873,  871,  849,  849,  849,  849,  849,  883,  849,
			  849,  849,  849,  186,  186,  849,  849,  186,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  283,  283,  849,  849,  283,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  883,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  849,  849,  849,  849,  849,  849,  849,  849,  849,  871,
			  871,  871,  871,  849,  849,  849,  849,  849,  873,  849,
			  849,  849,  873,  873,  873,  873,  873,  871,  849,  849,
			  849,  849,  186,  186,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  283,  283,  849,  849,  849,  883,
			  883,  849,  849,  849,  849,  849,  849,  849,  849,  871,
			  871,  871,  871,  849,  873,  849,  849,  849,  873,  873,
			  873,  873,  873,  871,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  871,  871,  871,  871,  849,  849,  849,  849,  873,

			  873,  873,  873,  873,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  871,  849,  849,  849,  849,  849,
			  873,  873,  873,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  892,  893,  894,  895,  849,  849,  873,  873,
			  873,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  896,  849,  849,  849,  849,  897,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,

			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,    0,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
			  849,  849,  849,  849,  849,  849,  849,  849>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    6,    7,    8,    9,   10,   11,   12,
			   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
			   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
			   33,   34,   35,   36,    9,   37,   38,   39,   40,   41,
			   42,   43,   44,   45,   44,   46,   47,   48,   49,   50,
			   51,   52,   53,   54,   55,   56,   44,   44,   57,   58,
			   59,   60,   61,   62,   61,   63,   61,   64,   65,   66,

			   67,   68,   69,   70,   44,   71,   44,   44,   72,   73,
			   74,   75,   76,   77,   78,   79,   80,   81,   82,   44,
			   83,   84,   44,   61,   85,   61,   61,   61,   86,   86,
			   86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
			   86,   86,   86,   86,   87,   87,   87,   87,   87,   87,
			   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
			   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
			   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
			   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
			   88,   88,    1,    1,   89,   89,   89,   89,   89,   89,

			   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
			   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
			   89,   89,   89,   89,   90,   91,   91,   91,   91,   91,
			   91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
			   92,   93,   93,   93,   93,   93,   93,   93,    1,    1,
			    1,    1,    1,    1,    1,    1,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    4,    5,    6,    7,    8,    6,
			    9,   10,   11,    6,    6,    6,    6,    6,   12,   13,
			    6,   14,   14,   15,   16,   17,   18,   19,   20,   21,
			   22,   23,   24,   25,    6,   26,   27,   28,   28,   28,
			   28,   28,   28,   29,   30,   29,   29,   29,   29,   29,
			   29,   29,   31,   29,   32,   33,   34,   35,   36,   37,
			   38,   26,   39,   40,   28,   28,   28,   28,   28,   28,
			   29,   29,   29,   29,   29,   29,   41,   42,   29,   43,
			   29,   44,   29,   45,   46,   26,    1,    1,    1,   47,
			   47,   47,   47,   47>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  139,  137,  133,  132,  131,
			  134,  120,   89,  136,  137,  137,  137,  137,  137,    4,
			    4,    6,  137,  137,  137,  137,  137,   19,   19,   20,
			   17,   22,  137,  137,  137,  137,  137,   15,   15,  137,
			  137,  137,  137,   26,   25,   25,   28,  137,  137,  137,
			  137,  137,   97,   97,  100,   99,   95,  137,   92,   98,
			   91,   93,  137,  137,  137,  137,  137,  115,  115,  115,

			  116,  126,  120,  125,  113,  137,  137,  137,  137,  137,
			  127,  128,  122,  121,  121,  123,   87,  120,  137,  137,
			  137,  137,  137,   65,   65,   84,   63,  137,   62,   63,
			   63,   63,   45,   46,  137,  137,  137,  137,  137,   44,
			  137,   72,   73,   75,   76,   71,   77,   63,   74,   63,
			   63,   70,  137,  137,  137,  137,  137,   43,  137,   42,
			   63,   63,   63,   63,   81,   79,   80,   63,   57,   57,
			   57,   57,  137,  137,  137,  137,  137,  133,  130,  134,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   88,    9,    0,

			  135,    0,    0,    0,    0,    4,    0,    0,    0,    0,
			    0,    3,    5,    0,    0,    0,    0,   19,   20,    0,
			    0,    0,    0,    0,   17,    0,    0,    0,    0,    0,
			   16,   18,    0,    0,    0,    0,   15,   10,    0,    0,
			    0,   26,    0,    0,    0,    0,    0,   25,    0,   27,
			    0,    0,    0,    0,   97,    0,   98,   91,   95,    0,
			    0,    0,    0,    0,   90,   93,    0,    0,    0,    0,
			    0,   94,    0,    0,    0,    0,  114,  116,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  117,    0,    0,    0,    0,  121,  123,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  124,    0,
			    0,    0,    0,   65,    0,    0,    0,    0,    0,    0,
			   63,    0,    0,    0,    0,    0,    0,   63,   63,   63,
			   63,    0,   64,    0,    0,    0,    0,    0,   77,    0,
			    0,    0,    0,    0,   63,    0,    0,    0,    0,    0,
			   63,   63,   64,    0,    0,    0,    0,    0,    0,    0,
			   63,   63,   34,   63,   63,   63,    0,    0,   57,    0,
			    0,    0,    0,    0,    0,  106,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,  129,    0,    0,    2,
			    0,    0,   21,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,   24,    0,    0,   96,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  111,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,   85,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  108,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,   82,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,   53,   63,   63,   63,   63,   54,    0,    0,
			    0,   78,    0,    0,    0,    0,    0,    0,    0,    0,
			   60,   63,    0,    0,    0,    0,    0,   63,   63,   63,
			   63,   63,   63,   55,   56,    0,    0,  118,    0,    0,
			    0,    0,    0,    0,    0,  104,  103,    0,  107,    0,
			    0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  104,  103,    0,  112,    0,    0,    0,
			    0,    0,    0,   86,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  109,    0,    0,    0,    0,    0,    0,

			   83,    0,    0,    0,    0,    0,    0,    0,    0,   63,
			   63,   63,   63,    0,    0,    0,    0,    0,   63,    0,
			    0,    0,   63,   63,   63,   63,   63,   63,  119,    0,
			    0,  105,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  105,    0,    0,    0,    0,  110,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   63,
			   63,   63,   63,    0,   59,    0,    0,    0,   33,   63,
			   35,   63,   63,   61,  101,  102,    0,    0,    8,    0,
			    7,    0,    0,    0,  101,  102,  110,    0,    0,    0,
			    0,   51,   63,   63,   63,    0,   32,    0,    0,   63,

			   37,   36,   63,   63,    0,    0,    8,    0,    0,    0,
			    0,    0,    0,    0,   52,    0,    0,   58,    0,    0,
			   63,   39,   63,    0,    0,    0,    0,    0,    0,    0,
			   49,    0,    0,    0,    0,    0,   31,    0,   38,   40,
			   41,   29,   23,    0,    0,    0,    0,   48,   47,    0,
			   69,   66,    0,    0,    0,    0,    0,   66,    0,    0,
			    0,    0,    0,   30,    0,    0,    0,    0,    0,   50,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
			   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   11,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,   13,    0,    0,    0,
			   14,    0,    0,    0,   12,    0,    0,    0,    0,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 4688
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 849
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 850
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 138
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 139
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is true
			-- Is `position' used?

	INITIAL: INTEGER is 0
	comment_state: INTEGER is 1
	processinginstruction: INTEGER is 2
	xmldeclaration: INTEGER is 3
	cdata: INTEGER is 4
	tag: INTEGER is 5
	attribute_value_single: INTEGER is 6
	attribute_value_double: INTEGER is 7
	entity_value_single: INTEGER is 8
	entity_value_double: INTEGER is 9
	doctype: INTEGER is 10
	dtd_in: INTEGER is 11
	dtd_element: INTEGER is 12
	dtd_attlist: INTEGER is 13
	dtd_entity: INTEGER is 14
	dtd_notation: INTEGER is 15
	dtd_ignore: INTEGER is 16
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make_scanner is
			-- Create a new scanner.
		do
			!! character_entity.make
			make_with_buffer (Empty_buffer)
			reset
		end

feature -- Reset

	reset is
			-- Reset.
		do
			Precursor
			filename := "-"
			!XM_FILE_SOURCE! source.make (filename)
			last_error := Void
			!! start_conditions.make
		end

	push_start_condition_dtd_ignore is
			-- Push start condition 'dtd_ignore' to the stack.
		do
			push_start_condition (dtd_ignore)
		end

feature -- Input

	set_input_buffer (a_buffer: like input_buffer) is
			-- Set `input_buffer' to `a_buffer'.
		do
			Precursor (a_buffer)
			filename := a_buffer.name
			!XM_FILE_SOURCE! source.make (filename)
		ensure then
			filename_set: filename = a_buffer.name
		end

	set_input_stream  (a_stream: KI_CHARACTER_INPUT_STREAM) is
			-- Set input buffer from a stream.
			-- This class is then in charge of closing it.
		require
			not_void: a_stream /= Void
			readable: a_stream.is_open_read
		local
			a_utf16: XM_EIFFEL_UTF16_INPUT_STREAM
		do
			input_stream := a_stream

			!! a_utf16.make_from_stream (a_stream)
			set_input_buffer (new_file_buffer (a_utf16))			
		end

	close_input is
			-- Close input buffer if needed.
		do
			if input_stream /= Void then
				if input_stream.is_closable then
					input_stream.close
				end
			end
		end
		
feature {NONE} -- Input

	input_stream: KI_CHARACTER_INPUT_STREAM
			 -- Saved stream for closing on end of stream.
			 
feature -- Error reporting

	has_error: BOOLEAN is
			-- Was there an error?
		do
			Result := last_error /= Void
		end

	last_error: STRING
			-- Last error

	fatal_error (a_message: STRING) is
			-- A fatal error occurred.
		do
			last_error := a_message
		end

feature -- Access

	filename: STRING
			-- Name of file being scanned

	source: XM_SOURCE
			-- Source of the XML document beeing parsed

	last_value: ANY
			-- Semantic value of last token read

feature {NONE} -- Character entity

	character_entity: XM_EIFFEL_CHARACTER_ENTITY
			-- Character entity manager (class once)

feature {NONE} -- Start condition stack

	push_start_condition (a_condition: INTEGER) is
			-- Set start condition and add previous to stack.
		do
			start_conditions.force (start_condition)
			set_start_condition (a_condition)
		end

	pop_start_condition is
			-- Restore previous start condition.
		do
			if not start_conditions.is_empty then
					-- This would be a precondition save for 
					-- invalid input document.
				set_start_condition (start_conditions.item)
				start_conditions.remove
			else 
				-- Error, to be reported later in parser hopefully.
			end
		end

	start_conditions: DS_LINKED_STACK [INTEGER]
			-- Start conditions

feature {NONE} -- System literal

	system_literal_text: STRING is
			-- Find last quoted substring in scanner text.
			-- (this is microparsing, justified above)
		require
			quote_at_end: text_item (text_count) = '%'' or text_item (text_count) = '%"'
			--quote_in: text_substring (1, text_count-1).has (text_item (text_count))
		local
			i: INTEGER
			a_quote: CHARACTER
		do
			from
				a_quote := text_item (text_count)
				i := text_count - 1
			invariant
				i >= 0
			variant
				i
			until
				text_item (i) = a_quote
			loop
				i := i - 1
			end
			Result := text_substring (i + 1, text_count - 1)
		end

feature {NONE} -- Constants

	normalized_newline: STRING is
			-- Newline normalized text (2.11)
		once
			Result := "%N"
		ensure
			normalized_newline_not_void: Result /= Void
		end

	has_normalized_newline: BOOLEAN is
			-- Has newline normalization already been applied?
		do
			Result := False
		end

	normalized_space: STRING is " "
			-- Normalized space

	two_normalized_spaces: STRING is "  "
			-- Two normalized spaces

invariant

	start_conditions_not_void: start_conditions /= Void
	character_entity_not_void: character_entity /= Void
	filename_not_void: filename /= Void
	source_not_void: source /= Void

end
