indexing

	description:

		"Eiffel parsers"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2002, Eric Bezault and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: 2002/11/29 09:57:41 $"
	revision: "$Revision: 1.20 $"

class ET_EIFFEL_PARSER

inherit

	ET_EIFFEL_PARSER_SKELETON

	ET_EIFFEL_SCANNER
		rename
			make as make_eiffel_scanner,
			make_with_factory as make_eiffel_scanner_with_factory
		undefine
			reset
		end

creation

	make, make_with_factory


feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate ?= yytranslate_template
			yyr1 ?= yyr1_template
			yyr2 ?= yyr2_template
			yydefact ?= yydefact_template
			yydefgoto ?= yydefgoto_template
			yypact ?= yypact_template
			yypgoto ?= yypgoto_template
			yytable ?= yytable_template
			yycheck ?= yycheck_template
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
			if yy_act <= 200 then
				yy_do_action_1_200 (yy_act)
			elseif yy_act <= 400 then
				yy_do_action_201_400 (yy_act)
			elseif yy_act <= 600 then
				yy_do_action_401_600 (yy_act)
			else
					-- No action
				yyval := yyval_default
			end
		end

	yy_do_action_1_200 (yy_act: INTEGER) is
			-- Execute semantic action.
		do
			inspect yy_act
when 1 then
--|#line 180 "et_eiffel_parser.y"
	yy_do_action_1
when 2 then
--|#line 184 "et_eiffel_parser.y"
	yy_do_action_2
when 3 then
--|#line 191 "et_eiffel_parser.y"
	yy_do_action_3
when 4 then
--|#line 192 "et_eiffel_parser.y"
	yy_do_action_4
when 5 then
--|#line 195 "et_eiffel_parser.y"
	yy_do_action_5
when 6 then
--|#line 201 "et_eiffel_parser.y"
	yy_do_action_6
when 7 then
--|#line 207 "et_eiffel_parser.y"
	yy_do_action_7
when 8 then
--|#line 213 "et_eiffel_parser.y"
	yy_do_action_8
when 9 then
--|#line 219 "et_eiffel_parser.y"
	yy_do_action_9
when 10 then
--|#line 225 "et_eiffel_parser.y"
	yy_do_action_10
when 11 then
--|#line 230 "et_eiffel_parser.y"
	yy_do_action_11
when 12 then
--|#line 247 "et_eiffel_parser.y"
	yy_do_action_12
when 13 then
--|#line 249 "et_eiffel_parser.y"
	yy_do_action_13
when 14 then
--|#line 249 "et_eiffel_parser.y"
	yy_do_action_14
when 15 then
--|#line 262 "et_eiffel_parser.y"
	yy_do_action_15
when 16 then
--|#line 264 "et_eiffel_parser.y"
	yy_do_action_16
when 17 then
--|#line 268 "et_eiffel_parser.y"
	yy_do_action_17
when 18 then
--|#line 279 "et_eiffel_parser.y"
	yy_do_action_18
when 19 then
--|#line 291 "et_eiffel_parser.y"
	yy_do_action_19
when 20 then
--|#line 291 "et_eiffel_parser.y"
	yy_do_action_20
when 21 then
--|#line 300 "et_eiffel_parser.y"
	yy_do_action_21
when 22 then
--|#line 300 "et_eiffel_parser.y"
	yy_do_action_22
when 23 then
--|#line 311 "et_eiffel_parser.y"
	yy_do_action_23
when 24 then
--|#line 318 "et_eiffel_parser.y"
	yy_do_action_24
when 25 then
--|#line 322 "et_eiffel_parser.y"
	yy_do_action_25
when 26 then
--|#line 332 "et_eiffel_parser.y"
	yy_do_action_26
when 27 then
--|#line 334 "et_eiffel_parser.y"
	yy_do_action_27
when 28 then
--|#line 339 "et_eiffel_parser.y"
	yy_do_action_28
when 29 then
--|#line 350 "et_eiffel_parser.y"
	yy_do_action_29
when 30 then
--|#line 359 "et_eiffel_parser.y"
	yy_do_action_30
when 31 then
--|#line 361 "et_eiffel_parser.y"
	yy_do_action_31
when 32 then
--|#line 363 "et_eiffel_parser.y"
	yy_do_action_32
when 33 then
--|#line 365 "et_eiffel_parser.y"
	yy_do_action_33
when 34 then
--|#line 367 "et_eiffel_parser.y"
	yy_do_action_34
when 35 then
--|#line 369 "et_eiffel_parser.y"
	yy_do_action_35
when 36 then
--|#line 371 "et_eiffel_parser.y"
	yy_do_action_36
when 37 then
--|#line 375 "et_eiffel_parser.y"
	yy_do_action_37
when 38 then
--|#line 386 "et_eiffel_parser.y"
	yy_do_action_38
when 39 then
--|#line 392 "et_eiffel_parser.y"
	yy_do_action_39
when 40 then
--|#line 399 "et_eiffel_parser.y"
	yy_do_action_40
when 41 then
--|#line 406 "et_eiffel_parser.y"
	yy_do_action_41
when 42 then
--|#line 417 "et_eiffel_parser.y"
	yy_do_action_42
when 43 then
--|#line 419 "et_eiffel_parser.y"
	yy_do_action_43
when 44 then
--|#line 425 "et_eiffel_parser.y"
	yy_do_action_44
when 45 then
--|#line 425 "et_eiffel_parser.y"
	yy_do_action_45
when 46 then
--|#line 439 "et_eiffel_parser.y"
	yy_do_action_46
when 47 then
--|#line 450 "et_eiffel_parser.y"
	yy_do_action_47
when 48 then
--|#line 459 "et_eiffel_parser.y"
	yy_do_action_48
when 49 then
--|#line 468 "et_eiffel_parser.y"
	yy_do_action_49
when 50 then
--|#line 470 "et_eiffel_parser.y"
	yy_do_action_50
when 51 then
--|#line 472 "et_eiffel_parser.y"
	yy_do_action_51
when 52 then
--|#line 476 "et_eiffel_parser.y"
	yy_do_action_52
when 53 then
--|#line 478 "et_eiffel_parser.y"
	yy_do_action_53
when 54 then
--|#line 478 "et_eiffel_parser.y"
	yy_do_action_54
when 55 then
--|#line 491 "et_eiffel_parser.y"
	yy_do_action_55
when 56 then
--|#line 502 "et_eiffel_parser.y"
	yy_do_action_56
when 57 then
--|#line 510 "et_eiffel_parser.y"
	yy_do_action_57
when 58 then
--|#line 519 "et_eiffel_parser.y"
	yy_do_action_58
when 59 then
--|#line 521 "et_eiffel_parser.y"
	yy_do_action_59
when 60 then
--|#line 523 "et_eiffel_parser.y"
	yy_do_action_60
when 61 then
--|#line 525 "et_eiffel_parser.y"
	yy_do_action_61
when 62 then
--|#line 527 "et_eiffel_parser.y"
	yy_do_action_62
when 63 then
--|#line 529 "et_eiffel_parser.y"
	yy_do_action_63
when 64 then
--|#line 531 "et_eiffel_parser.y"
	yy_do_action_64
when 65 then
--|#line 533 "et_eiffel_parser.y"
	yy_do_action_65
when 66 then
--|#line 537 "et_eiffel_parser.y"
	yy_do_action_66
when 67 then
--|#line 539 "et_eiffel_parser.y"
	yy_do_action_67
when 68 then
--|#line 542 "et_eiffel_parser.y"
	yy_do_action_68
when 69 then
--|#line 542 "et_eiffel_parser.y"
	yy_do_action_69
when 70 then
--|#line 555 "et_eiffel_parser.y"
	yy_do_action_70
when 71 then
--|#line 566 "et_eiffel_parser.y"
	yy_do_action_71
when 72 then
--|#line 575 "et_eiffel_parser.y"
	yy_do_action_72
when 73 then
--|#line 586 "et_eiffel_parser.y"
	yy_do_action_73
when 74 then
--|#line 588 "et_eiffel_parser.y"
	yy_do_action_74
when 75 then
--|#line 594 "et_eiffel_parser.y"
	yy_do_action_75
when 76 then
--|#line 596 "et_eiffel_parser.y"
	yy_do_action_76
when 77 then
--|#line 598 "et_eiffel_parser.y"
	yy_do_action_77
when 78 then
--|#line 605 "et_eiffel_parser.y"
	yy_do_action_78
when 79 then
--|#line 613 "et_eiffel_parser.y"
	yy_do_action_79
when 80 then
--|#line 620 "et_eiffel_parser.y"
	yy_do_action_80
when 81 then
--|#line 627 "et_eiffel_parser.y"
	yy_do_action_81
when 82 then
--|#line 635 "et_eiffel_parser.y"
	yy_do_action_82
when 83 then
--|#line 642 "et_eiffel_parser.y"
	yy_do_action_83
when 84 then
--|#line 649 "et_eiffel_parser.y"
	yy_do_action_84
when 85 then
--|#line 656 "et_eiffel_parser.y"
	yy_do_action_85
when 86 then
--|#line 665 "et_eiffel_parser.y"
	yy_do_action_86
when 87 then
--|#line 674 "et_eiffel_parser.y"
	yy_do_action_87
when 88 then
--|#line 681 "et_eiffel_parser.y"
	yy_do_action_88
when 89 then
--|#line 688 "et_eiffel_parser.y"
	yy_do_action_89
when 90 then
--|#line 695 "et_eiffel_parser.y"
	yy_do_action_90
when 91 then
--|#line 702 "et_eiffel_parser.y"
	yy_do_action_91
when 92 then
--|#line 711 "et_eiffel_parser.y"
	yy_do_action_92
when 93 then
--|#line 718 "et_eiffel_parser.y"
	yy_do_action_93
when 94 then
--|#line 725 "et_eiffel_parser.y"
	yy_do_action_94
when 95 then
--|#line 732 "et_eiffel_parser.y"
	yy_do_action_95
when 96 then
--|#line 741 "et_eiffel_parser.y"
	yy_do_action_96
when 97 then
--|#line 748 "et_eiffel_parser.y"
	yy_do_action_97
when 98 then
--|#line 759 "et_eiffel_parser.y"
	yy_do_action_98
when 99 then
--|#line 761 "et_eiffel_parser.y"
	yy_do_action_99
when 100 then
--|#line 761 "et_eiffel_parser.y"
	yy_do_action_100
when 101 then
--|#line 774 "et_eiffel_parser.y"
	yy_do_action_101
when 102 then
--|#line 781 "et_eiffel_parser.y"
	yy_do_action_102
when 103 then
--|#line 789 "et_eiffel_parser.y"
	yy_do_action_103
when 104 then
--|#line 798 "et_eiffel_parser.y"
	yy_do_action_104
when 105 then
--|#line 807 "et_eiffel_parser.y"
	yy_do_action_105
when 106 then
--|#line 818 "et_eiffel_parser.y"
	yy_do_action_106
when 107 then
--|#line 820 "et_eiffel_parser.y"
	yy_do_action_107
when 108 then
--|#line 820 "et_eiffel_parser.y"
	yy_do_action_108
when 109 then
--|#line 833 "et_eiffel_parser.y"
	yy_do_action_109
when 110 then
--|#line 835 "et_eiffel_parser.y"
	yy_do_action_110
when 111 then
--|#line 839 "et_eiffel_parser.y"
	yy_do_action_111
when 112 then
--|#line 850 "et_eiffel_parser.y"
	yy_do_action_112
when 113 then
--|#line 850 "et_eiffel_parser.y"
	yy_do_action_113
when 114 then
--|#line 865 "et_eiffel_parser.y"
	yy_do_action_114
when 115 then
--|#line 869 "et_eiffel_parser.y"
	yy_do_action_115
when 116 then
--|#line 869 "et_eiffel_parser.y"
	yy_do_action_116
when 117 then
--|#line 879 "et_eiffel_parser.y"
	yy_do_action_117
when 118 then
--|#line 883 "et_eiffel_parser.y"
	yy_do_action_118
when 119 then
--|#line 894 "et_eiffel_parser.y"
	yy_do_action_119
when 120 then
--|#line 902 "et_eiffel_parser.y"
	yy_do_action_120
when 121 then
--|#line 913 "et_eiffel_parser.y"
	yy_do_action_121
when 122 then
--|#line 913 "et_eiffel_parser.y"
	yy_do_action_122
when 123 then
--|#line 924 "et_eiffel_parser.y"
	yy_do_action_123
when 124 then
--|#line 928 "et_eiffel_parser.y"
	yy_do_action_124
when 125 then
--|#line 935 "et_eiffel_parser.y"
	yy_do_action_125
when 126 then
--|#line 943 "et_eiffel_parser.y"
	yy_do_action_126
when 127 then
--|#line 950 "et_eiffel_parser.y"
	yy_do_action_127
when 128 then
--|#line 960 "et_eiffel_parser.y"
	yy_do_action_128
when 129 then
--|#line 969 "et_eiffel_parser.y"
	yy_do_action_129
when 130 then
--|#line 980 "et_eiffel_parser.y"
	yy_do_action_130
when 131 then
--|#line 982 "et_eiffel_parser.y"
	yy_do_action_131
when 132 then
--|#line 982 "et_eiffel_parser.y"
	yy_do_action_132
when 133 then
--|#line 995 "et_eiffel_parser.y"
	yy_do_action_133
when 134 then
--|#line 997 "et_eiffel_parser.y"
	yy_do_action_134
when 135 then
--|#line 1001 "et_eiffel_parser.y"
	yy_do_action_135
when 136 then
--|#line 1003 "et_eiffel_parser.y"
	yy_do_action_136
when 137 then
--|#line 1003 "et_eiffel_parser.y"
	yy_do_action_137
when 138 then
--|#line 1016 "et_eiffel_parser.y"
	yy_do_action_138
when 139 then
--|#line 1018 "et_eiffel_parser.y"
	yy_do_action_139
when 140 then
--|#line 1022 "et_eiffel_parser.y"
	yy_do_action_140
when 141 then
--|#line 1024 "et_eiffel_parser.y"
	yy_do_action_141
when 142 then
--|#line 1024 "et_eiffel_parser.y"
	yy_do_action_142
when 143 then
--|#line 1037 "et_eiffel_parser.y"
	yy_do_action_143
when 144 then
--|#line 1039 "et_eiffel_parser.y"
	yy_do_action_144
when 145 then
--|#line 1043 "et_eiffel_parser.y"
	yy_do_action_145
when 146 then
--|#line 1054 "et_eiffel_parser.y"
	yy_do_action_146
when 147 then
--|#line 1062 "et_eiffel_parser.y"
	yy_do_action_147
when 148 then
--|#line 1071 "et_eiffel_parser.y"
	yy_do_action_148
when 149 then
--|#line 1082 "et_eiffel_parser.y"
	yy_do_action_149
when 150 then
--|#line 1084 "et_eiffel_parser.y"
	yy_do_action_150
when 151 then
--|#line 1091 "et_eiffel_parser.y"
	yy_do_action_151
when 152 then
--|#line 1102 "et_eiffel_parser.y"
	yy_do_action_152
when 153 then
--|#line 1102 "et_eiffel_parser.y"
	yy_do_action_153
when 154 then
--|#line 1117 "et_eiffel_parser.y"
	yy_do_action_154
when 155 then
--|#line 1119 "et_eiffel_parser.y"
	yy_do_action_155
when 156 then
--|#line 1121 "et_eiffel_parser.y"
	yy_do_action_156
when 157 then
--|#line 1121 "et_eiffel_parser.y"
	yy_do_action_157
when 158 then
--|#line 1133 "et_eiffel_parser.y"
	yy_do_action_158
when 159 then
--|#line 1133 "et_eiffel_parser.y"
	yy_do_action_159
when 160 then
--|#line 1145 "et_eiffel_parser.y"
	yy_do_action_160
when 161 then
--|#line 1147 "et_eiffel_parser.y"
	yy_do_action_161
when 162 then
--|#line 1149 "et_eiffel_parser.y"
	yy_do_action_162
when 163 then
--|#line 1149 "et_eiffel_parser.y"
	yy_do_action_163
when 164 then
--|#line 1161 "et_eiffel_parser.y"
	yy_do_action_164
when 165 then
--|#line 1161 "et_eiffel_parser.y"
	yy_do_action_165
when 166 then
--|#line 1175 "et_eiffel_parser.y"
	yy_do_action_166
when 167 then
--|#line 1186 "et_eiffel_parser.y"
	yy_do_action_167
when 168 then
--|#line 1194 "et_eiffel_parser.y"
	yy_do_action_168
when 169 then
--|#line 1203 "et_eiffel_parser.y"
	yy_do_action_169
when 170 then
--|#line 1214 "et_eiffel_parser.y"
	yy_do_action_170
when 171 then
--|#line 1219 "et_eiffel_parser.y"
	yy_do_action_171
when 172 then
--|#line 1223 "et_eiffel_parser.y"
	yy_do_action_172
when 173 then
--|#line 1231 "et_eiffel_parser.y"
	yy_do_action_173
when 174 then
--|#line 1238 "et_eiffel_parser.y"
	yy_do_action_174
when 175 then
--|#line 1247 "et_eiffel_parser.y"
	yy_do_action_175
when 176 then
--|#line 1254 "et_eiffel_parser.y"
	yy_do_action_176
when 177 then
--|#line 1263 "et_eiffel_parser.y"
	yy_do_action_177
when 178 then
--|#line 1268 "et_eiffel_parser.y"
	yy_do_action_178
when 179 then
--|#line 1275 "et_eiffel_parser.y"
	yy_do_action_179
when 180 then
--|#line 1276 "et_eiffel_parser.y"
	yy_do_action_180
when 181 then
--|#line 1281 "et_eiffel_parser.y"
	yy_do_action_181
when 182 then
--|#line 1286 "et_eiffel_parser.y"
	yy_do_action_182
when 183 then
--|#line 1292 "et_eiffel_parser.y"
	yy_do_action_183
when 184 then
--|#line 1297 "et_eiffel_parser.y"
	yy_do_action_184
when 185 then
--|#line 1303 "et_eiffel_parser.y"
	yy_do_action_185
when 186 then
--|#line 1309 "et_eiffel_parser.y"
	yy_do_action_186
when 187 then
--|#line 1318 "et_eiffel_parser.y"
	yy_do_action_187
when 188 then
--|#line 1320 "et_eiffel_parser.y"
	yy_do_action_188
when 189 then
--|#line 1322 "et_eiffel_parser.y"
	yy_do_action_189
when 190 then
--|#line 1324 "et_eiffel_parser.y"
	yy_do_action_190
when 191 then
--|#line 1327 "et_eiffel_parser.y"
	yy_do_action_191
when 192 then
--|#line 1331 "et_eiffel_parser.y"
	yy_do_action_192
when 193 then
--|#line 1334 "et_eiffel_parser.y"
	yy_do_action_193
when 194 then
--|#line 1338 "et_eiffel_parser.y"
	yy_do_action_194
when 195 then
--|#line 1340 "et_eiffel_parser.y"
	yy_do_action_195
when 196 then
--|#line 1343 "et_eiffel_parser.y"
	yy_do_action_196
when 197 then
--|#line 1346 "et_eiffel_parser.y"
	yy_do_action_197
when 198 then
--|#line 1350 "et_eiffel_parser.y"
	yy_do_action_198
when 199 then
--|#line 1353 "et_eiffel_parser.y"
	yy_do_action_199
when 200 then
--|#line 1357 "et_eiffel_parser.y"
	yy_do_action_200
			else
					-- No action
				yyval := yyval_default
			end
		end

	yy_do_action_201_400 (yy_act: INTEGER) is
			-- Execute semantic action.
		do
			inspect yy_act
when 201 then
--|#line 1360 "et_eiffel_parser.y"
	yy_do_action_201
when 202 then
--|#line 1364 "et_eiffel_parser.y"
	yy_do_action_202
when 203 then
--|#line 1366 "et_eiffel_parser.y"
	yy_do_action_203
when 204 then
--|#line 1369 "et_eiffel_parser.y"
	yy_do_action_204
when 205 then
--|#line 1372 "et_eiffel_parser.y"
	yy_do_action_205
when 206 then
--|#line 1378 "et_eiffel_parser.y"
	yy_do_action_206
when 207 then
--|#line 1380 "et_eiffel_parser.y"
	yy_do_action_207
when 208 then
--|#line 1384 "et_eiffel_parser.y"
	yy_do_action_208
when 209 then
--|#line 1386 "et_eiffel_parser.y"
	yy_do_action_209
when 210 then
--|#line 1392 "et_eiffel_parser.y"
	yy_do_action_210
when 211 then
--|#line 1394 "et_eiffel_parser.y"
	yy_do_action_211
when 212 then
--|#line 1396 "et_eiffel_parser.y"
	yy_do_action_212
when 213 then
--|#line 1398 "et_eiffel_parser.y"
	yy_do_action_213
when 214 then
--|#line 1400 "et_eiffel_parser.y"
	yy_do_action_214
when 215 then
--|#line 1402 "et_eiffel_parser.y"
	yy_do_action_215
when 216 then
--|#line 1404 "et_eiffel_parser.y"
	yy_do_action_216
when 217 then
--|#line 1406 "et_eiffel_parser.y"
	yy_do_action_217
when 218 then
--|#line 1408 "et_eiffel_parser.y"
	yy_do_action_218
when 219 then
--|#line 1410 "et_eiffel_parser.y"
	yy_do_action_219
when 220 then
--|#line 1412 "et_eiffel_parser.y"
	yy_do_action_220
when 221 then
--|#line 1414 "et_eiffel_parser.y"
	yy_do_action_221
when 222 then
--|#line 1416 "et_eiffel_parser.y"
	yy_do_action_222
when 223 then
--|#line 1418 "et_eiffel_parser.y"
	yy_do_action_223
when 224 then
--|#line 1420 "et_eiffel_parser.y"
	yy_do_action_224
when 225 then
--|#line 1422 "et_eiffel_parser.y"
	yy_do_action_225
when 226 then
--|#line 1424 "et_eiffel_parser.y"
	yy_do_action_226
when 227 then
--|#line 1426 "et_eiffel_parser.y"
	yy_do_action_227
when 228 then
--|#line 1428 "et_eiffel_parser.y"
	yy_do_action_228
when 229 then
--|#line 1430 "et_eiffel_parser.y"
	yy_do_action_229
when 230 then
--|#line 1432 "et_eiffel_parser.y"
	yy_do_action_230
when 231 then
--|#line 1434 "et_eiffel_parser.y"
	yy_do_action_231
when 232 then
--|#line 1436 "et_eiffel_parser.y"
	yy_do_action_232
when 233 then
--|#line 1439 "et_eiffel_parser.y"
	yy_do_action_233
when 234 then
--|#line 1441 "et_eiffel_parser.y"
	yy_do_action_234
when 235 then
--|#line 1443 "et_eiffel_parser.y"
	yy_do_action_235
when 236 then
--|#line 1445 "et_eiffel_parser.y"
	yy_do_action_236
when 237 then
--|#line 1447 "et_eiffel_parser.y"
	yy_do_action_237
when 238 then
--|#line 1449 "et_eiffel_parser.y"
	yy_do_action_238
when 239 then
--|#line 1451 "et_eiffel_parser.y"
	yy_do_action_239
when 240 then
--|#line 1453 "et_eiffel_parser.y"
	yy_do_action_240
when 241 then
--|#line 1455 "et_eiffel_parser.y"
	yy_do_action_241
when 242 then
--|#line 1457 "et_eiffel_parser.y"
	yy_do_action_242
when 243 then
--|#line 1459 "et_eiffel_parser.y"
	yy_do_action_243
when 244 then
--|#line 1461 "et_eiffel_parser.y"
	yy_do_action_244
when 245 then
--|#line 1463 "et_eiffel_parser.y"
	yy_do_action_245
when 246 then
--|#line 1465 "et_eiffel_parser.y"
	yy_do_action_246
when 247 then
--|#line 1467 "et_eiffel_parser.y"
	yy_do_action_247
when 248 then
--|#line 1469 "et_eiffel_parser.y"
	yy_do_action_248
when 249 then
--|#line 1471 "et_eiffel_parser.y"
	yy_do_action_249
when 250 then
--|#line 1473 "et_eiffel_parser.y"
	yy_do_action_250
when 251 then
--|#line 1479 "et_eiffel_parser.y"
	yy_do_action_251
when 252 then
--|#line 1481 "et_eiffel_parser.y"
	yy_do_action_252
when 253 then
--|#line 1481 "et_eiffel_parser.y"
	yy_do_action_253
when 254 then
--|#line 1494 "et_eiffel_parser.y"
	yy_do_action_254
when 255 then
--|#line 1501 "et_eiffel_parser.y"
	yy_do_action_255
when 256 then
--|#line 1508 "et_eiffel_parser.y"
	yy_do_action_256
when 257 then
--|#line 1518 "et_eiffel_parser.y"
	yy_do_action_257
when 258 then
--|#line 1529 "et_eiffel_parser.y"
	yy_do_action_258
when 259 then
--|#line 1536 "et_eiffel_parser.y"
	yy_do_action_259
when 260 then
--|#line 1545 "et_eiffel_parser.y"
	yy_do_action_260
when 261 then
--|#line 1554 "et_eiffel_parser.y"
	yy_do_action_261
when 262 then
--|#line 1563 "et_eiffel_parser.y"
	yy_do_action_262
when 263 then
--|#line 1572 "et_eiffel_parser.y"
	yy_do_action_263
when 264 then
--|#line 1583 "et_eiffel_parser.y"
	yy_do_action_264
when 265 then
--|#line 1585 "et_eiffel_parser.y"
	yy_do_action_265
when 266 then
--|#line 1587 "et_eiffel_parser.y"
	yy_do_action_266
when 267 then
--|#line 1587 "et_eiffel_parser.y"
	yy_do_action_267
when 268 then
--|#line 1600 "et_eiffel_parser.y"
	yy_do_action_268
when 269 then
--|#line 1607 "et_eiffel_parser.y"
	yy_do_action_269
when 270 then
--|#line 1614 "et_eiffel_parser.y"
	yy_do_action_270
when 271 then
--|#line 1624 "et_eiffel_parser.y"
	yy_do_action_271
when 272 then
--|#line 1635 "et_eiffel_parser.y"
	yy_do_action_272
when 273 then
--|#line 1642 "et_eiffel_parser.y"
	yy_do_action_273
when 274 then
--|#line 1651 "et_eiffel_parser.y"
	yy_do_action_274
when 275 then
--|#line 1660 "et_eiffel_parser.y"
	yy_do_action_275
when 276 then
--|#line 1669 "et_eiffel_parser.y"
	yy_do_action_276
when 277 then
--|#line 1678 "et_eiffel_parser.y"
	yy_do_action_277
when 278 then
--|#line 1689 "et_eiffel_parser.y"
	yy_do_action_278
when 279 then
--|#line 1691 "et_eiffel_parser.y"
	yy_do_action_279
when 280 then
--|#line 1693 "et_eiffel_parser.y"
	yy_do_action_280
when 281 then
--|#line 1695 "et_eiffel_parser.y"
	yy_do_action_281
when 282 then
--|#line 1697 "et_eiffel_parser.y"
	yy_do_action_282
when 283 then
--|#line 1699 "et_eiffel_parser.y"
	yy_do_action_283
when 284 then
--|#line 1701 "et_eiffel_parser.y"
	yy_do_action_284
when 285 then
--|#line 1703 "et_eiffel_parser.y"
	yy_do_action_285
when 286 then
--|#line 1707 "et_eiffel_parser.y"
	yy_do_action_286
when 287 then
--|#line 1709 "et_eiffel_parser.y"
	yy_do_action_287
when 288 then
--|#line 1711 "et_eiffel_parser.y"
	yy_do_action_288
when 289 then
--|#line 1713 "et_eiffel_parser.y"
	yy_do_action_289
when 290 then
--|#line 1715 "et_eiffel_parser.y"
	yy_do_action_290
when 291 then
--|#line 1719 "et_eiffel_parser.y"
	yy_do_action_291
when 292 then
--|#line 1721 "et_eiffel_parser.y"
	yy_do_action_292
when 293 then
--|#line 1723 "et_eiffel_parser.y"
	yy_do_action_293
when 294 then
--|#line 1725 "et_eiffel_parser.y"
	yy_do_action_294
when 295 then
--|#line 1727 "et_eiffel_parser.y"
	yy_do_action_295
when 296 then
--|#line 1731 "et_eiffel_parser.y"
	yy_do_action_296
when 297 then
--|#line 1733 "et_eiffel_parser.y"
	yy_do_action_297
when 298 then
--|#line 1737 "et_eiffel_parser.y"
	yy_do_action_298
when 299 then
--|#line 1739 "et_eiffel_parser.y"
	yy_do_action_299
when 300 then
--|#line 1743 "et_eiffel_parser.y"
	yy_do_action_300
when 301 then
--|#line 1745 "et_eiffel_parser.y"
	yy_do_action_301
when 302 then
--|#line 1747 "et_eiffel_parser.y"
	yy_do_action_302
when 303 then
--|#line 1749 "et_eiffel_parser.y"
	yy_do_action_303
when 304 then
--|#line 1755 "et_eiffel_parser.y"
	yy_do_action_304
when 305 then
--|#line 1757 "et_eiffel_parser.y"
	yy_do_action_305
when 306 then
--|#line 1763 "et_eiffel_parser.y"
	yy_do_action_306
when 307 then
--|#line 1765 "et_eiffel_parser.y"
	yy_do_action_307
when 308 then
--|#line 1767 "et_eiffel_parser.y"
	yy_do_action_308
when 309 then
--|#line 1769 "et_eiffel_parser.y"
	yy_do_action_309
when 310 then
--|#line 1771 "et_eiffel_parser.y"
	yy_do_action_310
when 311 then
--|#line 1773 "et_eiffel_parser.y"
	yy_do_action_311
when 312 then
--|#line 1775 "et_eiffel_parser.y"
	yy_do_action_312
when 313 then
--|#line 1777 "et_eiffel_parser.y"
	yy_do_action_313
when 314 then
--|#line 1781 "et_eiffel_parser.y"
	yy_do_action_314
when 315 then
--|#line 1785 "et_eiffel_parser.y"
	yy_do_action_315
when 316 then
--|#line 1787 "et_eiffel_parser.y"
	yy_do_action_316
when 317 then
--|#line 1791 "et_eiffel_parser.y"
	yy_do_action_317
when 318 then
--|#line 1794 "et_eiffel_parser.y"
	yy_do_action_318
when 319 then
--|#line 1794 "et_eiffel_parser.y"
	yy_do_action_319
when 320 then
--|#line 1807 "et_eiffel_parser.y"
	yy_do_action_320
when 321 then
--|#line 1818 "et_eiffel_parser.y"
	yy_do_action_321
when 322 then
--|#line 1827 "et_eiffel_parser.y"
	yy_do_action_322
when 323 then
--|#line 1838 "et_eiffel_parser.y"
	yy_do_action_323
when 324 then
--|#line 1840 "et_eiffel_parser.y"
	yy_do_action_324
when 325 then
--|#line 1847 "et_eiffel_parser.y"
	yy_do_action_325
when 326 then
--|#line 1849 "et_eiffel_parser.y"
	yy_do_action_326
when 327 then
--|#line 1856 "et_eiffel_parser.y"
	yy_do_action_327
when 328 then
--|#line 1858 "et_eiffel_parser.y"
	yy_do_action_328
when 329 then
--|#line 1865 "et_eiffel_parser.y"
	yy_do_action_329
when 330 then
--|#line 1867 "et_eiffel_parser.y"
	yy_do_action_330
when 331 then
--|#line 1874 "et_eiffel_parser.y"
	yy_do_action_331
when 332 then
--|#line 1876 "et_eiffel_parser.y"
	yy_do_action_332
when 333 then
--|#line 1883 "et_eiffel_parser.y"
	yy_do_action_333
when 334 then
--|#line 1885 "et_eiffel_parser.y"
	yy_do_action_334
when 335 then
--|#line 1892 "et_eiffel_parser.y"
	yy_do_action_335
when 336 then
--|#line 1894 "et_eiffel_parser.y"
	yy_do_action_336
when 337 then
--|#line 1901 "et_eiffel_parser.y"
	yy_do_action_337
when 338 then
--|#line 1912 "et_eiffel_parser.y"
	yy_do_action_338
when 339 then
--|#line 1912 "et_eiffel_parser.y"
	yy_do_action_339
when 340 then
--|#line 1927 "et_eiffel_parser.y"
	yy_do_action_340
when 341 then
--|#line 1929 "et_eiffel_parser.y"
	yy_do_action_341
when 342 then
--|#line 1931 "et_eiffel_parser.y"
	yy_do_action_342
when 343 then
--|#line 1933 "et_eiffel_parser.y"
	yy_do_action_343
when 344 then
--|#line 1935 "et_eiffel_parser.y"
	yy_do_action_344
when 345 then
--|#line 1937 "et_eiffel_parser.y"
	yy_do_action_345
when 346 then
--|#line 1939 "et_eiffel_parser.y"
	yy_do_action_346
when 347 then
--|#line 1941 "et_eiffel_parser.y"
	yy_do_action_347
when 348 then
--|#line 1943 "et_eiffel_parser.y"
	yy_do_action_348
when 349 then
--|#line 1945 "et_eiffel_parser.y"
	yy_do_action_349
when 350 then
--|#line 1947 "et_eiffel_parser.y"
	yy_do_action_350
when 351 then
--|#line 1949 "et_eiffel_parser.y"
	yy_do_action_351
when 352 then
--|#line 1951 "et_eiffel_parser.y"
	yy_do_action_352
when 353 then
--|#line 1957 "et_eiffel_parser.y"
	yy_do_action_353
when 354 then
--|#line 1959 "et_eiffel_parser.y"
	yy_do_action_354
when 355 then
--|#line 1961 "et_eiffel_parser.y"
	yy_do_action_355
when 356 then
--|#line 1963 "et_eiffel_parser.y"
	yy_do_action_356
when 357 then
--|#line 1967 "et_eiffel_parser.y"
	yy_do_action_357
when 358 then
--|#line 1969 "et_eiffel_parser.y"
	yy_do_action_358
when 359 then
--|#line 1971 "et_eiffel_parser.y"
	yy_do_action_359
when 360 then
--|#line 1973 "et_eiffel_parser.y"
	yy_do_action_360
when 361 then
--|#line 1977 "et_eiffel_parser.y"
	yy_do_action_361
when 362 then
--|#line 1979 "et_eiffel_parser.y"
	yy_do_action_362
when 363 then
--|#line 1985 "et_eiffel_parser.y"
	yy_do_action_363
when 364 then
--|#line 1987 "et_eiffel_parser.y"
	yy_do_action_364
when 365 then
--|#line 1989 "et_eiffel_parser.y"
	yy_do_action_365
when 366 then
--|#line 1991 "et_eiffel_parser.y"
	yy_do_action_366
when 367 then
--|#line 1995 "et_eiffel_parser.y"
	yy_do_action_367
when 368 then
--|#line 2002 "et_eiffel_parser.y"
	yy_do_action_368
when 369 then
--|#line 2009 "et_eiffel_parser.y"
	yy_do_action_369
when 370 then
--|#line 2018 "et_eiffel_parser.y"
	yy_do_action_370
when 371 then
--|#line 2029 "et_eiffel_parser.y"
	yy_do_action_371
when 372 then
--|#line 2031 "et_eiffel_parser.y"
	yy_do_action_372
when 373 then
--|#line 2035 "et_eiffel_parser.y"
	yy_do_action_373
when 374 then
--|#line 2037 "et_eiffel_parser.y"
	yy_do_action_374
when 375 then
--|#line 2044 "et_eiffel_parser.y"
	yy_do_action_375
when 376 then
--|#line 2051 "et_eiffel_parser.y"
	yy_do_action_376
when 377 then
--|#line 2060 "et_eiffel_parser.y"
	yy_do_action_377
when 378 then
--|#line 2069 "et_eiffel_parser.y"
	yy_do_action_378
when 379 then
--|#line 2071 "et_eiffel_parser.y"
	yy_do_action_379
when 380 then
--|#line 2071 "et_eiffel_parser.y"
	yy_do_action_380
when 381 then
--|#line 2084 "et_eiffel_parser.y"
	yy_do_action_381
when 382 then
--|#line 2095 "et_eiffel_parser.y"
	yy_do_action_382
when 383 then
--|#line 2103 "et_eiffel_parser.y"
	yy_do_action_383
when 384 then
--|#line 2112 "et_eiffel_parser.y"
	yy_do_action_384
when 385 then
--|#line 2121 "et_eiffel_parser.y"
	yy_do_action_385
when 386 then
--|#line 2123 "et_eiffel_parser.y"
	yy_do_action_386
when 387 then
--|#line 2127 "et_eiffel_parser.y"
	yy_do_action_387
when 388 then
--|#line 2129 "et_eiffel_parser.y"
	yy_do_action_388
when 389 then
--|#line 2131 "et_eiffel_parser.y"
	yy_do_action_389
when 390 then
--|#line 2135 "et_eiffel_parser.y"
	yy_do_action_390
when 391 then
--|#line 2141 "et_eiffel_parser.y"
	yy_do_action_391
when 392 then
--|#line 2143 "et_eiffel_parser.y"
	yy_do_action_392
when 393 then
--|#line 2150 "et_eiffel_parser.y"
	yy_do_action_393
when 394 then
--|#line 2152 "et_eiffel_parser.y"
	yy_do_action_394
when 395 then
--|#line 2154 "et_eiffel_parser.y"
	yy_do_action_395
when 396 then
--|#line 2154 "et_eiffel_parser.y"
	yy_do_action_396
when 397 then
--|#line 2167 "et_eiffel_parser.y"
	yy_do_action_397
when 398 then
--|#line 2178 "et_eiffel_parser.y"
	yy_do_action_398
when 399 then
--|#line 2187 "et_eiffel_parser.y"
	yy_do_action_399
when 400 then
--|#line 2198 "et_eiffel_parser.y"
	yy_do_action_400
			else
					-- No action
				yyval := yyval_default
			end
		end

	yy_do_action_401_600 (yy_act: INTEGER) is
			-- Execute semantic action.
		do
			inspect yy_act
when 401 then
--|#line 2200 "et_eiffel_parser.y"
	yy_do_action_401
when 402 then
--|#line 2202 "et_eiffel_parser.y"
	yy_do_action_402
when 403 then
--|#line 2204 "et_eiffel_parser.y"
	yy_do_action_403
when 404 then
--|#line 2206 "et_eiffel_parser.y"
	yy_do_action_404
when 405 then
--|#line 2210 "et_eiffel_parser.y"
	yy_do_action_405
when 406 then
--|#line 2212 "et_eiffel_parser.y"
	yy_do_action_406
when 407 then
--|#line 2216 "et_eiffel_parser.y"
	yy_do_action_407
when 408 then
--|#line 2218 "et_eiffel_parser.y"
	yy_do_action_408
when 409 then
--|#line 2222 "et_eiffel_parser.y"
	yy_do_action_409
when 410 then
--|#line 2226 "et_eiffel_parser.y"
	yy_do_action_410
when 411 then
--|#line 2228 "et_eiffel_parser.y"
	yy_do_action_411
when 412 then
--|#line 2232 "et_eiffel_parser.y"
	yy_do_action_412
when 413 then
--|#line 2234 "et_eiffel_parser.y"
	yy_do_action_413
when 414 then
--|#line 2238 "et_eiffel_parser.y"
	yy_do_action_414
when 415 then
--|#line 2240 "et_eiffel_parser.y"
	yy_do_action_415
when 416 then
--|#line 2242 "et_eiffel_parser.y"
	yy_do_action_416
when 417 then
--|#line 2244 "et_eiffel_parser.y"
	yy_do_action_417
when 418 then
--|#line 2246 "et_eiffel_parser.y"
	yy_do_action_418
when 419 then
--|#line 2248 "et_eiffel_parser.y"
	yy_do_action_419
when 420 then
--|#line 2254 "et_eiffel_parser.y"
	yy_do_action_420
when 421 then
--|#line 2256 "et_eiffel_parser.y"
	yy_do_action_421
when 422 then
--|#line 2258 "et_eiffel_parser.y"
	yy_do_action_422
when 423 then
--|#line 2258 "et_eiffel_parser.y"
	yy_do_action_423
when 424 then
--|#line 2271 "et_eiffel_parser.y"
	yy_do_action_424
when 425 then
--|#line 2282 "et_eiffel_parser.y"
	yy_do_action_425
when 426 then
--|#line 2290 "et_eiffel_parser.y"
	yy_do_action_426
when 427 then
--|#line 2297 "et_eiffel_parser.y"
	yy_do_action_427
when 428 then
--|#line 2297 "et_eiffel_parser.y"
	yy_do_action_428
when 429 then
--|#line 2313 "et_eiffel_parser.y"
	yy_do_action_429
when 430 then
--|#line 2322 "et_eiffel_parser.y"
	yy_do_action_430
when 431 then
--|#line 2324 "et_eiffel_parser.y"
	yy_do_action_431
when 432 then
--|#line 2326 "et_eiffel_parser.y"
	yy_do_action_432
when 433 then
--|#line 2328 "et_eiffel_parser.y"
	yy_do_action_433
when 434 then
--|#line 2335 "et_eiffel_parser.y"
	yy_do_action_434
when 435 then
--|#line 2337 "et_eiffel_parser.y"
	yy_do_action_435
when 436 then
--|#line 2343 "et_eiffel_parser.y"
	yy_do_action_436
when 437 then
--|#line 2345 "et_eiffel_parser.y"
	yy_do_action_437
when 438 then
--|#line 2347 "et_eiffel_parser.y"
	yy_do_action_438
when 439 then
--|#line 2349 "et_eiffel_parser.y"
	yy_do_action_439
when 440 then
--|#line 2351 "et_eiffel_parser.y"
	yy_do_action_440
when 441 then
--|#line 2353 "et_eiffel_parser.y"
	yy_do_action_441
when 442 then
--|#line 2355 "et_eiffel_parser.y"
	yy_do_action_442
when 443 then
--|#line 2357 "et_eiffel_parser.y"
	yy_do_action_443
when 444 then
--|#line 2359 "et_eiffel_parser.y"
	yy_do_action_444
when 445 then
--|#line 2361 "et_eiffel_parser.y"
	yy_do_action_445
when 446 then
--|#line 2363 "et_eiffel_parser.y"
	yy_do_action_446
when 447 then
--|#line 2365 "et_eiffel_parser.y"
	yy_do_action_447
when 448 then
--|#line 2367 "et_eiffel_parser.y"
	yy_do_action_448
when 449 then
--|#line 2369 "et_eiffel_parser.y"
	yy_do_action_449
when 450 then
--|#line 2384 "et_eiffel_parser.y"
	yy_do_action_450
when 451 then
--|#line 2386 "et_eiffel_parser.y"
	yy_do_action_451
when 452 then
--|#line 2388 "et_eiffel_parser.y"
	yy_do_action_452
when 453 then
--|#line 2390 "et_eiffel_parser.y"
	yy_do_action_453
when 454 then
--|#line 2392 "et_eiffel_parser.y"
	yy_do_action_454
when 455 then
--|#line 2394 "et_eiffel_parser.y"
	yy_do_action_455
when 456 then
--|#line 2396 "et_eiffel_parser.y"
	yy_do_action_456
when 457 then
--|#line 2398 "et_eiffel_parser.y"
	yy_do_action_457
when 458 then
--|#line 2400 "et_eiffel_parser.y"
	yy_do_action_458
when 459 then
--|#line 2402 "et_eiffel_parser.y"
	yy_do_action_459
when 460 then
--|#line 2404 "et_eiffel_parser.y"
	yy_do_action_460
when 461 then
--|#line 2406 "et_eiffel_parser.y"
	yy_do_action_461
when 462 then
--|#line 2408 "et_eiffel_parser.y"
	yy_do_action_462
when 463 then
--|#line 2410 "et_eiffel_parser.y"
	yy_do_action_463
when 464 then
--|#line 2412 "et_eiffel_parser.y"
	yy_do_action_464
when 465 then
--|#line 2414 "et_eiffel_parser.y"
	yy_do_action_465
when 466 then
--|#line 2416 "et_eiffel_parser.y"
	yy_do_action_466
when 467 then
--|#line 2418 "et_eiffel_parser.y"
	yy_do_action_467
when 468 then
--|#line 2420 "et_eiffel_parser.y"
	yy_do_action_468
when 469 then
--|#line 2422 "et_eiffel_parser.y"
	yy_do_action_469
when 470 then
--|#line 2424 "et_eiffel_parser.y"
	yy_do_action_470
when 471 then
--|#line 2426 "et_eiffel_parser.y"
	yy_do_action_471
when 472 then
--|#line 2428 "et_eiffel_parser.y"
	yy_do_action_472
when 473 then
--|#line 2430 "et_eiffel_parser.y"
	yy_do_action_473
when 474 then
--|#line 2432 "et_eiffel_parser.y"
	yy_do_action_474
when 475 then
--|#line 2434 "et_eiffel_parser.y"
	yy_do_action_475
when 476 then
--|#line 2436 "et_eiffel_parser.y"
	yy_do_action_476
when 477 then
--|#line 2438 "et_eiffel_parser.y"
	yy_do_action_477
when 478 then
--|#line 2440 "et_eiffel_parser.y"
	yy_do_action_478
when 479 then
--|#line 2442 "et_eiffel_parser.y"
	yy_do_action_479
when 480 then
--|#line 2446 "et_eiffel_parser.y"
	yy_do_action_480
when 481 then
--|#line 2450 "et_eiffel_parser.y"
	yy_do_action_481
when 482 then
--|#line 2452 "et_eiffel_parser.y"
	yy_do_action_482
when 483 then
--|#line 2452 "et_eiffel_parser.y"
	yy_do_action_483
when 484 then
--|#line 2465 "et_eiffel_parser.y"
	yy_do_action_484
when 485 then
--|#line 2476 "et_eiffel_parser.y"
	yy_do_action_485
when 486 then
--|#line 2484 "et_eiffel_parser.y"
	yy_do_action_486
when 487 then
--|#line 2493 "et_eiffel_parser.y"
	yy_do_action_487
when 488 then
--|#line 2495 "et_eiffel_parser.y"
	yy_do_action_488
when 489 then
--|#line 2495 "et_eiffel_parser.y"
	yy_do_action_489
when 490 then
--|#line 2508 "et_eiffel_parser.y"
	yy_do_action_490
when 491 then
--|#line 2519 "et_eiffel_parser.y"
	yy_do_action_491
when 492 then
--|#line 2527 "et_eiffel_parser.y"
	yy_do_action_492
when 493 then
--|#line 2536 "et_eiffel_parser.y"
	yy_do_action_493
when 494 then
--|#line 2538 "et_eiffel_parser.y"
	yy_do_action_494
when 495 then
--|#line 2538 "et_eiffel_parser.y"
	yy_do_action_495
when 496 then
--|#line 2553 "et_eiffel_parser.y"
	yy_do_action_496
when 497 then
--|#line 2564 "et_eiffel_parser.y"
	yy_do_action_497
when 498 then
--|#line 2572 "et_eiffel_parser.y"
	yy_do_action_498
when 499 then
--|#line 2581 "et_eiffel_parser.y"
	yy_do_action_499
when 500 then
--|#line 2583 "et_eiffel_parser.y"
	yy_do_action_500
when 501 then
--|#line 2585 "et_eiffel_parser.y"
	yy_do_action_501
when 502 then
--|#line 2587 "et_eiffel_parser.y"
	yy_do_action_502
when 503 then
--|#line 2589 "et_eiffel_parser.y"
	yy_do_action_503
when 504 then
--|#line 2591 "et_eiffel_parser.y"
	yy_do_action_504
when 505 then
--|#line 2597 "et_eiffel_parser.y"
	yy_do_action_505
when 506 then
--|#line 2599 "et_eiffel_parser.y"
	yy_do_action_506
when 507 then
--|#line 2601 "et_eiffel_parser.y"
	yy_do_action_507
when 508 then
--|#line 2603 "et_eiffel_parser.y"
	yy_do_action_508
when 509 then
--|#line 2607 "et_eiffel_parser.y"
	yy_do_action_509
when 510 then
--|#line 2609 "et_eiffel_parser.y"
	yy_do_action_510
when 511 then
--|#line 2611 "et_eiffel_parser.y"
	yy_do_action_511
when 512 then
--|#line 2622 "et_eiffel_parser.y"
	yy_do_action_512
when 513 then
--|#line 2627 "et_eiffel_parser.y"
	yy_do_action_513
when 514 then
--|#line 2633 "et_eiffel_parser.y"
	yy_do_action_514
when 515 then
--|#line 2640 "et_eiffel_parser.y"
	yy_do_action_515
when 516 then
--|#line 2650 "et_eiffel_parser.y"
	yy_do_action_516
when 517 then
--|#line 2651 "et_eiffel_parser.y"
	yy_do_action_517
when 518 then
--|#line 2652 "et_eiffel_parser.y"
	yy_do_action_518
when 519 then
--|#line 2655 "et_eiffel_parser.y"
	yy_do_action_519
when 520 then
--|#line 2658 "et_eiffel_parser.y"
	yy_do_action_520
when 521 then
--|#line 2661 "et_eiffel_parser.y"
	yy_do_action_521
when 522 then
--|#line 2664 "et_eiffel_parser.y"
	yy_do_action_522
when 523 then
--|#line 2667 "et_eiffel_parser.y"
	yy_do_action_523
when 524 then
--|#line 2670 "et_eiffel_parser.y"
	yy_do_action_524
when 525 then
--|#line 2673 "et_eiffel_parser.y"
	yy_do_action_525
when 526 then
--|#line 2676 "et_eiffel_parser.y"
	yy_do_action_526
when 527 then
--|#line 2683 "et_eiffel_parser.y"
	yy_do_action_527
when 528 then
--|#line 2685 "et_eiffel_parser.y"
	yy_do_action_528
when 529 then
--|#line 2687 "et_eiffel_parser.y"
	yy_do_action_529
when 530 then
--|#line 2689 "et_eiffel_parser.y"
	yy_do_action_530
when 531 then
--|#line 2691 "et_eiffel_parser.y"
	yy_do_action_531
when 532 then
--|#line 2693 "et_eiffel_parser.y"
	yy_do_action_532
when 533 then
--|#line 2695 "et_eiffel_parser.y"
	yy_do_action_533
when 534 then
--|#line 2697 "et_eiffel_parser.y"
	yy_do_action_534
when 535 then
--|#line 2699 "et_eiffel_parser.y"
	yy_do_action_535
when 536 then
--|#line 2701 "et_eiffel_parser.y"
	yy_do_action_536
when 537 then
--|#line 2703 "et_eiffel_parser.y"
	yy_do_action_537
when 538 then
--|#line 2705 "et_eiffel_parser.y"
	yy_do_action_538
when 539 then
--|#line 2707 "et_eiffel_parser.y"
	yy_do_action_539
when 540 then
--|#line 2709 "et_eiffel_parser.y"
	yy_do_action_540
when 541 then
--|#line 2711 "et_eiffel_parser.y"
	yy_do_action_541
when 542 then
--|#line 2713 "et_eiffel_parser.y"
	yy_do_action_542
when 543 then
--|#line 2715 "et_eiffel_parser.y"
	yy_do_action_543
when 544 then
--|#line 2717 "et_eiffel_parser.y"
	yy_do_action_544
when 545 then
--|#line 2719 "et_eiffel_parser.y"
	yy_do_action_545
when 546 then
--|#line 2721 "et_eiffel_parser.y"
	yy_do_action_546
when 547 then
--|#line 2723 "et_eiffel_parser.y"
	yy_do_action_547
when 548 then
--|#line 2727 "et_eiffel_parser.y"
	yy_do_action_548
when 549 then
--|#line 2729 "et_eiffel_parser.y"
	yy_do_action_549
when 550 then
--|#line 2733 "et_eiffel_parser.y"
	yy_do_action_550
when 551 then
--|#line 2735 "et_eiffel_parser.y"
	yy_do_action_551
when 552 then
--|#line 2739 "et_eiffel_parser.y"
	yy_do_action_552
when 553 then
--|#line 2741 "et_eiffel_parser.y"
	yy_do_action_553
when 554 then
--|#line 2746 "et_eiffel_parser.y"
	yy_do_action_554
when 555 then
--|#line 2753 "et_eiffel_parser.y"
	yy_do_action_555
when 556 then
--|#line 2755 "et_eiffel_parser.y"
	yy_do_action_556
when 557 then
--|#line 2760 "et_eiffel_parser.y"
	yy_do_action_557
when 558 then
--|#line 2767 "et_eiffel_parser.y"
	yy_do_action_558
when 559 then
--|#line 2769 "et_eiffel_parser.y"
	yy_do_action_559
when 560 then
--|#line 2776 "et_eiffel_parser.y"
	yy_do_action_560
when 561 then
--|#line 2778 "et_eiffel_parser.y"
	yy_do_action_561
when 562 then
--|#line 2784 "et_eiffel_parser.y"
	yy_do_action_562
			else
					-- No action
				yyval := yyval_default
			end
		end

	yy_do_action_1 is
			--|#line 180 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 180")
end
			yyval := yyval_default;
yytype27 (yyvs.item (yyvsp)).set_leading_break (yytype6 (yyvs.item (yyvsp - 1))) 

		end

	yy_do_action_2 is
			--|#line 184 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 184")
end

			yyval27 := yytype27 (yyvs.item (yyvsp))
			yyval27.set_first_indexing (yytype56 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_3 is
			--|#line 191 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 191")
end
			yyval := yyval_default;


		end

	yy_do_action_4 is
			--|#line 192 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 192")
end
			yyval := yyval_default;


		end

	yy_do_action_5 is
			--|#line 195 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 195")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 9))
			set_class_to_end (yyval27, yytype72 (yyvs.item (yyvsp - 7)), yytype76 (yyvs.item (yyvsp - 6)), yytype34 (yyvs.item (yyvsp - 5)), yytype45 (yyvs.item (yyvsp - 4)), yytype63 (yyvs.item (yyvsp - 3)), yytype56 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_6 is
			--|#line 201 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 201")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 9))
			set_class_to_end (yyval27, yytype72 (yyvs.item (yyvsp - 7)), yytype76 (yyvs.item (yyvsp - 6)), yytype34 (yyvs.item (yyvsp - 5)), yytype45 (yyvs.item (yyvsp - 4)), yytype63 (yyvs.item (yyvsp - 3)), yytype56 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_7 is
			--|#line 207 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 207")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 8))
			set_class_to_end (yyval27, yytype72 (yyvs.item (yyvsp - 6)), yytype76 (yyvs.item (yyvsp - 5)), Void, yytype45 (yyvs.item (yyvsp - 4)), yytype63 (yyvs.item (yyvsp - 3)), yytype56 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_8 is
			--|#line 213 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 213")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 7))
			set_class_to_end (yyval27, yytype72 (yyvs.item (yyvsp - 5)), yytype76 (yyvs.item (yyvsp - 4)), Void, Void, yytype63 (yyvs.item (yyvsp - 3)), yytype56 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_9 is
			--|#line 219 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 219")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 5))
			set_class_to_inheritance_end (yyval27, yytype72 (yyvs.item (yyvsp - 3)), yytype76 (yyvs.item (yyvsp - 2)))
			yytype27 (yyvs.item (yyvsp)).set_first_indexing (yytype56 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_10 is
			--|#line 225 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 225")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 6))
			set_class_to_end (yyval27, yytype72 (yyvs.item (yyvsp - 4)), yytype76 (yyvs.item (yyvsp - 3)), Void, Void, Void, yytype56 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval27
		end

	yy_do_action_11 is
			--|#line 230 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 230")
end

			yyval27 := yytype27 (yyvs.item (yyvsp - 3))
			set_class_to_inheritance_end (yyval27, yytype72 (yyvs.item (yyvsp - 1)), yytype76 (yyvs.item (yyvsp)))
		
			yyval := yyval27
		end

	yy_do_action_12 is
			--|#line 247 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 247")
end

yyval56 := ast_factory.new_indexings (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval56
		end

	yy_do_action_13 is
			--|#line 249 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 249")
end

			yyval56 := yytype56 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval56
		end

	yy_do_action_14 is
			--|#line 249 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 249")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_15 is
			--|#line 262 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 262")
end


			yyval := yyval56
		end

	yy_do_action_16 is
			--|#line 264 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 264")
end

yyval56 := yytype56 (yyvs.item (yyvsp)) 
			yyval := yyval56
		end

	yy_do_action_17 is
			--|#line 268 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 268")
end

			if yytype57 (yyvs.item (yyvsp)) /= Void then
				yyval56 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval56 /= Void then
					yyval56.put_first (yytype57 (yyvs.item (yyvsp)))
				end
			else
				yyval56 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
			yyval := yyval56
		end

	yy_do_action_18 is
			--|#line 279 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 279")
end

			if yytype57 (yyvs.item (yyvsp)) /= Void then
				yyval56 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval56 /= Void then
					yyval56.put_first (yytype57 (yyvs.item (yyvsp)))
				end
			else
				yyval56 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
			yyval := yyval56
		end

	yy_do_action_19 is
			--|#line 291 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 291")
end

			yyval56 := yytype56 (yyvs.item (yyvsp))
			if yyval56 /= Void and yytype57 (yyvs.item (yyvsp - 2)) /= Void then
				yyval56.put_first (yytype57 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval56
		end

	yy_do_action_20 is
			--|#line 291 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 291")
end
			yyval := yyval_default;
increment_counter 

		end

	yy_do_action_21 is
			--|#line 300 "et_eiffel_parser.y"
		local
			yyval56: ET_INDEXING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 300")
end

			yyval56 := yytype56 (yyvs.item (yyvsp))
			if yyval56 /= Void and yytype57 (yyvs.item (yyvsp - 2)) /= Void then
				yyval56.put_first (yytype57 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval56
		end

	yy_do_action_22 is
			--|#line 300 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 300")
end
			yyval := yyval_default;
increment_counter 

		end

	yy_do_action_23 is
			--|#line 311 "et_eiffel_parser.y"
		local
			yyval57: ET_INDEXING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 311")
end

			yyval57 := yytype57 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval57
		end

	yy_do_action_24 is
			--|#line 318 "et_eiffel_parser.y"
		local
			yyval57: ET_INDEXING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 318")
end

			yyval57 := ast_factory.new_indexing (yytype60 (yyvs.item (yyvsp)))
		
			yyval := yyval57
		end

	yy_do_action_25 is
			--|#line 322 "et_eiffel_parser.y"
		local
			yyval57: ET_INDEXING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 322")
end

			yyval57 := ast_factory.new_tagged_indexing (ast_factory.new_tag (yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype60 (yyvs.item (yyvsp)))
		
			yyval := yyval57
		end

	yy_do_action_26 is
			--|#line 332 "et_eiffel_parser.y"
		local
			yyval57: ET_INDEXING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 332")
end

yyval57 := ast_factory.new_indexing_semicolon (yytype57 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 
			yyval := yyval57
		end

	yy_do_action_27 is
			--|#line 334 "et_eiffel_parser.y"
		local
			yyval57: ET_INDEXING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 334")
end

yyval57 := ast_factory.new_indexing_semicolon (yytype57 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 
			yyval := yyval57
		end

	yy_do_action_28 is
			--|#line 339 "et_eiffel_parser.y"
		local
			yyval60: ET_INDEXING_TERM_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 339")
end

			if yytype58 (yyvs.item (yyvsp)) /= Void then
				yyval60 := ast_factory.new_indexing_terms (counter_value + 1)
				if yyval60 /= Void then
					yyval60.put_first (yytype58 (yyvs.item (yyvsp)))
				end
			else
				yyval60 := ast_factory.new_indexing_terms (counter_value)
			end
		
			yyval := yyval60
		end

	yy_do_action_29 is
			--|#line 350 "et_eiffel_parser.y"
		local
			yyval60: ET_INDEXING_TERM_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 350")
end

			yyval60 := yytype60 (yyvs.item (yyvsp))
			if yyval60 /= Void and yytype59 (yyvs.item (yyvsp - 1)) /= Void then
				yyval60.put_first (yytype59 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval60
		end

	yy_do_action_30 is
			--|#line 359 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 359")
end

yyval58 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_31 is
			--|#line 361 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 361")
end

yyval58 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_32 is
			--|#line 363 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 363")
end

yyval58 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_33 is
			--|#line 365 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 365")
end

yyval58 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_34 is
			--|#line 367 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 367")
end

yyval58 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_35 is
			--|#line 369 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 369")
end

yyval58 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_36 is
			--|#line 371 "et_eiffel_parser.y"
		local
			yyval58: ET_INDEXING_TERM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 371")
end

yyval58 := yytype4 (yyvs.item (yyvsp)) 
			yyval := yyval58
		end

	yy_do_action_37 is
			--|#line 375 "et_eiffel_parser.y"
		local
			yyval59: ET_INDEXING_TERM_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 375")
end

			yyval59 := ast_factory.new_indexing_term_comma (yytype58 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval59 /= Void then
				increment_counter
			end
		
			yyval := yyval59
		end

	yy_do_action_38 is
			--|#line 386 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 386")
end

			yyval27 := new_class (yytype10 (yyvs.item (yyvsp)))
			yyval27.set_class_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			last_class := yyval27
		
			yyval := yyval27
		end

	yy_do_action_39 is
			--|#line 392 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 392")
end

			yyval27 := new_class (yytype10 (yyvs.item (yyvsp)))
			yyval27.set_class_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			yyval27.set_class_mark (yytype1 (yyvs.item (yyvsp - 2)))
			last_class := yyval27
		
			yyval := yyval27
		end

	yy_do_action_40 is
			--|#line 399 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 399")
end

			yyval27 := new_class (yytype10 (yyvs.item (yyvsp)))
			yyval27.set_class_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			yyval27.set_class_mark (yytype1 (yyvs.item (yyvsp - 2)))
			last_class := yyval27
		
			yyval := yyval27
		end

	yy_do_action_41 is
			--|#line 406 "et_eiffel_parser.y"
		local
			yyval27: ET_CLASS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 406")
end

			yyval27 := new_class (yytype10 (yyvs.item (yyvsp)))
			yyval27.set_class_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			yyval27.set_class_mark (yytype1 (yyvs.item (yyvsp - 2)))
			last_class := yyval27
		
			yyval := yyval27
		end

	yy_do_action_42 is
			--|#line 417 "et_eiffel_parser.y"
		local
			yyval54: ET_FORMAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 417")
end


			yyval := yyval54
		end

	yy_do_action_43 is
			--|#line 419 "et_eiffel_parser.y"
		local
			yyval54: ET_FORMAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 419")
end

			yyval54 := ast_factory.new_formal_parameters (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0)
			set_formal_generic_parameters (yyval54)
		
			yyval := yyval54
		end

	yy_do_action_44 is
			--|#line 425 "et_eiffel_parser.y"
		local
			yyval54: ET_FORMAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 425")
end

			yyval54 := yytype54 (yyvs.item (yyvsp))
			set_formal_generic_parameters (yyval54)
			remove_symbol
			remove_counter
		
			yyval := yyval54
		end

	yy_do_action_45 is
			--|#line 425 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 425")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_46 is
			--|#line 439 "et_eiffel_parser.y"
		local
			yyval54: ET_FORMAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 439")
end

			if yytype52 (yyvs.item (yyvsp - 1)) /= Void then
				yyval54 := ast_factory.new_formal_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval54 /= Void then
					yyval54.put_first (yytype52 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval54 := ast_factory.new_formal_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval54
		end

	yy_do_action_47 is
			--|#line 450 "et_eiffel_parser.y"
		local
			yyval54: ET_FORMAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 450")
end

			yyval54 := yytype54 (yyvs.item (yyvsp))
			if yyval54 /= Void and yytype53 (yyvs.item (yyvsp - 1)) /= Void then
				yyval54.put_first (yytype53 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval54
		end

	yy_do_action_48 is
			--|#line 459 "et_eiffel_parser.y"
		local
			yyval53: ET_FORMAL_PARAMETER_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 459")
end

			yyval53 := ast_factory.new_formal_parameter_comma (yytype52 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval53 /= Void then
				increment_counter
			end
		
			yyval := yyval53
		end

	yy_do_action_49 is
			--|#line 468 "et_eiffel_parser.y"
		local
			yyval52: ET_FORMAL_PARAMETER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 468")
end

yyval52 := ast_factory.new_formal_parameter (yytype10 (yyvs.item (yyvsp))) 
			yyval := yyval52
		end

	yy_do_action_50 is
			--|#line 470 "et_eiffel_parser.y"
		local
			yyval52: ET_FORMAL_PARAMETER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 470")
end

yyval52 := ast_factory.new_constrained_formal_parameter (yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype85 (yyvs.item (yyvsp)), Void) 
			yyval := yyval52
		end

	yy_do_action_51 is
			--|#line 472 "et_eiffel_parser.y"
		local
			yyval52: ET_FORMAL_PARAMETER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 472")
end

yyval52 := ast_factory.new_constrained_formal_parameter (yytype10 (yyvs.item (yyvsp - 3)), yytype2 (yyvs.item (yyvsp - 2)), yytype85 (yyvs.item (yyvsp - 1)), yytype32 (yyvs.item (yyvsp))) 
			yyval := yyval52
		end

	yy_do_action_52 is
			--|#line 476 "et_eiffel_parser.y"
		local
			yyval32: ET_CONSTRAINT_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 476")
end

yyval32 := ast_factory.new_constraint_creator (yytype1 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval32
		end

	yy_do_action_53 is
			--|#line 478 "et_eiffel_parser.y"
		local
			yyval32: ET_CONSTRAINT_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 478")
end

			yyval32 := yytype32 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval32
		end

	yy_do_action_54 is
			--|#line 478 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 478")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_55 is
			--|#line 491 "et_eiffel_parser.y"
		local
			yyval32: ET_CONSTRAINT_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 491")
end

			if yytype10 (yyvs.item (yyvsp - 1)) /= Void then
				yyval32 := ast_factory.new_constraint_creator (last_keyword, yytype1 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval32 /= Void then
					yyval32.put_first (yytype10 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval32 := ast_factory.new_constraint_creator (last_keyword, yytype1 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval32
		end

	yy_do_action_56 is
			--|#line 502 "et_eiffel_parser.y"
		local
			yyval32: ET_CONSTRAINT_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 502")
end

			yyval32 := ast_factory.new_constraint_creator (last_keyword, yytype1 (yyvs.item (yyvsp)), counter_value)
			if yyval32 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval32.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval32
		end

	yy_do_action_57 is
			--|#line 510 "et_eiffel_parser.y"
		local
			yyval32: ET_CONSTRAINT_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 510")
end

			yyval32 := yytype32 (yyvs.item (yyvsp))
			if yyval32 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval32.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval32
		end

	yy_do_action_58 is
			--|#line 519 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 519")
end

yyval85 := new_constraint_named_type (Void, yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_59 is
			--|#line 521 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 521")
end

yyval85 := new_constraint_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_60 is
			--|#line 523 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 523")
end

yyval85 := new_constraint_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_61 is
			--|#line 525 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 525")
end

yyval85 := new_constraint_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_62 is
			--|#line 527 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 527")
end

yyval85 := ast_factory.new_like_current (yytype1 (yyvs.item (yyvsp - 1)), yytype8 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_63 is
			--|#line 529 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 529")
end

yyval85 := ast_factory.new_like_identifier (yytype1 (yyvs.item (yyvsp - 1)), yytype10 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_64 is
			--|#line 531 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 531")
end

yyval85 := ast_factory.new_bit_type (yytype10 (yyvs.item (yyvsp - 1)), yytype11 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_65 is
			--|#line 533 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 533")
end

yyval85 := ast_factory.new_bit_identifier (yytype10 (yyvs.item (yyvsp - 1)), yytype10 (yyvs.item (yyvsp)))  
			yyval := yyval85
		end

	yy_do_action_66 is
			--|#line 537 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 537")
end


			yyval := yyval20
		end

	yy_do_action_67 is
			--|#line 539 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 539")
end

yyval20 := ast_factory.new_actual_parameters (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval20
		end

	yy_do_action_68 is
			--|#line 542 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 542")
end

			yyval20 := yytype20 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval20
		end

	yy_do_action_69 is
			--|#line 542 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 542")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_70 is
			--|#line 555 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 555")
end

			if yytype85 (yyvs.item (yyvsp - 1)) /= Void then
				yyval20 := ast_factory.new_actual_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval20 /= Void then
					yyval20.put_first (yytype85 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval20 := ast_factory.new_actual_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval20
		end

	yy_do_action_71 is
			--|#line 566 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 566")
end

			yyval20 := yytype20 (yyvs.item (yyvsp))
			if yyval20 /= Void and yytype86 (yyvs.item (yyvsp - 1)) /= Void then
				yyval20.put_first (yytype86 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval20
		end

	yy_do_action_72 is
			--|#line 575 "et_eiffel_parser.y"
		local
			yyval86: ET_TYPE_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 575")
end

			yyval86 := ast_factory.new_type_comma (yytype85 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval86 /= Void then
				increment_counter
			end
		
			yyval := yyval86
		end

	yy_do_action_73 is
			--|#line 586 "et_eiffel_parser.y"
		local
			yyval72: ET_OBSOLETE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 586")
end


			yyval := yyval72
		end

	yy_do_action_74 is
			--|#line 588 "et_eiffel_parser.y"
		local
			yyval72: ET_OBSOLETE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 588")
end

yyval72 := ast_factory.new_obsolete_message (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval72
		end

	yy_do_action_75 is
			--|#line 594 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 594")
end


			yyval := yyval76
		end

	yy_do_action_76 is
			--|#line 596 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 596")
end

yyval76 := ast_factory.new_parents (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval76
		end

	yy_do_action_77 is
			--|#line 598 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 598")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval76
		end

	yy_do_action_78 is
			--|#line 605 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 605")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval76
		end

	yy_do_action_79 is
			--|#line 613 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 613")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_80 is
			--|#line 620 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 620")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp)), Void, Void, Void, Void, Void, Void)
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_81 is
			--|#line 627 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 627")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 7)), yytype20 (yyvs.item (yyvsp - 6)), yytype82 (yyvs.item (yyvsp - 5)), yytype39 (yyvs.item (yyvsp - 4)), yytype64 (yyvs.item (yyvsp - 3)), yytype64 (yyvs.item (yyvsp - 2)), yytype64 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_82 is
			--|#line 635 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 635")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 6)), yytype20 (yyvs.item (yyvsp - 5)), Void, yytype39 (yyvs.item (yyvsp - 4)), yytype64 (yyvs.item (yyvsp - 3)), yytype64 (yyvs.item (yyvsp - 2)), yytype64 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_83 is
			--|#line 642 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 642")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 5)), yytype20 (yyvs.item (yyvsp - 4)), Void, Void, yytype64 (yyvs.item (yyvsp - 3)), yytype64 (yyvs.item (yyvsp - 2)), yytype64 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_84 is
			--|#line 649 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 649")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 4)), yytype20 (yyvs.item (yyvsp - 3)), Void, Void, Void, yytype64 (yyvs.item (yyvsp - 2)), yytype64 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_85 is
			--|#line 656 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 656")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 3)), yytype20 (yyvs.item (yyvsp - 2)), Void, Void, Void, Void, yytype64 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_86 is
			--|#line 665 "et_eiffel_parser.y"
		local
			yyval74: ET_PARENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 665")
end

			yyval74 := new_parent (yytype10 (yyvs.item (yyvsp - 2)), yytype20 (yyvs.item (yyvsp - 1)), Void, Void, Void, Void, Void, yytype1 (yyvs.item (yyvsp)))
			if yyval74 /= Void then
				increment_counter
			end
		
			yyval := yyval74
		end

	yy_do_action_87 is
			--|#line 674 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 674")
end

			yyval76 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval76
		end

	yy_do_action_88 is
			--|#line 681 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 681")
end

			yyval76 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval76 /= Void and yytype75 (yyvs.item (yyvsp)) /= Void then
				yyval76.put_first (yytype75 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval76
		end

	yy_do_action_89 is
			--|#line 688 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 688")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_90 is
			--|#line 695 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 695")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_91 is
			--|#line 702 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 702")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype75 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype75 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_92 is
			--|#line 711 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 711")
end

			yyval76 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval76
		end

	yy_do_action_93 is
			--|#line 718 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 718")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_94 is
			--|#line 725 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 725")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype74 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype74 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_95 is
			--|#line 732 "et_eiffel_parser.y"
		local
			yyval76: ET_PARENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 732")
end

			yyval76 := yytype76 (yyvs.item (yyvsp))
			if yyval76 /= Void and yytype75 (yyvs.item (yyvsp - 1)) /= Void then
				yyval76.put_first (yytype75 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval76
		end

	yy_do_action_96 is
			--|#line 741 "et_eiffel_parser.y"
		local
			yyval75: ET_PARENT_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 741")
end

			yyval75 := ast_factory.new_parent_semicolon (yytype74 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)))
			if yyval75 /= Void and yytype74 (yyvs.item (yyvsp - 1)) = Void then
				increment_counter
			end
		
			yyval := yyval75
		end

	yy_do_action_97 is
			--|#line 748 "et_eiffel_parser.y"
		local
			yyval75: ET_PARENT_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 748")
end

			yyval75 := ast_factory.new_parent_semicolon (yytype74 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)))
			if yyval75 /= Void and yytype74 (yyvs.item (yyvsp - 1)) = Void then
				increment_counter
			end
		
			yyval := yyval75
		end

	yy_do_action_98 is
			--|#line 759 "et_eiffel_parser.y"
		local
			yyval82: ET_RENAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 759")
end

yyval82 := ast_factory.new_renames (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval82
		end

	yy_do_action_99 is
			--|#line 761 "et_eiffel_parser.y"
		local
			yyval82: ET_RENAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 761")
end

			yyval82 := yytype82 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval82
		end

	yy_do_action_100 is
			--|#line 761 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 761")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_101 is
			--|#line 774 "et_eiffel_parser.y"
		local
			yyval82: ET_RENAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 774")
end

			yyval82 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval82 /= Void and yytype81 (yyvs.item (yyvsp)) /= Void then
				yyval82.put_first (yytype81 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval82
		end

	yy_do_action_102 is
			--|#line 781 "et_eiffel_parser.y"
		local
			yyval82: ET_RENAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 781")
end

			yyval82 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval82 /= Void and yytype81 (yyvs.item (yyvsp)) /= Void then
				yyval82.put_first (yytype81 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval82
		end

	yy_do_action_103 is
			--|#line 789 "et_eiffel_parser.y"
		local
			yyval82: ET_RENAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 789")
end

			yyval82 := yytype82 (yyvs.item (yyvsp))
			if yyval82 /= Void and yytype81 (yyvs.item (yyvsp - 1)) /= Void then
				yyval82.put_first (yytype81 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval82
		end

	yy_do_action_104 is
			--|#line 798 "et_eiffel_parser.y"
		local
			yyval81: ET_RENAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 798")
end

			yyval81 := ast_factory.new_rename (yytype47 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype47 (yyvs.item (yyvsp)))
			if yyval81 /= Void then
				increment_counter
			end
		
			yyval := yyval81
		end

	yy_do_action_105 is
			--|#line 807 "et_eiffel_parser.y"
		local
			yyval81: ET_RENAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 807")
end

			yyval81 := ast_factory.new_rename_comma (yytype47 (yyvs.item (yyvsp - 3)), yytype1 (yyvs.item (yyvsp - 2)), yytype47 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval81 /= Void then
				increment_counter
			end
		
			yyval := yyval81
		end

	yy_do_action_106 is
			--|#line 818 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 818")
end

yyval39 := ast_factory.new_exports (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval39
		end

	yy_do_action_107 is
			--|#line 820 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 820")
end

			yyval39 := yytype39 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval39
		end

	yy_do_action_108 is
			--|#line 820 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 820")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_109 is
			--|#line 833 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 833")
end


			yyval := yyval39
		end

	yy_do_action_110 is
			--|#line 835 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 835")
end

yyval39 := yytype39 (yyvs.item (yyvsp)) 
			yyval := yyval39
		end

	yy_do_action_111 is
			--|#line 839 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 839")
end

			if yytype38 (yyvs.item (yyvsp)) /= Void then
				yyval39 := ast_factory.new_exports (last_keyword, counter_value + 1)
				if yyval39 /= Void then
					yyval39.put_first (yytype38 (yyvs.item (yyvsp)))
				end
			else
				yyval39 := ast_factory.new_exports (last_keyword, counter_value)
			end
		
			yyval := yyval39
		end

	yy_do_action_112 is
			--|#line 850 "et_eiffel_parser.y"
		local
			yyval39: ET_EXPORT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 850")
end

			yyval39 := yytype39 (yyvs.item (yyvsp))
			if yyval39 /= Void and yytype38 (yyvs.item (yyvsp - 2)) /= Void then
				yyval39.put_first (yytype38 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval39
		end

	yy_do_action_113 is
			--|#line 850 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 850")
end
			yyval := yyval_default;
			if yytype38 (yyvs.item (yyvsp)) /= Void then
				increment_counter
			end
		

		end

	yy_do_action_114 is
			--|#line 865 "et_eiffel_parser.y"
		local
			yyval38: ET_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 865")
end

			yyval38 := ast_factory.new_all_export (yytype29 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp)))
		
			yyval := yyval38
		end

	yy_do_action_115 is
			--|#line 869 "et_eiffel_parser.y"
		local
			yyval38: ET_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 869")
end

			yyval38 := yytype46 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval38
		end

	yy_do_action_116 is
			--|#line 869 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 869")
end
			yyval := yyval_default;
			last_export_clients := yytype29 (yyvs.item (yyvsp))
			add_counter
		

		end

	yy_do_action_117 is
			--|#line 879 "et_eiffel_parser.y"
		local
			yyval38: ET_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 879")
end

yyval38 := ast_factory.new_null_export (yytype18 (yyvs.item (yyvsp))) 
			yyval := yyval38
		end

	yy_do_action_118 is
			--|#line 883 "et_eiffel_parser.y"
		local
			yyval46: ET_FEATURE_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 883")
end

			if yytype47 (yyvs.item (yyvsp)) /= Void then
				yyval46 := ast_factory.new_feature_export (last_export_clients, counter_value + 1)
				if yyval46 /= Void then
					yyval46.put_first (yytype47 (yyvs.item (yyvsp)))
				end
			else
				yyval46 := ast_factory.new_feature_export (last_export_clients, counter_value)
			end
		
			yyval := yyval46
		end

	yy_do_action_119 is
			--|#line 894 "et_eiffel_parser.y"
		local
			yyval46: ET_FEATURE_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 894")
end

			yyval46 := ast_factory.new_feature_export (last_export_clients, counter_value)
			if yyval46 /= Void and yytype48 (yyvs.item (yyvsp)) /= Void then
				yyval46.put_first (yytype48 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval46
		end

	yy_do_action_120 is
			--|#line 902 "et_eiffel_parser.y"
		local
			yyval46: ET_FEATURE_EXPORT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 902")
end

			yyval46 := yytype46 (yyvs.item (yyvsp))
			if yyval46 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval46.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval46
		end

	yy_do_action_121 is
			--|#line 913 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 913")
end

			yyval29 := yytype29 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval29
		end

	yy_do_action_122 is
			--|#line 913 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 913")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_123 is
			--|#line 924 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 924")
end

yyval29 := ast_factory.new_none_clients (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp))) 
			yyval := yyval29
		end

	yy_do_action_124 is
			--|#line 928 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 928")
end

			yyval29 := ast_factory.new_clients (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval29 /= Void and yytype28 (yyvs.item (yyvsp - 1)) /= Void then
				yyval29.put_first (yytype28 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval29
		end

	yy_do_action_125 is
			--|#line 935 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 935")
end

			yyval29 := ast_factory.new_clients (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval29 /= Void and yytype28 (yyvs.item (yyvsp - 1)) /= Void then
				yyval29.put_first (yytype28 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval29
		end

	yy_do_action_126 is
			--|#line 943 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 943")
end

			yyval29 := yytype29 (yyvs.item (yyvsp))
			if yyval29 /= Void and yytype28 (yyvs.item (yyvsp - 1)) /= Void then
				yyval29.put_first (yytype28 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval29
		end

	yy_do_action_127 is
			--|#line 950 "et_eiffel_parser.y"
		local
			yyval29: ET_CLIENTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 950")
end

			yyval29 := yytype29 (yyvs.item (yyvsp))
			if yyval29 /= Void and yytype28 (yyvs.item (yyvsp - 1)) /= Void then
				yyval29.put_first (yytype28 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval29
		end

	yy_do_action_128 is
			--|#line 960 "et_eiffel_parser.y"
		local
			yyval28: ET_CLASS_NAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 960")
end

			yyval28 := yytype10 (yyvs.item (yyvsp))
			if yyval28 /= Void then
				increment_counter
			end
		
			yyval := yyval28
		end

	yy_do_action_129 is
			--|#line 969 "et_eiffel_parser.y"
		local
			yyval28: ET_CLASS_NAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 969")
end

			yyval28 := ast_factory.new_class_name_comma (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval28 /= Void then
				increment_counter
			end
		
			yyval := yyval28
		end

	yy_do_action_130 is
			--|#line 980 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 980")
end

yyval64 := ast_factory.new_keyword_feature_name_list (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval64
		end

	yy_do_action_131 is
			--|#line 982 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 982")
end

			yyval64 := yytype64 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval64
		end

	yy_do_action_132 is
			--|#line 982 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 982")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_133 is
			--|#line 995 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 995")
end


			yyval := yyval64
		end

	yy_do_action_134 is
			--|#line 997 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 997")
end

yyval64 := yytype64 (yyvs.item (yyvsp)) 
			yyval := yyval64
		end

	yy_do_action_135 is
			--|#line 1001 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1001")
end

yyval64 := ast_factory.new_keyword_feature_name_list (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval64
		end

	yy_do_action_136 is
			--|#line 1003 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1003")
end

			yyval64 := yytype64 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval64
		end

	yy_do_action_137 is
			--|#line 1003 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1003")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_138 is
			--|#line 1016 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1016")
end


			yyval := yyval64
		end

	yy_do_action_139 is
			--|#line 1018 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1018")
end

yyval64 := yytype64 (yyvs.item (yyvsp)) 
			yyval := yyval64
		end

	yy_do_action_140 is
			--|#line 1022 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1022")
end

yyval64 := ast_factory.new_keyword_feature_name_list (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval64
		end

	yy_do_action_141 is
			--|#line 1024 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1024")
end

			yyval64 := yytype64 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval64
		end

	yy_do_action_142 is
			--|#line 1024 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1024")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_143 is
			--|#line 1037 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1037")
end


			yyval := yyval64
		end

	yy_do_action_144 is
			--|#line 1039 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1039")
end

yyval64 := yytype64 (yyvs.item (yyvsp)) 
			yyval := yyval64
		end

	yy_do_action_145 is
			--|#line 1043 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1043")
end

			if yytype47 (yyvs.item (yyvsp)) /= Void then
				yyval64 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value + 1)
				if yyval64 /= Void then
					yyval64.put_first (yytype47 (yyvs.item (yyvsp)))
				end
			else
				yyval64 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			end
		
			yyval := yyval64
		end

	yy_do_action_146 is
			--|#line 1054 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1054")
end

			yyval64 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			if yyval64 /= Void and yytype48 (yyvs.item (yyvsp)) /= Void then
				yyval64.put_first (yytype48 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval64
		end

	yy_do_action_147 is
			--|#line 1062 "et_eiffel_parser.y"
		local
			yyval64: ET_KEYWORD_FEATURE_NAME_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1062")
end

			yyval64 := yytype64 (yyvs.item (yyvsp))
			if yyval64 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval64.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval64
		end

	yy_do_action_148 is
			--|#line 1071 "et_eiffel_parser.y"
		local
			yyval48: ET_FEATURE_NAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1071")
end

			yyval48 := ast_factory.new_feature_name_comma (yytype47 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval48 /= Void then
				increment_counter
			end
		
			yyval := yyval48
		end

	yy_do_action_149 is
			--|#line 1082 "et_eiffel_parser.y"
		local
			yyval34: ET_CREATOR_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1082")
end


			yyval := yyval34
		end

	yy_do_action_150 is
			--|#line 1084 "et_eiffel_parser.y"
		local
			yyval34: ET_CREATOR_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1084")
end

			yyval34 := yytype34 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval34
		end

	yy_do_action_151 is
			--|#line 1091 "et_eiffel_parser.y"
		local
			yyval34: ET_CREATOR_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1091")
end

			if yytype33 (yyvs.item (yyvsp)) /= Void then
				yyval34 := ast_factory.new_creators (counter_value + 1)
				if yyval34 /= Void then
					yyval34.put_first (yytype33 (yyvs.item (yyvsp)))
				end
			else
				yyval34 := ast_factory.new_creators (counter_value)
			end
		
			yyval := yyval34
		end

	yy_do_action_152 is
			--|#line 1102 "et_eiffel_parser.y"
		local
			yyval34: ET_CREATOR_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1102")
end

			yyval34 := yytype34 (yyvs.item (yyvsp))
			if yyval34 /= Void and yytype33 (yyvs.item (yyvsp - 2)) /= Void then
				yyval34.put_first (yytype33 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval34
		end

	yy_do_action_153 is
			--|#line 1102 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1102")
end
			yyval := yyval_default;
			if yytype33 (yyvs.item (yyvsp)) /= Void then
				increment_counter
			end
		

		end

	yy_do_action_154 is
			--|#line 1117 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1117")
end

yyval33 := ast_factory.new_creator (yytype1 (yyvs.item (yyvsp - 1)), yytype29 (yyvs.item (yyvsp)), 0) 
			yyval := yyval33
		end

	yy_do_action_155 is
			--|#line 1119 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1119")
end

yyval33 := ast_factory.new_creator (yytype1 (yyvs.item (yyvsp)), ast_factory.new_any_clients (yytype1 (yyvs.item (yyvsp))), 0) 
			yyval := yyval33
		end

	yy_do_action_156 is
			--|#line 1121 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1121")
end

			yyval33 := yytype33 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval33
		end

	yy_do_action_157 is
			--|#line 1121 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1121")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			last_clients := yytype29 (yyvs.item (yyvsp))
			add_counter
		

		end

	yy_do_action_158 is
			--|#line 1133 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1133")
end

			yyval33 := yytype33 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval33
		end

	yy_do_action_159 is
			--|#line 1133 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1133")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			last_clients := ast_factory.new_any_clients (last_keyword)
			add_counter
		

		end

	yy_do_action_160 is
			--|#line 1145 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1145")
end

yyval33 := ast_factory.new_creator (yytype1 (yyvs.item (yyvsp - 1)), yytype29 (yyvs.item (yyvsp)), 0) 
			yyval := yyval33
		end

	yy_do_action_161 is
			--|#line 1147 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1147")
end

yyval33 := ast_factory.new_creator (yytype1 (yyvs.item (yyvsp)), ast_factory.new_any_clients (yytype1 (yyvs.item (yyvsp))), 0) 
			yyval := yyval33
		end

	yy_do_action_162 is
			--|#line 1149 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1149")
end

			yyval33 := yytype33 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval33
		end

	yy_do_action_163 is
			--|#line 1149 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1149")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			last_clients := yytype29 (yyvs.item (yyvsp))
			add_counter
		

		end

	yy_do_action_164 is
			--|#line 1161 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1161")
end

			yyval33 := yytype33 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval33
		end

	yy_do_action_165 is
			--|#line 1161 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1161")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			last_clients := ast_factory.new_any_clients (last_keyword)
			add_counter
		

		end

	yy_do_action_166 is
			--|#line 1175 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1175")
end

			if yytype10 (yyvs.item (yyvsp)) /= Void then
				yyval33 := ast_factory.new_creator (last_keyword, last_clients, counter_value + 1)
				if yyval33 /= Void then
					yyval33.put_first (yytype10 (yyvs.item (yyvsp)))
				end
			else
				yyval33 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
			end
		
			yyval := yyval33
		end

	yy_do_action_167 is
			--|#line 1186 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1186")
end

			yyval33 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
			if yyval33 /= Void and yytype48 (yyvs.item (yyvsp)) /= Void then
				yyval33.put_first (yytype48 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval33
		end

	yy_do_action_168 is
			--|#line 1194 "et_eiffel_parser.y"
		local
			yyval33: ET_CREATOR
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1194")
end

			yyval33 := yytype33 (yyvs.item (yyvsp))
			if yyval33 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval33.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval33
		end

	yy_do_action_169 is
			--|#line 1203 "et_eiffel_parser.y"
		local
			yyval48: ET_FEATURE_NAME_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1203")
end

			yyval48 := ast_factory.new_feature_name_comma (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval48 /= Void then
				increment_counter
			end
		
			yyval := yyval48
		end

	yy_do_action_170 is
			--|#line 1214 "et_eiffel_parser.y"
		local
			yyval45: ET_FEATURE_CLAUSE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1214")
end

			-- $$ := Void
			set_named_features
		
			yyval := yyval45
		end

	yy_do_action_171 is
			--|#line 1219 "et_eiffel_parser.y"
		local
			yyval45: ET_FEATURE_CLAUSE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1219")
end

yyval45 := yytype45 (yyvs.item (yyvsp)) 
			yyval := yyval45
		end

	yy_do_action_172 is
			--|#line 1223 "et_eiffel_parser.y"
		local
			yyval45: ET_FEATURE_CLAUSE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1223")
end

			yyval45 := yytype45 (yyvs.item (yyvsp))
			set_named_features
			remove_counter
		
			yyval := yyval45
		end

	yy_do_action_173 is
			--|#line 1231 "et_eiffel_parser.y"
		local
			yyval45: ET_FEATURE_CLAUSE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1231")
end

			yyval45 := ast_factory.new_feature_clauses (counter_value)
			if yyval45 /= Void and yytype44 (yyvs.item (yyvsp)) /= Void then
				yyval45.put_first (yytype44 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval45
		end

	yy_do_action_174 is
			--|#line 1238 "et_eiffel_parser.y"
		local
			yyval45: ET_FEATURE_CLAUSE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1238")
end

			yyval45 := yytype45 (yyvs.item (yyvsp))
			if yyval45 /= Void and yytype44 (yyvs.item (yyvsp - 1)) /= Void then
				yyval45.put_first (yytype44 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval45
		end

	yy_do_action_175 is
			--|#line 1247 "et_eiffel_parser.y"
		local
			yyval44: ET_FEATURE_CLAUSE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1247")
end

			yyval44 := last_feature_clause
			if yyval44 /= Void then
				increment_counter
			end
		
			yyval := yyval44
		end

	yy_do_action_176 is
			--|#line 1254 "et_eiffel_parser.y"
		local
			yyval44: ET_FEATURE_CLAUSE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1254")
end

			yyval44 := last_feature_clause
			if yyval44 /= Void then
				increment_counter
			end
		
			yyval := yyval44
		end

	yy_do_action_177 is
			--|#line 1263 "et_eiffel_parser.y"
		local
			yyval44: ET_FEATURE_CLAUSE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1263")
end

			last_clients := yytype29 (yyvs.item (yyvsp))
			last_feature_clause := ast_factory.new_feature_clause (yytype1 (yyvs.item (yyvsp - 1)), last_clients)
		
			yyval := yyval44
		end

	yy_do_action_178 is
			--|#line 1268 "et_eiffel_parser.y"
		local
			yyval44: ET_FEATURE_CLAUSE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1268")
end

			last_clients := ast_factory.new_any_clients (yytype1 (yyvs.item (yyvsp)))
			last_feature_clause := ast_factory.new_feature_clause (yytype1 (yyvs.item (yyvsp)), last_clients)
		
			yyval := yyval44
		end

	yy_do_action_179 is
			--|#line 1275 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1275")
end
			yyval := yyval_default;


		end

	yy_do_action_180 is
			--|#line 1276 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1276")
end
			yyval := yyval_default;


		end

	yy_do_action_181 is
			--|#line 1281 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1281")
end

			yyval43 := yytype43 (yyvs.item (yyvsp))
			register_feature (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_182 is
			--|#line 1286 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1286")
end

			yyval43 := yytype43 (yyvs.item (yyvsp))
			yyval43.set_frozen_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			register_feature (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_183 is
			--|#line 1292 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1292")
end

			yyval43 := new_synonym_feature (ast_factory.new_feature_name_comma (yytype47 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype43 (yyvs.item (yyvsp)))
			register_synonym (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_184 is
			--|#line 1297 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1297")
end

			yyval43 := new_synonym_feature (yytype47 (yyvs.item (yyvsp - 1)), yytype43 (yyvs.item (yyvsp)))
			register_synonym (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_185 is
			--|#line 1303 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1303")
end

			yyval43 := new_synonym_feature (ast_factory.new_feature_name_comma (yytype47 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype43 (yyvs.item (yyvsp)))
			yyval43.set_frozen_keyword (yytype1 (yyvs.item (yyvsp - 3)))
			register_synonym (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_186 is
			--|#line 1309 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1309")
end

			yyval43 := new_synonym_feature (yytype47 (yyvs.item (yyvsp - 1)), yytype43 (yyvs.item (yyvsp)))
			yyval43.set_frozen_keyword (yytype1 (yyvs.item (yyvsp - 2)))
			register_synonym (yyval43)
		
			yyval := yyval43
		end

	yy_do_action_187 is
			--|#line 1318 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1318")
end

yyval43 := ast_factory.new_attribute (yytype47 (yyvs.item (yyvsp - 3)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 2)), yytype85 (yyvs.item (yyvsp - 1))), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_188 is
			--|#line 1320 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1320")
end

yyval43 := ast_factory.new_constant_attribute (yytype47 (yyvs.item (yyvsp - 5)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 4)), yytype85 (yyvs.item (yyvsp - 3))), yytype1 (yyvs.item (yyvsp - 2)), yytype31 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_189 is
			--|#line 1322 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1322")
end

yyval43 := ast_factory.new_unique_attribute (yytype47 (yyvs.item (yyvsp - 5)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 4)), yytype85 (yyvs.item (yyvsp - 3))), yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_190 is
			--|#line 1324 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1324")
end

yyval43 := ast_factory.new_do_procedure (yytype47 (yyvs.item (yyvsp - 9)), Void, yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_191 is
			--|#line 1327 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1327")
end

yyval43 := ast_factory.new_do_procedure (yytype47 (yyvs.item (yyvsp - 10)), yytype51 (yyvs.item (yyvsp - 9)), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_192 is
			--|#line 1331 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1331")
end

yyval43 := ast_factory.new_once_procedure (yytype47 (yyvs.item (yyvsp - 9)), Void, yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_193 is
			--|#line 1334 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1334")
end

yyval43 := ast_factory.new_once_procedure (yytype47 (yyvs.item (yyvsp - 10)), yytype51 (yyvs.item (yyvsp - 9)), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_194 is
			--|#line 1338 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1338")
end

yyval43 := ast_factory.new_deferred_procedure (yytype47 (yyvs.item (yyvsp - 7)), Void, yytype1 (yyvs.item (yyvsp - 6)), yytype72 (yyvs.item (yyvsp - 5)), yytype80 (yyvs.item (yyvsp - 4)), yytype1 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_195 is
			--|#line 1340 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1340")
end

yyval43 := ast_factory.new_deferred_procedure (yytype47 (yyvs.item (yyvsp - 8)), yytype51 (yyvs.item (yyvsp - 7)), yytype1 (yyvs.item (yyvsp - 6)), yytype72 (yyvs.item (yyvsp - 5)), yytype80 (yyvs.item (yyvsp - 4)), yytype1 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_196 is
			--|#line 1343 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1343")
end

yyval43 := ast_factory.new_external_procedure (yytype47 (yyvs.item (yyvsp - 9)), Void, yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), ast_factory.new_external_language (yytype1 (yyvs.item (yyvsp - 5)), yytype13 (yyvs.item (yyvsp - 4))), yytype42 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_197 is
			--|#line 1346 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1346")
end

yyval43 := ast_factory.new_external_procedure (yytype47 (yyvs.item (yyvsp - 10)), yytype51 (yyvs.item (yyvsp - 9)), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), ast_factory.new_external_language (yytype1 (yyvs.item (yyvsp - 5)), yytype13 (yyvs.item (yyvsp - 4))), yytype42 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_198 is
			--|#line 1350 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1350")
end

yyval43 := ast_factory.new_do_function (yytype47 (yyvs.item (yyvsp - 11)), Void, ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_199 is
			--|#line 1353 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1353")
end

yyval43 := ast_factory.new_do_function (yytype47 (yyvs.item (yyvsp - 12)), yytype51 (yyvs.item (yyvsp - 11)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_200 is
			--|#line 1357 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1357")
end

yyval43 := ast_factory.new_once_function (yytype47 (yyvs.item (yyvsp - 11)), Void, ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_201 is
			--|#line 1360 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1360")
end

yyval43 := ast_factory.new_once_function (yytype47 (yyvs.item (yyvsp - 12)), yytype51 (yyvs.item (yyvsp - 11)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), yytype67 (yyvs.item (yyvsp - 5)), yytype30 (yyvs.item (yyvsp - 4)), yytype77 (yyvs.item (yyvsp - 3)), yytype30 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_202 is
			--|#line 1364 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1364")
end

yyval43 := ast_factory.new_deferred_function (yytype47 (yyvs.item (yyvsp - 9)), Void, ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 8)), yytype85 (yyvs.item (yyvsp - 7))), yytype1 (yyvs.item (yyvsp - 6)), yytype72 (yyvs.item (yyvsp - 5)), yytype80 (yyvs.item (yyvsp - 4)), yytype1 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_203 is
			--|#line 1366 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1366")
end

yyval43 := ast_factory.new_deferred_function (yytype47 (yyvs.item (yyvsp - 10)), yytype51 (yyvs.item (yyvsp - 9)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 8)), yytype85 (yyvs.item (yyvsp - 7))), yytype1 (yyvs.item (yyvsp - 6)), yytype72 (yyvs.item (yyvsp - 5)), yytype80 (yyvs.item (yyvsp - 4)), yytype1 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_204 is
			--|#line 1369 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1369")
end

yyval43 := ast_factory.new_external_function (yytype47 (yyvs.item (yyvsp - 11)), Void, ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), ast_factory.new_external_language (yytype1 (yyvs.item (yyvsp - 5)), yytype13 (yyvs.item (yyvsp - 4))), yytype42 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_205 is
			--|#line 1372 "et_eiffel_parser.y"
		local
			yyval43: ET_FEATURE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1372")
end

yyval43 := ast_factory.new_external_function (yytype47 (yyvs.item (yyvsp - 12)), yytype51 (yyvs.item (yyvsp - 11)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 10)), yytype85 (yyvs.item (yyvsp - 9))), yytype1 (yyvs.item (yyvsp - 8)), yytype72 (yyvs.item (yyvsp - 7)), yytype80 (yyvs.item (yyvsp - 6)), ast_factory.new_external_language (yytype1 (yyvs.item (yyvsp - 5)), yytype13 (yyvs.item (yyvsp - 4))), yytype42 (yyvs.item (yyvsp - 3)), yytype77 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp)), last_clients, last_feature_clause, last_class) 
			yyval := yyval43
		end

	yy_do_action_206 is
			--|#line 1378 "et_eiffel_parser.y"
		local
			yyval18: ET_SEMICOLON_SYMBOL
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1378")
end


			yyval := yyval18
		end

	yy_do_action_207 is
			--|#line 1380 "et_eiffel_parser.y"
		local
			yyval18: ET_SEMICOLON_SYMBOL
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1380")
end

yyval18 := yytype18 (yyvs.item (yyvsp)) 
			yyval := yyval18
		end

	yy_do_action_208 is
			--|#line 1384 "et_eiffel_parser.y"
		local
			yyval42: ET_EXTERNAL_ALIAS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1384")
end


			yyval := yyval42
		end

	yy_do_action_209 is
			--|#line 1386 "et_eiffel_parser.y"
		local
			yyval42: ET_EXTERNAL_ALIAS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1386")
end

yyval42 := ast_factory.new_external_alias (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval42
		end

	yy_do_action_210 is
			--|#line 1392 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1392")
end

yyval47 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval47
		end

	yy_do_action_211 is
			--|#line 1394 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1394")
end

yyval47 := ast_factory.new_prefix_not_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_212 is
			--|#line 1396 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1396")
end

yyval47 := ast_factory.new_prefix_plus_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_213 is
			--|#line 1398 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1398")
end

yyval47 := ast_factory.new_prefix_minus_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_214 is
			--|#line 1400 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1400")
end

yyval47 := ast_factory.new_prefix_free_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_215 is
			--|#line 1402 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1402")
end

yyval47 := ast_factory.new_infix_plus_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_216 is
			--|#line 1404 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1404")
end

yyval47 := ast_factory.new_infix_minus_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_217 is
			--|#line 1406 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1406")
end

yyval47 := ast_factory.new_infix_times_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_218 is
			--|#line 1408 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1408")
end

yyval47 := ast_factory.new_infix_divide_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_219 is
			--|#line 1410 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1410")
end

yyval47 := ast_factory.new_infix_div_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_220 is
			--|#line 1412 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1412")
end

yyval47 := ast_factory.new_infix_mod_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_221 is
			--|#line 1414 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1414")
end

yyval47 := ast_factory.new_infix_power_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_222 is
			--|#line 1416 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1416")
end

yyval47 := ast_factory.new_infix_lt_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_223 is
			--|#line 1418 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1418")
end

yyval47 := ast_factory.new_infix_le_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_224 is
			--|#line 1420 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1420")
end

yyval47 := ast_factory.new_infix_gt_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_225 is
			--|#line 1422 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1422")
end

yyval47 := ast_factory.new_infix_ge_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_226 is
			--|#line 1424 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1424")
end

yyval47 := ast_factory.new_infix_and_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_227 is
			--|#line 1426 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1426")
end

yyval47 := ast_factory.new_infix_and_then_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_228 is
			--|#line 1428 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1428")
end

yyval47 := ast_factory.new_infix_or_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_229 is
			--|#line 1430 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1430")
end

yyval47 := ast_factory.new_infix_or_else_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_230 is
			--|#line 1432 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1432")
end

yyval47 := ast_factory.new_infix_implies_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_231 is
			--|#line 1434 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1434")
end

yyval47 := ast_factory.new_infix_xor_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_232 is
			--|#line 1436 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1436")
end

yyval47 := ast_factory.new_infix_free_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_233 is
			--|#line 1439 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1439")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_234 is
			--|#line 1441 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1441")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_235 is
			--|#line 1443 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1443")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_236 is
			--|#line 1445 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1445")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_237 is
			--|#line 1447 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1447")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_238 is
			--|#line 1449 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1449")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_239 is
			--|#line 1451 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1451")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_240 is
			--|#line 1453 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1453")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_241 is
			--|#line 1455 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1455")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_242 is
			--|#line 1457 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1457")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_243 is
			--|#line 1459 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1459")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_244 is
			--|#line 1461 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1461")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_245 is
			--|#line 1463 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1463")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_246 is
			--|#line 1465 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1465")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_247 is
			--|#line 1467 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1467")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_248 is
			--|#line 1469 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1469")
end

yyval47 := new_invalid_prefix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_249 is
			--|#line 1471 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1471")
end

yyval47 := new_invalid_infix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_250 is
			--|#line 1473 "et_eiffel_parser.y"
		local
			yyval47: ET_FEATURE_NAME
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1473")
end

yyval47 := new_invalid_infix_name (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval47
		end

	yy_do_action_251 is
			--|#line 1479 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1479")
end

yyval51 := ast_factory.new_formal_arguments (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval51
		end

	yy_do_action_252 is
			--|#line 1481 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1481")
end

			yyval51 := yytype51 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval51
		end

	yy_do_action_253 is
			--|#line 1481 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1481")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_254 is
			--|#line 1494 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1494")
end

			yyval51 := ast_factory.new_formal_arguments (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval51 /= Void and yytype50 (yyvs.item (yyvsp - 1)) /= Void then
				yyval51.put_first (yytype50 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval51
		end

	yy_do_action_255 is
			--|#line 1501 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1501")
end

			yyval51 := ast_factory.new_formal_arguments (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval51 /= Void and yytype50 (yyvs.item (yyvsp - 1)) /= Void then
				yyval51.put_first (yytype50 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval51
		end

	yy_do_action_256 is
			--|#line 1508 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1508")
end

			yyval51 := yytype51 (yyvs.item (yyvsp))
			if yyval51 /= Void and yytype49 (yyvs.item (yyvsp - 1)) /= Void then
				if not yyval51.is_empty then
					yytype49 (yyvs.item (yyvsp - 1)).set_declared_type (yyval51.first.type)
					yyval51.put_first (yytype49 (yyvs.item (yyvsp - 1)))
				end
			end
		
			yyval := yyval51
		end

	yy_do_action_257 is
			--|#line 1518 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1518")
end

			-- TODO: Syntax error
			yyval51 := yytype51 (yyvs.item (yyvsp))
			if yyval51 /= Void and yytype49 (yyvs.item (yyvsp - 1)) /= Void then
				if not yyval51.is_empty then
					yytype49 (yyvs.item (yyvsp - 1)).set_declared_type (yyval51.first.type)
					yyval51.put_first (yytype49 (yyvs.item (yyvsp - 1)))
				end
			end
		
			yyval := yyval51
		end

	yy_do_action_258 is
			--|#line 1529 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1529")
end

			yyval51 := yytype51 (yyvs.item (yyvsp))
			if yyval51 /= Void and yytype50 (yyvs.item (yyvsp - 1)) /= Void then
				yyval51.put_first (yytype50 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval51
		end

	yy_do_action_259 is
			--|#line 1536 "et_eiffel_parser.y"
		local
			yyval51: ET_FORMAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1536")
end

			yyval51 := yytype51 (yyvs.item (yyvsp))
			if yyval51 /= Void and yytype50 (yyvs.item (yyvsp - 1)) /= Void then
				yyval51.put_first (yytype50 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval51
		end

	yy_do_action_260 is
			--|#line 1545 "et_eiffel_parser.y"
		local
			yyval49: ET_FORMAL_ARGUMENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1545")
end

			yyval49 := ast_factory.new_formal_comma_argument (ast_factory.new_argument_name_comma (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp))), dummy_type)
			if yyval49 /= Void then
				increment_counter
			end
		
			yyval := yyval49
		end

	yy_do_action_261 is
			--|#line 1554 "et_eiffel_parser.y"
		local
			yyval49: ET_FORMAL_ARGUMENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1554")
end

			yyval49 := ast_factory.new_formal_comma_argument (yytype10 (yyvs.item (yyvsp)), dummy_type)
			if yyval49 /= Void then
				increment_counter
			end
		
			yyval := yyval49
		end

	yy_do_action_262 is
			--|#line 1563 "et_eiffel_parser.y"
		local
			yyval50: ET_FORMAL_ARGUMENT_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1563")
end

			yyval50 := ast_factory.new_formal_argument (yytype10 (yyvs.item (yyvsp - 2)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 1)), yytype85 (yyvs.item (yyvsp))))
			if yyval50 /= Void then
				increment_counter
			end
		
			yyval := yyval50
		end

	yy_do_action_263 is
			--|#line 1572 "et_eiffel_parser.y"
		local
			yyval50: ET_FORMAL_ARGUMENT_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1572")
end

			yyval50 := ast_factory.new_formal_argument_semicolon (ast_factory.new_formal_argument (yytype10 (yyvs.item (yyvsp - 3)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 2)), yytype85 (yyvs.item (yyvsp - 1)))), yytype18 (yyvs.item (yyvsp)))
			if yyval50 /= Void then
				increment_counter
			end
		
			yyval := yyval50
		end

	yy_do_action_264 is
			--|#line 1583 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1583")
end


			yyval := yyval67
		end

	yy_do_action_265 is
			--|#line 1585 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1585")
end

yyval67 := ast_factory.new_local_variables (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval67
		end

	yy_do_action_266 is
			--|#line 1587 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1587")
end

			yyval67 := yytype67 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval67
		end

	yy_do_action_267 is
			--|#line 1587 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1587")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_268 is
			--|#line 1600 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1600")
end

			yyval67 := ast_factory.new_local_variables (last_keyword, counter_value)
			if yytype66 (yyvs.item (yyvsp)) /= Void then
				yyval67.put_first (yytype66 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval67
		end

	yy_do_action_269 is
			--|#line 1607 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1607")
end

			yyval67 := ast_factory.new_local_variables (last_keyword, counter_value)
			if yytype66 (yyvs.item (yyvsp)) /= Void then
				yyval67.put_first (yytype66 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval67
		end

	yy_do_action_270 is
			--|#line 1614 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1614")
end

			yyval67 := yytype67 (yyvs.item (yyvsp))
			if yyval67 /= Void and yytype65 (yyvs.item (yyvsp - 1)) /= Void then
				if not yyval67.is_empty then
					yytype65 (yyvs.item (yyvsp - 1)).set_declared_type (yyval67.first.type)
					yyval67.put_first (yytype65 (yyvs.item (yyvsp - 1)))
				end
			end
		
			yyval := yyval67
		end

	yy_do_action_271 is
			--|#line 1624 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1624")
end

			-- TODO: Syntax error
			yyval67 := yytype67 (yyvs.item (yyvsp))
			if yyval67 /= Void and yytype65 (yyvs.item (yyvsp - 1)) /= Void then
				if not yyval67.is_empty then
					yytype65 (yyvs.item (yyvsp - 1)).set_declared_type (yyval67.first.type)
					yyval67.put_first (yytype65 (yyvs.item (yyvsp - 1)))
				end
			end
		
			yyval := yyval67
		end

	yy_do_action_272 is
			--|#line 1635 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1635")
end

			yyval67 := yytype67 (yyvs.item (yyvsp))
			if yyval67 /= Void and yytype66 (yyvs.item (yyvsp - 1)) /= Void then
				yyval67.put_first (yytype66 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval67
		end

	yy_do_action_273 is
			--|#line 1642 "et_eiffel_parser.y"
		local
			yyval67: ET_LOCAL_VARIABLE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1642")
end

			yyval67 := yytype67 (yyvs.item (yyvsp))
			if yyval67 /= Void and yytype66 (yyvs.item (yyvsp - 1)) /= Void then
				yyval67.put_first (yytype66 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval67
		end

	yy_do_action_274 is
			--|#line 1651 "et_eiffel_parser.y"
		local
			yyval65: ET_LOCAL_VARIABLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1651")
end

			yyval65 := ast_factory.new_local_comma_variable (ast_factory.new_local_name_comma (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp))), dummy_type)
			if yyval65 /= Void then
				increment_counter
			end
		
			yyval := yyval65
		end

	yy_do_action_275 is
			--|#line 1660 "et_eiffel_parser.y"
		local
			yyval65: ET_LOCAL_VARIABLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1660")
end

			yyval65 := ast_factory.new_local_comma_variable (yytype10 (yyvs.item (yyvsp)), dummy_type)
			if yyval65 /= Void then
				increment_counter
			end
		
			yyval := yyval65
		end

	yy_do_action_276 is
			--|#line 1669 "et_eiffel_parser.y"
		local
			yyval66: ET_LOCAL_VARIABLE_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1669")
end

			yyval66 := ast_factory.new_local_variable (yytype10 (yyvs.item (yyvsp - 2)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 1)), yytype85 (yyvs.item (yyvsp))))
			if yyval66 /= Void then
				increment_counter
			end
		
			yyval := yyval66
		end

	yy_do_action_277 is
			--|#line 1678 "et_eiffel_parser.y"
		local
			yyval66: ET_LOCAL_VARIABLE_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1678")
end

			yyval66 := ast_factory.new_local_variable_semicolon (ast_factory.new_local_variable (yytype10 (yyvs.item (yyvsp - 3)), ast_factory.new_colon_type (yytype2 (yyvs.item (yyvsp - 2)), yytype85 (yyvs.item (yyvsp - 1)))), yytype18 (yyvs.item (yyvsp)))
			if yyval66 /= Void then
				increment_counter
			end
		
			yyval := yyval66
		end

	yy_do_action_278 is
			--|#line 1689 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1689")
end
			yyval := yyval_default;
add_expression_assertion (yytype40 (yyvs.item (yyvsp)), Void) 

		end

	yy_do_action_279 is
			--|#line 1691 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1691")
end
			yyval := yyval_default;
add_expression_assertion (yytype40 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 

		end

	yy_do_action_280 is
			--|#line 1693 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1693")
end
			yyval := yyval_default;
add_tagged_assertion (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), Void) 

		end

	yy_do_action_281 is
			--|#line 1695 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1695")
end
			yyval := yyval_default;
add_tagged_assertion (yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 

		end

	yy_do_action_282 is
			--|#line 1697 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1697")
end
			yyval := yyval_default;
add_expression_assertion (yytype40 (yyvs.item (yyvsp)), Void) 

		end

	yy_do_action_283 is
			--|#line 1699 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1699")
end
			yyval := yyval_default;
add_expression_assertion (yytype40 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 

		end

	yy_do_action_284 is
			--|#line 1701 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1701")
end
			yyval := yyval_default;
add_tagged_assertion (yytype10 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), Void) 

		end

	yy_do_action_285 is
			--|#line 1703 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1703")
end
			yyval := yyval_default;
add_tagged_assertion (yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype18 (yyvs.item (yyvsp))) 

		end

	yy_do_action_286 is
			--|#line 1707 "et_eiffel_parser.y"
		local
			yyval80: ET_PRECONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1707")
end


			yyval := yyval80
		end

	yy_do_action_287 is
			--|#line 1709 "et_eiffel_parser.y"
		local
			yyval80: ET_PRECONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1709")
end

yyval80 := new_preconditions (yytype1 (yyvs.item (yyvsp)), Void) 
			yyval := yyval80
		end

	yy_do_action_288 is
			--|#line 1711 "et_eiffel_parser.y"
		local
			yyval80: ET_PRECONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1711")
end

yyval80 := new_preconditions (yytype1 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval80
		end

	yy_do_action_289 is
			--|#line 1713 "et_eiffel_parser.y"
		local
			yyval80: ET_PRECONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1713")
end

yyval80 := new_preconditions (yytype1 (yyvs.item (yyvsp - 1)), Void) 
			yyval := yyval80
		end

	yy_do_action_290 is
			--|#line 1715 "et_eiffel_parser.y"
		local
			yyval80: ET_PRECONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1715")
end

yyval80 := new_preconditions (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1))) 
			yyval := yyval80
		end

	yy_do_action_291 is
			--|#line 1719 "et_eiffel_parser.y"
		local
			yyval77: ET_POSTCONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1719")
end


			yyval := yyval77
		end

	yy_do_action_292 is
			--|#line 1721 "et_eiffel_parser.y"
		local
			yyval77: ET_POSTCONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1721")
end

yyval77 := new_postconditions (yytype1 (yyvs.item (yyvsp)), Void) 
			yyval := yyval77
		end

	yy_do_action_293 is
			--|#line 1723 "et_eiffel_parser.y"
		local
			yyval77: ET_POSTCONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1723")
end

yyval77 := new_postconditions (yytype1 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval77
		end

	yy_do_action_294 is
			--|#line 1725 "et_eiffel_parser.y"
		local
			yyval77: ET_POSTCONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1725")
end

yyval77 := new_postconditions (yytype1 (yyvs.item (yyvsp - 1)), Void) 
			yyval := yyval77
		end

	yy_do_action_295 is
			--|#line 1727 "et_eiffel_parser.y"
		local
			yyval77: ET_POSTCONDITIONS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1727")
end

yyval77 := new_postconditions (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1))) 
			yyval := yyval77
		end

	yy_do_action_296 is
			--|#line 1731 "et_eiffel_parser.y"
		local
			yyval63: ET_INVARIANTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1731")
end


			yyval := yyval63
		end

	yy_do_action_297 is
			--|#line 1733 "et_eiffel_parser.y"
		local
			yyval63: ET_INVARIANTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1733")
end

yyval63 := yytype63 (yyvs.item (yyvsp)) 
			yyval := yyval63
		end

	yy_do_action_298 is
			--|#line 1737 "et_eiffel_parser.y"
		local
			yyval63: ET_INVARIANTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1737")
end

yyval63 := new_invariants (yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval63
		end

	yy_do_action_299 is
			--|#line 1739 "et_eiffel_parser.y"
		local
			yyval63: ET_INVARIANTS
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1739")
end

yyval63 := new_invariants (yytype1 (yyvs.item (yyvsp - 1))) 
			yyval := yyval63
		end

	yy_do_action_300 is
			--|#line 1743 "et_eiffel_parser.y"
		local
			yyval87: ET_VARIANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1743")
end


			yyval := yyval87
		end

	yy_do_action_301 is
			--|#line 1745 "et_eiffel_parser.y"
		local
			yyval87: ET_VARIANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1745")
end

yyval87 := ast_factory.new_variant (yytype1 (yyvs.item (yyvsp)), Void, Void) 
			yyval := yyval87
		end

	yy_do_action_302 is
			--|#line 1747 "et_eiffel_parser.y"
		local
			yyval87: ET_VARIANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1747")
end

yyval87 := ast_factory.new_variant (yytype1 (yyvs.item (yyvsp - 1)), Void, yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval87
		end

	yy_do_action_303 is
			--|#line 1749 "et_eiffel_parser.y"
		local
			yyval87: ET_VARIANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1749")
end

yyval87 := ast_factory.new_variant (yytype1 (yyvs.item (yyvsp - 3)), ast_factory.new_tag (yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval87
		end

	yy_do_action_304 is
			--|#line 1755 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1755")
end


			yyval := yyval30
		end

	yy_do_action_305 is
			--|#line 1757 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1757")
end

yyval30 := yytype30 (yyvs.item (yyvsp)) 
			yyval := yyval30
		end

	yy_do_action_306 is
			--|#line 1763 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1763")
end

yyval85 := new_named_type (Void, yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_307 is
			--|#line 1765 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1765")
end

yyval85 := new_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_308 is
			--|#line 1767 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1767")
end

yyval85 := new_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_309 is
			--|#line 1769 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1769")
end

yyval85 := new_named_type (yytype1 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1)), yytype20 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_310 is
			--|#line 1771 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1771")
end

yyval85 := ast_factory.new_like_current (yytype1 (yyvs.item (yyvsp - 1)), yytype8 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_311 is
			--|#line 1773 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1773")
end

yyval85 := ast_factory.new_like_identifier (yytype1 (yyvs.item (yyvsp - 1)), yytype10 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_312 is
			--|#line 1775 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1775")
end

yyval85 := ast_factory.new_bit_type (yytype10 (yyvs.item (yyvsp - 1)), yytype11 (yyvs.item (yyvsp))) 
			yyval := yyval85
		end

	yy_do_action_313 is
			--|#line 1777 "et_eiffel_parser.y"
		local
			yyval85: ET_TYPE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1777")
end

yyval85 := ast_factory.new_bit_identifier (yytype10 (yyvs.item (yyvsp - 1)), yytype10 (yyvs.item (yyvsp)))  
			yyval := yyval85
		end

	yy_do_action_314 is
			--|#line 1781 "et_eiffel_parser.y"
		local
			yyval10: ET_IDENTIFIER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1781")
end

yyval10 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval10
		end

	yy_do_action_315 is
			--|#line 1785 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1785")
end


			yyval := yyval20
		end

	yy_do_action_316 is
			--|#line 1787 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1787")
end

yyval20 := yytype20 (yyvs.item (yyvsp)) 
			yyval := yyval20
		end

	yy_do_action_317 is
			--|#line 1791 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1791")
end

yyval20 := ast_factory.new_actual_parameters (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval20
		end

	yy_do_action_318 is
			--|#line 1794 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1794")
end

			yyval20 := yytype20 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval20
		end

	yy_do_action_319 is
			--|#line 1794 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1794")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_320 is
			--|#line 1807 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1807")
end

			if yytype85 (yyvs.item (yyvsp - 1)) /= Void then
				yyval20 := ast_factory.new_actual_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval20 /= Void then
					yyval20.put_first (yytype85 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval20 := ast_factory.new_actual_parameters (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval20
		end

	yy_do_action_321 is
			--|#line 1818 "et_eiffel_parser.y"
		local
			yyval20: ET_ACTUAL_PARAMETER_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1818")
end

			yyval20 := yytype20 (yyvs.item (yyvsp))
			if yyval20 /= Void and yytype86 (yyvs.item (yyvsp - 1)) /= Void then
				yyval20.put_first (yytype86 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval20
		end

	yy_do_action_322 is
			--|#line 1827 "et_eiffel_parser.y"
		local
			yyval86: ET_TYPE_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1827")
end

			yyval86 := ast_factory.new_type_comma (yytype85 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval86 /= Void then
				increment_counter
			end
		
			yyval := yyval86
		end

	yy_do_action_323 is
			--|#line 1838 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1838")
end

yyval30 := ast_factory.new_do_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_324 is
			--|#line 1840 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1840")
end

			yyval30 := ast_factory.new_do_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_325 is
			--|#line 1847 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1847")
end

yyval30 := ast_factory.new_once_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_326 is
			--|#line 1849 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1849")
end

			yyval30 := ast_factory.new_once_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_327 is
			--|#line 1856 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1856")
end

yyval30 := ast_factory.new_then_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_328 is
			--|#line 1858 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1858")
end

			yyval30 := ast_factory.new_then_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_329 is
			--|#line 1865 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1865")
end

yyval30 := ast_factory.new_else_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_330 is
			--|#line 1867 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1867")
end

			yyval30 := ast_factory.new_else_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_331 is
			--|#line 1874 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1874")
end

yyval30 := ast_factory.new_rescue_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_332 is
			--|#line 1876 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1876")
end

			yyval30 := ast_factory.new_rescue_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_333 is
			--|#line 1883 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1883")
end

yyval30 := ast_factory.new_from_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_334 is
			--|#line 1885 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1885")
end

			yyval30 := ast_factory.new_from_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_335 is
			--|#line 1892 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1892")
end

yyval30 := ast_factory.new_loop_compound (yytype1 (yyvs.item (yyvsp)), ast_factory.new_compound (0)) 
			yyval := yyval30
		end

	yy_do_action_336 is
			--|#line 1894 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1894")
end

			yyval30 := ast_factory.new_loop_compound (yytype1 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval30
		end

	yy_do_action_337 is
			--|#line 1901 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1901")
end

			if yytype62 (yyvs.item (yyvsp)) /= Void then
				yyval30 := ast_factory.new_compound (counter_value + 1)
				if yyval30 /= Void then
					yyval30.put_first (yytype62 (yyvs.item (yyvsp)))
				end
			else
				yyval30 := ast_factory.new_compound (counter_value)
			end
		
			yyval := yyval30
		end

	yy_do_action_338 is
			--|#line 1912 "et_eiffel_parser.y"
		local
			yyval30: ET_COMPOUND
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1912")
end

			yyval30 := yytype30 (yyvs.item (yyvsp))
			if yyval30 /= Void and yytype62 (yyvs.item (yyvsp - 2)) /= Void then
				yyval30.put_first (yytype62 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval30
		end

	yy_do_action_339 is
			--|#line 1912 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1912")
end
			yyval := yyval_default;
			if yytype62 (yyvs.item (yyvsp)) /= Void then
				increment_counter
			end
		

		end

	yy_do_action_340 is
			--|#line 1927 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1927")
end

yyval62 := yytype62 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_341 is
			--|#line 1929 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1929")
end

yyval62 := yytype62 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_342 is
			--|#line 1931 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1931")
end

yyval62 := yytype62 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_343 is
			--|#line 1933 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1933")
end

yyval62 := ast_factory.new_assignment (yytype90 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_344 is
			--|#line 1935 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1935")
end

yyval62 := ast_factory.new_assignment_attempt (yytype90 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_345 is
			--|#line 1937 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1937")
end

yyval62 := yytype55 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_346 is
			--|#line 1939 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1939")
end

yyval62 := yytype61 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_347 is
			--|#line 1941 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1941")
end

yyval62 := ast_factory.new_loop_instruction (yytype30 (yyvs.item (yyvsp - 6)), yytype63 (yyvs.item (yyvsp - 5)), yytype87 (yyvs.item (yyvsp - 4)), ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 3)), yytype40 (yyvs.item (yyvsp - 2))), yytype30 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_348 is
			--|#line 1943 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1943")
end

yyval62 := yytype35 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_349 is
			--|#line 1945 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1945")
end

yyval62 := new_check_instruction (yytype1 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_350 is
			--|#line 1947 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1947")
end

yyval62 := new_check_instruction (yytype1 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_351 is
			--|#line 1949 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1949")
end

yyval62 := yytype16 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_352 is
			--|#line 1951 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1951")
end

yyval62 := ast_factory.new_null_instruction (yytype18 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_353 is
			--|#line 1957 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1957")
end

yyval62 := ast_factory.new_bang_instruction (yytype2 (yyvs.item (yyvsp - 3)), yytype85 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype90 (yyvs.item (yyvsp)), Void) 
			yyval := yyval62
		end

	yy_do_action_354 is
			--|#line 1959 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1959")
end

yyval62 := ast_factory.new_bang_instruction (yytype2 (yyvs.item (yyvsp - 6)), yytype85 (yyvs.item (yyvsp - 5)), yytype2 (yyvs.item (yyvsp - 4)), yytype90 (yyvs.item (yyvsp - 3)), ast_factory.new_qualified_call (ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp)))) 
			yyval := yyval62
		end

	yy_do_action_355 is
			--|#line 1961 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1961")
end

yyval62 := ast_factory.new_bang_instruction (yytype2 (yyvs.item (yyvsp - 2)), Void, yytype2 (yyvs.item (yyvsp - 1)), yytype90 (yyvs.item (yyvsp)), Void) 
			yyval := yyval62
		end

	yy_do_action_356 is
			--|#line 1963 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1963")
end

yyval62 := ast_factory.new_bang_instruction (yytype2 (yyvs.item (yyvsp - 5)), Void, yytype2 (yyvs.item (yyvsp - 4)), yytype90 (yyvs.item (yyvsp - 3)), ast_factory.new_qualified_call (ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp)))) 
			yyval := yyval62
		end

	yy_do_action_357 is
			--|#line 1967 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1967")
end

yyval62 := ast_factory.new_create_instruction (yytype1 (yyvs.item (yyvsp - 4)), ast_factory.new_creation_type (yytype2 (yyvs.item (yyvsp - 3)), yytype85 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype90 (yyvs.item (yyvsp)), Void) 
			yyval := yyval62
		end

	yy_do_action_358 is
			--|#line 1969 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1969")
end

yyval62 := ast_factory.new_create_instruction (yytype1 (yyvs.item (yyvsp - 7)), ast_factory.new_creation_type (yytype2 (yyvs.item (yyvsp - 6)), yytype85 (yyvs.item (yyvsp - 5)), yytype2 (yyvs.item (yyvsp - 4))), yytype90 (yyvs.item (yyvsp - 3)), ast_factory.new_qualified_call (ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp)))) 
			yyval := yyval62
		end

	yy_do_action_359 is
			--|#line 1971 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1971")
end

yyval62 := ast_factory.new_create_instruction (yytype1 (yyvs.item (yyvsp - 1)), Void, yytype90 (yyvs.item (yyvsp)), Void) 
			yyval := yyval62
		end

	yy_do_action_360 is
			--|#line 1973 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1973")
end

yyval62 := ast_factory.new_create_instruction (yytype1 (yyvs.item (yyvsp - 4)), Void, yytype90 (yyvs.item (yyvsp - 3)), ast_factory.new_qualified_call (ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp)))) 
			yyval := yyval62
		end

	yy_do_action_361 is
			--|#line 1977 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1977")
end

yyval40 := ast_factory.new_create_expression (yytype1 (yyvs.item (yyvsp - 3)), ast_factory.new_creation_type (yytype2 (yyvs.item (yyvsp - 2)), yytype85 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp))), Void) 
			yyval := yyval40
		end

	yy_do_action_362 is
			--|#line 1979 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1979")
end

yyval40 := ast_factory.new_create_expression (yytype1 (yyvs.item (yyvsp - 6)), ast_factory.new_creation_type (yytype2 (yyvs.item (yyvsp - 5)), yytype85 (yyvs.item (yyvsp - 4)), yytype2 (yyvs.item (yyvsp - 3))), ast_factory.new_qualified_call (ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp)))) 
			yyval := yyval40
		end

	yy_do_action_363 is
			--|#line 1985 "et_eiffel_parser.y"
		local
			yyval55: ET_IF_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1985")
end

yyval55 := ast_factory.new_if_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 3)), yytype40 (yyvs.item (yyvsp - 2))), yytype30 (yyvs.item (yyvsp - 1)), Void, Void, yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval55
		end

	yy_do_action_364 is
			--|#line 1987 "et_eiffel_parser.y"
		local
			yyval55: ET_IF_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1987")
end

yyval55 := ast_factory.new_if_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 4)), yytype40 (yyvs.item (yyvsp - 3))), yytype30 (yyvs.item (yyvsp - 2)), Void, yytype30 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval55
		end

	yy_do_action_365 is
			--|#line 1989 "et_eiffel_parser.y"
		local
			yyval55: ET_IF_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1989")
end

yyval55 := ast_factory.new_if_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 4)), yytype40 (yyvs.item (yyvsp - 3))), yytype30 (yyvs.item (yyvsp - 2)), yytype37 (yyvs.item (yyvsp - 1)), Void, yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval55
		end

	yy_do_action_366 is
			--|#line 1991 "et_eiffel_parser.y"
		local
			yyval55: ET_IF_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1991")
end

yyval55 := ast_factory.new_if_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 5)), yytype40 (yyvs.item (yyvsp - 4))), yytype30 (yyvs.item (yyvsp - 3)), yytype37 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval55
		end

	yy_do_action_367 is
			--|#line 1995 "et_eiffel_parser.y"
		local
			yyval37: ET_ELSEIF_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1995")
end

			yyval37 := yytype37 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval37
		end

	yy_do_action_368 is
			--|#line 2002 "et_eiffel_parser.y"
		local
			yyval37: ET_ELSEIF_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2002")
end

			yyval37 := ast_factory.new_elseif_part_list (counter_value)
			if yyval37 /= Void and yytype36 (yyvs.item (yyvsp)) /= Void then
				yyval37.put_first (yytype36 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval37
		end

	yy_do_action_369 is
			--|#line 2009 "et_eiffel_parser.y"
		local
			yyval37: ET_ELSEIF_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2009")
end

			yyval37 := yytype37 (yyvs.item (yyvsp))
			if yyval37 /= Void and yytype36 (yyvs.item (yyvsp - 1)) /= Void then
				yyval37.put_first (yytype36 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval37
		end

	yy_do_action_370 is
			--|#line 2018 "et_eiffel_parser.y"
		local
			yyval36: ET_ELSEIF_PART
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2018")
end

			yyval36 := ast_factory.new_elseif_part (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 2)), yytype40 (yyvs.item (yyvsp - 1))), yytype30 (yyvs.item (yyvsp)))
			if yyval36 /= Void then
				increment_counter
			end
		
			yyval := yyval36
		end

	yy_do_action_371 is
			--|#line 2029 "et_eiffel_parser.y"
		local
			yyval61: ET_INSPECT_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2029")
end

yyval61 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 4)), yytype40 (yyvs.item (yyvsp - 3))), yytype89 (yyvs.item (yyvsp - 2)), yytype30 (yyvs.item (yyvsp - 1)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval61
		end

	yy_do_action_372 is
			--|#line 2031 "et_eiffel_parser.y"
		local
			yyval61: ET_INSPECT_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2031")
end

yyval61 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yytype1 (yyvs.item (yyvsp - 3)), yytype40 (yyvs.item (yyvsp - 2))), yytype89 (yyvs.item (yyvsp - 1)), Void, yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval61
		end

	yy_do_action_373 is
			--|#line 2035 "et_eiffel_parser.y"
		local
			yyval89: ET_WHEN_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2035")
end


			yyval := yyval89
		end

	yy_do_action_374 is
			--|#line 2037 "et_eiffel_parser.y"
		local
			yyval89: ET_WHEN_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2037")
end

			yyval89 := yytype89 (yyvs.item (yyvsp))
			remove_counter
		
			yyval := yyval89
		end

	yy_do_action_375 is
			--|#line 2044 "et_eiffel_parser.y"
		local
			yyval89: ET_WHEN_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2044")
end

			yyval89 := ast_factory.new_when_part_list (counter_value)
			if yyval89 /= Void and yytype88 (yyvs.item (yyvsp)) /= Void then
				yyval89.put_first (yytype88 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval89
		end

	yy_do_action_376 is
			--|#line 2051 "et_eiffel_parser.y"
		local
			yyval89: ET_WHEN_PART_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2051")
end

			yyval89 := yytype89 (yyvs.item (yyvsp))
			if yyval89 /= Void and yytype88 (yyvs.item (yyvsp - 1)) /= Void then
				yyval89.put_first (yytype88 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval89
		end

	yy_do_action_377 is
			--|#line 2060 "et_eiffel_parser.y"
		local
			yyval88: ET_WHEN_PART
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2060")
end

			yyval88 := ast_factory.new_when_part (yytype26 (yyvs.item (yyvsp - 1)), yytype30 (yyvs.item (yyvsp)))
			if yyval88 /= Void then
				increment_counter
			end
		
			yyval := yyval88
		end

	yy_do_action_378 is
			--|#line 2069 "et_eiffel_parser.y"
		local
			yyval26: ET_CHOICE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2069")
end

yyval26 := ast_factory.new_choice_list (yytype1 (yyvs.item (yyvsp)), 0) 
			yyval := yyval26
		end

	yy_do_action_379 is
			--|#line 2071 "et_eiffel_parser.y"
		local
			yyval26: ET_CHOICE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2071")
end

			yyval26 := yytype26 (yyvs.item (yyvsp))
			remove_keyword
			remove_counter
		
			yyval := yyval26
		end

	yy_do_action_380 is
			--|#line 2071 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2071")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_381 is
			--|#line 2084 "et_eiffel_parser.y"
		local
			yyval26: ET_CHOICE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2084")
end

			if yytype23 (yyvs.item (yyvsp)) /= Void then
				yyval26 := ast_factory.new_choice_list (last_keyword, counter_value + 1)
				if yyval26 /= Void then
					yyval26.put_first (yytype23 (yyvs.item (yyvsp)))
				end
			else
				yyval26 := ast_factory.new_choice_list (last_keyword, counter_value)
			end
		
			yyval := yyval26
		end

	yy_do_action_382 is
			--|#line 2095 "et_eiffel_parser.y"
		local
			yyval26: ET_CHOICE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2095")
end

			yyval26 := ast_factory.new_choice_list (last_keyword, counter_value)
			if yyval26 /= Void and yytype25 (yyvs.item (yyvsp)) /= Void then
				yyval26.put_first (yytype25 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval26
		end

	yy_do_action_383 is
			--|#line 2103 "et_eiffel_parser.y"
		local
			yyval26: ET_CHOICE_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2103")
end

			yyval26 := yytype26 (yyvs.item (yyvsp))
			if yyval26 /= Void and yytype25 (yyvs.item (yyvsp - 1)) /= Void then
				yyval26.put_first (yytype25 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval26
		end

	yy_do_action_384 is
			--|#line 2112 "et_eiffel_parser.y"
		local
			yyval25: ET_CHOICE_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2112")
end

			yyval25 := ast_factory.new_choice_comma (yytype23 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval25 /= Void then
				increment_counter
			end
		
			yyval := yyval25
		end

	yy_do_action_385 is
			--|#line 2121 "et_eiffel_parser.y"
		local
			yyval23: ET_CHOICE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2121")
end

yyval23 := yytype24 (yyvs.item (yyvsp)) 
			yyval := yyval23
		end

	yy_do_action_386 is
			--|#line 2123 "et_eiffel_parser.y"
		local
			yyval23: ET_CHOICE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2123")
end

yyval23 := ast_factory.new_choice_range (yytype24 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype24 (yyvs.item (yyvsp))) 
			yyval := yyval23
		end

	yy_do_action_387 is
			--|#line 2127 "et_eiffel_parser.y"
		local
			yyval24: ET_CHOICE_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2127")
end

yyval24 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval24
		end

	yy_do_action_388 is
			--|#line 2129 "et_eiffel_parser.y"
		local
			yyval24: ET_CHOICE_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2129")
end

yyval24 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval24
		end

	yy_do_action_389 is
			--|#line 2131 "et_eiffel_parser.y"
		local
			yyval24: ET_CHOICE_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2131")
end

yyval24 := yytype22 (yyvs.item (yyvsp)) 
			yyval := yyval24
		end

	yy_do_action_390 is
			--|#line 2135 "et_eiffel_parser.y"
		local
			yyval24: ET_CHOICE_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2135")
end

yyval24 := yytype83 (yyvs.item (yyvsp)) 
			yyval := yyval24
		end

	yy_do_action_391 is
			--|#line 2141 "et_eiffel_parser.y"
		local
			yyval35: ET_DEBUG_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2141")
end

yyval35 := ast_factory.new_debug_instruction (yytype70 (yyvs.item (yyvsp - 1)), ast_factory.new_debug_compound (yytype1 (yyvs.item (yyvsp - 2)), ast_factory.new_compound (0)), yytype1 (yyvs.item (yyvsp))) 
			yyval := yyval35
		end

	yy_do_action_392 is
			--|#line 2143 "et_eiffel_parser.y"
		local
			yyval35: ET_DEBUG_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2143")
end

			yyval35 := ast_factory.new_debug_instruction (yytype70 (yyvs.item (yyvsp - 3)), ast_factory.new_debug_compound (yytype1 (yyvs.item (yyvsp - 4)), yytype30 (yyvs.item (yyvsp - 1))), yytype1 (yyvs.item (yyvsp)))
			remove_counter
		
			yyval := yyval35
		end

	yy_do_action_393 is
			--|#line 2150 "et_eiffel_parser.y"
		local
			yyval70: ET_MANIFEST_STRING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2150")
end


			yyval := yyval70
		end

	yy_do_action_394 is
			--|#line 2152 "et_eiffel_parser.y"
		local
			yyval70: ET_MANIFEST_STRING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2152")
end

yyval70 := ast_factory.new_manifest_string_list (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval70
		end

	yy_do_action_395 is
			--|#line 2154 "et_eiffel_parser.y"
		local
			yyval70: ET_MANIFEST_STRING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2154")
end

			yyval70 := yytype70 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval70
		end

	yy_do_action_396 is
			--|#line 2154 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2154")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_397 is
			--|#line 2167 "et_eiffel_parser.y"
		local
			yyval70: ET_MANIFEST_STRING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2167")
end

			if yytype13 (yyvs.item (yyvsp - 1)) /= Void then
				yyval70 := ast_factory.new_manifest_string_list (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval70 /= Void then
					yyval70.put_first (yytype13 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval70 := ast_factory.new_manifest_string_list (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval70
		end

	yy_do_action_398 is
			--|#line 2178 "et_eiffel_parser.y"
		local
			yyval70: ET_MANIFEST_STRING_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2178")
end

			yyval70 := yytype70 (yyvs.item (yyvsp))
			if yyval70 /= Void and yytype69 (yyvs.item (yyvsp - 1)) /= Void then
				yyval70.put_first (yytype69 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval70
		end

	yy_do_action_399 is
			--|#line 2187 "et_eiffel_parser.y"
		local
			yyval69: ET_MANIFEST_STRING_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2187")
end

			yyval69 := ast_factory.new_manifest_string_comma (yytype13 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval69 /= Void then
				increment_counter
			end
		
			yyval := yyval69
		end

	yy_do_action_400 is
			--|#line 2198 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2198")
end

yyval62 := ast_factory.new_call_instruction (Void, yytype10 (yyvs.item (yyvsp - 1)), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_401 is
			--|#line 2200 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2200")
end

yyval62 := ast_factory.new_call_instruction (yytype40 (yyvs.item (yyvsp - 3)), ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_402 is
			--|#line 2202 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2202")
end

yyval62 := ast_factory.new_precursor_instruction (False, yytype1 (yyvs.item (yyvsp - 1)), Void, yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_403 is
			--|#line 2204 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2204")
end

yyval62 := yytype79 (yyvs.item (yyvsp)) 
			yyval := yyval62
		end

	yy_do_action_404 is
			--|#line 2206 "et_eiffel_parser.y"
		local
			yyval62: ET_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2206")
end

yyval62 := ast_factory.new_static_call_instruction (yytype1 (yyvs.item (yyvsp - 6)), ast_factory.new_static_type (yytype2 (yyvs.item (yyvsp - 5)), yytype85 (yyvs.item (yyvsp - 4)), yytype2 (yyvs.item (yyvsp - 3))), ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval62
		end

	yy_do_action_405 is
			--|#line 2210 "et_eiffel_parser.y"
		local
			yyval79: ET_PRECURSOR_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2210")
end

yyval79 := ast_factory.new_precursor_instruction (False, yytype1 (yyvs.item (yyvsp - 4)), ast_factory.new_precursor_class_name (yytype2 (yyvs.item (yyvsp - 3)), yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval79
		end

	yy_do_action_406 is
			--|#line 2212 "et_eiffel_parser.y"
		local
			yyval79: ET_PRECURSOR_INSTRUCTION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2212")
end

yyval79 := ast_factory.new_precursor_instruction (True, yytype1 (yyvs.item (yyvsp - 1)), ast_factory.new_precursor_class_name (yytype2 (yyvs.item (yyvsp - 4)), yytype10 (yyvs.item (yyvsp - 3)), yytype2 (yyvs.item (yyvsp - 2))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval79
		end

	yy_do_action_407 is
			--|#line 2216 "et_eiffel_parser.y"
		local
			yyval22: ET_CALL_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2216")
end

yyval22 := ast_factory.new_call_expression (Void, yytype10 (yyvs.item (yyvsp - 1)), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval22
		end

	yy_do_action_408 is
			--|#line 2218 "et_eiffel_parser.y"
		local
			yyval22: ET_CALL_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2218")
end

yyval22 := ast_factory.new_call_expression (yytype40 (yyvs.item (yyvsp - 3)), ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval22
		end

	yy_do_action_409 is
			--|#line 2222 "et_eiffel_parser.y"
		local
			yyval83: ET_STATIC_CALL_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2222")
end

yyval83 := ast_factory.new_static_call_expression (yytype1 (yyvs.item (yyvsp - 6)), ast_factory.new_static_type (yytype2 (yyvs.item (yyvsp - 5)), yytype85 (yyvs.item (yyvsp - 4)), yytype2 (yyvs.item (yyvsp - 3))), ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval83
		end

	yy_do_action_410 is
			--|#line 2226 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2226")
end

yyval40 := ast_factory.new_precursor_expression (False, yytype1 (yyvs.item (yyvsp - 1)), Void, yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_411 is
			--|#line 2228 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2228")
end

yyval40 := yytype78 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_412 is
			--|#line 2232 "et_eiffel_parser.y"
		local
			yyval78: ET_PRECURSOR_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2232")
end

yyval78 := ast_factory.new_precursor_expression (False, yytype1 (yyvs.item (yyvsp - 4)), ast_factory.new_precursor_class_name (yytype2 (yyvs.item (yyvsp - 3)), yytype10 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval78
		end

	yy_do_action_413 is
			--|#line 2234 "et_eiffel_parser.y"
		local
			yyval78: ET_PRECURSOR_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2234")
end

yyval78 := ast_factory.new_precursor_expression (True, yytype1 (yyvs.item (yyvsp - 1)), ast_factory.new_precursor_class_name (yytype2 (yyvs.item (yyvsp - 4)), yytype10 (yyvs.item (yyvsp - 3)), yytype2 (yyvs.item (yyvsp - 2))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval78
		end

	yy_do_action_414 is
			--|#line 2238 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2238")
end

yyval40 := ast_factory.new_call_expression (Void, yytype10 (yyvs.item (yyvsp - 1)), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_415 is
			--|#line 2240 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2240")
end

yyval40 := yytype15 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_416 is
			--|#line 2242 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2242")
end

yyval40 := yytype8 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_417 is
			--|#line 2244 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2244")
end

yyval40 := yytype73 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_418 is
			--|#line 2246 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2246")
end

yyval40 := yytype40 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_419 is
			--|#line 2248 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2248")
end

yyval40 := ast_factory.new_call_expression (yytype40 (yyvs.item (yyvsp - 3)), ast_factory.new_dot_feature_name (yytype2 (yyvs.item (yyvsp - 2)), yytype10 (yyvs.item (yyvsp - 1))), yytype19 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_420 is
			--|#line 2254 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2254")
end


			yyval := yyval19
		end

	yy_do_action_421 is
			--|#line 2256 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2256")
end

yyval19 := ast_factory.new_actual_arguments (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval19
		end

	yy_do_action_422 is
			--|#line 2258 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2258")
end

			yyval19 := yytype19 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval19
		end

	yy_do_action_423 is
			--|#line 2258 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2258")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_424 is
			--|#line 2271 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2271")
end

			if yytype40 (yyvs.item (yyvsp - 1)) /= Void then
				yyval19 := ast_factory.new_actual_arguments (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval19 /= Void then
					yyval19.put_first (yytype40 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval19 := ast_factory.new_actual_arguments (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval19
		end

	yy_do_action_425 is
			--|#line 2282 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2282")
end

			yyval19 := ast_factory.new_actual_arguments (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval19 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval19.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval19
		end

	yy_do_action_426 is
			--|#line 2290 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2290")
end

			yyval19 := yytype19 (yyvs.item (yyvsp))
			if yyval19 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval19.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval19
		end

	yy_do_action_427 is
			--|#line 2297 "et_eiffel_parser.y"
		local
			yyval19: ET_ACTUAL_ARGUMENT_LIST
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2297")
end

			yyval19 := yytype19 (yyvs.item (yyvsp))
			if yyval19 /= Void and yytype40 (yyvs.item (yyvsp - 2)) /= Void then
				yyval19.put_first (yytype40 (yyvs.item (yyvsp - 2)))
			end
		
			yyval := yyval19
		end

	yy_do_action_428 is
			--|#line 2297 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2297")
end
			yyval := yyval_default;
			if yytype40 (yyvs.item (yyvsp)) /= Void then
				increment_counter
			end
		

		end

	yy_do_action_429 is
			--|#line 2313 "et_eiffel_parser.y"
		local
			yyval41: ET_EXPRESSION_ITEM
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2313")
end

			yyval41 := ast_factory.new_expression_comma (yytype40 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)))
			if yyval41 /= Void then
				increment_counter
			end
		
			yyval := yyval41
		end

	yy_do_action_430 is
			--|#line 2322 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2322")
end

yyval40 := ast_factory.new_feature_address (yytype2 (yyvs.item (yyvsp - 1)), yytype47 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_431 is
			--|#line 2324 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2324")
end

yyval40 := ast_factory.new_current_address (yytype2 (yyvs.item (yyvsp - 1)), yytype8 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_432 is
			--|#line 2326 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2326")
end

yyval40 := ast_factory.new_result_address (yytype2 (yyvs.item (yyvsp - 1)), yytype15 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_433 is
			--|#line 2328 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2328")
end

yyval40 := ast_factory.new_expression_address (yytype2 (yyvs.item (yyvsp - 1)), yytype73 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_434 is
			--|#line 2335 "et_eiffel_parser.y"
		local
			yyval90: ET_WRITABLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2335")
end

yyval90 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval90
		end

	yy_do_action_435 is
			--|#line 2337 "et_eiffel_parser.y"
		local
			yyval90: ET_WRITABLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2337")
end

yyval90 := yytype15 (yyvs.item (yyvsp)) 
			yyval := yyval90
		end

	yy_do_action_436 is
			--|#line 2343 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2343")
end

yyval40 := yytype22 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_437 is
			--|#line 2345 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2345")
end

yyval40 := yytype83 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_438 is
			--|#line 2347 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2347")
end

yyval40 := yytype21 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_439 is
			--|#line 2349 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2349")
end

yyval40 := yytype40 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_440 is
			--|#line 2351 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2351")
end

yyval40 := yytype40 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_441 is
			--|#line 2353 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2353")
end

yyval40 := yytype15 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_442 is
			--|#line 2355 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2355")
end

yyval40 := yytype8 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_443 is
			--|#line 2357 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2357")
end

yyval40 := yytype73 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_444 is
			--|#line 2359 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2359")
end

yyval40 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_445 is
			--|#line 2361 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2361")
end

yyval40 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_446 is
			--|#line 2363 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2363")
end

yyval40 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_447 is
			--|#line 2365 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2365")
end

yyval40 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_448 is
			--|#line 2367 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2367")
end

yyval40 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_449 is
			--|#line 2369 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2369")
end

yyval40 := ast_factory.new_once_manifest_string (yytype1 (yyvs.item (yyvsp - 1)), yytype13 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_450 is
			--|#line 2384 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2384")
end

yyval40 := yytype4 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_451 is
			--|#line 2386 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2386")
end

yyval40 := yytype68 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_452 is
			--|#line 2388 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2388")
end

yyval40 := yytype71 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_453 is
			--|#line 2390 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2390")
end

yyval40 := ast_factory.new_prefix_expression (ast_factory.new_prefix_plus_operator (yytype17 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_454 is
			--|#line 2392 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2392")
end

yyval40 := ast_factory.new_prefix_expression (ast_factory.new_prefix_minus_operator (yytype17 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_455 is
			--|#line 2394 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2394")
end

yyval40 := ast_factory.new_prefix_expression (yytype12 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_456 is
			--|#line 2396 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2396")
end

yyval40 := ast_factory.new_prefix_expression (ast_factory.new_prefix_free_operator (yytype9 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_457 is
			--|#line 2398 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2398")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), ast_factory.new_infix_free_operator (yytype9 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_458 is
			--|#line 2400 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2400")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), ast_factory.new_infix_plus_operator (yytype17 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_459 is
			--|#line 2402 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2402")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), ast_factory.new_infix_minus_operator (yytype17 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_460 is
			--|#line 2404 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2404")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_461 is
			--|#line 2406 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2406")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_462 is
			--|#line 2408 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2408")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_463 is
			--|#line 2410 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2410")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_464 is
			--|#line 2412 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2412")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_465 is
			--|#line 2414 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2414")
end

yyval40 := ast_factory.new_equality_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_466 is
			--|#line 2416 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2416")
end

yyval40 := ast_factory.new_equality_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_467 is
			--|#line 2418 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2418")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_468 is
			--|#line 2420 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2420")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_469 is
			--|#line 2422 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2422")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_470 is
			--|#line 2424 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2424")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype17 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_471 is
			--|#line 2426 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2426")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype12 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_472 is
			--|#line 2428 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2428")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype12 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_473 is
			--|#line 2430 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2430")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype12 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_474 is
			--|#line 2432 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2432")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 3)), ast_factory.new_infix_and_then_operator (yytype12 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_475 is
			--|#line 2434 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2434")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 3)), ast_factory.new_infix_or_else_operator (yytype12 (yyvs.item (yyvsp - 2)), yytype1 (yyvs.item (yyvsp - 1))), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_476 is
			--|#line 2436 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2436")
end

yyval40 := ast_factory.new_infix_expression (yytype40 (yyvs.item (yyvsp - 2)), yytype12 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_477 is
			--|#line 2438 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2438")
end

yyval40 := ast_factory.new_old_expression (yytype1 (yyvs.item (yyvsp - 1)), yytype40 (yyvs.item (yyvsp))) 
			yyval := yyval40
		end

	yy_do_action_478 is
			--|#line 2440 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2440")
end

yyval40 := yytype84 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_479 is
			--|#line 2442 "et_eiffel_parser.y"
		local
			yyval40: ET_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2442")
end

yyval40 := yytype40 (yyvs.item (yyvsp)) 
			yyval := yyval40
		end

	yy_do_action_480 is
			--|#line 2446 "et_eiffel_parser.y"
		local
			yyval73: ET_PARENTHESIZED_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2446")
end

yyval73 := ast_factory.new_parenthesized_expression (yytype2 (yyvs.item (yyvsp - 2)), yytype40 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp))) 
			yyval := yyval73
		end

	yy_do_action_481 is
			--|#line 2450 "et_eiffel_parser.y"
		local
			yyval68: ET_MANIFEST_ARRAY
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2450")
end

yyval68 := ast_factory.new_manifest_array (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval68
		end

	yy_do_action_482 is
			--|#line 2452 "et_eiffel_parser.y"
		local
			yyval68: ET_MANIFEST_ARRAY
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2452")
end

			yyval68 := yytype68 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval68
		end

	yy_do_action_483 is
			--|#line 2452 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2452")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_484 is
			--|#line 2465 "et_eiffel_parser.y"
		local
			yyval68: ET_MANIFEST_ARRAY
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2465")
end

			if yytype40 (yyvs.item (yyvsp - 1)) /= Void then
				yyval68 := ast_factory.new_manifest_array (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval68 /= Void then
					yyval68.put_first (yytype40 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval68 := ast_factory.new_manifest_array (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval68
		end

	yy_do_action_485 is
			--|#line 2476 "et_eiffel_parser.y"
		local
			yyval68: ET_MANIFEST_ARRAY
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2476")
end

			yyval68 := ast_factory.new_manifest_array (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval68 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval68.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval68
		end

	yy_do_action_486 is
			--|#line 2484 "et_eiffel_parser.y"
		local
			yyval68: ET_MANIFEST_ARRAY
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2484")
end

			yyval68 := yytype68 (yyvs.item (yyvsp))
			if yyval68 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval68.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval68
		end

	yy_do_action_487 is
			--|#line 2493 "et_eiffel_parser.y"
		local
			yyval71: ET_MANIFEST_TUPLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2493")
end

yyval71 := ast_factory.new_manifest_tuple (yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval71
		end

	yy_do_action_488 is
			--|#line 2495 "et_eiffel_parser.y"
		local
			yyval71: ET_MANIFEST_TUPLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2495")
end

			yyval71 := yytype71 (yyvs.item (yyvsp))
			remove_symbol
			remove_counter
		
			yyval := yyval71
		end

	yy_do_action_489 is
			--|#line 2495 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2495")
end
			yyval := yyval_default;
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_490 is
			--|#line 2508 "et_eiffel_parser.y"
		local
			yyval71: ET_MANIFEST_TUPLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2508")
end

			if yytype40 (yyvs.item (yyvsp - 1)) /= Void then
				yyval71 := ast_factory.new_manifest_tuple (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval71 /= Void then
					yyval71.put_first (yytype40 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval71 := ast_factory.new_manifest_tuple (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval71
		end

	yy_do_action_491 is
			--|#line 2519 "et_eiffel_parser.y"
		local
			yyval71: ET_MANIFEST_TUPLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2519")
end

			yyval71 := ast_factory.new_manifest_tuple (last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval71 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval71.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval71
		end

	yy_do_action_492 is
			--|#line 2527 "et_eiffel_parser.y"
		local
			yyval71: ET_MANIFEST_TUPLE
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2527")
end

			yyval71 := yytype71 (yyvs.item (yyvsp))
			if yyval71 /= Void and yytype41 (yyvs.item (yyvsp - 1)) /= Void then
				yyval71.put_first (yytype41 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval71
		end

	yy_do_action_493 is
			--|#line 2536 "et_eiffel_parser.y"
		local
			yyval84: ET_STRIP_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2536")
end

yyval84 := ast_factory.new_strip_expression (yytype1 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp - 1)), yytype2 (yyvs.item (yyvsp)), 0) 
			yyval := yyval84
		end

	yy_do_action_494 is
			--|#line 2538 "et_eiffel_parser.y"
		local
			yyval84: ET_STRIP_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2538")
end

			yyval84 := yytype84 (yyvs.item (yyvsp))
			remove_keyword
			remove_symbol
			remove_counter
		
			yyval := yyval84
		end

	yy_do_action_495 is
			--|#line 2538 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2538")
end
			yyval := yyval_default;
			add_keyword (yytype1 (yyvs.item (yyvsp - 1)))
			add_symbol (yytype2 (yyvs.item (yyvsp)))
			add_counter
		

		end

	yy_do_action_496 is
			--|#line 2553 "et_eiffel_parser.y"
		local
			yyval84: ET_STRIP_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2553")
end

			if yytype47 (yyvs.item (yyvsp - 1)) /= Void then
				yyval84 := ast_factory.new_strip_expression (last_keyword, last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value + 1)
				if yyval84 /= Void then
					yyval84.put_first (yytype47 (yyvs.item (yyvsp - 1)))
				end
			else
				yyval84 := ast_factory.new_strip_expression (last_keyword, last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			end
		
			yyval := yyval84
		end

	yy_do_action_497 is
			--|#line 2564 "et_eiffel_parser.y"
		local
			yyval84: ET_STRIP_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2564")
end

			yyval84 := ast_factory.new_strip_expression (last_keyword, last_symbol, yytype2 (yyvs.item (yyvsp)), counter_value)
			if yyval84 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval84.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval84
		end

	yy_do_action_498 is
			--|#line 2572 "et_eiffel_parser.y"
		local
			yyval84: ET_STRIP_EXPRESSION
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2572")
end

			yyval84 := yytype84 (yyvs.item (yyvsp))
			if yyval84 /= Void and yytype48 (yyvs.item (yyvsp - 1)) /= Void then
				yyval84.put_first (yytype48 (yyvs.item (yyvsp - 1)))
			end
		
			yyval := yyval84
		end

	yy_do_action_499 is
			--|#line 2581 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2581")
end

yyval31 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_500 is
			--|#line 2583 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2583")
end

yyval31 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_501 is
			--|#line 2585 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2585")
end

yyval31 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_502 is
			--|#line 2587 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2587")
end

yyval31 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_503 is
			--|#line 2589 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2589")
end

yyval31 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_504 is
			--|#line 2591 "et_eiffel_parser.y"
		local
			yyval31: ET_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2591")
end

yyval31 := yytype4 (yyvs.item (yyvsp)) 
			yyval := yyval31
		end

	yy_do_action_505 is
			--|#line 2597 "et_eiffel_parser.y"
		local
			yyval21: ET_CALL_AGENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2597")
end

yyval21 := new_call_agent (yytype1 (yyvs.item (yyvsp - 2))) 
			yyval := yyval21
		end

	yy_do_action_506 is
			--|#line 2599 "et_eiffel_parser.y"
		local
			yyval21: ET_CALL_AGENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2599")
end

yyval21 := new_call_agent (yytype1 (yyvs.item (yyvsp - 4))) 
			yyval := yyval21
		end

	yy_do_action_507 is
			--|#line 2601 "et_eiffel_parser.y"
		local
			yyval21: ET_CALL_AGENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2601")
end

yyval21 := new_call_agent (yytype1 (yyvs.item (yyvsp - 4))) 
			yyval := yyval21
		end

	yy_do_action_508 is
			--|#line 2603 "et_eiffel_parser.y"
		local
			yyval21: ET_CALL_AGENT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2603")
end

yyval21 := new_call_agent (yytype1 (yyvs.item (yyvsp - 6))) 
			yyval := yyval21
		end

	yy_do_action_509 is
			--|#line 2607 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2607")
end
			yyval := yyval_default;


		end

	yy_do_action_510 is
			--|#line 2609 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2609")
end
			yyval := yyval_default;


		end

	yy_do_action_511 is
			--|#line 2611 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2611")
end
			yyval := yyval_default;


		end

	yy_do_action_512 is
			--|#line 2622 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2622")
end
			yyval := yyval_default;


		end

	yy_do_action_513 is
			--|#line 2627 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2627")
end
			yyval := yyval_default;


		end

	yy_do_action_514 is
			--|#line 2633 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2633")
end
			yyval := yyval_default;


		end

	yy_do_action_515 is
			--|#line 2640 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2640")
end
			yyval := yyval_default;


		end

	yy_do_action_516 is
			--|#line 2650 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2650")
end
			yyval := yyval_default;


		end

	yy_do_action_517 is
			--|#line 2651 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2651")
end
			yyval := yyval_default;


		end

	yy_do_action_518 is
			--|#line 2652 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2652")
end
			yyval := yyval_default;


		end

	yy_do_action_519 is
			--|#line 2655 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2655")
end
			yyval := yyval_default;


		end

	yy_do_action_520 is
			--|#line 2658 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2658")
end
			yyval := yyval_default;


		end

	yy_do_action_521 is
			--|#line 2661 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2661")
end
			yyval := yyval_default;


		end

	yy_do_action_522 is
			--|#line 2664 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2664")
end
			yyval := yyval_default;


		end

	yy_do_action_523 is
			--|#line 2667 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2667")
end
			yyval := yyval_default;


		end

	yy_do_action_524 is
			--|#line 2670 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2670")
end
			yyval := yyval_default;


		end

	yy_do_action_525 is
			--|#line 2673 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2673")
end
			yyval := yyval_default;


		end

	yy_do_action_526 is
			--|#line 2676 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2676")
end
			yyval := yyval_default;


		end

	yy_do_action_527 is
			--|#line 2683 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2683")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_528 is
			--|#line 2685 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2685")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_529 is
			--|#line 2687 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2687")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_530 is
			--|#line 2689 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2689")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_531 is
			--|#line 2691 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2691")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_532 is
			--|#line 2693 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2693")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_533 is
			--|#line 2695 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2695")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_534 is
			--|#line 2697 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2697")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_535 is
			--|#line 2699 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2699")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_536 is
			--|#line 2701 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2701")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_537 is
			--|#line 2703 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2703")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_538 is
			--|#line 2705 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2705")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_539 is
			--|#line 2707 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2707")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_540 is
			--|#line 2709 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2709")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_541 is
			--|#line 2711 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2711")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_542 is
			--|#line 2713 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2713")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_543 is
			--|#line 2715 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2715")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_544 is
			--|#line 2717 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2717")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_545 is
			--|#line 2719 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2719")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_546 is
			--|#line 2721 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2721")
end

yyval13 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval13
		end

	yy_do_action_547 is
			--|#line 2723 "et_eiffel_parser.y"
		local
			yyval13: ET_MANIFEST_STRING
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2723")
end

abort 
			yyval := yyval13
		end

	yy_do_action_548 is
			--|#line 2727 "et_eiffel_parser.y"
		local
			yyval7: ET_CHARACTER_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2727")
end

yyval7 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval7
		end

	yy_do_action_549 is
			--|#line 2729 "et_eiffel_parser.y"
		local
			yyval7: ET_CHARACTER_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2729")
end

abort 
			yyval := yyval7
		end

	yy_do_action_550 is
			--|#line 2733 "et_eiffel_parser.y"
		local
			yyval5: ET_BOOLEAN_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2733")
end

yyval5 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval5
		end

	yy_do_action_551 is
			--|#line 2735 "et_eiffel_parser.y"
		local
			yyval5: ET_BOOLEAN_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2735")
end

yyval5 := yytype5 (yyvs.item (yyvsp)) 
			yyval := yyval5
		end

	yy_do_action_552 is
			--|#line 2739 "et_eiffel_parser.y"
		local
			yyval11: ET_INTEGER_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2739")
end

yyval11 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval11
		end

	yy_do_action_553 is
			--|#line 2741 "et_eiffel_parser.y"
		local
			yyval11: ET_INTEGER_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2741")
end

			yyval11 := yytype11 (yyvs.item (yyvsp))
			yyval11.set_sign (yytype17 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval11
		end

	yy_do_action_554 is
			--|#line 2746 "et_eiffel_parser.y"
		local
			yyval11: ET_INTEGER_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2746")
end

			yyval11 := yytype11 (yyvs.item (yyvsp))
			yyval11.set_sign (yytype17 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval11
		end

	yy_do_action_555 is
			--|#line 2753 "et_eiffel_parser.y"
		local
			yyval14: ET_REAL_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2753")
end

yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
		end

	yy_do_action_556 is
			--|#line 2755 "et_eiffel_parser.y"
		local
			yyval14: ET_REAL_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2755")
end

			yyval14 := yytype14 (yyvs.item (yyvsp))
			yyval14.set_sign (yytype17 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval14
		end

	yy_do_action_557 is
			--|#line 2760 "et_eiffel_parser.y"
		local
			yyval14: ET_REAL_CONSTANT
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2760")
end

			yyval14 := yytype14 (yyvs.item (yyvsp))
			yyval14.set_sign (yytype17 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval14
		end

	yy_do_action_558 is
			--|#line 2767 "et_eiffel_parser.y"
		local
			yyval10: ET_IDENTIFIER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2767")
end

yyval10 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval10
		end

	yy_do_action_559 is
			--|#line 2769 "et_eiffel_parser.y"
		local
			yyval10: ET_IDENTIFIER
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2769")
end

				-- TO DO: reserved word `BIT'
			yyval10 := yytype10 (yyvs.item (yyvsp))
		
			yyval := yyval10
		end

	yy_do_action_560 is
			--|#line 2776 "et_eiffel_parser.y"
		local
			yyval6: ET_BREAK
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2776")
end


			yyval := yyval6
		end

	yy_do_action_561 is
			--|#line 2778 "et_eiffel_parser.y"
		local
			yyval6: ET_BREAK
		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2778")
end

yyval6 := yytype6 (yyvs.item (yyvsp)) 
			yyval := yyval6
		end

	yy_do_action_562 is
			--|#line 2784 "et_eiffel_parser.y"
		local

		do
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2784")
end
			yyval := yyval_default;
add_counter 

		end

feature {NONE} -- Table templates

	yytranslate_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  121,    2,    2,  119,    2,    2,    2,
			  113,  114,  106,  124,  116,  123,  120,   99,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,  115,  127,
			  103,  125,  101,  122,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,  117,    2,  118,  105,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  111,    2,  112,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,  100,  102,  104,  107,  108,  109,
			  110,  126>>)
		end

	yyr1_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,  276,  147,  277,  277,  146,  146,  146,  146,  146,
			  146,  146,  207,  207,  278,  208,  208,  209,  209,  209,
			  279,  209,  280,  210,  212,  212,  211,  211,  215,  215,
			  213,  213,  213,  213,  213,  213,  213,  214,  145,  145,
			  145,  145,  202,  202,  202,  282,  203,  203,  201,  200,
			  200,  200,  162,  162,  283,  163,  163,  163,  268,  268,
			  268,  268,  268,  268,  268,  268,  133,  133,  133,  284,
			  134,  134,  270,  245,  245,  250,  250,  250,  251,  285,
			  247,  247,  247,  247,  247,  247,  248,  252,  252,  252,
			  252,  252,  253,  253,  253,  253,  249,  249,  261,  261,

			  286,  262,  262,  262,  259,  260,  173,  173,  287,  174,
			  174,  175,  175,  288,  172,  172,  289,  172,  190,  190,
			  190,  150,  290,  150,  151,  151,  151,  151,  148,  149,
			  229,  229,  291,  230,  230,  227,  227,  292,  228,  228,
			  225,  225,  293,  226,  226,  224,  224,  224,  192,  167,
			  167,  166,  166,  294,  164,  164,  164,  295,  164,  296,
			  164,  164,  164,  297,  164,  298,  165,  165,  165,  193,
			  188,  188,  187,  189,  189,  185,  185,  186,  186,  299,
			  299,  183,  183,  183,  183,  183,  183,  184,  184,  184,
			  184,  184,  184,  184,  184,  184,  184,  184,  184,  184,

			  184,  184,  184,  184,  184,  184,  263,  263,  182,  182,
			  191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
			  191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
			  191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
			  191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
			  191,  198,  198,  300,  199,  199,  199,  199,  199,  199,
			  195,  194,  196,  197,  235,  235,  235,  301,  236,  236,
			  236,  236,  236,  236,  232,  231,  233,  234,  302,  302,
			  302,  302,  302,  302,  302,  302,  257,  257,  257,  257,
			  257,  254,  254,  254,  254,  254,  223,  223,  222,  222,

			  271,  271,  271,  271,  153,  153,  267,  267,  267,  267,
			  267,  267,  267,  267,  205,  130,  130,  132,  132,  303,
			  131,  131,  269,  154,  154,  155,  155,  156,  156,  157,
			  157,  158,  158,  159,  159,  160,  160,  152,  152,  304,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  218,  218,  218,  218,  220,  220,  220,
			  220,  180,  180,  206,  206,  206,  206,  170,  171,  171,
			  169,  216,  216,  274,  274,  273,  273,  272,  143,  143,
			  305,  144,  144,  144,  142,  140,  140,  141,  141,  141,
			  141,  168,  168,  242,  242,  242,  306,  241,  241,  240,

			  219,  219,  219,  219,  219,  256,  256,  138,  138,  264,
			  178,  178,  255,  255,  177,  177,  177,  177,  177,  177,
			  128,  128,  128,  307,  129,  129,  129,  129,  308,  181,
			  179,  179,  179,  179,  275,  275,  176,  176,  176,  176,
			  176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
			  176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
			  176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
			  176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
			  246,  237,  237,  309,  238,  238,  238,  243,  243,  310,
			  244,  244,  244,  265,  265,  311,  266,  266,  266,  161,

			  161,  161,  161,  161,  161,  137,  137,  137,  137,  312,
			  312,  312,  313,  313,  313,  313,  314,  314,  314,  314,
			  314,  314,  314,  314,  314,  314,  314,  239,  239,  239,
			  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
			  239,  239,  239,  239,  239,  239,  239,  239,  139,  139,
			  135,  135,  221,  221,  221,  258,  258,  258,  204,  204,
			  136,  136,  281>>)
		end

	yyr2_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    0,    1,   10,   10,    9,    8,    6,
			    7,    4,    1,    3,    0,    0,    1,    1,    1,    3,
			    0,    3,    0,    2,    1,    3,    2,    2,    1,    2,
			    1,    1,    1,    1,    1,    1,    1,    2,    2,    3,
			    3,    3,    0,    2,    3,    0,    2,    2,    2,    1,
			    3,    4,    2,    3,    0,    2,    2,    2,    2,    3,
			    3,    3,    2,    2,    2,    2,    0,    2,    3,    0,
			    2,    2,    2,    0,    2,    0,    1,    2,    2,    1,
			    2,    8,    7,    6,    5,    4,    3,    1,    1,    2,
			    2,    2,    1,    2,    2,    2,    2,    2,    1,    3,

			    0,    1,    1,    2,    3,    4,    1,    3,    0,    0,
			    1,    1,    3,    0,    2,    3,    0,    1,    1,    1,
			    2,    3,    0,    2,    2,    2,    2,    2,    1,    2,
			    1,    3,    0,    0,    1,    1,    3,    0,    0,    1,
			    1,    3,    0,    0,    1,    1,    1,    2,    2,    0,
			    2,    1,    3,    0,    2,    1,    4,    0,    3,    0,
			    2,    1,    4,    0,    3,    0,    1,    1,    2,    2,
			    0,    1,    2,    1,    2,    1,    2,    2,    1,    1,
			    2,    1,    2,    3,    2,    4,    3,    4,    6,    6,
			   10,   11,   10,   11,    8,    9,   10,   11,   12,   13,

			   12,   13,   10,   11,   12,   13,    0,    1,    0,    2,
			    1,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    3,    0,    2,    2,    2,    2,    2,    2,
			    2,    1,    3,    4,    0,    1,    3,    0,    1,    1,
			    2,    2,    2,    2,    2,    1,    3,    4,    1,    2,
			    2,    3,    2,    3,    3,    4,    0,    1,    2,    2,
			    3,    0,    1,    2,    2,    3,    0,    1,    1,    2,

			    0,    1,    2,    4,    0,    1,    2,    3,    3,    3,
			    2,    2,    2,    2,    1,    0,    1,    2,    3,    0,
			    2,    2,    2,    1,    3,    1,    3,    1,    3,    1,
			    3,    1,    3,    1,    3,    1,    3,    1,    3,    0,
			    1,    1,    1,    3,    3,    1,    1,    7,    1,    2,
			    3,    1,    1,    4,    7,    3,    6,    5,    8,    2,
			    5,    4,    7,    4,    5,    5,    6,    2,    1,    2,
			    3,    5,    4,    0,    2,    1,    2,    2,    1,    3,
			    0,    1,    1,    2,    2,    1,    3,    1,    1,    1,
			    1,    3,    5,    0,    2,    3,    0,    2,    2,    2,

			    2,    4,    2,    1,    7,    5,    5,    2,    4,    7,
			    2,    1,    5,    5,    2,    1,    1,    1,    1,    4,
			    0,    2,    3,    0,    2,    2,    2,    3,    0,    2,
			    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    1,    1,    1,    2,    2,    2,    2,    3,    3,    3,
			    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    3,    4,    4,    3,    2,    1,    1,
			    3,    2,    3,    0,    2,    2,    2,    2,    3,    0,
			    2,    2,    2,    3,    4,    0,    2,    2,    2,    1,

			    1,    1,    1,    1,    1,    3,    5,    5,    7,    0,
			    2,    3,    1,    2,    3,    2,    1,    1,    3,    4,
			    5,    5,    5,    4,    4,    4,    4,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    2,    2,    1,    2,    2,    1,    1,
			    0,    1,    0>>)
		end

	yydefact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  560,  561,   15,   14,    1,   16,    0,  562,    0,    0,
			    0,    0,   42,    2,   13,   20,   22,    0,    0,    0,
			    0,  559,  558,   38,   45,   73,   26,  562,   27,  562,
			    0,    0,  547,  549,  555,  527,  546,  545,  544,  543,
			  542,  541,  540,  539,  538,  537,  536,  535,  534,  533,
			  532,  531,  530,  529,  528,  552,  548,  550,  551,   36,
			   31,   32,   30,   23,   28,    0,   24,   33,   35,   34,
			   41,   40,   39,   43,    0,    0,   75,   19,   21,  557,
			  554,  556,  553,    0,   37,   30,   29,    0,    0,   44,
			   49,   74,   79,  562,  562,    0,   25,   46,   48,   47,

			    0,  562,    0,  298,  159,  165,  153,  562,  296,    0,
			   15,    0,  314,  315,   87,   92,   88,   77,   78,    0,
			    0,    0,    0,    0,   66,   50,  171,  296,  150,    0,
			    0,    0,  489,    0,    0,    0,  441,  447,    0,  446,
			    0,  442,  450,  483,  420,    0,    0,    0,    0,    0,
			  444,  438,  436,  445,  278,    0,  439,  479,  440,  420,
			  451,  448,  452,  443,  411,  437,  478,  299,  122,  157,
			    0,  163,    0,    0,  296,  297,   15,   15,    9,    0,
			  178,  173,  175,  172,  319,   80,  316,   96,   89,   93,
			   97,   90,   94,   91,   95,    0,    0,   65,   64,   66,

			   66,   66,   62,   63,   69,   58,   54,   51,   15,  453,
			  420,  454,  432,  431,    0,    0,  430,  210,  433,  487,
			    0,    0,    0,  477,  455,  456,  481,    0,  423,    0,
			  410,  495,  449,    0,    0,    0,  509,  210,    0,  279,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  280,
			  414,  282,  420,  123,    0,    0,  158,  167,  166,    0,
			  164,  152,   15,    0,    4,   10,   15,  177,  174,    0,
			  179,  181,    0,  176,  317,    0,  137,  142,  100,  132,
			  108,   86,  138,    0,  133,  143,  109,   60,   61,   59,

			   67,    0,   52,    0,    0,  233,  211,  214,  248,  247,
			  246,  245,  244,  243,  242,  241,  240,  239,  238,  237,
			  236,  235,  234,  213,  212,  249,  250,  232,  230,  229,
			  227,  231,  228,  226,  225,  224,  223,  222,  221,  220,
			  219,  218,  217,  216,  215,    0,    0,  488,  480,    0,
			    0,    0,  482,  421,    0,    0,  493,    0,    0,    0,
			    0,    0,    0,  315,    0,    0,    0,    0,  505,    0,
			    0,  466,  465,  458,  459,  460,  462,  464,  467,  469,
			  468,  470,  461,  463,  476,  473,    0,  472,    0,  471,
			  457,  420,  281,  283,  284,    0,    0,  121,  128,  156,

			  168,  169,  162,    0,   15,    8,  182,    0,    0,    0,
			  253,   73,  184,    0,  180,  318,    0,    0,    0,    0,
			    0,    0,    0,  139,  133,   85,  134,  143,  144,    0,
			  110,  138,   68,    0,    0,   53,    0,    0,   15,  490,
			  429,  491,  492,  420,  484,  485,  486,  422,  428,    0,
			  420,    0,    0,  494,  313,  312,  315,  315,  315,  310,
			  311,  306,    0,  361,    0,  517,  510,    0,  516,    0,
			  512,  509,  509,  475,  474,  419,  285,  124,  127,  125,
			  126,  129,   15,    7,    0,  186,  183,  206,  251,    0,
			  286,    0,   73,  320,  322,  321,  145,  146,  136,  141,

			    0,  101,  102,   99,  131,  117,  116,  113,  107,  143,
			    0,   84,  133,   70,   72,   71,   56,   57,   55,    5,
			  413,  424,    0,  425,  426,  412,  148,  496,  497,  498,
			  308,  309,  307,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  511,  513,  515,  506,  507,    6,  185,  207,
			   73,  187,    0,    0,    0,    0,  252,  261,  287,  264,
			    0,  286,  147,    0,  103,  114,    0,    0,    0,   83,
			  143,  427,  420,  420,  509,    0,    0,  315,  315,  315,
			    0,    0,  518,    0,  514,  504,  206,  499,  500,  206,
			  501,  503,  286,  502,  257,  256,  254,  259,  255,  258,

			  260,    0,  288,  289,  291,  267,    0,    0,   73,  264,
			  104,  115,  118,  119,  112,   82,    0,  409,  362,  508,
			  526,  525,    0,    0,    0,  523,  524,  519,  189,  188,
			  264,  262,  290,  292,    0,    0,  208,  562,  562,  291,
			  291,  286,  291,    0,    0,  105,  120,   81,  521,  522,
			  520,  291,    0,    0,  263,  293,  294,  206,  275,    0,
			    0,  268,  269,  266,    0,  291,    0,    0,  304,  304,
			  264,    0,  208,  291,  291,    0,  208,  291,  291,  295,
			  194,  274,    0,  271,  270,  273,  272,  209,    0,  352,
			    0,    0,  351,  435,  416,  420,    0,    0,  562,    0,

			  393,    0,    0,  326,  296,  348,    0,  418,  434,  345,
			  346,  339,  340,  342,  341,  417,  403,    0,  324,  562,
			    0,  305,    0,  291,    0,    0,  206,  291,  304,  304,
			  206,  291,  304,  304,  276,  206,    0,    0,    0,    0,
			  410,  562,    0,    0,    0,  396,  562,    0,  435,  434,
			  359,  349,    0,  300,    0,  414,    0,    0,    0,    0,
			  206,  206,    0,  208,  291,  291,  195,    0,    0,    0,
			  202,    0,    0,    0,  277,  196,  355,    0,    0,    0,
			    0,    0,  562,  562,  334,    0,  394,    0,  391,    0,
			    0,    0,  350,  301,    0,  420,  338,  344,  343,  332,

			  190,  192,  206,  291,  304,  304,  206,  206,  206,  206,
			  206,  206,    0,  353,  420,  420,  372,  562,    0,  380,
			    0,  375,  374,    0,  363,    0,    0,    0,    0,    0,
			    0,  395,    0,    0,  420,  302,  420,    0,  419,  203,
			    0,    0,    0,  197,  191,  193,  204,  198,  200,  420,
			    0,  413,  412,    0,  371,    0,  377,  376,  328,  364,
			  365,    0,    0,  368,  367,    0,  399,  397,  398,  392,
			  357,  360,    0,    0,  206,  206,  206,  356,  420,  330,
			  415,  389,  388,  381,  385,  382,  379,  387,  390,  366,
			    0,  369,  420,    0,  303,  562,    0,  205,  199,  201,

			  354,  384,    0,  383,  370,  404,  420,    0,  347,  386,
			  358,  336,    0,    0,    0>>)
		end

	yydefgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  260,  447,  185,  415,  186,  205,  432,  150,    2,  151,
			  152,  153,  883,  884,  885,  820,  886,   12,   13,  274,
			  395,  396,  506,  397,  703,  720,  639,  640,  783,  818,
			  721,  704,  896,  589,  207,  435,  106,  266,  107,  101,
			  705,  863,  826,  864,  507,  292,  431,  508,  154,  155,
			  156,  157,  158,  449,  665,  280,  281,  181,  182,  126,
			  127,  183,  611,  282,  497,  267,  552,  553,  554,  555,
			  413,  556,   87,   88,   25,   89,  210,  363,  709,    5,
			    6,   14,   15,   16,   63,   64,   65,   66,  710,  711,
			  712,  713,  714,   67,  175,  176,  498,  428,  429,  423,

			  424,  426,  427,  659,  660,  661,  662,  607,  663,  160,
			  352,  161,  830,  831,  746,  162,  347,   76,  163,  114,
			  115,  116,   93,   94,  117,  118,  634,  164,  716,  559,
			   69,  501,  502,  296,  503,  551,  165,  166,  453,  416,
			  433,  417,  434,  794,  821,  822,  780,  717,  912,  275,
			    7,   27,   29,   17,   74,  303,  301,   95,  420,  422,
			  567,  566,  264,  421,  418,  419,  173,  265,  170,  269,
			  172,  283,  489,  635,  167,  285,  756,  855,  787,  354,
			  522,  227,  220,  357,  368,  469,  470>>)
		end

	yypact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  868, -32768,  827,  482, -32768, -32768,  425, -32768,  920,  919,
			  912,  135,  801, -32768, -32768,  128,   74, 3182,  135,  135,
			  135, -32768, -32768, -32768,  804,  718, -32768, -32768, -32768, -32768,
			  141,  105, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,  783, -32768,  781, 3182, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768,  135,  974,  870, -32768, -32768, -32768,
			 -32768, -32768, -32768, 3182, -32768, -32768, -32768,  690,  135, -32768,
			  839, -32768,  857,  742,  578,  545, -32768, -32768, -32768, -32768,

			  548,  608,  530, 2548,  281,  219,  651,  608,  636,  304,
			  827,  854, -32768,  646,  117,   17,  545, -32768, -32768,  140,
			  545,  545,  545,  572,  748,  882, -32768,  636, -32768, 2548,
			 2548,  338,  776, 2548,  545, 2548,  552, -32768, 2548, -32768,
			 2548,  773, -32768,  834,  691,  775,  974,  774,  772,  387,
			 -32768, -32768, -32768, -32768, 2905,  769,  761, -32768, -32768,  683,
			 -32768, -32768, -32768,  758, -32768, -32768, -32768, 2548,  765,  836,
			  135,  737,  135,  530,  636, -32768,  827,  363, -32768,  860,
			  763,  854,  202, -32768,  753,  652, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  800,  799, -32768, -32768,  748,

			  748,  748, -32768, -32768,  746, -32768,  847, -32768,  827, -32768,
			  -39, -32768, -32768, -32768, 2969, 2866, -32768, -32768, -32768, -32768,
			 2548, 3008,  744, -32768, -32768, -32768, -32768, 2548,  747,  545,
			 -32768,  743, -32768,  508,  508,  508,  672,  740,  738, -32768,
			 2548, 2548, 2548, 2548, 2548, 2548, 2548, 2548, 2548, 2548,
			 2548, 2548, 2548, 2548, 2548, 2453, 2357, 2548,  135,  726,
			 1468, 2624,  655, -32768,  135,  135, -32768,  135,  736,  135,
			 -32768, -32768,  827,  829, -32768, -32768,  363, -32768, -32768,  380,
			 -32768, -32768,  402,  202, -32768,  508,  456,  828,  699,   55,
			  593, -32768,  768,  823,  759,  731,  820, -32768, -32768, -32768,

			 -32768,  548, -32768,  135,  821, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, 3253, 2262, -32768, -32768,  707,
			 1144, 2167, -32768, -32768, 2548,  723, -32768,  380,  140,  545,
			  545,  545,  486,  646,  722,  721,  720, 1313, -32768,  380,
			  380,  383,  383,  505,  505,   -8,   -8,   -8,  383,  383,
			  383,  383,   -8,   -8, 3335, 1344, 2548, 1344, 2548, 3054,
			 -32768,  -39, -32768, -32768,  704,  213,  120, -32768,  712, -32768,

			 -32768, -32768, -32768,  812,  363, -32768, -32768,  396,  202,  508,
			  711,  718, -32768,   -9, -32768, -32768,  675,  508,  380,  380,
			  380,  380,  196, -32768,  759, -32768, -32768,  731, -32768,  809,
			 -32768,  768, -32768,  661,  548, -32768,   26,   54,  363, -32768,
			 -32768, -32768, -32768,  -39, -32768, -32768, -32768, -32768, 3212, 2071,
			  -39,  624,  298, -32768, -32768, -32768,  646,  646,  646, -32768,
			 -32768, -32768,  703,  701,  700, -32768, -32768,  516, 3294,  705,
			 1217,  672,  672, 1344, 3054, 1072, -32768, -32768, -32768, -32768,
			 -32768, -32768,  363, -32768,  202, -32768, -32768,   12, -32768,  135,
			  656,  508,  718, -32768, -32768, -32768,  618,  380, -32768, -32768,

			  807, -32768,  380, -32768, -32768, -32768,  805,  554, -32768,  731,
			  788, -32768,  759, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, 2548, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,  135,  135,  380,  140,  545,  545,  545,
			  481,  341, -32768, 1976, -32768, -32768, -32768, -32768, -32768, -32768,
			 3132, -32768,  135,  135,  148,  125, -32768,  411, 1881,  484,
			  762,  656, -32768,  380, -32768, -32768,  380,  196,  771, -32768,
			  731, -32768,  -39,  -39,  672,  669,  664,  646,  646,  646,
			  650,  647,  707,  642, -32768, -32768,  106, -32768, -32768,  106,
			 -32768, -32768,  656, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768,  508, 2548, 2548,  405,  285,  974,  266,  718,  454,
			  633, -32768,  618,  380, -32768, -32768,  708, -32768, -32768, -32768,
			 -32768, -32768,  621,  615,  614, -32768, -32768, -32768, -32768, -32768,
			  427,  586, 2548, 1785,  697,  135,  581,  489,  420,  405,
			  405,  656,  405,  974,  266, -32768, -32768, -32768, -32768, -32768,
			 -32768,  405,  974,  266, -32768, 2548, 2548,  106,  313,  135,
			  135,  135,  135, -32768,  974,  405, 2733, 2733,  359,  359,
			  364,  678,  581,  405,  405,  671,  581,  405,  405, 2548,
			 -32768, -32768,  508, -32768, -32768, -32768, -32768, -32768,  658, -32768,
			  154,  545, -32768,  552, -32768,  609, 2548, 2548,  474,  547,

			  546,  238, 1690, -32768,  636, -32768,  533, -32768,  910, -32768,
			 -32768,  802, -32768, -32768, -32768, -32768, -32768,  323, -32768,  632,
			  631, -32768,  611,  405,  974,  266,  106,  405,  359,  359,
			  106,  405,  359,  359,  515,  106,  259,  504,  507,  545,
			 3078,  605,  893, 2733,  508,  499,  592,  508, -32768, -32768,
			  476, -32768, 1593,  543,  135, 2975, 2733, 2548, 2548, 2733,
			  106,  106,  580,  581,  405,  405, -32768,  564,  557,  521,
			 -32768,  506,  498,  495, -32768, -32768,  330,  259,  437,  367,
			  619,  305,  452,  567, -32768,  344, -32768,  974, -32768, 2733,
			  334,  135, -32768, 2548,  423,  -39, -32768, 3294, 3294, -32768,

			 -32768, -32768,  106,  405,  359,  359,  106,  106,  106,  106,
			  106,  106,  135,  275,  -39,  -39, -32768,  401,  373,  329,
			  319,  305, -32768, 2733, -32768,  327,  378,  227,  193,   -1,
			  974, -32768,  324,  259,  -39, 3294,  -35, 2548, 2872, -32768,
			  317,  306,  278, -32768, -32768, -32768, -32768, -32768, -32768,  -39,
			  135, 2769, 2666, 2733, -32768,  276, -32768, -32768, -32768, -32768,
			 -32768,  274, 2548,  227, -32768,  135, -32768, -32768, -32768, -32768,
			  165, -32768, 2548, 2802,  106,  106,  106, -32768,  -39, -32768,
			 -32768, -32768, -32768,  136,  176,  276, -32768, -32768, -32768, -32768,
			  893, -32768,  -39,  135, 3294,  184,  147, -32768, -32768, -32768,

			 -32768, -32768,  276, -32768, -32768, -32768,  -39, 2733, -32768, -32768,
			 -32768, -32768,  121,  107, -32768>>)
		end

	yypgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			 -134, -353, -329,  559,  433,  574,  539,  -12, -32768, -32768,
			 -535,  -15, -32768,   70, -32768, -32768,   86, -32768,  861,  967,
			 -32768, -32768,   81,  167, -656, -538, -577, -580, -774, -721,
			 -32768, -32768, -32768, -32768, -32768,  532, -32768, -116,    9, -32768,
			 -32768, -32768, -32768,   91, -32768,  670, -32768,  395,  659, -634,
			 -642, -32768, -32768, -178, -591, -267,  674, -32768, -32768,  867,
			  843,  779,  335,  -83, -354, -273, -32768, -32768, -32768, -32768,
			 -32768,  144, -32768, -32768, -32768,  859,  -11,  -77, -32768, -32768,
			  -58,  780, -32768, -32768, -32768, -32768, -32768,  162, -32768, -32768,
			 -32768, -32768, -32768, -118,  852, -123, -331,  767, -405,  766,

			  513,  760, -393, -32768, -32768, -32768, -32768, -472,   23, -32768,
			  591,    0, -32768,  113, -32768, -32768,  595, -390, -102, -32768,
			 -32768, -32768, -32768, -32768,  603,  379, -363, -32768, -32768, -506,
			  390, -32768, -32768, -32768,  432, -432, -554, -32768,  487, -174,
			  838, -32768, -32768, -32768, -32768,  112, -32768, -602, -32768, -262,
			 -32768, -32768, -32768,  -81, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -523, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -444, -379, -32768>>)
		end

	yytable_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		local
			an_array: ARRAY [INTEGER]
		once
			!! an_array.make (0, 3461)
			yytable_template_1 (an_array)
			yytable_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytable_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			   23,  198,   61,  452,  208,   60,   62,   70,   71,   72,
			  230,  718,  102,  111,  405,  412,  414,   68,  113,  492,
			  111,  490,  510,  124,  707,  707,  111,  545,  546,  218,
			  436,  509,  706,  706,  461,  603,  109,  113,  113,  113,
			  550,  516,  346,  199,  200,  201,  856,  238,  216,  351,
			   61,  272,  179,   60,   85,  609,  270,  222,  257,  364,
			  365,  366,  825,   90,  674,   68,  236,  673,   61,  518,
			 -130,   60,   85,  678,  228,   91,  677,   90,  228,  632,
			  872,  727,  -18,   68,  112,  731,  630,  784,  499,  -18,
			  504,  544,  159,   22,   21, -130,  524,  245,  452,  750,

			  796,  707,  561,  799,  568,  861,  491,  914,  197,  706,
			  656,  128,  203,  867,  707,  866,  904,  707,  273,  570,
			  217,  913,  706,  -18,  -18,  706,  -18,  530,  531,  532,
			  619,  722,  679,  832,  776,  670,  -17,  644,  237,  549,
			  485,  486,  483,  -17,  190,  765,  232,  707,  764,  399,
			  304,  400,  355,  402,  628,  706,  262,  629,  653,  268,
			  592,  268,  908,  436,  584,  616,  562,  858,  346,  571,
			  401,  217,  803,  351,   82,  813,  519,  -17,  -17,  752,
			  -17,  707,  271,  362,  112,  169,  171,   22,   21,  706,
			  768,  769,   22,   21,  772,  773,  407,  879,  725, -335,

			   81,   28,   22,   21,  361,  360,  359,   22,   21,   55,
			   80,  707,  613,  707,  403,   22,   21,  548,  641,  706,
			  547,  112,  358,  279,  124,  680,  215,   86, -161, -161,
			  902,  870,  479,  549, -161,  487,   79,  214, -161,  598,
			  455,  862, -161,  707,  187,   96, -161,  391,  622,  623,
			  624,  911,  901,  398,  268,   26,  268,  475,  268,  613,
			  707,  277,  596,  196,  195,  707,  841,  842,  217,   22,
			   21,  217,  217,  706,  451,  736,  668,  669,  638,  671,
			   22,   21,  456,  457,  458,  893,  471,  472,  675,  889,
			 -155, -155,  437,  876,  766,  147, -155, -265,  770,  637,

			 -155,  888,  688,  775, -155,   22,   21,  168, -155,  520,
			  728,  729,   11,  865,  732,  733,  525,  560, -265,  177,
			  881,  875,  215,  505,  144,  477,   22,   21,  800,  801,
			  168,  888,  874,  214,  748,  496,  496,  500,  496,  869,
			   56,  694,  859,   22,   21,   55,  217,  454,  888,  747,
			  881,  460,  819,   10,    9,  748,    8,  124,  217,  217,
			  762,  782,  215,   -3,  767,   22,   21,  881,  771,  451,
			  839, -378,  880,  214,  843,  844,  845,  846,  847,  848,
			  758,  757,  724,   33,  398,  398,    3,  134,  854,  133,
			  541,  817,  168,  860,  605,  850,  217,  217,  719,  196,

			  195,  804,  805,  213,  215,   22,   21,  217,  217,  217,
			  217,  215,  528,  723,  496,  214, -329,  279,  576,  500,
			  215,  633,  214,  279,  411,  437,  215,  631,  682,  681,
			  411,  214,  590,   11,  212, -323, -323,  214,  617,  618,
			  840,  217,  897,  898,  899,  652,  833,   22,   21,  257,
			  812,  133,  574,  582,   22,   21,  828,  605,  184, -323,
			  577,  578,  579,   22,   21, -327, -327, -327,  837,   22,
			   21, -135,  643,  217,   10,    9,  651,    8,  557,  815,
			  610,  252,  251,  612,  605,  814,  217,  246,  245,  244,
			  -12,  217, -135,  189,  192,  194, -135,  -12,  235, -327,

			  133, -333,  606,  642, -325, -325,  243,  242,  734,  410,
			  811,  409,  484,  810,  605,  410,  737,  409,  408, -333,
			 -333,  809,  572,  573,  217,  575,  601,  600, -325,  581,
			  612,  -12,  -12,  604,  -12,  588,  808,  362,  587,  105,
			  104,  557,  557,  557,  557,  540,  580,  159,   22,   21,
			  591,  459,  217,   22,   21,  217,  666,  667,  361,  360,
			  359,  740,  478,  480,  715,  715,  539,  538,  537, -111,
			  785,  257,  807,  790,  755,  112,  358,  123,  -11,  806,
			  817,  753,  824,  112,  536,  664,  -15,  105,  104,  793,
			 -111,  159,  262,  -15, -111,  802,  791, -111,  122,  121,

			  120,    3,  217,  252,  251,  103,  636,  788, -106,  246,
			  245,  244,  112,  786,  738,  112,  119,  743, -373,  778,
			 -373,  262,  159, -170,  658,  777,  761,  -15,  -15, -106,
			  -15, -170,  817, -106,  816, -170, -106,  202,  759,   22,
			   21,  715,  774,  672,  159,  262,  760, -331,  658,  658,
			  658,  658,  676,  754,  715,  708,  708,  715,  744,  745,
			  781,  838,  779,  103,  687,  789, -151,  291,  262,  290,
			 -151,  257, -415,  735, -151,  256,  255,  254, -151,  253,
			  851,  852,  683,  684,  685,  686,  730,  715,  289,  288,
			  749,  159,  287,  726,  558,  286,  594,  595,  597,  599,

			  871,  823,  827,  252,  251,  250,  249,  248,  247,  246,
			  245,  244,  657,  654,  -98,  877,  -98,  188,  191,  193,
			  739,  715,  228,  647,  763,  749,  650,  649,  243,  242,
			  241,  240,  708,  648,  526,  -98,  853,  887,  527,  -98,
			  526,  262,  -98,  795,  900,  708, -160, -160,  708,  645,
			   75,  715, -160,  715,  627,  443, -160, -149,  905,  626,
			 -160, -149,  625,  184, -160, -149,  749,  887,  228, -149,
			  394,  287,  910,  297,  298,  299,  621,  514,  708,  513,
			  834,  620,  836,  715,  887,  367,  615,  829,  209,  211,
			  608,  494,  221,  493,  223,  289,  228,  224,  259,  225,

			  715,  849,  229,  569,  228,  715,   98,   77,   97,   78,
			  565,  286,  708,  563,  907, -337, -337, -337, -337,  542,
			  535,  534,  749,  533,  511,  488,  261,  482,  481, -337,
			  829,  476,  464,  463,  462,  450,  438,  290,  425,  878,
			  882, -337,  708, -140,  404, -154, -154, -337, -337, -337,
			    3, -154,  401,  392,  892, -154,  349,  356,  370, -154,
			  369,  353,  302, -154,  300,  204,  -76,  -76,   82,   80,
			  882,  284,  -76,  180,  168,  276,  -76,  263, -417,  345,
			  -76, -418,  906,  234,  -76,  233,  350,  882,  231,  258,
			  226,  206,  100, -416,  219,   92,  708,   84,   83,  371,

			  372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
			  382,  383,  384,  385,  387,  389,  390, -420,   24, -420,
			   20, -420,   73, -420, -420, -420, -420,   19,   18, -420,
			 -420,    1, -420,  857,  564,  782, -420, -420,  125,  529,
			  593,  442,  446,  868,  512,  295,  110,   99,  646, -420,
			  174,  294,  293,  406,  891, -420, -420, -420, -420,  257,
			  278,  108,  614,  256,  255,  254,  430,  253,  517,    4,
			  178,  903,  909,  515,  583, -420,  495, -420, -420,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  252,  251,  250,  249,  248,  247,  246,  245,  244,

			    0,    0,    0,    0,    0,  345, -420, -420,    0,    0,
			  350,    0,    0,  448,    0,    0,  243,  242,  241,  240,
			    0, -420,    0,  228,    0,    0,  468,    0,    0,    0,
			 -420, -420,    0,    0,    0,    0,    0, -420,    0,    0,
			    0,    0,    0,    0,    0,  473,    0,  474,    0,   54,
			   53,   52,   51,   50,   49,   48,   47,   46,   45,   44,
			   43,   42,   41,   40,   39,   38,   37,   36,   35,    0,
			    0,    0,    0,    0,    0, -408,    0,    0,    0, -408,
			    0, -408,   32, -408, -408, -408, -408, -408, -408,    0,
			 -408, -408, -408,    0, -408, -408,    0,    0, -408, -408,

			    0,    0, -408, -408,    0, -408, -408,    0,  448,    0,
			    0, -408,    0, -408, -408,    0,    0, -408, -408, -408,
			 -408, -408,    0,    0,    0,    0, -408, -408, -408,  468,
			    0,    0, -408, -408, -408,    0, -408, -408, -408, -408,
			 -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
			 -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
			 -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
			 -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
			 -408,  448, -408, -408,    0, -408, -408,    0, -408, -408,
			 -408, -408,    0, -408, -408, -408, -408, -408, -408, -408,

			  444,    0,  468,    0,    0,    0,    0,    0,    0,    0,
			  257,    0,    0,    0,  256,  255,  254,    0,  253,    0,
			  149,    0,    0,    0,    0,    0,  148,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  147,    0,    0,    0,
			    0,    0,  252,  251,  250,  249,  248,  247,  246,  245,
			  244,  146,    0,    0,    0,    0,    0,    0,  145,    0,
			  440,    0,  261,    0,    0,  144,    0,  243,  242,  241,
			  240,    0,  143,    0,    0,    0,    0,  142,   58,   57,
			    0,   56,  141,  140,   22,   21,  139,    0,    0,    0,
			  138,  261,   54,   53,   52,   51,   50,   49,   48,   47,

			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,   35,  137,  136,    0,  261,  149,    0,    0,    0,
			    0,    0,  148,    0,   33,   32,    0,  135,  467,    0,
			  133,    0,  147,  543,  132,    0,  131,    0,  261,  465,
			  130,  129,    0,    0,    0,    0,    0,  146,    0,    0,
			    0,    0,    0,    0,  145,  741,  742,    0,    0,    0,
			    0,  144,    0,    0,    0,    0,    0,    0,  143,    0,
			    0,    0,    0,  142,   58,   57,    0,   56,  141,  140,
			   22,   21,  139,    0,    0,    0,  138,    0,   54,   53,
			   52,   51,   50,   49,   48,   47,   46,   45,   44,   43,

			   42,   41,   40,   39,   38,   37,   36,   35,  137,  136,
			  257,  261,    0,    0,  256,    0,  797,  798,    0,    0,
			   33,   32,    0,  135,  467,    0,  133,  466,    0,    0,
			  132,    0,  131,    0,    0,  465,  130,  129,    0,    0,
			    0,    0,  252,  251,  250,  249,  248,  247,  246,  245,
			  244,    0,  835,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  243,  242,  241,
			  240, -407,    0,    0,    0, -407,    0, -407,    0, -407,
			 -407, -407, -407, -407, -407,    0, -407, -407, -407,    0,
			 -407, -407,    0,    0, -407, -407,  873,    0, -407, -407,

			    0, -407, -407,    0,    0,    0,    0, -407,    0, -407,
			 -407,    0,    0, -407, -407, -407, -407, -407,    0,    0,
			    0,  890, -407, -407, -407,    0,    0,    0, -407, -407,
			 -407,  894, -407, -407, -407, -407, -407, -407, -407, -407,
			 -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
			 -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
			 -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
			 -407, -407, -407, -407, -407, -407, -407,    0, -407, -407,
			    0, -407, -407,    0, -407, -407, -407, -407,    0, -407,
			 -407, -407, -407, -407, -407, -407,  149,    0,    0,    0,

			    0,    0,  148,    0,    0,    0,    0,    0,  792,    0,
			    0,    0,  147,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  146,    0,    0,
			    0,    0,    0,    0,  145,    0,    0,    0,    0,    0,
			    0,  144,    0,    0,    0,    0,    0,    0,  143,    0,
			    0,    0,    0,  142,   58,   57,    0,   56,  141,  140,
			   22,   21,  139,    0,    0,    0,  138,    0,   54,   53,
			   52,   51,   50,   49,   48,   47,   46,   45,   44,   43,
			   42,   41,   40,   39,   38,   37,   36,   35,  137,  136,
			    0,    0,    0,  149,    0,    0,    0,    0,    0,  148,

			   33,   32,    0,  135,  134,  751,  133,    0,    0,  147,
			  132,    0,  131,    0,    0,    0,  130,  129,    0,    0,
			    0,    0,    0,    0,  146,    0,    0,    0,    0,    0,
			    0,  145,    0,    0,    0,    0,    0,    0,  144,    0,
			    0,    0,    0,    0,    0,  143,    0,    0,    0,    0,
			  142,   58,   57,    0,   56,  141,  140,   22,   21,  139,
			    0,    0,    0,  138,    0,   54,   53,   52,   51,   50,
			   49,   48,   47,   46,   45,   44,   43,   42,   41,   40,
			   39,   38,   37,   36,   35,  137,  136,    0,  149,    0,
			    0,    0,    0,    0,  148,    0,    0,   33,   32,    0,

			  135,  134,    0,  133,  147,    0,    0,  132,    0,  131,
			    0,    0,    0,  130,  129,    0,    0,    0,    0,  146,
			    0,    0,    0,    0,    0,    0,  145,  655,    0,    0,
			    0,    0,    0,  144,    0,    0,    0,    0,    0,    0,
			  143,    0,    0,    0,    0,  142,   58,   57,    0,   56,
			  141,  140,   22,   21,  139,    0,    0,    0,  138,    0,
			   54,   53,   52,   51,   50,   49,   48,   47,   46,   45,
			   44,   43,   42,   41,   40,   39,   38,   37,   36,   35,
			  137,  136,    0,    0,  149,    0,    0,    0,    0,    0,
			  148,    0,   33,   32,  602,  135,  134,    0,  133,    0,

			  147,    0,  132,    0,  131,    0,    0,    0,  130,  129,
			    0,    0,    0,    0,    0,  146,    0,    0,    0,    0,
			    0,    0,  145,    0,    0,    0,    0,    0,    0,  144,
			    0,    0,    0,    0,    0,    0,  143,    0,    0,    0,
			    0,  142,   58,   57,    0,   56,  141,  140,   22,   21,
			  139,    0,    0,    0,  138,    0,   54,   53,   52,   51,
			   50,   49,   48,   47,   46,   45,   44,   43,   42,   41,
			   40,   39,   38,   37,   36,   35,  137,  136,    0,  149,
			    0,    0,    0,    0,    0,  148,    0,    0,   33,   32,
			    0,  135,  134,    0,  133,  147,    0,    0,  132,    0,

			  131,    0,    0,    0,  130,  129,    0,    0,    0,    0,
			  146,    0,    0,    0,    0,    0,    0,  145,    0,    0,
			    0,    0,    0,    0,  144,    0,    0,    0,    0,    0,
			    0,  143,    0,    0,    0,    0,  142,   58,   57,    0,
			   56,  141,  140,   22,   21,  139,    0,    0,    0,  138,
			    0,   54,   53,   52,   51,   50,   49,   48,   47,   46,
			   45,   44,   43,   42,   41,   40,   39,   38,   37,   36,
			   35,  137,  136,    0,  149,    0,    0,    0,    0,    0,
			  148,    0,    0,   33,   32,    0,  135,  467,    0,  133,
			  147,    0,    0,  132,    0,  131,    0,    0,  465,  130,

			  129,    0,    0,    0,    0,  146,    0,    0,    0,    0,
			    0,    0,  145,    0,    0,    0,    0,    0,    0,  144,
			    0,    0,    0,    0,    0,    0,  143,    0,    0,    0,
			    0,  142,   58,   57,    0,   56,  141,  140,   22,   21,
			  139,    0,    0,    0,  138,    0,   54,   53,   52,   51,
			   50,   49,   48,   47,   46,   45,   44,   43,   42,   41,
			   40,   39,   38,   37,   36,   35,  137,  136,    0,    0,
			  149,    0,    0,    0,    0,    0,  148,    0,   33,   32,
			    0,  135,  134,    0,  133,  523,  147,    0,  132,    0,
			  131,    0,    0,    0,  130,  129,    0,    0,    0,    0,

			    0,  146,    0,    0,    0,    0,    0,    0,  145,    0,
			    0,    0,    0,    0,    0,  144,    0,    0,    0,    0,
			    0,    0,  143,  445,    0,    0,    0,  142,   58,   57,
			    0,   56,  141,  140,   22,   21,  139,    0,    0,    0,
			  138,    0,   54,   53,   52,   51,   50,   49,   48,   47,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,   35,  137,  136,    0,  149,    0,    0,    0,    0,
			    0,  148,    0,    0,   33,   32,    0,  135,  134,    0,
			  133,  147,    0,    0,  132,    0,  131,    0,    0,    0,
			  130,  129,    0,    0,    0,    0,  146,    0,    0,    0,

			    0,    0,    0,  145,    0,    0,    0,    0,    0,    0,
			  144,    0,    0,    0,    0,    0,    0,  143,    0,    0,
			    0,    0,  142,   58,   57,    0,   56,  141,  140,   22,
			   21,  139,    0,    0,    0,  138,    0,   54,   53,   52,
			   51,   50,   49,   48,   47,   46,   45,   44,   43,   42,
			   41,   40,   39,   38,   37,   36,   35,  137,  136,    0,
			  149,    0,    0,    0,    0,    0,  148,    0,    0,   33,
			   32,    0,  135,  134,    0,  133,  147,    0,    0,  132,
			  441,  131,    0,    0,    0,  130,  129,    0,    0,    0,
			    0,  146,    0,    0,    0,    0,    0,    0,  145,  388,

			    0,    0,    0,    0,    0,  144,    0,    0,    0,    0,
			    0,    0,  143,    0,    0,    0,    0,  142,   58,   57,
			    0,   56,  141,  140,   22,   21,  139,    0,    0,    0,
			  138,    0,   54,   53,   52,   51,   50,   49,   48,   47,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,   35,  137,  136,    0,    0,  149,    0,    0,    0,
			    0,    0,  148,    0,   33,   32,  386,  135,  134,    0,
			  133,    0,  147,    0,  132,    0,  131,    0,    0,    0,
			  130,  129,    0,    0,    0,    0,    0,  146,    0,    0,
			    0,    0,    0,    0,  145,    0,    0,    0,    0,    0,

			    0,  144,    0,    0,    0,    0,    0,    0,  143,    0,
			    0,    0,    0,  142,   58,   57,    0,   56,  141,  140,
			   22,   21,  139,    0,    0,    0,  138,    0,   54,   53,
			   52,   51,   50,   49,   48,   47,   46,   45,   44,   43,
			   42,   41,   40,   39,   38,   37,   36,   35,  137,  136,
			    0,  149,    0,    0,    0,    0,    0,  148,    0,    0,
			   33,   32,    0,  135,  134,    0,  133,  147,    0,    0,
			  132,    0,  131,    0,    0,    0,  130,  129,    0,    0,
			    0,    0,  146,    0,    0,    0,    0,    0,    0,  145,
			    0,    0,    0,    0,    0,    0,  144,    0,    0,    0,

			    0,    0,    0,  143,    0,    0,    0,    0,  142,   58,
			   57,    0,   56,  141,  140,   22,   21,  139,    0,    0,
			    0,  138,    0,   54,   53,   52,   51,   50,   49,   48,
			   47,   46,   45,   44,   43,   42,   41,   40,   39,   38,
			   37,   36,   35,  137,  136,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,   33,   32,    0,  135,  134,
			    0,  133,    0,    0,    0,  132,    0,  131,    0,    0,
			    0,  130,  129, -405,    0, -405,    0, -405,    0, -405,
			 -405, -405, -405,    0,    0, -405, -405,    0, -405,    0,
			  257,    0, -405, -405,  256,  255,  254,    0,  253,    0,

			    0,    0,    0,    0,    0, -405,    0,    0,    0,    0,
			    0, -405, -405, -405, -405,    0,    0,    0,    0,    0,
			    0,    0,  252,  251,  250,  249,  248,  247,  246,  245,
			  244, -405,    0, -405, -405,    0,    0,    0,    0,    0,
			  702,    0,  701,    0,  700,    0,    0,  243,  242,  241,
			  240,  393,  699,  698,    0,  697,    0,    0,    0,  696,
			    0,    0, -405, -405,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -406, -405, -406, -405,
			 -406,  695, -406, -406, -406, -406,    0, -405, -406, -406,
			    0, -406,    0, -405,    0, -406, -406,    0,  694,    0,

			   22,   21,    0,    0,    0,    0,    0,    0, -406,    0,
			    0,    0,    0,    0, -406, -406, -406, -406,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  693,
			  692,    0,    0,  895, -406,    0, -406, -406,    0,    0,
			    0,    0,    0,    0,  691,    0,  133,    0,    0,    0,
			    0,    0,    0,    0,  690,    0,    0,    0,    0,    0,
			  689,    0,    0,    0,    0, -406, -406,    0,  257,    0,
			    0,    0,  256,  255,  254,    0,  253,    0,    0, -401,
			 -406, -401, -406, -401,    0, -401, -401, -401, -401,    0,
			 -406, -401, -401,    0, -401,    0, -406,    0, -401, -401,

			  252,  251,  250,  249,  248,  247,  246,  245,  244,    0,
			    0, -401,    0,    0,    0,    0,    0, -401, -401, -401,
			 -401,    0,    0,    0,    0,  243,  242,  241,  240,    0,
			    0,    0,    0,    0,    0,    0,    0, -401,    0, -401,
			 -401,  344,  343,  342,  341,  340,  339,  338,  337,  336,
			  335,  334,  333,  332,  331,  330,  329,  328,  327,  326,
			  325,    0,    0,    0,    0,    0,    0,    0, -401, -401,
			    0,  257,    0,    0,    0,  256,  255,  254,    0,  253,
			    0,    0, -400, -401, -400, -401, -400,    0, -400, -400,
			 -400, -400,    0, -401, -400, -400,    0, -400,    0, -401>>,
			1, 3000, 0)
		end

	yytable_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			    0, -400, -400,  252,  251,  250,  249,  248,  247,  246,
			  245,  244,    0,    0, -400,    0,    0,    0,    0,    0,
			 -400, -400, -400, -400,    0,    0,    0,    0,  243,  242,
			  241,  240,  239,    0,    0,    0,    0,    0,    0,    0,
			 -400,    0, -400, -400,  324,  323,  322,  321,  320,  319,
			  318,  317,  316,  315,  314,  313,  312,  311,  310,  309,
			  308,  307,  306,  305,    0,    0,    0,    0,    0,    0,
			    0, -400, -400,    0,  257,    0,    0,    0,  256,  255,
			  254,    0,  253,    0,    0, -402, -400, -402, -400, -402,
			    0, -402, -402, -402, -402,    0, -400, -402, -402,    0,

			 -402,    0, -400,    0, -402, -402,  252,  251,  250,  249,
			  248,  247,  246,  245,  244,    0,    0, -402,    0,    0,
			  257,    0,  348, -402, -402, -402, -402,    0,    0,    0,
			    0,  243,  242,  241,  240,    0,    0,    0,    0,    0,
			    0,    0,    0, -402,    0, -402, -402,    0,    0,    0,
			    0,    0,  252,  251,  250,  249,  248,  247,  246,  245,
			  244,    0,    0,    0,   75,    0,    0,    0,    0,    0,
			    0,    0,    0,    0, -402, -402,  586,  243,  242,  241,
			  240,    0,    0,    0,    0,    0,    0,    0,    0, -402,
			    0, -402,  585,   58,   57,    0,   56,    0,    0, -402,

			    0,   55,    0,    0,    0, -402,    0,   54,   53,   52,
			   51,   50,   49,   48,   47,   46,   45,   44,   43,   42,
			   41,   40,   39,   38,   37,   36,   35,   34,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   33,
			   32,    0,   59,   58,   57,    0,   56,    0,    0,   22,
			   21,   55,    0,    0,    0,   31,   30,   54,   53,   52,
			   51,   50,   49,   48,   47,   46,   45,   44,   43,   42,
			   41,   40,   39,   38,   37,   36,   35,   34,  257,    0,
			    0,    0,  256,  255,  254,    0,  253,    0,    0,   33,
			   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,   31,   30,    0,    0,    0,
			  252,  251,  250,  249,  248,  247,  246,  245,  244,  257,
			    0,    0,    0,  256,  255,  254,  521,  253,  440,    0,
			    0,    0,    0,    0,    0,  243,  242,  241,  240,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  252,  251,  250,  249,  248,  247,  246,  245,  244,
			  257,    0,    0,    0,  256,  255,  254,    0,  253,  440,
			    0,  439,    0,    0,    0,    0,  243,  242,  241,  240,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  252,  251,  250,  249,  248,  247,  246,  245,

			  244,  257,    0,    0,    0,  256,  255,  254,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  243,  242,  241,
			  240,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  252,  251,  250,  249,  248,  247,  246,
			  245,  244,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  243,  242,
			  241,  240>>,
			1, 462, 3000)
		end

	yycheck_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		local
			an_array: ARRAY [INTEGER]
		once
			!! an_array.make (0, 3461)
			yycheck_template_1 (an_array)
			yycheck_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yycheck_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			   11,  119,   17,  357,  127,   17,   17,   18,   19,   20,
			  144,  667,   93,   94,  276,  282,  283,   17,   95,   28,
			  101,  411,  427,  100,  666,  667,  107,  471,  472,  131,
			  303,  424,  666,  667,  363,  558,   94,  114,  115,  116,
			   28,   15,  220,  120,  121,  122,  820,  149,  131,  227,
			   65,  174,  110,   65,   65,  561,  172,  134,   66,  233,
			  234,  235,  783,   74,  644,   65,  149,  644,   83,   15,
			   15,   83,   83,  653,  113,   75,  653,   88,  113,  602,
			  115,  672,    8,   83,   67,  676,  592,  743,  419,   15,
			  421,  470,  103,   67,   68,   40,  449,  105,  452,  701,

			  756,  743,  492,  759,  509,  826,  115,    0,  119,  743,
			  633,  102,  123,  114,  756,  116,  890,  759,  176,  512,
			  131,    0,  756,   49,   50,  759,   52,  456,  457,  458,
			  574,  669,  655,  789,  736,  641,    8,  609,  149,  127,
			  407,  408,  404,   15,  127,  725,  146,  789,  725,  265,
			  208,  267,  229,  269,  586,  789,  167,  589,  630,  170,
			  550,  172,   15,  436,  543,  570,  497,  823,  346,  522,
			  116,  182,  763,  351,   69,  777,  438,   49,   50,  702,
			   52,  823,  173,   29,   67,  104,  105,   67,   68,  823,
			  728,  729,   67,   68,  732,  733,  279,  853,  670,   15,

			   95,  127,   67,   68,   50,   51,   52,   67,   68,   69,
			   69,  853,  566,  855,  272,   67,   68,  484,  608,  853,
			  482,   67,   68,   21,  301,  657,   24,   65,    9,   10,
			   54,  833,  112,  127,   15,  409,   95,   35,   19,  114,
			  358,   14,   23,  885,  127,   83,   27,  258,  577,  578,
			  579,  907,  116,  264,  265,  127,  267,  391,  269,  613,
			  902,  180,  114,  123,  124,  907,  804,  805,  279,   67,
			   68,  282,  283,  907,  357,  121,  639,  640,   12,  642,
			   67,   68,  359,  360,  361,  120,  369,  370,  651,   15,
			    9,   10,  303,   15,  726,   19,   15,   12,  730,   33,

			   19,  855,  665,  735,   23,   67,   68,  111,   27,  443,
			  673,  674,    8,  120,  677,  678,  450,  491,   33,   15,
			  855,   15,   24,  127,   48,  112,   67,   68,  760,  761,
			  111,  885,   15,   35,   96,  418,  419,  420,  421,   15,
			   64,   65,   15,   67,   68,   69,  357,  358,  902,  111,
			  885,  362,   47,   49,   50,   96,   52,  434,  369,  370,
			  723,   42,   24,    0,  727,   67,   68,  902,  731,  452,
			  802,   42,   96,   35,  806,  807,  808,  809,  810,  811,
			   57,   58,   18,  107,  395,  396,   23,  111,   15,  113,
			  467,   13,  111,   15,   30,  120,  407,  408,   39,  123,

			  124,  764,  765,   65,   24,   67,   68,  418,  419,  420,
			  421,   24,  114,   49,  497,   35,   15,   21,  536,  502,
			   24,   16,   35,   21,   28,  436,   24,  601,  115,  116,
			   28,   35,  550,    8,   96,   15,   16,   35,  572,  573,
			  803,  452,  874,  875,  876,   18,  112,   67,   68,   66,
			  120,  113,  535,  112,   67,   68,  112,   30,  117,   39,
			  537,  538,  539,   67,   68,   13,   14,   15,   45,   67,
			   68,   15,   18,  484,   49,   50,   49,   52,  489,  112,
			  563,   98,   99,  566,   30,   48,  497,  104,  105,  106,
			    8,  502,   36,  114,  115,  116,   40,   15,  111,   47,

			  113,   27,   18,   49,   15,   16,  123,  124,  682,  113,
			   15,  115,  116,   15,   30,  113,  690,  115,  116,   45,
			   46,   15,  533,  534,  535,  536,  115,  116,   39,  540,
			  613,   49,   50,   49,   52,  550,   15,   29,  550,    9,
			   10,  552,  553,  554,  555,   29,   65,  558,   67,   68,
			  550,   65,  563,   67,   68,  566,  637,  638,   50,   51,
			   52,  695,  395,  396,  666,  667,   50,   51,   52,   15,
			  744,   66,   15,  747,  708,   67,   68,   29,    0,   15,
			   13,  704,   15,   67,   68,    4,    8,    9,   10,   46,
			   36,  602,  603,   15,   40,   15,  120,   43,   50,   51,

			   52,   23,  613,   98,   99,   27,  606,   15,   15,  104,
			  105,  106,   67,  114,  691,   67,   68,  698,   13,  112,
			   15,  632,  633,   15,  635,  121,   15,   49,   50,   36,
			   52,   23,   13,   40,   15,   27,   43,   65,  719,   67,
			   68,  743,  127,  643,  655,  656,   15,   15,  659,  660,
			  661,  662,  652,  120,  756,  666,  667,  759,  111,  113,
			  741,  795,  739,   27,  664,  746,   15,   15,  679,   17,
			   19,   66,  120,   15,   23,   70,   71,   72,   27,   74,
			  814,  815,  659,  660,  661,  662,   15,  789,   36,   37,
			  701,  702,   40,   15,   38,   43,  552,  553,  554,  555,

			  834,  782,  783,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,   15,  127,   15,  849,   17,  114,  115,  116,
			  111,  823,  113,   15,  724,  736,  112,  112,  123,  124,
			  125,  126,  743,  112,  116,   36,  817,  855,  114,   40,
			  116,  752,   43,  754,  878,  756,    9,   10,  759,  116,
			   32,  853,   15,  855,  112,   48,   19,   15,  892,  112,
			   23,   19,  112,  117,   27,   23,  777,  885,  113,   27,
			  115,   40,  906,  199,  200,  201,  112,  116,  789,  118,
			  791,  112,  793,  885,  902,  113,   15,  787,  129,  130,
			   28,  116,  133,  118,  135,   36,  113,  138,  115,  140,

			  902,  812,  111,   15,  113,  907,  116,   27,  118,   29,
			    5,   43,  823,    6,  895,   13,   14,   15,   16,  114,
			  120,  120,  833,  120,   15,  114,  167,   15,  116,   27,
			  830,  127,  112,  112,  112,  112,   15,   17,   15,  850,
			  855,   39,  853,   15,   15,    9,   10,   45,   46,   47,
			   23,   15,  116,  127,  865,   19,  112,  114,  120,   23,
			  120,  114,   15,   27,  118,  117,    9,   10,   69,   69,
			  885,  118,   15,   19,  111,   15,   19,  112,  120,  220,
			   23,  120,  893,  111,   27,  111,  227,  902,  113,  120,
			   56,    9,   53,  120,  118,   25,  907,  116,  115,  240,

			  241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
			  251,  252,  253,  254,  255,  256,  257,    7,  117,    9,
			    8,   11,  118,   13,   14,   15,   16,    8,    8,   19,
			   20,   63,   22,  821,  502,   42,   26,   27,  100,  452,
			  550,  346,  351,  830,  431,  185,   94,   88,  613,   39,
			  107,  185,  185,  279,  863,   45,   46,   47,   48,   66,
			  181,   94,  567,   70,   71,   72,  296,   74,  436,    2,
			  109,  885,  902,  434,  541,   65,  417,   67,   68,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   98,   99,  100,  101,  102,  103,  104,  105,  106,

			   -1,   -1,   -1,   -1,   -1,  346,   96,   97,   -1,   -1,
			  351,   -1,   -1,  354,   -1,   -1,  123,  124,  125,  126,
			   -1,  111,   -1,  113,   -1,   -1,  367,   -1,   -1,   -1,
			  120,  121,   -1,   -1,   -1,   -1,   -1,  127,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  386,   -1,  388,   -1,   75,
			   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   -1,
			   -1,   -1,   -1,   -1,   -1,    3,   -1,   -1,   -1,    7,
			   -1,    9,  108,   11,   12,   13,   14,   15,   16,   -1,
			   18,   19,   20,   -1,   22,   23,   -1,   -1,   26,   27,

			   -1,   -1,   30,   31,   -1,   33,   34,   -1,  449,   -1,
			   -1,   39,   -1,   41,   42,   -1,   -1,   45,   46,   47,
			   48,   49,   -1,   -1,   -1,   -1,   54,   55,   56,  470,
			   -1,   -1,   60,   61,   62,   -1,   64,   65,   66,   67,
			   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  522,  110,  111,   -1,  113,  114,   -1,  116,  117,
			  118,  119,   -1,  121,  122,  123,  124,  125,  126,  127,

			   56,   -1,  543,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   66,   -1,   -1,   -1,   70,   71,   72,   -1,   74,   -1,
			    3,   -1,   -1,   -1,   -1,   -1,    9,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   19,   -1,   -1,   -1,
			   -1,   -1,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,   34,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
			  116,   -1,  603,   -1,   -1,   48,   -1,  123,  124,  125,
			  126,   -1,   55,   -1,   -1,   -1,   -1,   60,   61,   62,
			   -1,   64,   65,   66,   67,   68,   69,   -1,   -1,   -1,
			   73,  632,   75,   76,   77,   78,   79,   80,   81,   82,

			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   -1,  656,    3,   -1,   -1,   -1,
			   -1,   -1,    9,   -1,  107,  108,   -1,  110,  111,   -1,
			  113,   -1,   19,  116,  117,   -1,  119,   -1,  679,  122,
			  123,  124,   -1,   -1,   -1,   -1,   -1,   34,   -1,   -1,
			   -1,   -1,   -1,   -1,   41,  696,  697,   -1,   -1,   -1,
			   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   -1,   -1,   -1,   60,   61,   62,   -1,   64,   65,   66,
			   67,   68,   69,   -1,   -1,   -1,   73,   -1,   75,   76,
			   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,

			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   66,  752,   -1,   -1,   70,   -1,  757,  758,   -1,   -1,
			  107,  108,   -1,  110,  111,   -1,  113,  114,   -1,   -1,
			  117,   -1,  119,   -1,   -1,  122,  123,  124,   -1,   -1,
			   -1,   -1,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,   -1,  793,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,    3,   -1,   -1,   -1,    7,   -1,    9,   -1,   11,
			   12,   13,   14,   15,   16,   -1,   18,   19,   20,   -1,
			   22,   23,   -1,   -1,   26,   27,  837,   -1,   30,   31,

			   -1,   33,   34,   -1,   -1,   -1,   -1,   39,   -1,   41,
			   42,   -1,   -1,   45,   46,   47,   48,   49,   -1,   -1,
			   -1,  862,   54,   55,   56,   -1,   -1,   -1,   60,   61,
			   62,  872,   64,   65,   66,   67,   68,   69,   70,   71,
			   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,  108,   -1,  110,  111,
			   -1,  113,  114,   -1,  116,  117,  118,  119,   -1,  121,
			  122,  123,  124,  125,  126,  127,    3,   -1,   -1,   -1,

			   -1,   -1,    9,   -1,   -1,   -1,   -1,   -1,   15,   -1,
			   -1,   -1,   19,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   34,   -1,   -1,
			   -1,   -1,   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,
			   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   -1,   -1,   -1,   60,   61,   62,   -1,   64,   65,   66,
			   67,   68,   69,   -1,   -1,   -1,   73,   -1,   75,   76,
			   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   -1,   -1,   -1,    3,   -1,   -1,   -1,   -1,   -1,    9,

			  107,  108,   -1,  110,  111,   15,  113,   -1,   -1,   19,
			  117,   -1,  119,   -1,   -1,   -1,  123,  124,   -1,   -1,
			   -1,   -1,   -1,   -1,   34,   -1,   -1,   -1,   -1,   -1,
			   -1,   41,   -1,   -1,   -1,   -1,   -1,   -1,   48,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   -1,   -1,   -1,
			   60,   61,   62,   -1,   64,   65,   66,   67,   68,   69,
			   -1,   -1,   -1,   73,   -1,   75,   76,   77,   78,   79,
			   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   -1,    3,   -1,
			   -1,   -1,   -1,   -1,    9,   -1,   -1,  107,  108,   -1,

			  110,  111,   -1,  113,   19,   -1,   -1,  117,   -1,  119,
			   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,   -1,   34,
			   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   -1,   -1,
			   -1,   -1,   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,
			   55,   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   64,
			   65,   66,   67,   68,   69,   -1,   -1,   -1,   73,   -1,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   -1,   -1,    3,   -1,   -1,   -1,   -1,   -1,
			    9,   -1,  107,  108,   13,  110,  111,   -1,  113,   -1,

			   19,   -1,  117,   -1,  119,   -1,   -1,   -1,  123,  124,
			   -1,   -1,   -1,   -1,   -1,   34,   -1,   -1,   -1,   -1,
			   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,   -1,   48,
			   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   -1,   -1,
			   -1,   60,   61,   62,   -1,   64,   65,   66,   67,   68,
			   69,   -1,   -1,   -1,   73,   -1,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   -1,    3,
			   -1,   -1,   -1,   -1,   -1,    9,   -1,   -1,  107,  108,
			   -1,  110,  111,   -1,  113,   19,   -1,   -1,  117,   -1,

			  119,   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,   -1,
			   34,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
			   -1,   -1,   -1,   -1,   48,   -1,   -1,   -1,   -1,   -1,
			   -1,   55,   -1,   -1,   -1,   -1,   60,   61,   62,   -1,
			   64,   65,   66,   67,   68,   69,   -1,   -1,   -1,   73,
			   -1,   75,   76,   77,   78,   79,   80,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   -1,    3,   -1,   -1,   -1,   -1,   -1,
			    9,   -1,   -1,  107,  108,   -1,  110,  111,   -1,  113,
			   19,   -1,   -1,  117,   -1,  119,   -1,   -1,  122,  123,

			  124,   -1,   -1,   -1,   -1,   34,   -1,   -1,   -1,   -1,
			   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,   -1,   48,
			   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   -1,   -1,
			   -1,   60,   61,   62,   -1,   64,   65,   66,   67,   68,
			   69,   -1,   -1,   -1,   73,   -1,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   -1,   -1,
			    3,   -1,   -1,   -1,   -1,   -1,    9,   -1,  107,  108,
			   -1,  110,  111,   -1,  113,  114,   19,   -1,  117,   -1,
			  119,   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,   -1,

			   -1,   34,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
			   -1,   -1,   -1,   -1,   -1,   48,   -1,   -1,   -1,   -1,
			   -1,   -1,   55,   56,   -1,   -1,   -1,   60,   61,   62,
			   -1,   64,   65,   66,   67,   68,   69,   -1,   -1,   -1,
			   73,   -1,   75,   76,   77,   78,   79,   80,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   -1,    3,   -1,   -1,   -1,   -1,
			   -1,    9,   -1,   -1,  107,  108,   -1,  110,  111,   -1,
			  113,   19,   -1,   -1,  117,   -1,  119,   -1,   -1,   -1,
			  123,  124,   -1,   -1,   -1,   -1,   34,   -1,   -1,   -1,

			   -1,   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,   -1,
			   48,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   -1,
			   -1,   -1,   60,   61,   62,   -1,   64,   65,   66,   67,
			   68,   69,   -1,   -1,   -1,   73,   -1,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   -1,
			    3,   -1,   -1,   -1,   -1,   -1,    9,   -1,   -1,  107,
			  108,   -1,  110,  111,   -1,  113,   19,   -1,   -1,  117,
			  118,  119,   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,
			   -1,   34,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,

			   -1,   -1,   -1,   -1,   -1,   48,   -1,   -1,   -1,   -1,
			   -1,   -1,   55,   -1,   -1,   -1,   -1,   60,   61,   62,
			   -1,   64,   65,   66,   67,   68,   69,   -1,   -1,   -1,
			   73,   -1,   75,   76,   77,   78,   79,   80,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   -1,   -1,    3,   -1,   -1,   -1,
			   -1,   -1,    9,   -1,  107,  108,   13,  110,  111,   -1,
			  113,   -1,   19,   -1,  117,   -1,  119,   -1,   -1,   -1,
			  123,  124,   -1,   -1,   -1,   -1,   -1,   34,   -1,   -1,
			   -1,   -1,   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,

			   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   -1,   -1,   -1,   60,   61,   62,   -1,   64,   65,   66,
			   67,   68,   69,   -1,   -1,   -1,   73,   -1,   75,   76,
			   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   -1,    3,   -1,   -1,   -1,   -1,   -1,    9,   -1,   -1,
			  107,  108,   -1,  110,  111,   -1,  113,   19,   -1,   -1,
			  117,   -1,  119,   -1,   -1,   -1,  123,  124,   -1,   -1,
			   -1,   -1,   34,   -1,   -1,   -1,   -1,   -1,   -1,   41,
			   -1,   -1,   -1,   -1,   -1,   -1,   48,   -1,   -1,   -1,

			   -1,   -1,   -1,   55,   -1,   -1,   -1,   -1,   60,   61,
			   62,   -1,   64,   65,   66,   67,   68,   69,   -1,   -1,
			   -1,   73,   -1,   75,   76,   77,   78,   79,   80,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  107,  108,   -1,  110,  111,
			   -1,  113,   -1,   -1,   -1,  117,   -1,  119,   -1,   -1,
			   -1,  123,  124,    7,   -1,    9,   -1,   11,   -1,   13,
			   14,   15,   16,   -1,   -1,   19,   20,   -1,   22,   -1,
			   66,   -1,   26,   27,   70,   71,   72,   -1,   74,   -1,

			   -1,   -1,   -1,   -1,   -1,   39,   -1,   -1,   -1,   -1,
			   -1,   45,   46,   47,   48,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,   65,   -1,   67,   68,   -1,   -1,   -1,   -1,   -1,
			    7,   -1,    9,   -1,   11,   -1,   -1,  123,  124,  125,
			  126,  127,   19,   20,   -1,   22,   -1,   -1,   -1,   26,
			   -1,   -1,   96,   97,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,    7,  111,    9,  113,
			   11,   48,   13,   14,   15,   16,   -1,  121,   19,   20,
			   -1,   22,   -1,  127,   -1,   26,   27,   -1,   65,   -1,

			   67,   68,   -1,   -1,   -1,   -1,   -1,   -1,   39,   -1,
			   -1,   -1,   -1,   -1,   45,   46,   47,   48,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   96,
			   97,   -1,   -1,   31,   65,   -1,   67,   68,   -1,   -1,
			   -1,   -1,   -1,   -1,  111,   -1,  113,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  121,   -1,   -1,   -1,   -1,   -1,
			  127,   -1,   -1,   -1,   -1,   96,   97,   -1,   66,   -1,
			   -1,   -1,   70,   71,   72,   -1,   74,   -1,   -1,    7,
			  111,    9,  113,   11,   -1,   13,   14,   15,   16,   -1,
			  121,   19,   20,   -1,   22,   -1,  127,   -1,   26,   27,

			   98,   99,  100,  101,  102,  103,  104,  105,  106,   -1,
			   -1,   39,   -1,   -1,   -1,   -1,   -1,   45,   46,   47,
			   48,   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   65,   -1,   67,
			   68,   75,   76,   77,   78,   79,   80,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   96,   97,
			   -1,   66,   -1,   -1,   -1,   70,   71,   72,   -1,   74,
			   -1,   -1,    7,  111,    9,  113,   11,   -1,   13,   14,
			   15,   16,   -1,  121,   19,   20,   -1,   22,   -1,  127>>,
			1, 3000, 0)
		end

	yycheck_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			   -1,   26,   27,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,   -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,
			   45,   46,   47,   48,   -1,   -1,   -1,   -1,  123,  124,
			  125,  126,  127,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   65,   -1,   67,   68,   75,   76,   77,   78,   79,   80,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   96,   97,   -1,   66,   -1,   -1,   -1,   70,   71,
			   72,   -1,   74,   -1,   -1,    7,  111,    9,  113,   11,
			   -1,   13,   14,   15,   16,   -1,  121,   19,   20,   -1,

			   22,   -1,  127,   -1,   26,   27,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,   -1,   -1,   39,   -1,   -1,
			   66,   -1,  114,   45,   46,   47,   48,   -1,   -1,   -1,
			   -1,  123,  124,  125,  126,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   65,   -1,   67,   68,   -1,   -1,   -1,
			   -1,   -1,   98,   99,  100,  101,  102,  103,  104,  105,
			  106,   -1,   -1,   -1,   32,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   96,   97,   44,  123,  124,  125,
			  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  111,
			   -1,  113,   60,   61,   62,   -1,   64,   -1,   -1,  121,

			   -1,   69,   -1,   -1,   -1,  127,   -1,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  107,
			  108,   -1,   60,   61,   62,   -1,   64,   -1,   -1,   67,
			   68,   69,   -1,   -1,   -1,  123,  124,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   66,   -1,
			   -1,   -1,   70,   71,   72,   -1,   74,   -1,   -1,  107,
			  108,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,  123,  124,   -1,   -1,   -1,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,   66,
			   -1,   -1,   -1,   70,   71,   72,  114,   74,  116,   -1,
			   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			   66,   -1,   -1,   -1,   70,   71,   72,   -1,   74,  116,
			   -1,  118,   -1,   -1,   -1,   -1,  123,  124,  125,  126,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   98,   99,  100,  101,  102,  103,  104,  105,

			  106,   66,   -1,   -1,   -1,   70,   71,   72,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
			  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,
			  125,  126>>,
			1, 462, 3000)
		end

feature {NONE} -- Conversion

	yytype1 (v: ANY): ET_KEYWORD is
		require
			valid_type: yyis_type1 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type1 (v: ANY): BOOLEAN is
		local
			u: ET_KEYWORD
		do
			u ?= v
			Result := (u = v)
		end

	yytype2 (v: ANY): ET_SYMBOL is
		require
			valid_type: yyis_type2 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type2 (v: ANY): BOOLEAN is
		local
			u: ET_SYMBOL
		do
			u ?= v
			Result := (u = v)
		end

	yytype4 (v: ANY): ET_BIT_CONSTANT is
		require
			valid_type: yyis_type4 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type4 (v: ANY): BOOLEAN is
		local
			u: ET_BIT_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype5 (v: ANY): ET_BOOLEAN_CONSTANT is
		require
			valid_type: yyis_type5 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type5 (v: ANY): BOOLEAN is
		local
			u: ET_BOOLEAN_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype6 (v: ANY): ET_BREAK is
		require
			valid_type: yyis_type6 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type6 (v: ANY): BOOLEAN is
		local
			u: ET_BREAK
		do
			u ?= v
			Result := (u = v)
		end

	yytype7 (v: ANY): ET_CHARACTER_CONSTANT is
		require
			valid_type: yyis_type7 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type7 (v: ANY): BOOLEAN is
		local
			u: ET_CHARACTER_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype8 (v: ANY): ET_CURRENT is
		require
			valid_type: yyis_type8 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type8 (v: ANY): BOOLEAN is
		local
			u: ET_CURRENT
		do
			u ?= v
			Result := (u = v)
		end

	yytype9 (v: ANY): ET_FREE_OPERATOR is
		require
			valid_type: yyis_type9 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type9 (v: ANY): BOOLEAN is
		local
			u: ET_FREE_OPERATOR
		do
			u ?= v
			Result := (u = v)
		end

	yytype10 (v: ANY): ET_IDENTIFIER is
		require
			valid_type: yyis_type10 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type10 (v: ANY): BOOLEAN is
		local
			u: ET_IDENTIFIER
		do
			u ?= v
			Result := (u = v)
		end

	yytype11 (v: ANY): ET_INTEGER_CONSTANT is
		require
			valid_type: yyis_type11 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type11 (v: ANY): BOOLEAN is
		local
			u: ET_INTEGER_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype12 (v: ANY): ET_KEYWORD_OPERATOR is
		require
			valid_type: yyis_type12 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type12 (v: ANY): BOOLEAN is
		local
			u: ET_KEYWORD_OPERATOR
		do
			u ?= v
			Result := (u = v)
		end

	yytype13 (v: ANY): ET_MANIFEST_STRING is
		require
			valid_type: yyis_type13 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type13 (v: ANY): BOOLEAN is
		local
			u: ET_MANIFEST_STRING
		do
			u ?= v
			Result := (u = v)
		end

	yytype14 (v: ANY): ET_REAL_CONSTANT is
		require
			valid_type: yyis_type14 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type14 (v: ANY): BOOLEAN is
		local
			u: ET_REAL_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype15 (v: ANY): ET_RESULT is
		require
			valid_type: yyis_type15 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type15 (v: ANY): BOOLEAN is
		local
			u: ET_RESULT
		do
			u ?= v
			Result := (u = v)
		end

	yytype16 (v: ANY): ET_RETRY_INSTRUCTION is
		require
			valid_type: yyis_type16 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type16 (v: ANY): BOOLEAN is
		local
			u: ET_RETRY_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype17 (v: ANY): ET_SYMBOL_OPERATOR is
		require
			valid_type: yyis_type17 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type17 (v: ANY): BOOLEAN is
		local
			u: ET_SYMBOL_OPERATOR
		do
			u ?= v
			Result := (u = v)
		end

	yytype18 (v: ANY): ET_SEMICOLON_SYMBOL is
		require
			valid_type: yyis_type18 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type18 (v: ANY): BOOLEAN is
		local
			u: ET_SEMICOLON_SYMBOL
		do
			u ?= v
			Result := (u = v)
		end

	yytype19 (v: ANY): ET_ACTUAL_ARGUMENT_LIST is
		require
			valid_type: yyis_type19 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type19 (v: ANY): BOOLEAN is
		local
			u: ET_ACTUAL_ARGUMENT_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype20 (v: ANY): ET_ACTUAL_PARAMETER_LIST is
		require
			valid_type: yyis_type20 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type20 (v: ANY): BOOLEAN is
		local
			u: ET_ACTUAL_PARAMETER_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype21 (v: ANY): ET_CALL_AGENT is
		require
			valid_type: yyis_type21 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type21 (v: ANY): BOOLEAN is
		local
			u: ET_CALL_AGENT
		do
			u ?= v
			Result := (u = v)
		end

	yytype22 (v: ANY): ET_CALL_EXPRESSION is
		require
			valid_type: yyis_type22 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type22 (v: ANY): BOOLEAN is
		local
			u: ET_CALL_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype23 (v: ANY): ET_CHOICE is
		require
			valid_type: yyis_type23 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type23 (v: ANY): BOOLEAN is
		local
			u: ET_CHOICE
		do
			u ?= v
			Result := (u = v)
		end

	yytype24 (v: ANY): ET_CHOICE_CONSTANT is
		require
			valid_type: yyis_type24 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type24 (v: ANY): BOOLEAN is
		local
			u: ET_CHOICE_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype25 (v: ANY): ET_CHOICE_ITEM is
		require
			valid_type: yyis_type25 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type25 (v: ANY): BOOLEAN is
		local
			u: ET_CHOICE_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype26 (v: ANY): ET_CHOICE_LIST is
		require
			valid_type: yyis_type26 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type26 (v: ANY): BOOLEAN is
		local
			u: ET_CHOICE_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype27 (v: ANY): ET_CLASS is
		require
			valid_type: yyis_type27 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type27 (v: ANY): BOOLEAN is
		local
			u: ET_CLASS
		do
			u ?= v
			Result := (u = v)
		end

	yytype28 (v: ANY): ET_CLASS_NAME_ITEM is
		require
			valid_type: yyis_type28 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type28 (v: ANY): BOOLEAN is
		local
			u: ET_CLASS_NAME_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype29 (v: ANY): ET_CLIENTS is
		require
			valid_type: yyis_type29 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type29 (v: ANY): BOOLEAN is
		local
			u: ET_CLIENTS
		do
			u ?= v
			Result := (u = v)
		end

	yytype30 (v: ANY): ET_COMPOUND is
		require
			valid_type: yyis_type30 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type30 (v: ANY): BOOLEAN is
		local
			u: ET_COMPOUND
		do
			u ?= v
			Result := (u = v)
		end

	yytype31 (v: ANY): ET_CONSTANT is
		require
			valid_type: yyis_type31 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type31 (v: ANY): BOOLEAN is
		local
			u: ET_CONSTANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype32 (v: ANY): ET_CONSTRAINT_CREATOR is
		require
			valid_type: yyis_type32 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type32 (v: ANY): BOOLEAN is
		local
			u: ET_CONSTRAINT_CREATOR
		do
			u ?= v
			Result := (u = v)
		end

	yytype33 (v: ANY): ET_CREATOR is
		require
			valid_type: yyis_type33 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type33 (v: ANY): BOOLEAN is
		local
			u: ET_CREATOR
		do
			u ?= v
			Result := (u = v)
		end

	yytype34 (v: ANY): ET_CREATOR_LIST is
		require
			valid_type: yyis_type34 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type34 (v: ANY): BOOLEAN is
		local
			u: ET_CREATOR_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype35 (v: ANY): ET_DEBUG_INSTRUCTION is
		require
			valid_type: yyis_type35 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type35 (v: ANY): BOOLEAN is
		local
			u: ET_DEBUG_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype36 (v: ANY): ET_ELSEIF_PART is
		require
			valid_type: yyis_type36 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type36 (v: ANY): BOOLEAN is
		local
			u: ET_ELSEIF_PART
		do
			u ?= v
			Result := (u = v)
		end

	yytype37 (v: ANY): ET_ELSEIF_PART_LIST is
		require
			valid_type: yyis_type37 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type37 (v: ANY): BOOLEAN is
		local
			u: ET_ELSEIF_PART_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype38 (v: ANY): ET_EXPORT is
		require
			valid_type: yyis_type38 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type38 (v: ANY): BOOLEAN is
		local
			u: ET_EXPORT
		do
			u ?= v
			Result := (u = v)
		end

	yytype39 (v: ANY): ET_EXPORT_LIST is
		require
			valid_type: yyis_type39 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type39 (v: ANY): BOOLEAN is
		local
			u: ET_EXPORT_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype40 (v: ANY): ET_EXPRESSION is
		require
			valid_type: yyis_type40 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type40 (v: ANY): BOOLEAN is
		local
			u: ET_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype41 (v: ANY): ET_EXPRESSION_ITEM is
		require
			valid_type: yyis_type41 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type41 (v: ANY): BOOLEAN is
		local
			u: ET_EXPRESSION_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype42 (v: ANY): ET_EXTERNAL_ALIAS is
		require
			valid_type: yyis_type42 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type42 (v: ANY): BOOLEAN is
		local
			u: ET_EXTERNAL_ALIAS
		do
			u ?= v
			Result := (u = v)
		end

	yytype43 (v: ANY): ET_FEATURE is
		require
			valid_type: yyis_type43 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type43 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE
		do
			u ?= v
			Result := (u = v)
		end

	yytype44 (v: ANY): ET_FEATURE_CLAUSE is
		require
			valid_type: yyis_type44 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type44 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE_CLAUSE
		do
			u ?= v
			Result := (u = v)
		end

	yytype45 (v: ANY): ET_FEATURE_CLAUSE_LIST is
		require
			valid_type: yyis_type45 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type45 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE_CLAUSE_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype46 (v: ANY): ET_FEATURE_EXPORT is
		require
			valid_type: yyis_type46 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type46 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE_EXPORT
		do
			u ?= v
			Result := (u = v)
		end

	yytype47 (v: ANY): ET_FEATURE_NAME is
		require
			valid_type: yyis_type47 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type47 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE_NAME
		do
			u ?= v
			Result := (u = v)
		end

	yytype48 (v: ANY): ET_FEATURE_NAME_ITEM is
		require
			valid_type: yyis_type48 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type48 (v: ANY): BOOLEAN is
		local
			u: ET_FEATURE_NAME_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype49 (v: ANY): ET_FORMAL_ARGUMENT is
		require
			valid_type: yyis_type49 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type49 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_ARGUMENT
		do
			u ?= v
			Result := (u = v)
		end

	yytype50 (v: ANY): ET_FORMAL_ARGUMENT_ITEM is
		require
			valid_type: yyis_type50 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type50 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_ARGUMENT_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype51 (v: ANY): ET_FORMAL_ARGUMENT_LIST is
		require
			valid_type: yyis_type51 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type51 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_ARGUMENT_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype52 (v: ANY): ET_FORMAL_PARAMETER is
		require
			valid_type: yyis_type52 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type52 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_PARAMETER
		do
			u ?= v
			Result := (u = v)
		end

	yytype53 (v: ANY): ET_FORMAL_PARAMETER_ITEM is
		require
			valid_type: yyis_type53 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type53 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_PARAMETER_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype54 (v: ANY): ET_FORMAL_PARAMETER_LIST is
		require
			valid_type: yyis_type54 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type54 (v: ANY): BOOLEAN is
		local
			u: ET_FORMAL_PARAMETER_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype55 (v: ANY): ET_IF_INSTRUCTION is
		require
			valid_type: yyis_type55 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type55 (v: ANY): BOOLEAN is
		local
			u: ET_IF_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype56 (v: ANY): ET_INDEXING_LIST is
		require
			valid_type: yyis_type56 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type56 (v: ANY): BOOLEAN is
		local
			u: ET_INDEXING_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype57 (v: ANY): ET_INDEXING_ITEM is
		require
			valid_type: yyis_type57 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type57 (v: ANY): BOOLEAN is
		local
			u: ET_INDEXING_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype58 (v: ANY): ET_INDEXING_TERM is
		require
			valid_type: yyis_type58 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type58 (v: ANY): BOOLEAN is
		local
			u: ET_INDEXING_TERM
		do
			u ?= v
			Result := (u = v)
		end

	yytype59 (v: ANY): ET_INDEXING_TERM_ITEM is
		require
			valid_type: yyis_type59 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type59 (v: ANY): BOOLEAN is
		local
			u: ET_INDEXING_TERM_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype60 (v: ANY): ET_INDEXING_TERM_LIST is
		require
			valid_type: yyis_type60 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type60 (v: ANY): BOOLEAN is
		local
			u: ET_INDEXING_TERM_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype61 (v: ANY): ET_INSPECT_INSTRUCTION is
		require
			valid_type: yyis_type61 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type61 (v: ANY): BOOLEAN is
		local
			u: ET_INSPECT_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype62 (v: ANY): ET_INSTRUCTION is
		require
			valid_type: yyis_type62 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type62 (v: ANY): BOOLEAN is
		local
			u: ET_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype63 (v: ANY): ET_INVARIANTS is
		require
			valid_type: yyis_type63 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type63 (v: ANY): BOOLEAN is
		local
			u: ET_INVARIANTS
		do
			u ?= v
			Result := (u = v)
		end

	yytype64 (v: ANY): ET_KEYWORD_FEATURE_NAME_LIST is
		require
			valid_type: yyis_type64 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type64 (v: ANY): BOOLEAN is
		local
			u: ET_KEYWORD_FEATURE_NAME_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype65 (v: ANY): ET_LOCAL_VARIABLE is
		require
			valid_type: yyis_type65 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type65 (v: ANY): BOOLEAN is
		local
			u: ET_LOCAL_VARIABLE
		do
			u ?= v
			Result := (u = v)
		end

	yytype66 (v: ANY): ET_LOCAL_VARIABLE_ITEM is
		require
			valid_type: yyis_type66 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type66 (v: ANY): BOOLEAN is
		local
			u: ET_LOCAL_VARIABLE_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype67 (v: ANY): ET_LOCAL_VARIABLE_LIST is
		require
			valid_type: yyis_type67 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type67 (v: ANY): BOOLEAN is
		local
			u: ET_LOCAL_VARIABLE_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype68 (v: ANY): ET_MANIFEST_ARRAY is
		require
			valid_type: yyis_type68 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type68 (v: ANY): BOOLEAN is
		local
			u: ET_MANIFEST_ARRAY
		do
			u ?= v
			Result := (u = v)
		end

	yytype69 (v: ANY): ET_MANIFEST_STRING_ITEM is
		require
			valid_type: yyis_type69 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type69 (v: ANY): BOOLEAN is
		local
			u: ET_MANIFEST_STRING_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype70 (v: ANY): ET_MANIFEST_STRING_LIST is
		require
			valid_type: yyis_type70 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type70 (v: ANY): BOOLEAN is
		local
			u: ET_MANIFEST_STRING_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype71 (v: ANY): ET_MANIFEST_TUPLE is
		require
			valid_type: yyis_type71 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type71 (v: ANY): BOOLEAN is
		local
			u: ET_MANIFEST_TUPLE
		do
			u ?= v
			Result := (u = v)
		end

	yytype72 (v: ANY): ET_OBSOLETE is
		require
			valid_type: yyis_type72 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type72 (v: ANY): BOOLEAN is
		local
			u: ET_OBSOLETE
		do
			u ?= v
			Result := (u = v)
		end

	yytype73 (v: ANY): ET_PARENTHESIZED_EXPRESSION is
		require
			valid_type: yyis_type73 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type73 (v: ANY): BOOLEAN is
		local
			u: ET_PARENTHESIZED_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype74 (v: ANY): ET_PARENT is
		require
			valid_type: yyis_type74 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type74 (v: ANY): BOOLEAN is
		local
			u: ET_PARENT
		do
			u ?= v
			Result := (u = v)
		end

	yytype75 (v: ANY): ET_PARENT_ITEM is
		require
			valid_type: yyis_type75 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type75 (v: ANY): BOOLEAN is
		local
			u: ET_PARENT_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype76 (v: ANY): ET_PARENT_LIST is
		require
			valid_type: yyis_type76 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type76 (v: ANY): BOOLEAN is
		local
			u: ET_PARENT_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype77 (v: ANY): ET_POSTCONDITIONS is
		require
			valid_type: yyis_type77 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type77 (v: ANY): BOOLEAN is
		local
			u: ET_POSTCONDITIONS
		do
			u ?= v
			Result := (u = v)
		end

	yytype78 (v: ANY): ET_PRECURSOR_EXPRESSION is
		require
			valid_type: yyis_type78 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type78 (v: ANY): BOOLEAN is
		local
			u: ET_PRECURSOR_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype79 (v: ANY): ET_PRECURSOR_INSTRUCTION is
		require
			valid_type: yyis_type79 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type79 (v: ANY): BOOLEAN is
		local
			u: ET_PRECURSOR_INSTRUCTION
		do
			u ?= v
			Result := (u = v)
		end

	yytype80 (v: ANY): ET_PRECONDITIONS is
		require
			valid_type: yyis_type80 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type80 (v: ANY): BOOLEAN is
		local
			u: ET_PRECONDITIONS
		do
			u ?= v
			Result := (u = v)
		end

	yytype81 (v: ANY): ET_RENAME_ITEM is
		require
			valid_type: yyis_type81 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type81 (v: ANY): BOOLEAN is
		local
			u: ET_RENAME_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype82 (v: ANY): ET_RENAME_LIST is
		require
			valid_type: yyis_type82 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type82 (v: ANY): BOOLEAN is
		local
			u: ET_RENAME_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype83 (v: ANY): ET_STATIC_CALL_EXPRESSION is
		require
			valid_type: yyis_type83 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type83 (v: ANY): BOOLEAN is
		local
			u: ET_STATIC_CALL_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype84 (v: ANY): ET_STRIP_EXPRESSION is
		require
			valid_type: yyis_type84 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type84 (v: ANY): BOOLEAN is
		local
			u: ET_STRIP_EXPRESSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype85 (v: ANY): ET_TYPE is
		require
			valid_type: yyis_type85 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type85 (v: ANY): BOOLEAN is
		local
			u: ET_TYPE
		do
			u ?= v
			Result := (u = v)
		end

	yytype86 (v: ANY): ET_TYPE_ITEM is
		require
			valid_type: yyis_type86 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type86 (v: ANY): BOOLEAN is
		local
			u: ET_TYPE_ITEM
		do
			u ?= v
			Result := (u = v)
		end

	yytype87 (v: ANY): ET_VARIANT is
		require
			valid_type: yyis_type87 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type87 (v: ANY): BOOLEAN is
		local
			u: ET_VARIANT
		do
			u ?= v
			Result := (u = v)
		end

	yytype88 (v: ANY): ET_WHEN_PART is
		require
			valid_type: yyis_type88 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type88 (v: ANY): BOOLEAN is
		local
			u: ET_WHEN_PART
		do
			u ?= v
			Result := (u = v)
		end

	yytype89 (v: ANY): ET_WHEN_PART_LIST is
		require
			valid_type: yyis_type89 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type89 (v: ANY): BOOLEAN is
		local
			u: ET_WHEN_PART_LIST
		do
			u ?= v
			Result := (u = v)
		end

	yytype90 (v: ANY): ET_WRITABLE is
		require
			valid_type: yyis_type90 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type90 (v: ANY): BOOLEAN is
		local
			u: ET_WRITABLE
		do
			u ?= v
			Result := (u = v)
		end


feature {NONE} -- Constants

	yyFinal: INTEGER is 914
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 128
			-- Number of tokens

	yyLast: INTEGER is 3461
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 361
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 315
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



end
